#!/usr/bin/env python
# coding=utf-8

TEMPLATE = r"""
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>TreeMap</title>
    <style>
        @font-face{font-family:KaTeX_AMS;src:url(fonts/KaTeX_AMS-Regular.eot);src:url(fonts/KaTeX_AMS-Regular.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_AMS-Regular.woff2) format('woff2'),url(fonts/KaTeX_AMS-Regular.woff) format('woff'),url(fonts/KaTeX_AMS-Regular.ttf) format('truetype');font-weight:400;font-style:normal}@font-face{font-family:KaTeX_Caligraphic;src:url(fonts/KaTeX_Caligraphic-Bold.eot);src:url(fonts/KaTeX_Caligraphic-Bold.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Caligraphic-Bold.woff2) format('woff2'),url(fonts/KaTeX_Caligraphic-Bold.woff) format('woff'),url(fonts/KaTeX_Caligraphic-Bold.ttf) format('truetype');font-weight:700;font-style:normal}@font-face{font-family:KaTeX_Caligraphic;src:url(fonts/KaTeX_Caligraphic-Regular.eot);src:url(fonts/KaTeX_Caligraphic-Regular.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Caligraphic-Regular.woff2) format('woff2'),url(fonts/KaTeX_Caligraphic-Regular.woff) format('woff'),url(fonts/KaTeX_Caligraphic-Regular.ttf) format('truetype');font-weight:400;font-style:normal}@font-face{font-family:KaTeX_Fraktur;src:url(fonts/KaTeX_Fraktur-Bold.eot);src:url(fonts/KaTeX_Fraktur-Bold.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Fraktur-Bold.woff2) format('woff2'),url(fonts/KaTeX_Fraktur-Bold.woff) format('woff'),url(fonts/KaTeX_Fraktur-Bold.ttf) format('truetype');font-weight:700;font-style:normal}@font-face{font-family:KaTeX_Fraktur;src:url(fonts/KaTeX_Fraktur-Regular.eot);src:url(fonts/KaTeX_Fraktur-Regular.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Fraktur-Regular.woff2) format('woff2'),url(fonts/KaTeX_Fraktur-Regular.woff) format('woff'),url(fonts/KaTeX_Fraktur-Regular.ttf) format('truetype');font-weight:400;font-style:normal}@font-face{font-family:KaTeX_Main;src:url(fonts/KaTeX_Main-Bold.eot);src:url(fonts/KaTeX_Main-Bold.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Main-Bold.woff2) format('woff2'),url(fonts/KaTeX_Main-Bold.woff) format('woff'),url(fonts/KaTeX_Main-Bold.ttf) format('truetype');font-weight:700;font-style:normal}@font-face{font-family:KaTeX_Main;src:url(fonts/KaTeX_Main-Italic.eot);src:url(fonts/KaTeX_Main-Italic.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Main-Italic.woff2) format('woff2'),url(fonts/KaTeX_Main-Italic.woff) format('woff'),url(fonts/KaTeX_Main-Italic.ttf) format('truetype');font-weight:400;font-style:italic}@font-face{font-family:KaTeX_Main;src:url(fonts/KaTeX_Main-Regular.eot);src:url(fonts/KaTeX_Main-Regular.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Main-Regular.woff2) format('woff2'),url(fonts/KaTeX_Main-Regular.woff) format('woff'),url(fonts/KaTeX_Main-Regular.ttf) format('truetype');font-weight:400;font-style:normal}@font-face{font-family:KaTeX_Math;src:url(fonts/KaTeX_Math-Italic.eot);src:url(fonts/KaTeX_Math-Italic.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Math-Italic.woff2) format('woff2'),url(fonts/KaTeX_Math-Italic.woff) format('woff'),url(fonts/KaTeX_Math-Italic.ttf) format('truetype');font-weight:400;font-style:italic}@font-face{font-family:KaTeX_SansSerif;src:url(fonts/KaTeX_SansSerif-Regular.eot);src:url(fonts/KaTeX_SansSerif-Regular.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_SansSerif-Regular.woff2) format('woff2'),url(fonts/KaTeX_SansSerif-Regular.woff) format('woff'),url(fonts/KaTeX_SansSerif-Regular.ttf) format('truetype');font-weight:400;font-style:normal}@font-face{font-family:KaTeX_Script;src:url(fonts/KaTeX_Script-Regular.eot);src:url(fonts/KaTeX_Script-Regular.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Script-Regular.woff2) format('woff2'),url(fonts/KaTeX_Script-Regular.woff) format('woff'),url(fonts/KaTeX_Script-Regular.ttf) format('truetype');font-weight:400;font-style:normal}@font-face{font-family:KaTeX_Size1;src:url(fonts/KaTeX_Size1-Regular.eot);src:url(fonts/KaTeX_Size1-Regular.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Size1-Regular.woff2) format('woff2'),url(fonts/KaTeX_Size1-Regular.woff) format('woff'),url(fonts/KaTeX_Size1-Regular.ttf) format('truetype');font-weight:400;font-style:normal}@font-face{font-family:KaTeX_Size2;src:url(fonts/KaTeX_Size2-Regular.eot);src:url(fonts/KaTeX_Size2-Regular.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Size2-Regular.woff2) format('woff2'),url(fonts/KaTeX_Size2-Regular.woff) format('woff'),url(fonts/KaTeX_Size2-Regular.ttf) format('truetype');font-weight:400;font-style:normal}@font-face{font-family:KaTeX_Size3;src:url(fonts/KaTeX_Size3-Regular.eot);src:url(fonts/KaTeX_Size3-Regular.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Size3-Regular.woff2) format('woff2'),url(fonts/KaTeX_Size3-Regular.woff) format('woff'),url(fonts/KaTeX_Size3-Regular.ttf) format('truetype');font-weight:400;font-style:normal}@font-face{font-family:KaTeX_Size4;src:url(fonts/KaTeX_Size4-Regular.eot);src:url(fonts/KaTeX_Size4-Regular.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Size4-Regular.woff2) format('woff2'),url(fonts/KaTeX_Size4-Regular.woff) format('woff'),url(fonts/KaTeX_Size4-Regular.ttf) format('truetype');font-weight:400;font-style:normal}@font-face{font-family:KaTeX_Typewriter;src:url(fonts/KaTeX_Typewriter-Regular.eot);src:url(fonts/KaTeX_Typewriter-Regular.eot#iefix) format('embedded-opentype'),url(fonts/KaTeX_Typewriter-Regular.woff2) format('woff2'),url(fonts/KaTeX_Typewriter-Regular.woff) format('woff'),url(fonts/KaTeX_Typewriter-Regular.ttf) format('truetype');font-weight:400;font-style:normal}.katex-display{display:block;margin:1em 0;text-align:center}.katex .base,.katex .katex-html,.katex .strut{display:inline-block}.katex-display>.katex{display:inline-block;text-align:initial}.katex{font:400 1.21em KaTeX_Main,Times New Roman,serif;line-height:1.2;white-space:nowrap;text-indent:0;text-rendering:auto}.katex *{-ms-high-contrast-adjust:none!important}.katex .katex-mathml{position:absolute;clip:rect(1px,1px,1px,1px);padding:0;border:0;height:1px;width:1px;overflow:hidden}.katex .base{position:relative}.katex .mathrm{font-style:normal}.katex .mainit,.katex .mathit,.katex .textit{font-style:italic}.katex .mathit{font-family:KaTeX_Math}.katex .mathbf{font-family:KaTeX_Main;font-weight:700}.katex .amsrm,.katex .mathbb{font-family:KaTeX_AMS}.katex .mathcal{font-family:KaTeX_Caligraphic}.katex .mathfrak{font-family:KaTeX_Fraktur}.katex .mathtt{font-family:KaTeX_Typewriter}.katex .mathscr{font-family:KaTeX_Script}.katex .mathsf{font-family:KaTeX_SansSerif}.katex .mainit{font-family:KaTeX_Main}.katex .mainrm{font-family:KaTeX_Main;font-style:normal}.katex .mord+.mop{margin-left:.16667em}.katex .mord+.mbin{margin-left:.22222em}.katex .mord+.mrel{margin-left:.27778em}.katex .mop+.mop,.katex .mop+.mord,.katex .mord+.minner{margin-left:.16667em}.katex .mop+.mrel{margin-left:.27778em}.katex .mop+.minner{margin-left:.16667em}.katex .mbin+.minner,.katex .mbin+.mop,.katex .mbin+.mopen,.katex .mbin+.mord{margin-left:.22222em}.katex .mrel+.minner,.katex .mrel+.mop,.katex .mrel+.mopen,.katex .mrel+.mord{margin-left:.27778em}.katex .mclose+.mop{margin-left:.16667em}.katex .mclose+.mbin{margin-left:.22222em}.katex .mclose+.mrel{margin-left:.27778em}.katex .mclose+.minner,.katex .minner+.mop,.katex .minner+.mord,.katex .mpunct+.mclose,.katex .mpunct+.minner,.katex .mpunct+.mop,.katex .mpunct+.mopen,.katex .mpunct+.mord,.katex .mpunct+.mpunct,.katex .mpunct+.mrel{margin-left:.16667em}.katex .minner+.mbin{margin-left:.22222em}.katex .minner+.mrel{margin-left:.27778em}.katex .minner+.minner,.katex .minner+.mopen,.katex .minner+.mpunct{margin-left:.16667em}.katex .mbin.mtight,.katex .mclose.mtight,.katex .minner.mtight,.katex .mop.mtight,.katex .mopen.mtight,.katex .mord.mtight,.katex .mpunct.mtight,.katex .mrel.mtight{margin-left:0}.katex .mclose+.mop.mtight,.katex .minner+.mop.mtight,.katex .mop+.mop.mtight,.katex .mop+.mord.mtight,.katex .mord+.mop.mtight{margin-left:.16667em}.katex .vlist-t{display:inline-table;table-layout:fixed}.katex .vlist-r{display:table-row}.katex .vlist{display:table-cell;vertical-align:bottom;position:relative}.katex .vlist>span{display:block;height:0;position:relative}.katex .vlist>span>span{display:inline-block}.katex .vlist>span>.pstrut{overflow:hidden;width:0}.katex .vlist-t2{margin-right:-2px}.katex .vlist-s{display:table-cell;vertical-align:bottom;font-size:1px;width:2px}.katex .fontsize-ensurer,.katex .llap>.fix,.katex .mfrac .frac-line,.katex .mspace,.katex .mtable .arraycolsep,.katex .mtable .vertical-separator,.katex .nulldelimiter,.katex .rlap>.fix,.katex .rule,.katex .sizing{display:inline-block}.katex .msupsub{text-align:left}.katex .accent>.vlist-t,.katex .mfrac>span>span,.katex .mtable .col-align-c>.vlist-t,.katex .op-limits>.vlist-t{text-align:center}.katex .mfrac .frac-line{width:100%;border-bottom-style:solid}.katex .mspace.negativethinspace{margin-left:-.16667em}.katex .mspace.thinspace{width:.16667em}.katex .mspace.negativemediumspace{margin-left:-.22222em}.katex .mspace.mediumspace{width:.22222em}.katex .mspace.thickspace{width:.27778em}.katex .mspace.sixmuspace{width:.333333em}.katex .mspace.eightmuspace{width:.444444em}.katex .mspace.enspace{width:.5em}.katex .mspace.twelvemuspace{width:.666667em}.katex .mspace.quad{width:1em}.katex .mspace.qquad{width:2em}.katex .llap,.katex .rlap{width:0;position:relative}.katex .llap>.inner,.katex .rlap>.inner{position:absolute}.katex .llap>.inner{right:0}.katex .rlap>.inner{left:0}.katex .katex-logo .a{font-size:.75em;margin-left:-.32em;position:relative;top:-.2em}.katex .katex-logo .t{margin-left:-.23em}.katex .katex-logo .e{margin-left:-.1667em;position:relative;top:.2155em}.katex .katex-logo .x{margin-left:-.125em}.katex .rule{border:0 solid;position:relative}.katex .overline .overline-line,.katex .underline .underline-line{display:inline-block;width:100%;border-bottom-style:solid}.katex .sqrt>.root{margin-left:.27777778em;margin-right:-.55555556em}.katex .fontsize-ensurer.reset-size1.size1,.katex .sizing.reset-size1.size1{font-size:1em}.katex .fontsize-ensurer.reset-size1.size2,.katex .sizing.reset-size1.size2{font-size:1.2em}.katex .fontsize-ensurer.reset-size1.size3,.katex .sizing.reset-size1.size3{font-size:1.4em}.katex .fontsize-ensurer.reset-size1.size4,.katex .sizing.reset-size1.size4{font-size:1.6em}.katex .fontsize-ensurer.reset-size1.size5,.katex .sizing.reset-size1.size5{font-size:1.8em}.katex .fontsize-ensurer.reset-size1.size6,.katex .sizing.reset-size1.size6{font-size:2em}.katex .fontsize-ensurer.reset-size1.size7,.katex .sizing.reset-size1.size7{font-size:2.4em}.katex .fontsize-ensurer.reset-size1.size8,.katex .sizing.reset-size1.size8{font-size:2.88em}.katex .fontsize-ensurer.reset-size1.size9,.katex .sizing.reset-size1.size9{font-size:3.456em}.katex .fontsize-ensurer.reset-size1.size10,.katex .sizing.reset-size1.size10{font-size:4.148em}.katex .fontsize-ensurer.reset-size1.size11,.katex .sizing.reset-size1.size11{font-size:4.976em}.katex .fontsize-ensurer.reset-size2.size1,.katex .sizing.reset-size2.size1{font-size:.83333333em}.katex .fontsize-ensurer.reset-size2.size2,.katex .sizing.reset-size2.size2{font-size:1em}.katex .fontsize-ensurer.reset-size2.size3,.katex .sizing.reset-size2.size3{font-size:1.16666667em}.katex .fontsize-ensurer.reset-size2.size4,.katex .sizing.reset-size2.size4{font-size:1.33333333em}.katex .fontsize-ensurer.reset-size2.size5,.katex .sizing.reset-size2.size5{font-size:1.5em}.katex .fontsize-ensurer.reset-size2.size6,.katex .sizing.reset-size2.size6{font-size:1.66666667em}.katex .fontsize-ensurer.reset-size2.size7,.katex .sizing.reset-size2.size7{font-size:2em}.katex .fontsize-ensurer.reset-size2.size8,.katex .sizing.reset-size2.size8{font-size:2.4em}.katex .fontsize-ensurer.reset-size2.size9,.katex .sizing.reset-size2.size9{font-size:2.88em}.katex .fontsize-ensurer.reset-size2.size10,.katex .sizing.reset-size2.size10{font-size:3.45666667em}.katex .fontsize-ensurer.reset-size2.size11,.katex .sizing.reset-size2.size11{font-size:4.14666667em}.katex .fontsize-ensurer.reset-size3.size1,.katex .sizing.reset-size3.size1{font-size:.71428571em}.katex .fontsize-ensurer.reset-size3.size2,.katex .sizing.reset-size3.size2{font-size:.85714286em}.katex .fontsize-ensurer.reset-size3.size3,.katex .sizing.reset-size3.size3{font-size:1em}.katex .fontsize-ensurer.reset-size3.size4,.katex .sizing.reset-size3.size4{font-size:1.14285714em}.katex .fontsize-ensurer.reset-size3.size5,.katex .sizing.reset-size3.size5{font-size:1.28571429em}.katex .fontsize-ensurer.reset-size3.size6,.katex .sizing.reset-size3.size6{font-size:1.42857143em}.katex .fontsize-ensurer.reset-size3.size7,.katex .sizing.reset-size3.size7{font-size:1.71428571em}.katex .fontsize-ensurer.reset-size3.size8,.katex .sizing.reset-size3.size8{font-size:2.05714286em}.katex .fontsize-ensurer.reset-size3.size9,.katex .sizing.reset-size3.size9{font-size:2.46857143em}.katex .fontsize-ensurer.reset-size3.size10,.katex .sizing.reset-size3.size10{font-size:2.96285714em}.katex .fontsize-ensurer.reset-size3.size11,.katex .sizing.reset-size3.size11{font-size:3.55428571em}.katex .fontsize-ensurer.reset-size4.size1,.katex .sizing.reset-size4.size1{font-size:.625em}.katex .fontsize-ensurer.reset-size4.size2,.katex .sizing.reset-size4.size2{font-size:.75em}.katex .fontsize-ensurer.reset-size4.size3,.katex .sizing.reset-size4.size3{font-size:.875em}.katex .fontsize-ensurer.reset-size4.size4,.katex .sizing.reset-size4.size4{font-size:1em}.katex .fontsize-ensurer.reset-size4.size5,.katex .sizing.reset-size4.size5{font-size:1.125em}.katex .fontsize-ensurer.reset-size4.size6,.katex .sizing.reset-size4.size6{font-size:1.25em}.katex .fontsize-ensurer.reset-size4.size7,.katex .sizing.reset-size4.size7{font-size:1.5em}.katex .fontsize-ensurer.reset-size4.size8,.katex .sizing.reset-size4.size8{font-size:1.8em}.katex .fontsize-ensurer.reset-size4.size9,.katex .sizing.reset-size4.size9{font-size:2.16em}.katex .fontsize-ensurer.reset-size4.size10,.katex .sizing.reset-size4.size10{font-size:2.5925em}.katex .fontsize-ensurer.reset-size4.size11,.katex .sizing.reset-size4.size11{font-size:3.11em}.katex .fontsize-ensurer.reset-size5.size1,.katex .sizing.reset-size5.size1{font-size:.55555556em}.katex .fontsize-ensurer.reset-size5.size2,.katex .sizing.reset-size5.size2{font-size:.66666667em}.katex .fontsize-ensurer.reset-size5.size3,.katex .sizing.reset-size5.size3{font-size:.77777778em}.katex .fontsize-ensurer.reset-size5.size4,.katex .sizing.reset-size5.size4{font-size:.88888889em}.katex .fontsize-ensurer.reset-size5.size5,.katex .sizing.reset-size5.size5{font-size:1em}.katex .fontsize-ensurer.reset-size5.size6,.katex .sizing.reset-size5.size6{font-size:1.11111111em}.katex .fontsize-ensurer.reset-size5.size7,.katex .sizing.reset-size5.size7{font-size:1.33333333em}.katex .fontsize-ensurer.reset-size5.size8,.katex .sizing.reset-size5.size8{font-size:1.6em}.katex .fontsize-ensurer.reset-size5.size9,.katex .sizing.reset-size5.size9{font-size:1.92em}.katex .fontsize-ensurer.reset-size5.size10,.katex .sizing.reset-size5.size10{font-size:2.30444444em}.katex .fontsize-ensurer.reset-size5.size11,.katex .sizing.reset-size5.size11{font-size:2.76444444em}.katex .fontsize-ensurer.reset-size6.size1,.katex .sizing.reset-size6.size1{font-size:.5em}.katex .fontsize-ensurer.reset-size6.size2,.katex .sizing.reset-size6.size2{font-size:.6em}.katex .fontsize-ensurer.reset-size6.size3,.katex .sizing.reset-size6.size3{font-size:.7em}.katex .fontsize-ensurer.reset-size6.size4,.katex .sizing.reset-size6.size4{font-size:.8em}.katex .fontsize-ensurer.reset-size6.size5,.katex .sizing.reset-size6.size5{font-size:.9em}.katex .fontsize-ensurer.reset-size6.size6,.katex .sizing.reset-size6.size6{font-size:1em}.katex .fontsize-ensurer.reset-size6.size7,.katex .sizing.reset-size6.size7{font-size:1.2em}.katex .fontsize-ensurer.reset-size6.size8,.katex .sizing.reset-size6.size8{font-size:1.44em}.katex .fontsize-ensurer.reset-size6.size9,.katex .sizing.reset-size6.size9{font-size:1.728em}.katex .fontsize-ensurer.reset-size6.size10,.katex .sizing.reset-size6.size10{font-size:2.074em}.katex .fontsize-ensurer.reset-size6.size11,.katex .sizing.reset-size6.size11{font-size:2.488em}.katex .fontsize-ensurer.reset-size7.size1,.katex .sizing.reset-size7.size1{font-size:.41666667em}.katex .fontsize-ensurer.reset-size7.size2,.katex .sizing.reset-size7.size2{font-size:.5em}.katex .fontsize-ensurer.reset-size7.size3,.katex .sizing.reset-size7.size3{font-size:.58333333em}.katex .fontsize-ensurer.reset-size7.size4,.katex .sizing.reset-size7.size4{font-size:.66666667em}.katex .fontsize-ensurer.reset-size7.size5,.katex .sizing.reset-size7.size5{font-size:.75em}.katex .fontsize-ensurer.reset-size7.size6,.katex .sizing.reset-size7.size6{font-size:.83333333em}.katex .fontsize-ensurer.reset-size7.size7,.katex .sizing.reset-size7.size7{font-size:1em}.katex .fontsize-ensurer.reset-size7.size8,.katex .sizing.reset-size7.size8{font-size:1.2em}.katex .fontsize-ensurer.reset-size7.size9,.katex .sizing.reset-size7.size9{font-size:1.44em}.katex .fontsize-ensurer.reset-size7.size10,.katex .sizing.reset-size7.size10{font-size:1.72833333em}.katex .fontsize-ensurer.reset-size7.size11,.katex .sizing.reset-size7.size11{font-size:2.07333333em}.katex .fontsize-ensurer.reset-size8.size1,.katex .sizing.reset-size8.size1{font-size:.34722222em}.katex .fontsize-ensurer.reset-size8.size2,.katex .sizing.reset-size8.size2{font-size:.41666667em}.katex .fontsize-ensurer.reset-size8.size3,.katex .sizing.reset-size8.size3{font-size:.48611111em}.katex .fontsize-ensurer.reset-size8.size4,.katex .sizing.reset-size8.size4{font-size:.55555556em}.katex .fontsize-ensurer.reset-size8.size5,.katex .sizing.reset-size8.size5{font-size:.625em}.katex .fontsize-ensurer.reset-size8.size6,.katex .sizing.reset-size8.size6{font-size:.69444444em}.katex .fontsize-ensurer.reset-size8.size7,.katex .sizing.reset-size8.size7{font-size:.83333333em}.katex .fontsize-ensurer.reset-size8.size8,.katex .sizing.reset-size8.size8{font-size:1em}.katex .fontsize-ensurer.reset-size8.size9,.katex .sizing.reset-size8.size9{font-size:1.2em}.katex .fontsize-ensurer.reset-size8.size10,.katex .sizing.reset-size8.size10{font-size:1.44027778em}.katex .fontsize-ensurer.reset-size8.size11,.katex .sizing.reset-size8.size11{font-size:1.72777778em}.katex .fontsize-ensurer.reset-size9.size1,.katex .sizing.reset-size9.size1{font-size:.28935185em}.katex .fontsize-ensurer.reset-size9.size2,.katex .sizing.reset-size9.size2{font-size:.34722222em}.katex .fontsize-ensurer.reset-size9.size3,.katex .sizing.reset-size9.size3{font-size:.40509259em}.katex .fontsize-ensurer.reset-size9.size4,.katex .sizing.reset-size9.size4{font-size:.46296296em}.katex .fontsize-ensurer.reset-size9.size5,.katex .sizing.reset-size9.size5{font-size:.52083333em}.katex .fontsize-ensurer.reset-size9.size6,.katex .sizing.reset-size9.size6{font-size:.5787037em}.katex .fontsize-ensurer.reset-size9.size7,.katex .sizing.reset-size9.size7{font-size:.69444444em}.katex .fontsize-ensurer.reset-size9.size8,.katex .sizing.reset-size9.size8{font-size:.83333333em}.katex .fontsize-ensurer.reset-size9.size9,.katex .sizing.reset-size9.size9{font-size:1em}.katex .fontsize-ensurer.reset-size9.size10,.katex .sizing.reset-size9.size10{font-size:1.20023148em}.katex .fontsize-ensurer.reset-size9.size11,.katex .sizing.reset-size9.size11{font-size:1.43981481em}.katex .fontsize-ensurer.reset-size10.size1,.katex .sizing.reset-size10.size1{font-size:.24108004em}.katex .fontsize-ensurer.reset-size10.size2,.katex .sizing.reset-size10.size2{font-size:.28929605em}.katex .fontsize-ensurer.reset-size10.size3,.katex .sizing.reset-size10.size3{font-size:.33751205em}.katex .fontsize-ensurer.reset-size10.size4,.katex .sizing.reset-size10.size4{font-size:.38572806em}.katex .fontsize-ensurer.reset-size10.size5,.katex .sizing.reset-size10.size5{font-size:.43394407em}.katex .fontsize-ensurer.reset-size10.size6,.katex .sizing.reset-size10.size6{font-size:.48216008em}.katex .fontsize-ensurer.reset-size10.size7,.katex .sizing.reset-size10.size7{font-size:.57859209em}.katex .fontsize-ensurer.reset-size10.size8,.katex .sizing.reset-size10.size8{font-size:.69431051em}.katex .fontsize-ensurer.reset-size10.size9,.katex .sizing.reset-size10.size9{font-size:.83317261em}.katex .fontsize-ensurer.reset-size10.size10,.katex .sizing.reset-size10.size10{font-size:1em}.katex .fontsize-ensurer.reset-size10.size11,.katex .sizing.reset-size10.size11{font-size:1.19961427em}.katex .fontsize-ensurer.reset-size11.size1,.katex .sizing.reset-size11.size1{font-size:.20096463em}.katex .fontsize-ensurer.reset-size11.size2,.katex .sizing.reset-size11.size2{font-size:.24115756em}.katex .fontsize-ensurer.reset-size11.size3,.katex .sizing.reset-size11.size3{font-size:.28135048em}.katex .fontsize-ensurer.reset-size11.size4,.katex .sizing.reset-size11.size4{font-size:.32154341em}.katex .fontsize-ensurer.reset-size11.size5,.katex .sizing.reset-size11.size5{font-size:.36173633em}.katex .fontsize-ensurer.reset-size11.size6,.katex .sizing.reset-size11.size6{font-size:.40192926em}.katex .fontsize-ensurer.reset-size11.size7,.katex .sizing.reset-size11.size7{font-size:.48231511em}.katex .fontsize-ensurer.reset-size11.size8,.katex .sizing.reset-size11.size8{font-size:.57877814em}.katex .fontsize-ensurer.reset-size11.size9,.katex .sizing.reset-size11.size9{font-size:.69453376em}.katex .fontsize-ensurer.reset-size11.size10,.katex .sizing.reset-size11.size10{font-size:.83360129em}.katex .fontsize-ensurer.reset-size11.size11,.katex .sizing.reset-size11.size11{font-size:1em}.katex .delimsizing.size1{font-family:KaTeX_Size1}.katex .delimsizing.size2{font-family:KaTeX_Size2}.katex .delimsizing.size3{font-family:KaTeX_Size3}.katex .delimsizing.size4{font-family:KaTeX_Size4}.katex .delimsizing.mult .delim-size1>span{font-family:KaTeX_Size1}.katex .delimsizing.mult .delim-size4>span{font-family:KaTeX_Size4}.katex .nulldelimiter{width:.12em}.katex .delimcenter,.katex .op-symbol{position:relative}.katex .op-symbol.small-op{font-family:KaTeX_Size1}.katex .op-symbol.large-op{font-family:KaTeX_Size2}.katex .accent .accent-body>span{width:0}.katex .accent .accent-body.accent-vec>span{position:relative;left:.326em}.katex .accent .accent-body.accent-hungarian>span{position:relative;left:.25em}.katex .mtable .vertical-separator{margin:0 -.025em;border-right:.05em solid #000}.katex .stretchy,.katex svg{width:100%;display:block}.katex .mtable .col-align-l>.vlist-t{text-align:left}.katex .mtable .col-align-r>.vlist-t{text-align:right}.katex .svg-align{text-align:left}.katex svg{position:absolute}.katex svg path{fill:currentColor}.katex svg line{stroke:currentColor}.katex .stretchy:after,.katex .stretchy:before{content:""}.katex .x-arrow-pad{padding:0 .5em}.katex .mover,.katex .munder,.katex .x-arrow{text-align:center}.katex .boxpad{padding:0 .3em}.katex .fbox{box-sizing:border-box;border:.04em solid #000}.katex .cancel-pad{padding:0 .2em}.katex .cancel-lap+.mbin,.katex .cancel-lap+.mord,.katex .cancel-lap+.msupsub,.katex .mbin+.cancel-lap,.katex .mord+.cancel-lap{margin-left:-.2em}.katex .sout{border-bottom-style:solid;border-bottom-width:.08em}
    </style>
    <style>
         ::-webkit-scrollbar {
            display: none;
        }

        html,
        body {
            overflow: hidden;
        }
    </style>
</head>

<body>
    <div id="myTreeMap"></div>
    <script>
            !function(t,e){"object"==typeof exports&&"object"==typeof module?module.exports=e():"function"==typeof define&&define.amd?define("G6",[],e):"object"==typeof exports?exports.G6=e():t.G6=e()}(this,function(){return function(t){function e(i){if(n[i])return n[i].exports;var r=n[i]={exports:{},id:i,loaded:!1};return t[i].call(r.exports,r,r.exports,e),r.loaded=!0,r.exports}var n={};return e.m=t,e.c=n,e.p="",e(0)}([function(t,e,n){"use strict";var i={},r=n(34);i.Color=n(95),i.Math=n(8),i.Matrix=n(3),i.Tween=n(35),i.Canvas=n(10),i.Layouts=n(68),i.Graph=n(13),i.Net=n(184),i.Tree=n(188),i.Global=i.Graph.Global,i.Handler=i.Graph.Handler,i.Shape=i.Graph.Shape,i.Util=i.Graph.Util,i.Item=i.Graph.Item,i.registNode=i.Graph.registNode,i.registEdge=i.Graph.registEdge,i.Layout=i.Layouts,i.registerNode=i.Graph.registNode,i.registerEdge=i.Graph.registEdge,i.registBehaviour=i.Handler.registBehaviour,r.tracking=!0,i.track=function(t){r.tracking=t},n(186),t.exports=i},function(t,e,n){var i=n(91);t.exports=i},function(t,e){"use strict";var n={resetMode:function(t,e){var i=void 0;e._off();for(var r=0;r<t.length;r++)i=n[t[r]],i&&i(e)},registBehaviour:function(t,e){n[t]=e}};t.exports=n},function(t,e,n){var i={Matrix3:n(72),Vector2:n(73),Vector3:n(74)};t.exports=i},function(t,e,n){"use strict";var i=n(1),r=n(31),a=n(18),o=n(30),s=n(138),u=n(141),c=n(64),h={};i.mix(h,i,o,r,a,u,c,s),t.exports=h},function(t,e,n){var i=n(1),r=n(41),a=n(6),o=n(3).Vector3,s=function(t){s.superclass.constructor.call(this,t)};s.ATTRS={},i.extend(s,r),i.augment(s,{isShape:!0,createPath:function(){},drawInner:function(t){var e=this,n=e.__attrs;e.createPath(t);var r=t.globalAlpha;if(e.hasFill()){var a=n.fillOpacity;i.isNull(a)||1===a?t.fill():(t.globalAlpha=a,t.fill(),t.globalAlpha=r)}if(e.hasStroke()){var o=e.__attrs.lineWidth;if(o>0){var s=n.strokeOpacity;i.isNull(s)||1===s||(t.globalAlpha=s),t.stroke()}}},isPointInPath:function(){return!1},isHitBox:function(){return!0},isHit:function(t,e){var n=this,i=new o(t,e,1);if(n.invert(i),n.isHitBox()){var r=n.getBBox();if(r&&!a.box(r.minX,r.maxX,r.minY,r.maxY,i.x,i.y))return!1}var s=n.__attrs.clip;return s?!!s.inside(t,e)&&n.isPointInPath(i.x,i.y):n.isPointInPath(i.x,i.y)},calculateBox:function(){return null},clearTotalMatrix:function(){this.__cfg.totalMatrix=null,this.__cfg.region=null},clearBBox:function(){this.__cfg.box=null,this.__cfg.region=null},getBBox:function(){var t=this.__cfg.box;return t||(t=this.calculateBox(),t&&(t.x=t.minX,t.y=t.minY,t.width=t.maxX-t.minX,t.height=t.maxY-t.minY),this.__cfg.box=t),t}}),t.exports=s},function(t,e,n){var i=n(22),r=n(23),a=n(17),o=n(21);t.exports={line:function(t,e,n,r,a,o,s){var u=i.box(t,e,n,r,a);if(!this.box(u.minX,u.maxX,u.minY,u.maxY,o,s))return!1;var c=i.pointDistance(t,e,n,r,o,s);return!isNaN(c)&&c<=a/2},polyline:function(t,e,n,i){var r=t.length-1;if(r<1)return!1;for(var a=0;a<r;a++){var o=t[a][0],s=t[a][1],u=t[a+1][0],c=t[a+1][1];if(this.line(o,s,u,c,e,n,i))return!0}return!1},cubicline:function(t,e,n,i,r,o,s,u,c,h,l){return a.pointDistance(t,e,n,i,r,o,s,u,h,l)<=c/2},quadraticline:function(t,e,n,i,a,o,s,u,c){return r.pointDistance(t,e,n,i,a,o,u,c)<=s/2},arcline:function(t,e,n,i,r,a,s,u,c){return o.pointDistance(t,e,n,i,r,a,u,c)<=s/2},rect:function(t,e,n,i,r,a){return t<=r&&r<=t+n&&e<=a&&a<=e+i},circle:function(t,e,n,i,r){return Math.pow(i-t,2)+Math.pow(r-e,2)<=Math.pow(n,2)},box:function(t,e,n,i,r,a){return t<=r&&r<=e&&n<=a&&a<=i}}},function(t,e){"use strict";t.exports={colors:["#4E7CCC","#36B3C3","#4ECDA5","#94E08A","#E2F194","#EDCC72","#F8AB60","#F9815C","#EB4456","#C82B3D"],guide:{},grid:{line:{stroke:"#F5F5F5",lineWidth:1},forceAlign:!0,cell:10},nodeStyle:{stroke:"#666",fill:"#fff",lineWidth:1,radius:4,fillOpacity:.1},nodeDelegationStyle:{stroke:"#108EE9",lineDash:[3,3]},edgeDelegationStyle:{stroke:"#108EE9",lineDash:[3,3]},nodePadding:[8,16],nodeLabelStyle:{fill:"#666",textAlign:"center",textBaseline:"middle",fontSize:14},edgeStyle:{lineWidth:1,stroke:"#999",lineAppendWidth:10},edgeLabelStyle:{fill:"#666",textAlign:"center",textBaseline:"middle"},edgeLabelRectStyle:{fill:"white"},anchorPointStyle:{fill:"#108EE9",lineWidth:.1,r:4},anchorPointHoverStyle:{lineWidth:6,stroke:"#108EE9",strokeOpacity:.2},frameRectStyle:{fill:"blue",opacity:.1},nodeControlPointStyle:{r:4,fill:"#fff",shadowBlur:4,shadowColor:"#666"},edgeControlPointStyle:{r:4,fill:"#fff",shadowBlur:4,shadowColor:"#666"},nodeAcitvedBoxStyle:{},nodeActivedBoxStyle:{stroke:"#108EE9",lineDash:[3,3]},modalRectStyle:{fill:"white",fillOpacity:.8},zIndex:{node:1,edge:0,nodeLabel:5,edgeLabel:4,edgeLabelBackground:3},treeButtonStyle:{fill:"#fff",stroke:"#333"},wheelZoomTimeout:200,toolTipTimeout:200,treeButtonRadius:6,treeButtonPadding:3,fitViewPadding:10,updateDuration:450,enterDuration:450,leaveDuration:450,updateEasing:"easeOutQuart",enterEasing:"easeOutQuart",leaveEasing:"easeOutQuart",fontFamily:'"Helvetica Neue", Helvetica, "PingFang SC", "Hiragino Sans GB", "Microsoft YaHei", "\u5fae\u8f6f\u96c5\u9ed1", SimSun, "sans-serif"'}},function(t,e,n){var i=n(97);t.exports=i},function(t,e,n){"use strict";var i=n(7),r=n(4),a={addNode:function(t,e){var n=void 0,i=void 0,r=void 0,o=t.get("gridAssist"),s=o&&o.forceAlign;t._on(e,function(e){n=t.get("addingType"),i=t.get("addingModel"),"node"===n&&(i.x=e.x,i.y=e.y,s&&a.alignPoint(i,o.cell),r=t.addItem("node",i),t.clearAllActived(),t.setItemActived(r),t.updateRollback(),t.draw(!1),t.endAdd(r))})},onWheelZoom:function(t,e,n){var r=setTimeout(function(){},i.wheelZoomTimeout),a=1;t._on("wheelzoom",function(){clearTimeout(r),a&&(e(),a=0),r=setTimeout(function(){n(),a=1},i.wheelZoomTimeout)})},autoText:function(t){var e=t.getKeyShape(),n=t.getGroup(),i=r.getBBox(e,n.getParent().getParent().getParent()),a=i.maxX-i.minX;n.traverseChildren(function(t){if("text"===t.type&&t.get("freezePoint")){var e=t.getBBox(),n=e.maxX-e.minX;n>7/3*a?(t.hide(),t.set("autoTextHide",!0)):(t.set("autoTextHide",!1),t.show())}})},autoTexts:function(t){var e=t.getNodes();r.each(e,function(t){a.autoText(t)}),t.draw()},hideTexts:function(t){var e=t.get("rootGroup");e.traverseChildren(function(t){"text"===t.type&&t.hide()}),t.draw(!1)},showText:function(t){var e=t.getGroup();e.traverseChildren(function(t){"text"===t.type&&t.show()})},showTexts:function(t){var e=t.get("rootGroup");e.traverseChildren(function(t){"text"===t.type&&t.show()}),t.draw(!1)},alignPoint:function(t,e){t.x=Math.round(t.x/e)*e,t.y=Math.round(t.y/e)*e},getControlInfo:function(t,e,n,i,r){var a=t.x-n.x,o=t.y-n.y,s=i.getBBox(),u=i.getPosition(),c=void 0,h=void 0;switch("frontCanvas"===r&&(u=i.getCenter()),e){case 0:c=s.width-a,h=s.height-o;break;case 1:c=s.width+a,h=s.height-o;break;case 2:c=s.width+a,h=s.height+o;break;default:c=s.width-a,h=s.height+o}var l=[c,h];return{x:u.x+a/2,y:u.y+o/2,size:l}},dragEdgeExtremePoint:function(t,e,n,i){var r=t.get("behaviourSignal"),a=void 0,o=void 0,s=void 0,u=void 0,c=void 0,h=void 0,l=void 0;t._on("mousedown",function(t){o=t.shape,s=t.shape,u=e(t),c=n(t,u),!u||u.isSourcePoint(c)||u.isTargetPoint(c)||(u=void 0),u&&o&&o.hasClass("anchor-point")&&u.updateModel({controlPoints:[o.get("point"),o.get("point")],sourceAnchor:o.get("index")})}),t._on("dragmove",function(e){t.isEdge(u)&&(r.draggingEdge=!0,a=e.item,l={x:e.x,y:e.y,controlPointIndex:c},u.showDelegation(l),t.refreshFront())}),t.on("mouseup",function(e){t.isEdge(u)&&(a=e.item,o=e.shape,h={},r.draggingEdge&&(o&&"anchor-point"===o.get("class")?o.get("linkable")!==!1&&o!==s&&(u.isSourcePoint(c)?(h.source=a.get("id"),h.sourceAnchor=o.get("index")):u.isTargetPoint(c)&&(h.target=a.get("id"),h.targetAnchor=o.get("index"))):t.isNode(a)&&(u.isSourcePoint(c)?(h.source=a.get("id"),h.sourceAnchor=null):u.isTargetPoint(c)&&(h.target=a.get("id"),h.targetAnchor=null)),u.hideDelegation()),i(u,h),t.fire("dragedgeend",{edge:u,shape:o,item:a}),s=void 0,a=void 0,u=void 0,h=void 0,c=void 0,l=void 0,o=void 0,r.draggingEdge=void 0)})}};t.exports=a},function(t,e,n){var i=n(99),r=n(43);i.G=r,i.Group=r.Group,i.Shape={},i.Shape.Marker=r.Marker,i.Util=n(59),i.Matrix=n(3),t.exports=i},function(t,e,n){var i=n(92);t.exports=i},function(t,e,n){function i(t,e,n){var i=new s(1,0).angleTo(t),r=i-u,a=i+u,o=6+3*n;return[{x:e.x-o*Math.cos(r),y:e.y-o*Math.sin(r)},e,{x:e.x-o*Math.cos(a),y:e.y-o*Math.sin(a)}]}function r(t,e){t.moveTo(e[0].x,e[0].y),t.lineTo(e[1].x,e[1].y),t.lineTo(e[2].x,e[2].y)}function a(t,e,n,a){r(t,i(e,n,a))}function o(t,e,n){var i=n/Math.sin(u);return t.setLength(i/2),e.sub(t),e}var s=n(3).Vector2,u=Math.PI/6;t.exports={makeArrow:a,getEndPoint:o}},function(t,e,n){"use strict";var i=n(123);n(120),n(122),i.Mapper=n(62),i.Item=n(61),i.Shape=n(63),i.Util=n(4),i.Global=n(7),i.Handler=n(2),i.IdGroup=n(26),i.SortGroup=n(60),i.HtmlShape=n(121),i.registNode=i.Shape.registNode,i.registEdge=i.Shape.registEdge,t.exports=i},function(t,e,n){"use strict";function i(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var r=n(33),a=n(1),o=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};i(this,t);var n=this;n.options=e,a.isFunction(e.callback)||(n.options.callback=function(){})}return t.prototype._prepareRoot=function(){var t=this;t.rootNode=new r(t.root,t.options)},t.prototype.execute=function(){throw new Error("please override this method")},t.prototype.getNodes=function(){var t=this,e=t.execute();e.translate(-(e.x+e.width/2+e.hgap),-(e.y+e.height/2+e.vgap));var n=[];return e.eachNode(function(t){n.push(t.data)}),n},t.prototype.getEdges=function(){var t=this,e=t.options,n=e.extraEdges,i=this.rootNode,r=[];return i.eachNode(function(t){t.children.forEach(function(e){r.push({id:t.id+"-"+e.id,source:t.id,target:e.id})})}),r.concat(n),r},t}();t.exports=o},function(t,e,n){"use strict";function i(t,e){if(a.isNumeric(t)&&a.isNumeric(e))return o.number(t,e);if(a.isString(t)&&a.isString(e)){var n=new u(t),i=new u(e);if(n.getType()&&i.getType())return s.color(n,i)}}function r(t,e){if(a.isNumeric(t)&&a.isNumeric(e))return o.unNumber(t,e);if(a.isString(t)&&a.isString(e)){var n=new u(t),i=new u(e);if(n.getType()&&i.getType())return s.unColor(n,i)}}var a=n(1),o=n(82),s=n(79),u=n(16);t.exports={singular:i,unSingular:r}},function(t,e,n){t.exports=n(85)},function(t,e,n){function i(t,e,n,i,r){var a=1-r;return a*a*(a*i+3*r*n)+r*r*(r*t+3*a*e)}function r(t,e,n,i,r){var a=1-r;return 3*(((e-t)*a+2*(n-e)*r)*a+(i-n)*r*r)}function a(t,e,n,r,a,o,s,u,h,l,d){var f,g,p,v,x,m,y,b,w=.005,_=1/0,M=1e-4,S=new c(h,l);for(g=0;g<1;g+=.05)p=new c(i(t,n,a,s,g),i(e,r,o,u,g)),v=p.distanceToSquared(S),v<_&&(f=g,_=v);_=1/0;for(var A=0;A<32&&!(w<M);A++)y=f-w,b=f+w,p=new c(i(t,n,a,s,y),i(e,r,o,u,y)),v=p.distanceToSquared(S),y>=0&&v<_?(f=y,_=v):(m=new c(i(t,n,a,s,b),i(e,r,o,u,b)),x=m.distanceToSquared(S),b<=1&&x<_?(f=b,_=x):w*=.5);return d&&(d.x=i(t,n,a,s,f),d.y=i(e,r,o,u,f)),Math.sqrt(_)}function o(t,e,n,i){var r,a,o,s=3*t-9*e+9*n-3*i,u=6*e-12*n+6*i,c=3*n-3*i,l=[];if(h.equal(s,0))h.equal(u,0)||(r=-c/u,r>=0&&r<=1&&l.push(r));else{var d=u*u-4*s*c;h.equal(d,0)?l.push(-u/(2*s)):d>0&&(o=Math.sqrt(d),r=(-u+o)/(2*s),a=(-u-o)/(2*s),r>=0&&r<=1&&l.push(r),a>=0&&a<=1&&l.push(a))}return l}function s(t,e,n,i,r){var a=-3*e+9*n-9*i+3*r,o=t*a+6*e-12*n+6*i;return t*o-3*e+3*n}function u(t,e,n,i,r,a,o,u,c){l.isNull(c)&&(c=1),c=c>1?1:c<0?0:c;for(var h=c/2,d=12,f=[-.1252,.1252,-.3678,.3678,-.5873,.5873,-.7699,.7699,-.9041,.9041,-.9816,.9816],g=[.2491,.2491,.2335,.2335,.2032,.2032,.1601,.1601,.1069,.1069,.0472,.0472],p=0,v=0;v<d;v++){var x=h*f[v]+h,m=s(x,t,n,r,o),y=s(x,e,i,a,u),b=m*m+y*y;p+=g[v]*Math.sqrt(b)}return h*p}var c=n(3).Vector2,h=n(8),l=n(1);t.exports={at:i,derivativeAt:r,projectPoint:function(t,e,n,i,r,o,s,u,c,h){var l={};return a(t,e,n,i,r,o,s,u,c,h,l),l},pointDistance:a,extrema:o,len:u}},function(t,e,n){"use strict";function i(t){var e=[];return r.each(t,function(t){e.push(t.x),e.push(t.y)}),e}var r=n(1),a=n(98),o={};r.mix(o,{pathToArray:a.toArray,pathToString:a.toString,pathToCurve:a.toCurve,pathToAbsolute:a.toAbsolute,pathCatmullRomToBezier:a.catmullRomToBezier,getRectPath:a.rectPath,pathIntersection:a.intersection,getEllipsePath:function(t,e,n,i){var r=[["M",t,e-i],["a",n,i,0,1,1,0,2*i],["a",n,i,0,1,1,0,-2*i],["z"]];return r},pointsToPolygon:function(t,e){if(!t.length)return"";for(var n="",i="",a=0,o=t.length;a<o;a++){var s=t[a];i=0===a?"M{x} {y}":"L{x} {y}",n+=r.substitute(i,s)}return e&&(n+="Z"),n},pointsToCurve:function(t){t=i(t);var e=o.pathCatmullRomToBezier(t);return e.unshift(["M",t[0],t[1]]),e},getWaterPositions:function(t,e,n,i){return 0===e?[[t+.5*n/Math.PI/2,i/2],[t+.5*n/Math.PI,i],[t+n/4,i]]:1===e?[[t+.5*n/Math.PI/2*(Math.PI-2),i],[t+.5*n/Math.PI/2*(Math.PI-1),i/2],[t+n/4,0]]:2===e?[[t+.5*n/Math.PI/2,-i/2],[t+.5*n/Math.PI,-i],[t+n/4,-i]]:[[t+.5*n/Math.PI/2*(Math.PI-2),-i],[t+.5*n/Math.PI/2*(Math.PI-1),-i/2],[t+n/4,0]]},getWaterPath:function(t,e,n,i,r,a,s){for(var u=2*Math.ceil(2*t/n*4),c=[];i<2*-Math.PI;)i+=2*Math.PI;for(;i>0;)i-=2*Math.PI;i=i/Math.PI/2*n;var h=a-t+i-2*t;c.push(["M",h,e]);for(var l=0,d=0;d<u;++d){var f=d%4,g=o.getWaterPositions(d*n/4,f,n,r);c.push(["C",g[0][0]+h,-g[0][1]+e,g[1][0]+h,-g[1][1]+e,g[2][0]+h,-g[2][1]+e]),d===u-1&&(l=g[2][0])}return c.push(["L",l+h,s+t]),c.push(["L",h,s+t]),c.push(["L",h,e]),c}}),t.exports=o},function(t,e,n){"use strict";var i=n(2),r=function(t,e,n,i){var r=t.get("rootGroup"),a=void 0,o=void 0,s=void 0,u=void 0,c=void 0;t._on("mousedown",function(t){e&&(t.shape||t.frontEvObj.shape)||(a={x:t.domX,y:t.domY},o=r.getMatrix())}),t._on("dragmove",function(e){a&&(u=e.domX-a.x,c=e.domY-a.y,s=o.clone(),n===!1&&(u=0),i===!1&&(c=0),s.translate(u,c),t.updateMatrix(s),t.setCapture(!1),t.draw(!1))}),t._on("dommouseleave",function(){t.setCapture(!0),a=void 0,o=void 0,u=void 0,c=void 0,s=void 0}),t._on("mouseup",function(){t.setCapture(!0),a=void 0,o=void 0,u=void 0,c=void 0,s=void 0})};i.dragCanvas=r,t.exports=r},function(t,e,n){"use strict";var i=(n(1),"\t\n\v\f\r \xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029"),r=new RegExp("([a-z])["+i+",]*((-?\\d*\\.?\\d*(?:e[\\-+]?\\d+)?["+i+"]*,?["+i+"]*)+)","ig"),a=new RegExp("(-?\\d*\\.?\\d*(?:e[\\-+]?\\d+)?)["+i+"]*,?["+i+"]*","ig"),o=function(t){if(!t)return null;if(typeof t==typeof[])return t;var e={a:7,c:6,o:2,h:1,l:2,m:2,r:4,q:4,s:4,t:2,v:1,u:3,z:0},n=[];return String(t).replace(r,function(t,i,r){var o=[],s=i.toLowerCase();if(r.replace(a,function(t,e){e&&o.push(+e)}),"m"==s&&o.length>2&&(n.push([i].concat(o.splice(0,2))),s="l",i="m"==i?"l":"L"),"o"==s&&1==o.length&&n.push([i,o[0]]),"r"==s)n.push([i].concat(o));else for(;o.length>=e[s]&&(n.push([i].concat(o.splice(0,e[s]))),e[s]););}),n},s=function(t,e){for(var n=[],i=0,r=t.length;r-2*!e>i;i+=2){var a=[{x:+t[i-2],y:+t[i-1]},{x:+t[i],y:+t[i+1]},{x:+t[i+2],y:+t[i+3]},{x:+t[i+4],y:+t[i+5]}];e?i?r-4==i?a[3]={x:+t[0],y:+t[1]}:r-2==i&&(a[2]={x:+t[0],y:+t[1]},a[3]={x:+t[2],y:+t[3]}):a[0]={x:+t[r-2],y:+t[r-1]}:r-4==i?a[3]=a[2]:i||(a[0]={x:+t[i],y:+t[i+1]}),n.push(["C",(-a[0].x+6*a[1].x+a[2].x)/6,(-a[0].y+6*a[1].y+a[2].y)/6,(a[1].x+6*a[2].x-a[3].x)/6,(a[1].y+6*a[2].y-a[3].y)/6,a[2].x,a[2].y])}return n},u=function(t,e,n,i,r){if(null==r&&null==i&&(i=n),t=+t,e=+e,n=+n,i=+i,null!=r)var a=Math.PI/180,o=t+n*Math.cos(-i*a),s=t+n*Math.cos(-r*a),u=e+n*Math.sin(-i*a),c=e+n*Math.sin(-r*a),h=[["M",o,u],["A",n,n,0,+(r-i>180),0,s,c]];else h=[["M",t,e],["m",0,-i],["a",n,i,0,1,1,0,2*i],["a",n,i,0,1,1,0,-2*i],["z"]];return h},c=function(t){if(t=o(t),!t||!t.length)return[["M",0,0]];var e,n=[],i=0,r=0,a=0,c=0,h=0;"M"==t[0][0]&&(i=+t[0][1],r=+t[0][2],a=i,c=r,h++,n[0]=["M",i,r]);for(var l,d,f=3==t.length&&"M"==t[0][0]&&"R"==t[1][0].toUpperCase()&&"Z"==t[2][0].toUpperCase(),g=h,p=t.length;g<p;g++){if(n.push(l=[]),d=t[g],e=d[0],e!=e.toUpperCase())switch(l[0]=e.toUpperCase(),l[0]){case"A":l[1]=d[1],l[2]=d[2],l[3]=d[3],l[4]=d[4],l[5]=d[5],l[6]=+d[6]+i,l[7]=+d[7]+r;break;case"V":l[1]=+d[1]+r;break;case"H":l[1]=+d[1]+i;break;case"R":for(var v=[i,r].concat(d.slice(1)),x=2,m=v.length;x<m;x++)v[x]=+v[x]+i,v[++x]=+v[x]+r;n.pop(),n=n.concat(s(v,f));break;case"O":n.pop(),v=u(i,r,d[1],d[2]),v.push(v[0]),n=n.concat(v);break;case"U":n.pop(),n=n.concat(u(i,r,d[1],d[2],d[3])),l=["U"].concat(n[n.length-1].slice(-2));break;case"M":a=+d[1]+i,c=+d[2]+r;default:for(x=1,m=d.length;x<m;x++)l[x]=+d[x]+(x%2?i:r)}else if("R"==e)v=[i,r].concat(d.slice(1)),n.pop(),n=n.concat(s(v,f)),l=["R"].concat(d.slice(-2));else if("O"==e)n.pop(),v=u(i,r,d[1],d[2]),v.push(v[0]),n=n.concat(v);else if("U"==e)n.pop(),n=n.concat(u(i,r,d[1],d[2],d[3])),l=["U"].concat(n[n.length-1].slice(-2));else for(var y=0,b=d.length;y<b;y++)l[y]=d[y];if(e=e.toUpperCase(),"O"!=e)switch(l[0]){case"Z":i=+a,r=+c;break;case"H":i=l[1];break;case"V":r=l[1];break;case"M":a=l[l.length-2],c=l[l.length-1];default:i=l[l.length-2],r=l[l.length-1]}}return n},h=function(t,e,n,i){return[t,e,n,i,n,i]},l=function(t,e,n,i,r,a){var o=1/3,s=2/3;return[o*t+s*n,o*e+s*i,o*r+s*n,o*a+s*i,r,a]},d=function(t,e,n,i,r,a,o,s,u,c){n===i&&(n+=1);var h,l=120*Math.PI/180,f=Math.PI/180*(+r||0),g=[],p=function(t,e,n){var i=t*Math.cos(n)-e*Math.sin(n),r=t*Math.sin(n)+e*Math.cos(n);return{x:i,y:r}};if(c)S=c[0],A=c[1],_=c[2],M=c[3];else{h=p(t,e,-f),t=h.x,e=h.y,h=p(s,u,-f),s=h.x,u=h.y,t===s&&e===u&&(s+=1,u+=1);var v=(Math.cos(Math.PI/180*r),Math.sin(Math.PI/180*r),(t-s)/2),x=(e-u)/2,m=v*v/(n*n)+x*x/(i*i);m>1&&(m=Math.sqrt(m),n*=m,i*=m);var y=n*n,b=i*i,w=(a==o?-1:1)*Math.sqrt(Math.abs((y*b-y*x*x-b*v*v)/(y*x*x+b*v*v))),_=w*n*x/i+(t+s)/2,M=w*-i*v/n+(e+u)/2,S=Math.asin(((e-M)/i).toFixed(9)),A=Math.asin(((u-M)/i).toFixed(9));S=t<_?Math.PI-S:S,A=s<_?Math.PI-A:A,S<0&&(S=2*Math.PI+S),A<0&&(A=2*Math.PI+A),o&&S>A&&(S-=2*Math.PI),!o&&A>S&&(A-=2*Math.PI)}var P=A-S;if(Math.abs(P)>l){var T=A,C=s,I=u;A=S+l*(o&&A>S?1:-1),s=_+n*Math.cos(A),u=M+i*Math.sin(A),g=d(s,u,n,i,r,0,o,C,I,[A,T,_,M])}P=A-S;var k=Math.cos(S),B=Math.sin(S),E=Math.cos(A),O=Math.sin(A),F=Math.tan(P/4),z=4/3*n*F,R=4/3*i*F,N=[t,e],G=[t+z*B,e-R*k],D=[s+z*O,u-R*E],X=[s,u];if(G[0]=2*N[0]-G[0],G[1]=2*N[1]-G[1],c)return[G,D,X].concat(g);g=[G,D,X].concat(g).join().split(",");for(var Y=[],L=0,j=g.length;L<j;L++)Y[L]=L%2?p(g[L-1],g[L],f).y:p(g[L],g[L+1],f).x;return Y},f=function(t,e){for(var n=c(t),i=e&&c(e),r={x:0,y:0,bx:0,by:0,X:0,Y:0,qx:null,qy:null},a={x:0,y:0,bx:0,by:0,X:0,Y:0,qx:null,qy:null},o=(function(t,e,n){var i,r;if(!t)return["C",e.x,e.y,e.x,e.y,e.x,e.y];switch(!(t[0]in{T:1,Q:1})&&(e.qx=e.qy=null),t[0]){case"M":e.X=t[1],e.Y=t[2];break;case"A":t=["C"].concat(d.apply(0,[e.x,e.y].concat(t.slice(1))));break;case"S":"C"==n||"S"==n?(i=2*e.x-e.bx,r=2*e.y-e.by):(i=e.x,r=e.y),t=["C",i,r].concat(t.slice(1));break;case"T":"Q"==n||"T"==n?(e.qx=2*e.x-e.qx,e.qy=2*e.y-e.qy):(e.qx=e.x,e.qy=e.y),t=["C"].concat(l(e.x,e.y,e.qx,e.qy,t[1],t[2]));break;case"Q":e.qx=t[1],e.qy=t[2],t=["C"].concat(l(e.x,e.y,t[1],t[2],t[3],t[4]));break;case"L":t=["C"].concat(h(e.x,e.y,t[1],t[2]));break;case"H":t=["C"].concat(h(e.x,e.y,t[1],e.y));break;case"V":t=["C"].concat(h(e.x,e.y,e.x,t[1]));break;case"Z":t=["C"].concat(h(e.x,e.y,e.X,e.Y))}return t}),s=function(t,e){if(t[e].length>7){t[e].shift();for(var r=t[e];r.length;)f[e]="A",i&&(g[e]="A"),t.splice(e++,0,["C"].concat(r.splice(0,6)));t.splice(e,1),m=Math.max(n.length,i&&i.length||0)}},u=function(t,e,r,a,o){t&&e&&"M"==t[o][0]&&"M"!=e[o][0]&&(e.splice(o,0,["M",a.x,a.y]),r.bx=0,r.by=0,r.x=t[o][1],r.y=t[o][2],m=Math.max(n.length,i&&i.length||0))},f=[],g=[],p="",v="",x=0,m=Math.max(n.length,i&&i.length||0);x<m;x++){n[x]&&(p=n[x][0]),"C"!=p&&(f[x]=p,x&&(v=f[x-1])),n[x]=o(n[x],r,v),"A"!=f[x]&&"C"==p&&(f[x]="C"),s(n,x),i&&(i[x]&&(p=i[x][0]),"C"!=p&&(g[x]=p,x&&(v=g[x-1])),i[x]=o(i[x],a,v),"A"!=g[x]&&"C"==p&&(g[x]="C"),s(i,x)),u(n,i,r,a,x),u(i,n,a,r,x);var y=n[x],b=i&&i[x],w=y.length,_=i&&b.length;r.x=y[w-2],r.y=y[w-1],r.bx=parseFloat(y[w-4])||r.x,r.by=parseFloat(y[w-3])||r.y,a.bx=i&&(parseFloat(b[_-4])||a.x),a.by=i&&(parseFloat(b[_-3])||a.y),a.x=i&&b[_-2],a.y=i&&b[_-1]}return i?[n,i]:n},g=/,?([a-z]),?/gi,p=function(t){return t.join(",").replace(g,"$1")},v={toArray:o,toString:p,toCurve:f,toAbsolute:c,catmullRomToBezier:s};t.exports=v},function(t,e,n){function i(t,e,n,i){return{x:Math.cos(i)*n+t,y:Math.sin(i)*n+e}}function r(t,e,n,i){var r,a;return i?t<e?(r=e-t,a=2*Math.PI-n+t):t>n&&(r=2*Math.PI-t+e,a=t-n):(r=t-e,a=n-t),r>a?n:e}function a(t,e,n,i){var a=0;return n-e>=2*Math.PI&&(a=2*Math.PI),e=c.mod(e,2*Math.PI),n=c.mod(n,2*Math.PI)+a,t=c.mod(t,2*Math.PI),i?e>=n?t>n&&t<e?t:r(t,n,e,!0):t<e||t>n?t:r(t,e,n):e<=n?e<t&&t<n?t:r(t,e,n,!0):t>e||t<n?t:r(t,n,e)}function o(t,e,n,i,r,o,s,c,h){var l=new u(s,c),d=new u(t,e),f=new u(1,0),g=u.sub(l,d),p=f.angleTo(g);p=a(p,i,r,o);var v=new u(n*Math.cos(p)+t,n*Math.sin(p)+e);h&&(h.x=v.x,h.y=v.y);var x=l.distanceTo(v);return x}function s(t,e,n,r,o,s){var u=0,c=Math.PI/2,l=Math.PI,d=3*Math.PI/2,f=[],g=a(u,r,o,s);g===u&&f.push(i(t,e,n,u)),g=a(c,r,o,s),g===c&&f.push(i(t,e,n,c)),g=a(l,r,o,s),g===l&&f.push(i(t,e,n,l)),g=a(d,r,o,s),g===d&&f.push(i(t,e,n,d)),f.push(i(t,e,n,r)),f.push(i(t,e,n,o));var p=1/0,v=-(1/0),x=1/0,m=-(1/0);return h.each(f,function(t){p>t.x&&(p=t.x),v<t.x&&(v=t.x),x>t.y&&(x=t.y),m<t.y&&(m=t.y)}),{minX:p,minY:x,maxX:v,maxY:m}}var u=n(3).Vector2,c=n(8),h=n(1);t.exports={nearAngle:a,projectPoint:function(t,e,n,i,r,a,s,u){var c={};return o(t,e,n,i,r,a,s,u,c),c},pointDistance:o,box:s}},function(t,e,n){var i=n(3).Vector2;t.exports={at:function(t,e,n){return(e-t)*n+t},pointDistance:function(t,e,n,r,a,o){var s=new i(n-t,r-e);if(s.isZero())return NaN;var u=s.vertical();u.normalize();var c=new i(a-t,o-e);return Math.abs(c.dot(u))},box:function(t,e,n,i,r){var a=r/2,o=Math.min(t,n),s=Math.max(t,n),u=Math.min(e,i),c=Math.max(e,i);return{minX:o-a,minY:u-a,maxX:s+a,maxY:c+a}},len:function(t,e,n,i){return Math.sqrt((n-t)*(n-t)+(i-e)*(i-e))}}},function(t,e,n){function i(t,e,n,i){var r=1-i;return r*(r*t+2*i*e)+i*i*n}function r(t,e,n,r,a,s,u,c,h){var l,d,f,g,p,v,x,m=.005,y=1/0,b=1e-4,w=new o(u,c);for(p=0;p<1;p+=.05)f=new o(i(t,n,a,p),i(e,r,s,p)),d=f.distanceToSquared(w),d<y&&(l=p,y=d);for(y=1/0,x=0;x<32&&!(m<b);x++){var _=l-m,M=l+m;f=new o(i(t,n,a,_),i(e,r,s,_)),d=f.distanceToSquared(w),_>=0&&d<y?(l=_,y=d):(g=new o(i(t,n,a,M),i(e,r,s,M)),v=g.distanceToSquared(w),M<=1&&v<y?(l=M,y=v):m*=.5)}return h&&(h.x=i(t,n,a,l),h.y=i(e,r,s,l)),Math.sqrt(y)}function a(t,e,n){var i=t+n-2*e;if(s.equal(i,0))return[.5];var r=(t-e)/i;return r<=1&&r>=0?[r]:[]}var o=n(3).Vector2,s=n(8);t.exports={at:i,projectPoint:function(t,e,n,i,a,o,s,u){var c={};return r(t,e,n,i,a,o,s,u,c),c},pointDistance:r,extrema:a}},function(t,e,n){"use strict";t.exports={centerScaleIn:n(111),centerScaleOut:n(112),update:n(113),Util:n(25)}},function(t,e,n){"use strict";var i=n(7),r={scaleIn:function(t,e,n,r,a){r=r?r:e,a=a?a:n,t.transform([["t",-r,-a],["s",.01,.01],["t",e,n]]),setTimeout(function(){t&&!t.get("destroyed")&&t.animate({transform:[["t",-e,-n],["s",100,100],["t",r,a]]},i.enterDuration,i.enterEasing)},16)},scaleOut:function(t,e,n){t.animate({transform:[["t",-e,-n],["s",.01,.01],["t",e,n]]},i.leaveDuration,i.leaveEasing,function(){t.remove()})}};t.exports=r},function(t,e,n){"use strict";var i=n(1),r=n(10).G,a=r.Group,o=function t(e){t.superclass.constructor.call(this,e)};i.extend(o,a),i.augment(o,{init:function(){o.superclass.init.call(this),this.set("gid",this.get("id"))},addShape:function(t,e){var n=this.get("id"),i=o.superclass.addShape.call(this,t,e);return i.set("id",n),i.set("gid",n+"-"+this.get("children").length),i},addGroup:function(t,e){var n=this.get("id"),i=o.superclass.addGroup.call(this,t,e);return i.set("id",n),i.set("gid",n+this.get("children").length),i}}),t.exports=o},function(t,e,n){"use strict";var i=n(11),r=n(4),a=n(128),o=n(28),s=n(63),u=n(7),c=n(24),h=function t(e){t.superclass.constructor.call(this,e),this._init()};h.ATTRS={id:"",type:null,model:{},mapper:null,group:null,controlGroup:null,keyShape:null,class:null,drawFrameObj:{},enterAnimate:c.centerScaleIn,leaveAnimate:c.centerScaleOut},r.extend(h,i),r.mixin(h,[a,o]),r.augment(h,{_init:function(){var t=this,e=t.get("type"),n=s.getShape(e);this.set("shapeManger",n)},_calculateBBox:function(){var t=this,e=t.getKeyShape(),n=e.get("parent"),i=r.getBBox(e,n);return this.set("boxStash",i),i},_setAnimate:function(){var t=this.get("group"),e=this.getShapeObj(),n=this.get("graph"),i=this.get("enterAnimate"),a=this.get("leaveAnimate");if(n){var o=r.mix(!0,{},{enterAnimate:i,leaveAnimate:a},{enterAnimate:n.enterAnimate,leaveAnimate:n.leaveAnimate},{enterAnimate:e.enterAnimate,leaveAnimate:e.leaveAnimate});t.set("enterAnimate",o.enterAnimate),t.set("leaveAnimate",o.leaveAnimate)}},hideControlPoints:function(){var t=this.get("controlGroup");t&&t.remove()},showControlPoints:function(){var t=this,e=t.getControlPoints(),n=t.get("type"),i=u[n+"ControlPointStyle"],a=t.get("controlPointRootGroup"),o=t.get("controlGroup");if(o&&o.remove(!0),o=a.addGroup({zIndex:u.zIndex.controlPoint,id:t.get("id")}),t.set("controlGroup",o),i){var s=i.r?i.r:5;r.each(e,function(e,n){o.addShape("rect",{class:"control-point",freezePoint:e,pointIndex:n,point:e,item:t,attrs:r.mix({},i,{x:e.x-s,y:e.y-s,width:2*s,height:2*s})})})}},isVisible:function(){var t=this.getGroup();return t.get("visible")},_show:function(){var t=this.get("group");t.show()},_hide:function(){var t=this.get("group");t.hide(),this.clearActived()},getLabelShape:function(){var t=this.get("group");return t.findBy(function(t){return t.hasClass("label")})},getType:function(){return this.get("type")},getBBox:function(){var t=this.get("boxStash");return t||this._calculateBBox()},getGroup:function(){return this.get("group")},getKeyShape:function(){var t=this,e=t.get("group"),n=e.get("children"),i=t.get("keyShape");return i||n[0]},getShapeObj:function(){return this.get("shapeObj")},getShapeCfg:function(){return this.get("group").get("shapeCfg")},update:function(t){var e=this.get("group");e.clear(t),this.draw()},draw:function(){var t=this,e=t.get("model"),n=t.get("mapper"),i=n.mapping(e),a=t.get("group"),o=t.get("shapeManger"),s=void 0,u=void 0,c=void 0;if(a.set("shapeCfg",i),t.beforeDraw(),s=i.shape,r.isArray(i.shape)&&(s=i.shape[0]),s&&s.startsWith&&s.startsWith("http")){if(!i.size)return u=new Image,c=t.getCanvas(),u.src=i.shape,void(u.onload=function(){return!(!t||t.get("destroyed"))&&(e.size=[u.width,u.height],t.draw(),void c.draw())});s="image"}var h=o.draw(s,i,a);t.set("shapeObj",o.getShape(s)),t.set("keyShape",h),a.set("keyShape",h),t._setAnimate(),t.afterDraw()},getCanvas:function(){var t=this.get("group").get("canvas");return t},beforeDraw:function(){},afterDraw:function(){var t=this.get("graph"),e=this.get("actived");e&&this.setActiveStatus(e),t.fire("afteritemrender",{item:this})},destroyItem:function(){},destroy:function(t){var e=this.get("group"),n=this.get("controlGroup"),i=this.get("delegateEl");e&&e.remove(t),n&&n.remove(),i&&i.remove(),this.destroyItem(),h.superclass.destroy.call(this)},setActiveStatus:function(t,e,n){if(!this.destroyed){var i=this.getShapeObj();i&&r.isFunction(i.setActived)?i.setActived(this,t):t?(this.showControlPoints(),e&&e()):(this.hideControlPoints(),n&&n())}},showDelegation:function(t){var e=this.getDelegationPath(t),n=this.get("delegateEl"),i=t.stroke,a=this.get("delegaRootGroup"),o=this.get("type"),s=r.mix(!0,{},u[o+"DelegationStyle"],{path:e,stroke:i});n?n.attr(s):(n=a.addShape("path",{attrs:s,capture:!1,zIndex:u.zIndex.delegate}),this.set("delegateEl",n))},getModel:function(){return this.get("model")},updateModel:function(t){var e=this.getModel();r.mix(e,t)},getControlPoints:function(){},getDelegationPath:function(){},hideDelegation:function(){var t=this.get("delegateEl");t&&t.remove(),this.set("delegateEl",null)},style:function(t){var e=this.get("group");r.traverseTree(e,function(e){e.attr(t)})}}),t.exports=h},function(t,e,n){"use strict";var i=n(1),r=function(){};i.augment(r,{hasClass:function(t){var e=this.get("class");return!(!e||e.indexOf(t)===-1)}}),t.exports=r},function(t,e,n){"use strict";function i(t,e,n){return n?t.getShape(n):t.getShape(e)}var r=n(1),a={},o={defaultShapeType:null,getShape:function(t){var e=this,n=e[t]||e[e.defaultShapeType]||a.ShapeBase;return n},draw:function(t,e,n){var i=this.getShape(t),a=i.style(e);a&&(r.isObject(e.style)?e.style=r.mix({},a,e.style):e.style=a);var o=i.draw(e,n);return i.afterDraw(e,n,o),o}},s={afterDraw:function(){},draw:function(){},style:function(){}};a.registGeom=function(t,e){var n=r.ucfirst(t),i=r.mix({},o,e);return a[n]=i,i.className=n,i},a.registNode=function(t,e,n){var o=a.Node,s=i(o,t,n),u=r.mix({},s,e);return o[t]=u,u},a.registEdge=function(t,e,n){var o=a.Edge,s=i(o,t,n),u=r.mix({},s,e);return o[t]=u,u},a.getShape=function(t){var e=this;return t=r.ucfirst(t),e[t]||a.ShapeBase},a.GeomShape=o,a.ShapeBase=s,t.exports=a},function(t,e,n){"use strict";var i=n(1),r={};i.mix(r,{traverseTree:function(t,e){var n=t.get("children");i.each(n,function(n){e(n,t),n.get("children")&&i.traverseTree(n,e)})},isNode:function(t){return t&&i.isObject(t)&&"node"===t.get("type")},isEdge:function(t){return t&&i.isObject(t)&&"edge"===t.get("type")},objectToValues:function(t){var e=[],n=void 0;for(n in t)t.hasOwnProperty(n)&&e.push(t[n]);return e},frameDraw:function(t){function e(){t.animateHandler=i.requestAnimationFrame(function(){try{t.callback()}catch(t){console.warn(t)}t.animateHandler=void 0})}void 0===t.animateHandler&&e()},drawLabel:function(t,e,n){return t.addShape("text",{attrs:e,class:"label",zIndex:n,freezePoint:{x:e.x,y:e.y}})},getNineBoxPosition:function(t,e,n,i,r){var a={};switch(t){case"tl":a.y=r[0],a.x=r[3];break;case"lc":a.y=(e.height-i)/2,a.x=r[3];break;case"bl":a.y=e.height-i-r[2],a.x=r[3];break;case"cc":a.y=(e.height-i)/2,a.x=(e.width-n)/2;break;case"tc":a.y=r[0],a.x=(e.width-n)/2;break;case"tr":a.y=r[0],a.x=e.width-n-r[1];break;case"rc":a.y=(e.height-i)/2,a.x=e.width-n-r[1];break;case"br":a.y=e.height-i-r[2],a.x=e.width-n-r[1];break;case"bc":a.y=e.height-i-r[2],a.x=(e.width-n)/2;break;default:a.y=e.minX+r[0],a.x=e.minY+r[3]}return a.x+=e.x,a.y+=e.y,a}}),t.exports=r},function(t,e,n){"use strict";var i=n(1),r=n(8),a=n(3),o=a.Vector2,s=a.Vector3,u=2,c=.001;i.mix(r,{getpointInRectQuadrant:function(t,e){var n=new o(t.maxX-t.minX,t.minY-t.maxY),i=new o(t.maxX-t.minX,t.maxY-t.minY),a=new o(t.minX-t.maxX,t.maxY-t.minY),s=new o(t.minX-t.maxX,t.minY-t.maxY),u=new o(e.x-(t.minX+t.maxX)/2,e.y-(t.minY+t.maxY)/2);return r.getVectorAngle(u,i)<r.getVectorAngle(a,i)?2:r.getVectorAngle(u,n)<r.getVectorAngle(i,n)?1:r.getVectorAngle(u,s)<r.getVectorAngle(n,s)?0:r.getVectorAngle(u,a)<r.getVectorAngle(s,a)?3:void 0},getVectorAngle:function(t,e){var n=t.angleTo(e,!0);return n},isBetween:function(t,e,n){return t>=e&&t<=n},applyPoints:function(t,e,n){var a=[];return i.each(t,function(t){a.push(r.applyPoint(t,e,n))}),a},applyPoint:function(t,e,n){var i=new s(t.x,t.y,1);return e.apply(i,n),t.x=i.x,t.y=i.y,t},getBBox:function(t,e){e=e?e:t;var n=t.getBBox(),i=r.applyPoint({x:n.minX,y:n.minY},t,e),a=r.applyPoint({x:n.maxX,y:n.maxY},t,e),o=i.x,s=i.y,u=a.x,c=a.y,h={minX:o,minY:s,x:o,y:s,maxX:u,maxY:c,centerX:(u+o)/2,centerY:(c+s)/2,width:u-o,height:c-s};return h},radixSort:function(t,e){var n=10,i=1,r=[],a=1,o=void 0,s=void 0,u=void 0,c=void 0,h=void 0,l=void 0,d=void 0;for(u=0;u<t.length;u++)o=e(t[u]),o=parseInt(o,10),s=o.toString().length,o.toString().length>a&&(a=s);for(u=0;u<a;u++,i*=10,n*=10){for(c=0;c<t.length;c++)h=e(t[c]),h=parseInt(h%n/i,10),void 0===r[h]&&(r[h]=[]),r[h].push(t[c]);for(l=0,c=0;c<r.length;c++)if(d=void 0,void 0!==r[c])for(d=r[c].shift();void 0!==d;)t[l++]=d,d=r[c].shift()}return t},scaleMatrix:function(t,e,n){e&&n.translate(-e.x,-e.y),n.scale(t,t),e&&n.translate(e.x,e.y)},invertPoint:function(t,e,n){return e=e.getInverse(),r.converPoint(t,e,n)},converPoint:function(t,e,n){void 0===n&&(n=1);var i=new s(t.x,t.y,n);return i.applyMatrix(e),{x:i.x,y:i.y}},getRectIntersect:function(t,e){var n=t.x,i=t.y,a=t.width,o=t.height,s=n+a/2,u=i+o/2,c=[],h={x:s,y:u};c.push({x:n,y:i}),c.push({x:n+a,y:i}),c.push({x:n+a,y:i+o}),c.push({x:n,y:i+o}),c.push({x:n,
                y:i});for(var l=null,d=1;d<c.length&&!(l=r.getLineIntersect(c[d-1],c[d],h,e));d++);return l},getLineIntersect:function(t,e,n,i){var a=r.vector(t,n),o=r.vector(t,e),s=r.vector(n,i),u=o.x*s.y-o.y*s.x,h=u*u,l=o.x*o.x+o.y*o.y,d=s.x*s.x+s.y*s.y,f=null;if(h>c*l*d){var g=(a.x*s.y-a.y*s.x)/u,p=(a.x*o.y-a.y*o.x)/u;r.isBetween(g,0,1)&&r.isBetween(p,0,1)&&(f={x:t.x+g*o.x,y:t.y+g*o.y})}return f},getSnapPoint:function(t,e){for(var n=r.distance(t[0],e,!1),i=t[0],a=1;a<t.length;a++){var o=t[a],s=r.distance(o,e,!1);s<n&&(i=o,n=s)}return i},distance:function(t,e,n){var i=(e.x-t.x)*(e.x-t.x)+(e.y-t.y)*(e.y-t.y);return n===!1?i:Math.sqrt(i)},isInRect:function(t,e,n,i,r){return t.x<i&&t.x>e&&t.y<r&&t.y>n},isInSegment:function(t,e,n){if(!t||!e||!n)return!1;var i=r.segmentDistance(t,e,n);return i!==1/0&&i<u},segmentDistance:function(t,e,n){var i=r.vector(t,n),a=r.vector(e,n),o=r.vector(t,e),s=i.angle(o),u=a.angle(o);if(s=s-Math.PI/2>0?1:0,u=u-Math.PI/2>0?1:0,s===u)return 1/0;var c=o.angle(i),h=o.length();return Math.abs(h*Math.sin(c))},vector:function(t,e){return new o(e.x-t.x,e.y-t.y)},guid:function(){return"xxxxxxxx".replace(/[xy]/g,function(t){var e=16*Math.random()|0,n="x"===t?e:3&e|8;return n.toString(16)})}}),t.exports=r},function(t,e,n){"use strict";var i=n(174),r=n(181),a=n(71),o=n(70),s=i[0];t.exports=function(t,e,n){var u=e.direction||s;if(e.isHorizontal=r(u),u&&i.indexOf(u)===-1)throw new TypeError("Invalid direction: "+u);if(u===i[0])n(t,e),a(t,"L","R",e);else if(u===i[1])n(t,e),t.right2left(),a(t,"R","L",e);else if(u===i[2])n(t,e),a(t,"T","B",e);else if(u===i[3])n(t,e),t.bottom2top(),a(t,"B","T",e);else if(u===i[4]||u===i[5]){var c=o(t,e),h=c.left,l=c.right;n(h,e),n(l,e),e.isHorizontal?(a(h,"R","L",e),a(l,"L","R",e)):(a(h,"B","T",e),a(l,"T","B",e)),e.isHorizontal?h.right2left():h.bottom2top(),l.translate(h.x-l.x,h.y-l.y),t.x=h.x,t.y=l.y,a(t,"C","C",e,!0);var d=t.getBoundingBox();e.isHorizontal?d.top<0&&t.translate(0,-d.top):d.left<0&&t.translate(-d.left,0)}return t.translate(-(t.x+t.width/2+t.hgap),-(t.y+t.height/2+t.vgap)),t.eachNode(function(t){var e=t.data;e.x=t.x+t.width/2+t.hgap,e.y=t.y+t.height/2+t.vgap,e.align=t.align,e.inAnchor=t.inAnchor?[t.inAnchor.x,t.inAnchor.y]:null,e.outAnchor=t.outAnchor?[t.outAnchor.x,t.outAnchor.y]:null}),t}},function(t,e,n){"use strict";function i(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var r=n(176),a=2*r,o=r,s={getId:function(t){return t.id||t.name},getHGap:function(t){return t.hgap||o},getVGap:function(t){return t.vgap||o},getChildren:function(t){return t.children},getHeight:function(t){return t.height||a},getWidth:function(t){var e=t.name||" ";return t.width||e.split("").length*r}},u=function(){function t(e){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},r=arguments[2];i(this,t);var a=this;if(a.vgap=a.hgap=0,e instanceof t)return e;a.data=e;var o=(n.getHGap||s.getHGap)(e),u=(n.getVGap||s.getVGap)(e);if(a.width=(n.getWidth||s.getWidth)(e),a.height=(n.getHeight||s.getHeight)(e),a.id=(n.getId||s.getId)(e),a.x=a.y=0,a.inAnchor={x:0,y:.5},a.outAnchor={x:1,y:.5},a.depth=0,!r&&!e.isCollapsed)for(var c=[a],h=c.pop();h;){if(!h.data.isCollapsed){var l=(n.getChildren||s.getChildren)(h.data),d=l?l.length:0;if(h.children=[],l&&d)for(var f=0;f<d;f++){var g=new t(l[f],n);h.children.push(g),c.push(g),g.parent=h,g.depth=h.depth+1}}h=c.pop()}a.children||(a.children=[]),a.addGap(o,u)}return t.prototype.isRoot=function(){return 0===this.depth},t.prototype.isLeaf=function(){return 0===this.children.length},t.prototype.addGap=function(t,e){var n=this;n.hgap+=t,n.vgap+=e,n.width+=2*t,n.height+=2*e},t.prototype.eachNode=function(t){for(var e=this,n=[e],i=n.pop();i;)t(i),n=n.concat(i.children),i=n.pop()},t.prototype.DFTraverse=function(t){this.eachNode(t)},t.prototype.BFTraverse=function(t){for(var e=this,n=[e],i=n.shift();i;)t(i),n=n.concat(i.children),i=n.shift()},t.prototype.getBoundingBox=function(){var t={left:Number.MAX_VALUE,top:Number.MAX_VALUE,width:0,height:0};return this.eachNode(function(e){t.left=Math.min(t.left,e.x),t.top=Math.min(t.top,e.y),t.width=Math.max(t.width,e.x+e.width),t.height=Math.max(t.height,e.y+e.height)}),t},t.prototype.translate=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0,e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0;this.eachNode(function(n){n.x+=t,n.y+=e})},t.prototype.right2left=function(){var t=this,e=t.getBoundingBox();t.eachNode(function(t){t.x=t.x-2*(t.x-e.left)-t.width}),t.translate(e.width,0)},t.prototype.bottom2top=function(){var t=this,e=t.getBoundingBox();t.eachNode(function(t){t.y=t.y-2*(t.y-e.top)-t.height}),t.translate(0,e.height)},t.prototype.getCenterX=function(){var t=this;return t.x+t.width/2},t.prototype.getCenterY=function(){var t=this;return t.y+t.height/2},t.prototype.getActualWidth=function(){var t=this;return t.width-2*t.hgap},t.prototype.getActualHeight=function(){var t=this;return t.height-2*t.vgap},t.prototype.getAnchorPoint=function(t){var e=this,n=e.getActualWidth(),i=e.getActualHeight();return{x:e.x+e.hgap+n*t.x,y:e.y+e.vgap+i*t.y}},t}();t.exports=u},function(t,e,n){"use strict";function i(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(e,"__esModule",{value:!0});var r=function(){function t(t,e){for(var n=0;n<e.length;n++){var i=e[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(t,i.key,i)}}return function(e,n,i){return n&&t(e.prototype,n),i&&t(e,i),e}}(),a="https://kcart.alipay.com/web/bi.do",o=n(1),s=function(){function t(e){i(this,t);var n=this,r=e||{},s=new Image;o.mix(n,{image:s,server:a},r)}return r(t,[{key:"log",value:function(t){var e=this,n=t||{},i=o.mix({pg:document.URL,r:(new Date).getTime()},n),r=encodeURIComponent(JSON.stringify([i]));e.image.src=e.server+"?BIProfile=merge&d="+r}}]),t}();e.default=s,t.exports=e.default},function(t,e,n){var i=n(89);i.Tween=n(38),i.Ease=n(36),t.exports=i},function(t,e){var n={linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return-1*t*(t-2)},easeInOutQuad:function(t){return(t/=.5)<1?.5*t*t:-.5*(--t*(t-2)-1)},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return 1*((t=t/1-1)*t*t+1)},easeInOutCubic:function(t){return(t/=.5)<1?.5*t*t*t:.5*((t-=2)*t*t+2)},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return-1*((t=t/1-1)*t*t*t-1)},easeInOutQuart:function(t){return(t/=.5)<1?.5*t*t*t*t:-.5*((t-=2)*t*t*t-2)},easeInQuint:function(t){return 1*(t/=1)*t*t*t*t},easeOutQuint:function(t){return 1*((t=t/1-1)*t*t*t*t+1)},easeInOutQuint:function(t){return(t/=.5)<1?.5*t*t*t*t*t:.5*((t-=2)*t*t*t*t+2)},easeInSine:function(t){return-1*Math.cos(t/1*(Math.PI/2))+1},easeOutSine:function(t){return 1*Math.sin(t/1*(Math.PI/2))},easeInOutSine:function(t){return-.5*(Math.cos(Math.PI*t/1)-1)},easeInExpo:function(t){return 0===t?1:1*Math.pow(2,10*(t/1-1))},easeOutExpo:function(t){return 1===t?1:1*(-Math.pow(2,-10*t/1)+1)},easeInOutExpo:function(t){return 0===t?0:1===t?1:(t/=.5)<1?.5*Math.pow(2,10*(t-1)):.5*(-Math.pow(2,-10*--t)+2)},easeInCirc:function(t){return t>=1?t:-1*(Math.sqrt(1-(t/=1)*t)-1)},easeOutCirc:function(t){return 1*Math.sqrt(1-(t=t/1-1)*t)},easeInOutCirc:function(t){return(t/=.5)<1?-.5*(Math.sqrt(1-t*t)-1):.5*(Math.sqrt(1-(t-=2)*t)+1)},easeInElastic:function(t){var e=1.70158,n=0,i=1;return 0===t?0:1==(t/=1)?1:(n||(n=.3),i<Math.abs(1)?(i=1,e=n/4):e=n/(2*Math.PI)*Math.asin(1/i),-(i*Math.pow(2,10*(t-=1))*Math.sin((1*t-e)*(2*Math.PI)/n)))},easeOutElastic:function(t){var e=1.70158,n=0,i=1;return 0===t?0:1==(t/=1)?1:(n||(n=.3),i<Math.abs(1)?(i=1,e=n/4):e=n/(2*Math.PI)*Math.asin(1/i),i*Math.pow(2,-10*t)*Math.sin((1*t-e)*(2*Math.PI)/n)+1)},easeInOutElastic:function(t){var e=1.70158,n=0,i=1;return 0===t?0:2==(t/=.5)?1:(n||(n=1*(.3*1.5)),i<Math.abs(1)?(i=1,e=n/4):e=n/(2*Math.PI)*Math.asin(1/i),t<1?-.5*(i*Math.pow(2,10*(t-=1))*Math.sin((1*t-e)*(2*Math.PI)/n)):i*Math.pow(2,-10*(t-=1))*Math.sin((1*t-e)*(2*Math.PI)/n)*.5+1)},easeInBack:function(t){var e=1.70158;return 1*(t/=1)*t*((e+1)*t-e)},easeOutBack:function(t){var e=1.70158;return 1*((t=t/1-1)*t*((e+1)*t+e)+1)},easeInOutBack:function(t){var e=1.70158;return(t/=.5)<1?.5*(t*t*(((e*=1.525)+1)*t-e)):.5*((t-=2)*t*(((e*=1.525)+1)*t+e)+2)},easeInBounce:function(t){return 1-n.easeOutBounce(1-t)},easeOutBounce:function(t){return(t/=1)<1/2.75?1*(7.5625*t*t):t<2/2.75?1*(7.5625*(t-=1.5/2.75)*t+.75):t<2.5/2.75?1*(7.5625*(t-=2.25/2.75)*t+.9375):1*(7.5625*(t-=2.625/2.75)*t+.984375)},easeInOutBounce:function(t){return t<.5?.5*n.easeInBounce(2*t):.5*n.easeOutBounce(2*t-1)+.5}};t.exports=n},function(t,e,n){"use strict";var i=n(1),r=n(3),a=n(77),o={duration:"duration",destroy:"destroy",delay:"delay",repeat:"repeat",onUpdate:"onUpdate"},s=r.Matrix3,u={getObjectLength:function(t){var e,n=0;for(e in t)t.hasOwnProperty(e)&&n++;return n},isEqual:function(t,e){var n,r;if(typeof t!=typeof e)return!1;if(i.isNumber(t)||i.isString(t))return t===e;if(i.isArray(t)){if(!i.isArray(t[0]))return!!i.equalsArray(t,e);if(t===e)return!0;if(t.length!==e.length)return!1;for(n=0;n<t.length;n++)if(!i.equalsArray(t[n],e[n]))return!1;return!0}if(i.isObject(t)){if(u.getObjectLength(t)!==u.getObjectLength(e))return!1;for(r in t){if(typeof t[r]!=typeof e[r])return!1;if(t[r]!==e[r])return!1}return!0}return t===e},interpolation:a.interpolation,getFrame:function(t,e,n,r,a){var o={attrs:{},matrix:null},s=n.onUpdate;for(var u in r.attrs)o.attrs[u]=r.attrs[u](t);return r.matrix&&(o.matrix=r.matrix(t)),i.isFunction(s)&&s(o,t),o},getInterpolations:function(t,e){var n,r,a={attrs:{},matrix:null};return i.each(t.attrs,function(t,o){n=null,r=e.attrs[o],u.isEqual(t,r)||(n="path"===o?u.interpolation({path:t,type:"path"},{path:r,type:"path"}):u.interpolation(t,r),i.isFunction(n)&&(a.attrs[o]=n))}),e.matrix&&t.matrix&&!s.equal(t.matrix,e.matrix)&&(n=u.interpolation(t.matrix,e.matrix),i.isFunction(n)&&(a.matrix=n)),a},getKeyFrameByProps:function(t,e){var n=[],i=u.props2frame(t,e),r={attrs:u.getTargetAttrs(t,i.attrs),matrix:t.getMatrix()};return n[0]=r,n[1]=i,n},props2frame:function(t,e){var n={matrix:null,attrs:{}};return i.each(e,function(i,r){"transform"!==r||e.k?"matrix"===r?n.matrix=i:"onUpdate"===r?n.onUpdate=e.onUpdate:o[r]||(n.attrs[r]=i):n.matrix=u.transform(t.getMatrix(),i)}),n},transform:function(t,e){return t=t.clone(),i.each(e,function(e){switch(e[0]){case"t":t.translate(e[1],e[2]);break;case"s":t.scale(e[1],e[2]);break;case"r":t.rotate(e[1]);break;case"m":t.multiply(e[1]);break;default:return!1}}),t},getTargetAttrs:function(t,e){var n,i={};for(n in e)i[n]=t.attr(n);return i}};t.exports=u},function(t,e,n){"use strict";var i=(n(11),n(37)),r=n(1),a=n(36),o=function(t){r.mix(this,t),this._init()};r.augment(o,{type:"tween",canvas:null,target:null,startTime:null,endTime:null,duration:null,ratio:0,destroyTarget:!1,needsDestroy:!1,available:!0,repeat:!1,callBack:null,currentFrame:null,startKeyFrame:{attrs:null,matrix:null},endKeyFrame:{attrs:null,matrix:null},interpolations:null,_init:function(){var t=this.startTime,e=this.duration;this.endTime=t+e},tryStep:function(t){var e=(this.startTime,this.duration,this.startKeyFrame,this.target);if(!e||e.get("destroyed"))return this.needsDestroy=!0,!1;try{this.step(t)}catch(t){return this.needsDestroy=!0,!1}},step:function(t){var e,n,o,s=this.target,u=this.startTime,c=t-u,h=this.duration,l=this.startKeyFrame,d=this.endKeyFrame,f=this.easing,g=this.interpolations;return r.isFunction(f)||(f=a[f]?a[f]:a.linear),n=c/h,n=n<=0?0:n>=1?1:n,o=f(n),e=i.getFrame(o,l,d,g,s),e.attrs&&s.attr(e.attrs),e.matrix&&s.setMatrix(e.matrix),this.ratio=n,this.currentFrame=e,this.updateStatus(),s},updateStatus:function(){var t=this.ratio,e=this.callBack,n=this.destroyTarget,i=this.target,r=this.repeat;if(t>=1)if(r){var a=this.startTime,o=this.endTime,s=this.duration;this.startTime=a+s,this.endTime=o+s,this.reset()}else this.needsDestroy=!0,e&&e.call(i),n&&!i.get("destroyed")&&i.remove(!0)},reset:function(){var t=this.target,e=this.startKeyFrame;e.attrs&&t.attr(e.attrs),e.matrix&&t.setMatrix(e.matrix),this.ratio=0,this.needsDestroy=!1},destroy:function(){var t=this.target,e=this.endKeyFrame;t&&!t.get("destroyed")&&(e.attrs&&t.attr(e.attrs),e.matrix&&t.setMatrix(e.matrix)),this.destroyed=!0}}),t.exports=o},function(t,e){"use strict";function n(){var t=document.createElement("i");return t.title="Web Colour Picker",t.style.display="none",document.body.appendChild(t),t}var i=/rgb\((\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\)/,r={},a=null;t.exports={toRGB:function(t){a||(a=n());var e;if(r[t])e=r[t];else{a.style.color=t,e=document.defaultView.getComputedStyle(a,"").getPropertyValue("color");var o=i.exec(e);o.shift(),e=this.arr2rgb(o),r[t]=e}return e},toHex:function(t){return t=Math.round(t),t=t.toString(16),1===t.length&&(t="0"+t),t},hsl2Rgb:function(t){var e=t[0],n=t[1],i=t[2],r={};if(0===n)r.r=r.g=r.b=i;else{var a=function(t,e,n){return n<0&&(n+=1),n>1&&(n-=1),n<1/6?t+6*(e-t)*n:n<.5?e:n<2/3?t+6*(e-t)*(2/3-n):t},o=i<=.5?i*(1+n):i+n-i*n,s=2*i-o;r.r=a(s,o,e+1/3),r.g=a(s,o,e),r.b=a(s,o,e-1/3)}return r.r=Math.min(Math.round(255*r.r),255),r.g=Math.min(Math.round(255*r.g),255),r.b=Math.min(Math.round(255*r.b),255),"#"+this.toHex(r.r)+this.toHex(r.g)+this.toHex(r.b)},rgb2hsl:function(t){var e,n,i,r=this.rgb2arr(t),a=r[0]/255,o=r[1]/255,s=r[2]/255,u=Math.min(a,o,s),c=Math.max(a,o,s),h=c-u;return c===u?e=0:a===c?e=(o-s)/h:o===c?e=2+(s-a)/h:s===c&&(e=4+(a-o)/h),e=Math.min(60*e,360),e<0&&(e+=360),i=(u+c)/2,n=c===u?0:i<=.5?h/(c+u):h/(2-c-u),[e/360,n,i]},arr2rgb:function(t){return"#"+this.toHex(t[0])+this.toHex(t[1])+this.toHex(t[2])},rgb2arr:function(t){var e=[];return e.push(parseInt(t.substr(1,2),16)),e.push(parseInt(t.substr(3,2),16)),e.push(parseInt(t.substr(5,2),16)),e}}},function(t,e){t.exports={prefix:"g",backupContext:document.createElement("canvas").getContext("2d"),debug:!1,warn:function(){}}},function(t,e,n){var i=n(1),r=n(105),a=n(106),o=n(104),s=n(42),u=n(101),c=["fillStyle","font","globalAlpha","lineCap","lineWidth","lineJoin","miterLimit","shadowBlur","shadowColor","shadowOffsetX","shadowOffsetY","strokeStyle","textAlign","textBaseline","lineDash"],h=function(t){this.__cfg={zIndex:0,capture:!0,visible:!0,destroyed:!1},i.simpleMix(this.__cfg,this.getDefaultCfg(),t),this.initAttrs(this.__cfg.attrs),this.initTransform(),this.initEventDispatcher(),this.init()};h.CFG={id:null,zIndex:0,canvas:null,parent:null,capture:!0,context:null,visible:!0,destroyed:!1},i.augment(h,r,u,a,o,{init:function(){this.setSilent("animable",!0);var t=this.__attrs;t&&t.rotate&&this.rotateAtStart(t.rotate)},getParent:function(){return this.get("parent")},getDefaultCfg:function(){return{}},set:function(t,e){var n="__set"+i.ucfirst(t);return this[n]&&(e=this[n](e)),this.__cfg[t]=e,this},setSilent:function(t,e){this.__cfg[t]=e},get:function(t){return this.__cfg[t]},draw:function(t){this.get("destroyed")||this.get("visible")&&(this.setContext(t),this.drawInner(t),this.restoreContext(t))},setContext:function(t){var e=this.__attrs.clip;t.save(),e&&(e.resetTransform(t),e.createPath(t),t.clip()),this.resetContext(t),this.resetTransform(t)},restoreContext:function(t){t.restore()},resetContext:function(t){var e=this.__attrs;if(!this.isGroup)for(var n in e)if(c.indexOf(n)>-1){var r=e[n];"fillStyle"===n&&(r=s.parseStyle(r,this)),"strokeStyle"===n&&(r=s.parseStyle(r,this)),"lineDash"===n&&t.setLineDash?i.isArray(r)?t.setLineDash(r):i.isString(r)&&t.setLineDash(r.split(" ")):t[n]=r}},drawInner:function(){},show:function(){return this.set("visible",!0),this},hide:function(){return this.set("visible",!1),this},remove:function(t){if(void 0===t&&(t=!0),this.get("parent")){var e=this.get("parent"),n=e.get("children");i.remove(n,this)}return t&&this.destroy(),this},destroy:function(){var t=this.get("destroyed");t||(this.__cfg={},this.__attrs=null,this.__listeners=null,this.__m=null,this.set("destroyed",!0))},__setZIndex:function(t){return this.__cfg.zIndex=t,i.notNull(this.get("parent"))&&this.get("parent").sort(),t},__setAttrs:function(t){return this.attr(t),t},clone:function(){return i.clone(this)},getBBox:function(){return{minX:0,maxX:0,minY:0,maxY:0}}}),t.exports=h},function(t,e,n){function i(t,e){if(void 0===e)return t;t=new h(t),t.multiplyA(e);var n=t.getType();return"hsl"===n?t.getHSLStyle():"rgb"===n?t.getRGBStyle():void 0}function r(t,e,n){var r=t.match(v);u.each(r,function(t){t=t.split(":");var r=i(t[1],n);e.addColorStop(t[0],r)})}function a(t,e,n){var i,a,o=f.exec(t),s=c.mod(c.degreeToRad(parseFloat(o[1])),2*Math.PI),u=o[2],h=e.getBBox();s>=0&&s<.5*Math.PI?(i={x:h.minX,y:h.minY},a={x:h.maxX,y:h.maxY}):.5*Math.PI<=s&&s<Math.PI?(i={x:h.maxX,y:h.minY},a={x:h.minX,y:h.maxY}):Math.PI<=s&&s<1.5*Math.PI?(i={x:h.maxX,y:h.maxY},a={x:h.minX,y:h.minY}):(i={x:h.minX,y:h.maxY},a={x:h.maxX,y:h.minY});var l=Math.tan(s),d=l*l,g=(a.x-i.x+l*(a.y-i.y))/(d+1)+i.x,p=l*(a.x-i.x+l*(a.y-i.y))/(d+1)+i.y,v=e.get("context"),x=v.createLinearGradient(i.x,i.y,g,p);return r(u,x,n),x}function o(t,e,n){var i=g.exec(t),a=parseFloat(i[1]),o=parseFloat(i[2]),s=parseFloat(i[3]),u=i[4],c=e.getBBox(),h=e.get("context"),l=c.maxX-c.minX,d=c.maxY-c.minY,f=Math.sqrt(l*l+d*d)/2,p=h.createRadialGradient(c.minX+l*a,c.minY+d*o,s,c.minX+l/2,c.minY+d/2,f);return r(u,p,n),p}function s(t,e){var n=p.exec(t),i=n[1],r=n[2];switch(i){case"a":i="repeat";break;case"x":i="repeat-x";break;case"y":i="repeat-y";break;case"n":i="no-repeat";break;default:i="no-repeat"}var a=document.getElementById(r),o=e.get("context"),s=o.createPattern(a,i);return s}var u=n(1),c=n(8),h=n(16),l=/[MLHVQTCSAZ]([^MLHVQTCSAZ]*)/gi,d=/[^\s\,]+/gi,f=/^l\s*\(\s*([\d.]+)\s*\)\s*(.*)/i,g=/^r\s*\(\s*([\d.]+)\s*,\s*([\d.]+)\s*,\s*([\d.]+)\s*\)\s*(.*)/i,p=/^p\s*([axyn])\s+(.*)/i,v=/[\d.]+:(#[^\s]+|[^\)]+\))/gi,x={};t.exports={parsePath:function(t){return t=t||[],u.isArray(t)?t:u.isString(t)?(t=t.match(l),u.each(t,function(e,n){if(e=e.match(d),e[0].length>1){var i=e[0].charAt(0);e.splice(1,0,e[0].substr(1)),e[0]=i}u.each(e,function(t,n){isNaN(t)||(e[n]=+t)}),t[n]=e}),t):void 0},parseStyle:function(t,e,n){if(u.isString(t)){if("("===t[1]||"("===t[2]){if("l"===t[0])return a(t,e,n);if("r"===t[0])return o(t,e,n);if("p"===t[0])return s(t,e)}return u.isNull(n)?t:i(t,n)}},numberToColor:function(t){var e=x[t];if(!e){for(var n=t.toString(16),i=n.length;i<6;i++)n="0"+n;e="#"+n,x[t]=e}return e}}},function(t,e,n){var i=n(40),r={Group:n(103),Shape:n(5),Rect:n(57),Circle:n(45),Ellipse:n(47),Path:n(53),Text:n(58),Line:n(51),Image:n(49),Polygon:n(54),Polyline:n(55),Arc:n(44),Fan:n(48),Cubic:n(46),Quadratic:n(56),Marker:n(52),debug:function(t){i.debug=t}};t.exports=r},function(t,e,n){var i=n(1),r=n(3).Vector2,a=n(5),o=n(6),s=n(21),u=n(12),c=function(t){c.superclass.constructor.call(this,t)};c.ATTRS={x:0,y:0,r:0,startAngle:0,endAngle:0,clockwise:!1,lineWidth:1,arrow:!1},i.extend(c,a),i.augment(c,{canStroke:!0,type:"arc",getDefaultAttrs:function(){return{x:0,y:0,r:0,startAngle:0,endAngle:0,clockwise:!1,lineWidth:1,arrow:!1}},calculateBox:function(){var t=this.__attrs,e=t.x,n=t.y,i=t.r,r=t.startAngle,a=t.endAngle,o=t.clockwise,u=t.lineWidth,c=u/2,h=s.box(e,n,i,r,a,o);return h.minX-=c,h.minY-=c,h.maxX+=c,h.maxY+=c,h},isPointInPath:function(t,e){var n=this.__attrs,i=n.x,r=n.y,a=n.r,s=n.startAngle,u=n.endAngle,c=n.clockwise,h=n.lineWidth;return!!this.hasStroke()&&o.arcline(i,r,a,s,u,c,h,t,e)},createPath:function(t){var e=this.__attrs,n=e.x,i=e.y,a=e.r,o=e.startAngle,s=e.endAngle,c=e.clockwise,h=e.lineWidth,l=e.arrow;if(t=t||self.get("context"),t.beginPath(),t.arc(n,i,a,o,s,c),l){var d={x:n+a*Math.cos(s),y:i+a*Math.sin(s)},f=new r(-a*Math.sin(s),a*Math.cos(s));c&&f.multiplyScaler(-1),u.makeArrow(t,f,d,h)}}}),t.exports=c},function(t,e,n){var i=n(1),r=n(5),a=n(6),o=function(t){o.superclass.constructor.call(this,t)};o.ATTRS={x:0,y:0,r:0,lineWidth:1},i.extend(o,r),i.augment(o,{canFill:!0,canStroke:!0,type:"circle",getDefaultAttrs:function(){return{lineWidth:1}},calculateBox:function(){var t=this.__attrs,e=t.x,n=t.y,i=t.r,r=t.lineWidth,a=r/2+i;return{minX:e-a,minY:n-a,maxX:e+a,maxY:n+a}},isPointInPath:function(t,e){var n=this.hasFill(),i=this.hasStroke();return n&&i?this.__isPointInFill(t,e)||this.__isPointInStroke(t,e):n?this.__isPointInFill(t,e):!!i&&this.__isPointInStroke(t,e)},__isPointInFill:function(t,e){var n=this.__attrs,i=n.x,r=n.y,o=n.r;return a.circle(i,r,o,t,e)},__isPointInStroke:function(t,e){var n=this.__attrs,i=n.x,r=n.y,o=n.r,s=n.lineWidth;return a.arcline(i,r,o,0,2*Math.PI,!1,s,t,e)},createPath:function(t){var e=this.__attrs,n=e.x,i=e.y,r=e.r;t=t||self.get("context"),t.beginPath(),t.arc(n,i,r,0,2*Math.PI,!1)}}),t.exports=o},function(t,e,n){var i=n(1),r=n(5),a=n(6),o=n(12),s=n(17),u=n(3).Vector2,c=function(t){c.superclass.constructor.call(this,t)};c.ATTRS={p1:null,p2:null,p3:null,p4:null,lineWidth:1,arrow:!1},i.extend(c,r),i.augment(c,{canStroke:!0,type:"cubic",getDefaultAttrs:function(){return{lineWidth:1}},calculateBox:function(){var t,e,n=this.__attrs,r=n.p1,a=n.p2,o=n.p3,u=n.p4;if(i.isNull(r)||i.isNull(a)||i.isNull(o)||i.isNull(u))return null;var c=n.lineWidth/2,h=s.extrema(r[0],a[0],o[0],u[0]);for(t=0,e=h.length;t<e;t++)h[t]=s.at(r[0],a[0],o[0],u[0],h[t]);var l=s.extrema(r[1],a[1],o[1],u[1]);for(t=0,e=l.length;t<e;t++)l[t]=s.at(r[1],a[1],o[1],u[1],l[t]);return h.push(r[0],u[0]),l.push(r[1],u[1]),{minX:Math.min.apply(Math,h)-c,maxX:Math.max.apply(Math,h)+c,minY:Math.min.apply(Math,l)-c,maxY:Math.max.apply(Math,l)+c}},isPointInPath:function(t,e){var n=this.__attrs,i=n.p1,r=n.p2,o=n.p3,s=n.p4,u=n.lineWidth;return a.cubicline(i[0],i[1],r[0],r[1],o[0],o[1],s[0],s[1],u,t,e)},createPath:function(t){var e=this.__attrs,n=e.p1,r=e.p2,a=e.p3,s=e.p4,c=e.lineWidth,h=e.arrow;if(t=t||self.get("context"),!(i.isNull(n)||i.isNull(r)||i.isNull(a)||i.isNull(s)))if(t.beginPath(),t.moveTo(n[0],n[1]),h){var l=new u(s[0]-a[0],s[1]-a[1]),d=o.getEndPoint(l,new u(s[0],s[1]),c);t.bezierCurveTo(r[0],r[1],a[0],a[1],d.x,d.y),o.makeArrow(t,l,d,c)}else t.bezierCurveTo(r[0],r[1],a[0],a[1],s[0],s[1])},getPoint:function(t){var e=this.__attrs;return{x:s.at(e.p4[0],e.p3[0],e.p2[0],e.p1[0],t),y:s.at(e.p4[1],e.p3[1],e.p2[1],e.p1[1],t)}}}),t.exports=c},function(t,e,n){var i=n(1),r=n(5),a=n(6),o=n(3),s=o.Matrix3,u=o.Vector3,c=function(t){c.superclass.constructor.call(this,t)};c.ATTRS={x:0,y:0,rx:1,ry:1,lineWidth:1},i.extend(c,r),i.augment(c,{canFill:!0,canStroke:!0,type:"ellipse",getDefaultAttrs:function(){return{lineWidth:1}},calculateBox:function(){var t=this.__attrs,e=t.x,n=t.y,i=t.rx,r=t.ry,a=t.lineWidth,o=i+a/2,s=r+a/2;return{minX:e-o,minY:n-s,maxX:e+o,maxY:n+s}},isPointInPath:function(t,e){var n=this.hasFill(),i=this.hasStroke();return n&&i?this.__isPointInFill(t,e)||this.__isPointInStroke(t,e):n?this.__isPointInFill(t,e):!!i&&this.__isPointInStroke(t,e)},__isPointInFill:function(t,e){var n=this.__attrs,i=n.x,r=n.y,o=n.rx,c=n.ry,h=o>c?o:c,l=o>c?1:o/c,d=o>c?c/o:1,f=new u(t,e,1),g=new s;g.scale(l,d),g.translate(i,r);var p=g.getInverse();return f.applyMatrix(p),a.circle(0,0,h,f.x,f.y)},__isPointInStroke:function(t,e){var n=this.__attrs,i=n.x,r=n.y,o=n.rx,c=n.ry,h=n.lineWidth,l=o>c?o:c,d=o>c?1:o/c,f=o>c?c/o:1,g=new u(t,e,1),p=new s;p.scale(d,f),p.translate(i,r);var v=p.getInverse();return g.applyMatrix(v),a.arcline(0,0,l,0,2*Math.PI,!1,h,g.x,g.y)},createPath:function(t){var e=this.__attrs,n=e.x,i=e.y,r=e.rx,a=e.ry;t=t||self.get("context");var o=r>a?r:a,u=r>a?1:r/a,c=r>a?a/r:1,h=new s;h.scale(u,c),h.translate(n,i);var l=h.to2DObject();t.beginPath(),t.save(),t.transform(l.a,l.b,l.c,l.d,l.e,l.f),t.arc(0,0,o,0,2*Math.PI),t.restore(),t.closePath()}}),t.exports=c},function(t,e,n){var i=n(1),r=n(5),a=n(6),o=n(8),s=n(21),u=n(3),c=u.Vector2,h=function(t){h.superclass.constructor.call(this,t)};h.ATTRS={x:0,y:0,rs:0,re:0,startAngle:0,endAngle:0,clockwise:!1,lineWidth:1},i.extend(h,r),i.augment(h,{canFill:!0,canStroke:!0,type:"fan",getDefaultAttrs:function(){return{clockwise:!1,lineWidth:1,rs:0,re:0}},calculateBox:function(){var t=this,e=t.__attrs,n=e.x,i=e.y,r=e.rs,a=e.re,o=e.startAngle,u=e.endAngle,c=e.clockwise,h=e.lineWidth,l=s.box(n,i,r,o,u,c),d=s.box(n,i,a,o,u,c),f=Math.min(l.minX,d.minX),g=Math.min(l.minY,d.minY),p=Math.max(l.maxX,d.maxX),v=Math.max(l.maxY,d.maxY),x=h/2;return{minX:f-x,minY:g-x,maxX:p+x,maxY:v+x}},isPointInPath:function(t,e){var n=this.hasFill(),i=this.hasStroke();return n&&i?this.__isPointInFill(t,e)||this.__isPointInStroke(t,e):n?this.__isPointInFill(t,e):!!i&&this.__isPointInStroke(t,e)},__isPointInFill:function(t,e){var n=this.__attrs,i=n.x,r=n.y,a=n.rs,u=n.re,h=n.startAngle,l=n.endAngle,d=n.clockwise,f=new c(1,0),g=new c(t-i,e-r),p=f.angleTo(g),v=s.nearAngle(p,h,l,d);if(o.equal(p,v)){var x=g.lengthSq();if(a*a<=x&&x<=u*u)return!0}return!1},__isPointInStroke:function(t,e){var n=this.__attrs,i=n.x,r=n.y,o=n.rs,s=n.re,u=n.startAngle,c=n.endAngle,h=n.clockwise,l=n.lineWidth,d={x:Math.cos(u)*o+i,y:Math.sin(u)*o+r},f={x:Math.cos(u)*s+i,y:Math.sin(u)*s+r},g={x:Math.cos(c)*o+i,y:Math.sin(c)*o+r},p={x:Math.cos(c)*s+i,y:Math.sin(c)*s+r};return!!a.line(d.x,d.y,f.x,f.y,l,t,e)||(!!a.line(g.x,g.y,p.x,p.y,l,t,e)||(!!a.arcline(i,r,o,u,c,h,l,t,e)||!!a.arcline(i,r,s,u,c,h,l,t,e)))},createPath:function(t){var e=this.__attrs,n=e.x,i=e.y,r=e.rs,a=e.re,o=e.startAngle,s=e.endAngle,u=e.clockwise,c={x:Math.cos(o)*r+n,y:Math.sin(o)*r+i},h={x:Math.cos(o)*a+n,y:Math.sin(o)*a+i},l={x:Math.cos(s)*r+n,y:Math.sin(s)*r+i};t=t||self.get("context"),t.beginPath(),t.moveTo(c.x,c.y),t.lineTo(h.x,h.y),t.arc(n,i,a,o,s,u),t.lineTo(l.x,l.y),t.arc(n,i,r,s,o,!u),t.closePath()}}),t.exports=h},function(t,e,n){var i=n(1),r=n(5),a=n(6),o=function(t){o.superclass.constructor.call(this,t)};o.ATTRS={x:0,y:0,img:void 0,width:0,height:0,sx:null,sy:null,swidth:null,sheight:null},i.extend(o,r),i.augment(o,{type:"image",__afterSetAttrImg:function(t){this.__setAttrImg(t)},__afterSetAttrAll:function(t){t.img&&this.__setAttrImg(t.img)},isHitBox:function(){return!1},calculateBox:function(){var t=this.__attrs,e=t.x,n=t.y,i=t.width,r=t.height;return{minX:e,minY:n,maxX:e+i,maxY:n+r}},isPointInPath:function(t,e){var n=this.__attrs;if(this.get("toDraw")||!n.img)return!1;var i=n.x,r=n.y,o=n.width,s=n.height;return a.rect(i,r,o,s,t,e)},__setLoading:function(t){var e=this.get("canvas");return t===!1&&this.get("toDraw")===!0&&(this.__cfg.loading=!1,e.draw()),t},__setAttrImg:function(t){var e=this,n=e.__attrs;if(!i.isString(t))return t instanceof Image?(n.width||e.attr("width",t.width),n.height||e.attr("height",t.height),t):t instanceof HTMLElement&&i.isString(t.nodeName)&&"CANVAS"===t.nodeName.toUpperCase()?(n.width||e.attr("width",Number(t.getAttribute("width"))),n.height||e.attr("height",Number(t.getAttribute("height"))),t):t instanceof ImageData?(n.width||e.attr("width",t.width),n.height||e.attr("height",t.height),t):null;var r=new Image;r.onload=function(){if(e.get("destroyed"))return!1;e.attr("imgSrc",t),e.attr("img",r);var n=e.get("callback");n&&n.call(e),e.set("loading",!1)},r.src=t,e.set("loading",!0)},drawInner:function(t){return this.get("loading")?void this.set("toDraw",!0):void this.__drawImage(t)},__drawImage:function(t){var e=this.__attrs,n=e.x,r=e.y,a=e.img,o=e.width,s=e.height,u=e.sx,c=e.sy,h=e.swidth,l=e.sheight;if(this.set("toDraw",!1),a instanceof Image||a instanceof HTMLElement&&i.isString(a.nodeName)&&"CANVAS"===a.nodeName.toUpperCase()){if(i.isNull(u)||i.isNull(c)||i.isNull(h)||i.isNull(l))return void t.drawImage(a,n,r,o,s);if(i.notNull(u)&&i.notNull(c)&&i.notNull(h)&&i.notNull(l))return void t.drawImage(a,u,c,h,l,n,r,o,s)}else if(a instanceof ImageData)return void t.putImageData(a,n,r,u||0,c||0,h||o,l||s)}}),t.exports=o},function(t,e,n){var i={Rect:n(57),Circle:n(45),Ellipse:n(47),Path:n(53),Text:n(58),Line:n(51),Image:n(49),Polygon:n(54),Polyline:n(55),Arc:n(44),Fan:n(48),Cubic:n(46),Quadratic:n(56),Marker:n(52)};t.exports=i},function(t,e,n){var i=n(1),r=n(5),a=n(6),o=n(12),s=n(22),u=n(3),c=u.Vector2,h=function(t){h.superclass.constructor.call(this,t)};h.ATTRS={x1:0,y1:0,x2:0,y2:0,lineWidth:1,arrow:!1},i.extend(h,r),i.augment(h,{canStroke:!0,type:"line",getDefaultAttrs:function(){return{lineWidth:1,arrow:!1}},calculateBox:function(){var t=this.__attrs,e=t.x1,n=t.y1,i=t.x2,r=t.y2,a=t.lineWidth;return s.box(e,n,i,r,a)},isPointInPath:function(t,e){var n=this.__attrs,i=n.x1,r=n.y1,o=n.x2,s=n.y2,u=n.lineWidth;return!!this.hasStroke()&&a.line(i,r,o,s,u,t,e)},createPath:function(t){var e=this.__attrs,n=e.x1,i=e.y1,r=e.x2,a=e.y2,s=e.arrow,u=e.lineWidth;if(t=t||self.get("context"),t.beginPath(),t.moveTo(n,i),s){var h=new c(r-n,a-i),l=o.getEndPoint(h,new c(r,a),u);t.lineTo(l.x,l.y),o.makeArrow(t,h,l,u)}else t.lineTo(r,a)},getPoint:function(t){var e=this.__attrs;return{x:s.at(e.x1,e.x2,t),y:s.at(e.y1,e.y2,t)}}}),t.exports=h},function(t,e,n){var i=n(1),r=n(5),a=n(6),o=function(t){o.superclass.constructor.call(this,t)};o.Symbols={circle:function(t,e,n,i){i.arc(t,e,n,0,2*Math.PI,!1)},square:function(t,e,n,i){i.moveTo(t-n,e-n),i.lineTo(t+n,e-n),i.lineTo(t+n,e+n),i.lineTo(t-n,e+n),i.closePath()},diamond:function(t,e,n,i){i.moveTo(t-n,e),i.lineTo(t,e-n),i.lineTo(t+n,e),i.lineTo(t,e+n),i.closePath()},triangle:function(t,e,n,i){var r=n/.966,a=n;i.moveTo(t,e-n),i.lineTo(t+r,e+a),i.lineTo(t-r,e+a),i.closePath()},"triangle-down":function(t,e,n,i){var r=n/.966,a=n;i.moveTo(t,e+n),i.lineTo(t+r,e-a),i.lineTo(t-r,e-a),i.closePath()}},o.ATTRS={path:null,lineWidth:1},i.extend(o,r),i.augment(o,{type:"marker",canFill:!0,canStroke:!0,getDefaultAttrs:function(){return{x:0,y:0,lineWidth:1}},calculateBox:function(){var t=this.__attrs,e=t.x,n=t.y,i=t.radius,r=t.lineWidth,a=r/2+i;return{minX:e-a,minY:n-a,maxX:e+a,maxY:n+a}},isPointInPath:function(t,e){var n=this.__attrs,i=n.x,r=n.y,o=n.radius;return a.circle(i,r,o,t,e)},createPath:function(t){var e,n=this.__attrs,r=n.x,a=n.y,s=n.radius,u=n.symbol||"circle";e=i.isFunction(u)?u:o.Symbols[u],t.beginPath(),e(r,a,s,t)}}),t.exports=o},function(t,e,n){var i=n(1),r=n(5),a=n(108),o=n(42),s=n(12),u=n(20),c=n(17),h=n(3),l=h.Vector2,d=function(t){d.superclass.constructor.call(this,t)};d.ATTRS={path:null,lineWidth:1,curve:null,tCache:null},i.extend(d,r),i.augment(d,{canFill:!0,canStroke:!0,type:"path",getDefaultAttrs:function(){return{lineWidth:1}},__afterSetAttrPath:function(t){var e=this;if(i.isNull(t))return e.setSilent("segments",null),void e.setSilent("box",void 0);var n,r=o.parsePath(t),s=[];if(i.isArray(r)&&0!==r.length&&("M"===r[0][0]||"m"===r[0][0])){for(var u=r.length,c=0;c<r.length;c++){var h=r[c];n=new a(h,n,c===u-1),s.push(n)}e.setSilent("segments",s),e.set("tCache",null),this.setSilent("box",null)}},__afterSetAttrAll:function(t){t.path&&this.__afterSetAttrPath(t.path)},calculateBox:function(){var t=this,e=t.__attrs,n=e.lineWidth,r=e.lineAppendWidth||0,a=t.get("segments");if(!a)return null;n+=r;var o=1/0,s=-(1/0),u=1/0,c=-(1/0);return i.each(a,function(t){t.getBBox(n);var e=t.box;e&&(e.minX<o&&(o=e.minX),e.maxX>s&&(s=e.maxX),e.minY<u&&(u=e.minY),e.maxY>c&&(c=e.maxY))}),{minX:o,minY:u,maxX:s,maxY:c}},isPointInPath:function(t,e){var n=this,i=n.hasFill(),r=n.hasStroke();return i&&r?n.__isPointInFill(t,e)||n.__isPointInStroke(t,e):i?n.__isPointInFill(t,e):!!r&&n.__isPointInStroke(t,e)},__isPointInFill:function(t,e){var n=this,i=n.get("context");if(i)return n.createPath(),i.isPointInPath(t,e)},__isPointInStroke:function(t,e){var n=this,i=n.get("segments"),r=n.__attrs,a=r.lineWidth,o=r.lineAppendWidth||0;a+=o;for(var s=0,u=i.length;s<u;s++)if(i[s].isInside(t,e,a))return!0;return!1},__setTcache:function(){var t,e,n,r,a=0,o=0,s=[],u=this.curve;u&&(i.each(u,function(t,e){n=u[e+1],r=t.length,n&&(a+=c.len(t[r-2],t[r-1],n[1],n[2],n[3],n[4],n[5],n[6]))}),i.each(u,function(i,h){n=u[h+1],r=i.length,n&&(t=[],t[0]=o/a,e=c.len(i[r-2],i[r-1],n[1],n[2],n[3],n[4],n[5],n[6]),o+=e,t[1]=o/a,s.push(t))}),this.tCache=s)},__calculateCurve:function(){var t=this,e=t.__attrs,n=e.path;this.curve=u.toCurve(n)},getPoint:function(t){var e,n,r,a,o,s,u=this.tCache;return u||(this.__calculateCurve(),this.__setTcache(),u=this.tCache),e=this.curve,u?(i.each(u,function(e,i){
                t>=e[0]&&t<=e[1]&&(n=(t-e[0])/(e[1]-e[0]),r=i)}),a=e[r],i.isNull(a)||i.isNull(r)?null:(o=a.length,s=e[r+1],{x:c.at(a[o-2],s[1],s[3],s[5],1-n),y:c.at(a[o-1],s[2],s[4],s[6],1-n)})):e?{x:e[0][1],y:e[0][2]}:null},createPath:function(t){var e=this,n=e.__attrs,r=e.get("segments"),a=n.lineWidth,o=n.arrow;if(i.isArray(r)){t=t||e.get("context"),t.beginPath();for(var u=0,c=r.length;u<c;u++)if(u===c-1&&o){var h=r[u],d=r[u].endTangent,f={x:h.params[h.params.length-1].x,y:h.params[h.params.length-1].y};if(h&&i.isFunction(d)){var g=d(),p=s.getEndPoint(g,new l(f.x,f.y),a);h.params[h.params.length-1]=p,r[u].draw(t),s.makeArrow(t,g,p,a),h.params[h.params.length-1]=f}}else r[u].draw(t)}}}),t.exports=d},function(t,e,n){var i=n(1),r=n(5),a=n(6),o=function(t){o.superclass.constructor.call(this,t)};o.ATTRS={points:null,lineWidth:1},i.extend(o,r),i.augment(o,{canFill:!0,canStroke:!0,type:"polygon",getDefaultAttrs:function(){return{lineWidth:1}},calculateBox:function(){var t=this,e=t.__attrs,n=e.points,r=e.lineWidth;if(!n||0===n.length)return null;var a=1/0,o=1/0,s=-(1/0),u=-(1/0);i.each(n,function(t){var e=t[0],n=t[1];e<a&&(a=e),e>s&&(s=e),n<o&&(o=n),n>u&&(u=n)});var c=r/2;return{minX:a-c,minY:o-c,maxX:s+c,maxY:u+c}},isPointInPath:function(t,e){var n=this,i=n.hasFill(),r=n.hasStroke();return i&&r?n.__isPointInFill(t,e)||n.__isPointInStroke(t,e):i?n.__isPointInFill(t,e):!!r&&n.__isPointInStroke(t,e)},__isPointInFill:function(t,e){var n=this,i=n.get("context");return n.createPath(),i.isPointInPath(t,e)},__isPointInStroke:function(t,e){var n=this,i=n.__attrs,r=i.points;if(r.length<2)return!1;var o=i.lineWidth,s=r.slice(0);return r.length>=3&&s.push(r[0]),a.polyline(s,o,t,e)},createPath:function(t){var e=this,n=e.__attrs,r=n.points;r.length<2||(t=t||e.get("context"),t.beginPath(),i.each(r,function(e,n){0===n?t.moveTo(e[0],e[1]):t.lineTo(e[0],e[1])}),t.closePath())}}),t.exports=o},function(t,e,n){var i=n(1),r=n(5),a=n(6),o=n(12),s=n(22),u=n(3),c=u.Vector2,h=function(t){h.superclass.constructor.call(this,t)};h.ATTRS={points:null,lineWidth:1,arrow:!1,tCache:null},i.extend(h,r),i.augment(h,{canStroke:!0,type:"polyline",tCache:null,getDefaultAttrs:function(){return{lineWidth:1,arrow:!1}},calculateBox:function(){var t=this,e=t.__attrs,n=e.lineWidth,r=e.points;if(!r||0===r.length)return null;var a=1/0,o=1/0,s=-(1/0),u=-(1/0);i.each(r,function(t){var e=t[0],n=t[1];e<a&&(a=e),e>s&&(s=e),n<o&&(o=n),n>u&&(u=n)});var c=n/2;return{minX:a-c,minY:o-c,maxX:s+c,maxY:u+c}},__setTcache:function(){var t,e,n=this,r=n.__attrs,a=r.points,o=0,u=0,c=[];a&&0!==a.length&&(i.each(a,function(t,e){a[e+1]&&(o+=s.len(t[0],t[1],a[e+1][0],a[e+1][1]))}),o<=0||(i.each(a,function(n,i){a[i+1]&&(t=[],t[0]=u/o,e=s.len(n[0],n[1],a[i+1][0],a[i+1][1]),u+=e,t[1]=u/o,c.push(t))}),this.tCache=c))},isPointInPath:function(t,e){var n=this,i=n.__attrs;if(n.hasStroke()){var r=i.points;if(r.length<2)return!1;var o=i.lineWidth;return a.polyline(r,o,t,e)}return!1},createPath:function(t){var e,n,i=this,r=i.__attrs,a=r.points,s=r.arrow,u=r.lineWidth;if(!(a.length<2)){for(t=t||i.get("context"),t.beginPath(),t.moveTo(a[0][0],a[0][1]),n=1,e=a.length-1;n<e;n++)t.lineTo(a[n][0],a[n][1]);if(s){var h=new c(a[e][0]-a[e-1][0],a[e][1]-a[e-1][1]),l=o.getEndPoint(h,new c(a[e][0],a[e][1]),u);t.lineTo(l.x,l.y),o.makeArrow(t,h,l,u)}else t.lineTo(a[e][0],a[e][1])}},getPoint:function(t){var e,n,r=this.__attrs,a=r.points,o=this.tCache;return o||(this.__setTcache(),o=this.tCache),i.each(o,function(i,r){t>=i[0]&&t<=i[1]&&(e=(t-i[0])/(i[1]-i[0]),n=r)}),{x:s.at(a[n][0],a[n+1][0],e),y:s.at(a[n][1],a[n+1][1],e)}}}),t.exports=h},function(t,e,n){var i=n(1),r=n(5),a=n(6),o=n(12),s=n(23),u=n(3).Vector2,c=function(t){c.superclass.constructor.call(this,t)};c.ATTRS={p1:null,p2:null,p3:null,lineWidth:1,arrow:!1},i.extend(c,r),i.augment(c,{canStroke:!0,type:"quadratic",getDefaultAttrs:function(){return{lineWidth:1,arrow:!1}},calculateBox:function(){var t,e,n=this,r=n.__attrs,a=r.p1,o=r.p2,u=r.p3;if(i.isNull(a)||i.isNull(o)||i.isNull(u))return null;var c=r.lineWidth/2,h=s.extrema(a[0],o[0],u[0]);for(t=0,e=h.length;t<e;t++)h[t]=s.at(a[0],o[0],u[0],h[t]);h.push(a[0],u[0]);var l=s.extrema(a[1],o[1],u[1]);for(t=0,e=l.length;t<e;t++)l[t]=s.at(a[1],o[1],u[1],l[t]);return l.push(a[1],u[1]),{minX:Math.min.apply(Math,h)-c,maxX:Math.max.apply(Math,h)+c,minY:Math.min.apply(Math,l)-c,maxY:Math.max.apply(Math,l)+c}},isPointInPath:function(t,e){var n=this,i=n.__attrs,r=i.p1,o=i.p2,s=i.p3,u=i.lineWidth;return a.quadraticline(r[0],r[1],o[0],o[1],s[0],s[1],u,t,e)},createPath:function(t){var e=this,n=e.__attrs,r=n.p1,a=n.p2,s=n.p3,c=n.lineWidth,h=n.arrow;if(!(i.isNull(r)||i.isNull(a)||i.isNull(s)))if(t=t||e.get("context"),t.beginPath(),t.moveTo(r[0],r[1]),h){var l=new u(s[0]-a[0],s[1]-a[1]),d=o.getEndPoint(l,new u(s[0],s[1]),c);t.quadraticCurveTo(a[0],a[1],d.x,d.y),o.makeArrow(t,l,d,c)}else t.quadraticCurveTo(a[0],a[1],s[0],s[1])},getPoint:function(t){var e=this.__attrs;return{x:s.at(e.p1[0],e.p2[0],e.p3[0],t),y:s.at(e.p1[1],e.p2[1],e.p3[1],t)}}}),t.exports=c},function(t,e,n){var i=n(1),r=n(5),a=n(6),o=function(t){o.superclass.constructor.call(this,t)};o.ATTRS={x:0,y:0,width:0,height:0,radius:0,lineWidth:1},i.extend(o,r),i.augment(o,{canFill:!0,canStroke:!0,type:"rect",getDefaultAttrs:function(){return{lineWidth:1,radius:0}},calculateBox:function(){var t=this,e=t.__attrs,n=e.x,i=e.y,r=e.width,a=e.height,o=e.lineWidth,s=o/2;return{minX:n-s,minY:i-s,maxX:n+r+s,maxY:i+a+s}},isPointInPath:function(t,e){var n=this,i=n.hasFill(),r=n.hasStroke();return i&&r?n.__isPointInFill(t,e)||n.__isPointInStroke(t,e):i?n.__isPointInFill(t,e):!!r&&n.__isPointInStroke(t,e)},__isPointInFill:function(t,e){var n=this.get("context");return!!n&&(this.createPath(),n.isPointInPath(t,e))},__isPointInStroke:function(t,e){var n=this,i=n.__attrs,r=i.x,o=i.y,s=i.width,u=i.height,c=i.radius,h=i.lineWidth;if(0===c){var l=h/2;return a.line(r-l,o,r+s+l,o,h,t,e)||a.line(r+s,o-l,r+s,o+u+l,h,t,e)||a.line(r+s+l,o+u,r-l,o+u,h,t,e)||a.line(r,o+u+l,r,o-l,h,t,e)}return a.line(r+c,o,r+s-c,o,h,t,e)||a.line(r+s,o+c,r+s,o+u-c,h,t,e)||a.line(r+s-c,o+u,r+c,o+u,h,t,e)||a.line(r,o+u-c,r,o+c,h,t,e)||a.arcline(r+s-c,o+c,c,1.5*Math.PI,2*Math.PI,!1,h,t,e)||a.arcline(r+s-c,o+u-c,c,0,.5*Math.PI,!1,h,t,e)||a.arcline(r+c,o+u-c,c,.5*Math.PI,Math.PI,!1,h,t,e)||a.arcline(r+c,o+c,c,Math.PI,1.5*Math.PI,!1,h,t,e)},createPath:function(t){var e=this,n=e.__attrs,i=n.x,r=n.y,a=n.width,o=n.height,s=n.radius;t=t||e.get("context"),t.beginPath(),0===s?t.rect(i,r,a,o):(t.moveTo(i+s,r),t.lineTo(i+a-s,r),t.arc(i+a-s,r+s,s,-Math.PI/2,0,!1),t.lineTo(i+a,r+o-s),t.arc(i+a-s,r+o-s,s,0,Math.PI/2,!1),t.lineTo(i+s,r+o),t.arc(i+s,r+o-s,s,Math.PI/2,Math.PI,!1),t.lineTo(i,r+s),t.arc(i+s,r+s,s,Math.PI,3*Math.PI/2,!1),t.closePath())}}),t.exports=o},function(t,e,n){var i=n(1),r=n(5),a=n(6),o=n(40),s=function(t){s.superclass.constructor.call(this,t)};s.ATTRS={x:0,y:0,text:null,fontSize:12,fontFamily:"sans-serif",fontStyle:"normal",fontWeight:"normal",fontVariant:"normal",textAlign:"start",textBaseline:"bottom",lineHeight:null,textArr:null},i.extend(s,r),i.augment(s,{canFill:!0,canStroke:!0,type:"text",getDefaultAttrs:function(){return{lineWidth:1,lineCount:1,fontSize:12,fontFamily:"sans-serif",fontStyle:"normal",fontWeight:"normal",fontVariant:"normal",textAlign:"start",textBaseline:"bottom"}},__assembleFont:function(){var t=this.__attrs,e=t.fontSize,n=t.fontFamily,i=t.fontWeight,r=t.fontStyle,a=t.fontVariant;t.font=[r,a,i,e+"px",n].join(" ")},__afterSetAttrFontSize:function(){this.__assembleFont()},__afterSetAttrFontFamily:function(){this.__assembleFont()},__afterSetAttrFontWeight:function(){this.__assembleFont()},__afterSetAttrFontStyle:function(){this.__assembleFont()},__afterSetAttrFontVariant:function(){this.__assembleFont()},__afterSetAttrFont:function(){},__afterSetAttrText:function(){var t,e=this.__attrs,n=e.text;if(i.isString(n)&&n.indexOf("\n")!==-1){t=n.split("\n");var r=t.length;e.lineCount=r,e.textArr=t}},__getTextHeight:function(){var t=this.__attrs,e=t.lineCount,n=1*t.fontSize;if(e>1){var i=this.__getSpaceingY();return n*e+i*(e-1)}return n},__afterSetAttrAll:function(t){var e=this;("fontSize"in t||"fontWeight"in t||"fontStyle"in t||"fontVariant"in t||"fontFamily"in t)&&e.__assembleFont(),"text"in t&&e.__afterSetAttrText(t.text)},isHitBox:function(){return!1},calculateBox:function(){var t=this,e=t.__attrs,n=e.x,i=e.y,r=t.measureText();if(!r)return{minX:n,minY:i,maxX:n,maxY:i};var a=t.__getTextHeight(),o=e.textAlign,s=e.textBaseline,u=e.lineWidth,c={x:n,y:i-a};o&&("end"===o||"right"===o?c.x-=r:"center"===o&&(c.x-=r/2)),s&&("top"===s?c.y+=a:"middle"===s&&(c.y+=a/2)),this.set("startPoint",c);var h=u/2;return{minX:c.x-h,minY:c.y-h,maxX:c.x+r+h,maxY:c.y+a+h}},__getSpaceingY:function(){var t=this.__attrs,e=t.lineHeight,n=1*t.fontSize;return e?e-n:.14*n},isPointInPath:function(t,e){var n=this,i=n.getBBox();if(n.hasFill()||n.hasStroke())return a.box(i.minX,i.maxX,i.minY,i.maxY,t,e)},drawInner:function(t){var e=this,n=e.__attrs,r=n.text;if(r){var a,o=n.textArr,s=1*n.fontSize,u=e.__getSpaceingY(),c=n.x,h=n.y,l=n.textBaseline;if(o){var d=e.getBBox();a=d.maxY-d.minY}var f;if(t.beginPath(),e.hasFill()){var g=n.fillOpacity;i.isNull(g)||1===g||(t.globalAlpha=g),o?i.each(o,function(e,n){f=h+n*(u+s)-a+s,"middle"===l&&(f+=a-s-(a-s)/2),"top"===l&&(f+=a-s),t.fillText(e,c,f)}):t.fillText(r,c,h)}e.hasStroke()&&(o?i.each(o,function(e,n){f=h+n*(u+s)-a+s,"middle"===l&&(f+=a-s-(a-s)/2),"top"===l&&(f+=a-s),t.strokeText(e,c,f)}):t.strokeText(r,c,h))}},measureText:function(){var t,e=this,n=e.__attrs,r=n.text,a=n.font,s=n.textArr,u=0;if(!i.isNull(r)){var c=o.backupContext;return c.save(),c.font=a,s?i.each(s,function(e){t=c.measureText(e).width,u<t&&(u=t),c.restore()}):(u=c.measureText(r).width,c.restore()),u}}}),t.exports=s},function(t,e,n){var i=n(1),r=n(110),a=n(109),o=n(20);i.mix(i,a,{mixin:function(t,e){var n=t.CFG?"CFG":"ATTRS";if(t&&e){t._mixins=e,t[n]=t[n]||{};var r={};i.each(e,function(e){i.augment(t,e);var a=e[n];a&&i.mix(r,a)}),t[n]=i.mix(r,t[n])}},isPositiveNum:function(t){var e=/^[0-9]*[1-9][0-9]*$/;return e.test(t)},getRatio:function(){return window.devicePixelRatio?window.devicePixelRatio:2},getWidth:function(t){var e=i.getStyle(t,"width");return"auto"===e&&(e=t.offsetWidth),parseFloat(e)},getHeight:function(t){var e=i.getStyle(t,"height");return"auto"===e&&(e=t.offsetHeight),parseFloat(e)},getOuterHeight:function(t){var e=i.getHeight(t),n=parseFloat(i.getStyle(t,"borderTopWidth"))||0,r=parseFloat(i.getStyle(t,"paddingTop")),a=parseFloat(i.getStyle(t,"paddingBottom")),o=parseFloat(i.getStyle(t,"borderBottomWidth"))||0;return e+n+o+r+a},parsePathString:o.toArray,path2string:o.toString,path2curve:o.toCurve,pathToAbsolute:o.toAbsolute,catmullRom2bezier:o.catmullRomToBezier,parsePathArray:function(t){return i.path2string(t)},path2Absolute:function(t){return i.pathToAbsolute(t)}}),i.MatrixUtil=r,t.exports=i},function(t,e,n){"use strict";function i(t,e){var n=e.get("children");o.each(n,function(e){e.isGroup&&e.get("visible")?i(t,e):t.push(e)})}function r(t,e,n){for(var i=t.get("parent");i!==n;)e.push(i),i=i.get("parent")}var a=n(10).G,o=n(4),s=a.Group,u=function t(e){t.superclass.constructor.call(this,e)};o.extend(u,s),o.augment(u,{drawInner:function(t){var e=this,n=[],a=void 0;return i(n,e),o.radixSort(n,function(t){return t.get("zIndex")}),o.each(n,function(n){a=[],t.save(),r(n,a,e),o.each(a,function(e){e.resetTransform(t)}),n.draw(t),t.restore()}),e}}),t.exports=u},function(t,e,n){"use strict";var i=n(27);i.Node=n(125),i.Edge=n(124),t.exports=i},function(t,e,n){"use strict";var i=n(1),r=n(11),a=["color","shape","size","label","tooltip","style"],o=n(126),s="origin",u=function t(e){t.superclass.constructor.call(this,e),this._init()};u.ATTRS={attrs:null,type:null},i.extend(u,r),i.augment(u,{_init:function(){this._initAttrs()},_initAttrs:function(){var t=this,e={};i.each(a,function(t){e[t]=new o({type:t})}),t.set("attrs",e)},_getAttr:function(t){return this.get("attrs")[t]},_updateCallbackMappingAttr:function(t,e){var n=this._getAttr(t);n.mappingType="custom",n.callback=e},_updateAutoMappingAttr:function(t,e,n){var i=this._getAttr(t);i.dims=this._parseDims(e),i.callback=n},_parseDims:function(t){var e=null;return e=i.isArray(t)?t:i.isString(t)?t.split("*"):[t]},mapping:function(t){var e=this,n=e.get("attrs"),r={};return i.each(n,function(e){var n=e.type;i.isNull(t[n])?r[n]=e.getValue(t):r[n]=t[n]}),r.x=t.x?t.x:0,r.y=t.y?t.y:0,r.style=i.mix({},r.style,t.style),r.labelStyle=t.labelStyle,r[s]=t,r.model=t,r}}),i.each(a,function(t){u.prototype[t]=function(e,n){var r=this;return i.isFunction(e)?r._updateCallbackMappingAttr(t,e):("label"!==t||n||(n=function(){return i.toArray(arguments)}),"tooltip"!==t||n||(n=function(){var t=i.toArray(arguments),n=r._parseDims(e),a=[],o=void 0;for(o=0;o<t.length;o++)a.push([n[o],t[o]]);return a}),r._updateAutoMappingAttr(t,e,n)),r}}),t.exports=u},function(t,e,n){"use strict";var i=n(29);n(137),n(136),t.exports=i},function(t,e,n){"use strict";function i(t){var e=r.mix({},s.nodeStyle);return t.color&&(e.stroke=t.color,e.fill=t.color),t.style&&r.mix(e,t.style),e}var r=n(1),a=n(142),o=n(31),s=n(7);t.exports={drawNode:function(t,e,n){var r=i(e),o=a[t](e,n,r);return"text"!==t&&"html"!==t&&o.attr(r),o.set("zIndex",s.zIndex.node),o.set("class","node-key-shape"),o},getSnapAnchor:function(t,e){if(!t||!e)return!1;var n=t.getCenter(),i=t.getAnchorPoints(),a=o.vector(n,e),s=1/0,u=void 0,c=void 0,h=void 0;return r.each(i,function(t){h=o.vector(n,t),u=a.angleTo(h),u>Math.PI&&(u=2*Math.PI-u),u<s&&(s=u,c=t)}),c}}},function(t,e,n){"use strict";var i=n(2);i.buttonPointer=function(t){t._on("mouseenter",function(e){var n=e.shape;n&&n.hasClass("Button")&&t.css({cursor:"pointer"})}),t._on("mouseleave",function(e){var n=e.shape;n&&n.hasClass("Button")&&t.css({cursor:"default"})})}},function(t,e,n){"use strict";var i=n(2),r=n(19);i.dragBlank=function(t){r(t,!0)}},function(t,e,n){"use strict";var i=n(2),r=n(4);i.wheelZoom=function(t){var e=1,n=1.05,i=t.get("rootGroup"),a=i.get("canvas"),o=setTimeout(function(){},100),s=t.get("wheelScaleLimit"),u=void 0,c=void 0,h=void 0,l=void 0;t._on("mousewheel",function(d){var f=t.get("domFocus");if(f&&(u=d.domEvent,u.preventDefault(),c=u.wheelDelta,Math.abs(c)>10)){if(h=a.getPointByClient(u.clientX,u.clientY),h={x:h.x/a.get("pixelRatio"),y:h.y/a.get("pixelRatio")},l=i.getMatrix().clone(),c>0?(e*=n,r.scaleMatrix(n,h,l)):(e/=n,r.scaleMatrix(1/n,h,l)),!r.isBetween(l.elements[0],s[0],s[1]))return;t.setCapture(!1),t.updateMatrix(l),t.refresh(),t.fire("wheelzoom",r.mix({scale:l.elements[0]},d)),clearTimeout(o),o=setTimeout(function(){t.setCapture(!0),t.fire("wheelzoomend",r.mix({scale:l.elements[0]},d)),t.draw(!1)},60)}})}},function(t,e,n){"use strict";var i={CompactBoxTree:n(172),Dendrogram:n(177),IndentedTree:n(178),LayeredTidyTree:n(179),TreeLayout:n(14)};t.exports=i},function(t,e){"use strict";function n(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function i(t,e,n){n?t.y+=e:t.x+=e,t.children.forEach(function(t){i(t,e,n)})}function r(t,e){var n=e?t.y:t.x;return t.children.forEach(function(t){n=Math.min(r(t,e),n)}),n}function a(t,e){var n=r(t,e);i(t,-n,e)}function o(t,e,n){n?e.y=t.x:e.x=t.x,t.c.forEach(function(t,i){o(t,e.children[i],n)})}function s(t,e){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:0;e?(t.x=n,n+=t.width):(t.y=n,n+=t.height),t.children.forEach(function(t){s(t,e,n)})}var u=function t(e,i,r){var a=arguments.length>3&&void 0!==arguments[3]?arguments[3]:[];n(this,t);var o=this;o.w=e||0,o.h=i||0,o.y=r||0,o.x=0,o.c=a||[],o.cs=a.length,o.prelim=0,o.mod=0,o.shift=0,o.change=0,o.tl=null,o.tr=null,o.el=null,o.er=null,o.msel=0,o.mser=0};u.fromNode=function(t,e){if(!t)return null;var n=[];return t.children.forEach(function(t){n.push(u.fromNode(t,e))}),e?new u(t.height,t.width,t.x,n):new u(t.width,t.height,t.y,n)},t.exports=function(t){function e(t){if(0===t.cs)return void n(t);e(t.c[0]);for(var r=m(l(t.c[0].el),0,null),a=1;a<t.cs;++a){e(t.c[a]);var o=l(t.c[a].er);i(t,a,r),r=m(o,a,r)}g(t),n(t)}function n(t){0===t.cs?(t.el=t,t.er=t,t.msel=t.mser=0):(t.el=t.c[0].el,t.msel=t.c[0].msel,t.er=t.c[t.cs-1].er,t.mser=t.c[t.cs-1].mser)}function i(t,e,n){for(var i=t.c[e-1],a=i.mod,o=t.c[e],s=o.mod;null!==i&&null!==o;){l(i)>n.low&&(n=n.nxt);var u=a+i.prelim+i.w-(s+o.prelim);u>0&&(s+=u,r(t,e,n.index,u));var g=l(i),p=l(o);g<=p&&(i=h(i),null!==i&&(a+=i.mod)),g>=p&&(o=c(o),null!==o&&(s+=o.mod))}!i&&o?d(t,e,o,s):i&&!o&&f(t,e,i,a)}function r(t,e,n,i){t.c[e].mod+=i,t.c[e].msel+=i,t.c[e].mser+=i,v(t,e,n,i)}function c(t){return 0===t.cs?t.tl:t.c[0]}function h(t){return 0===t.cs?t.tr:t.c[t.cs-1]}function l(t){return t.y+t.h}function d(t,e,n,i){var r=t.c[0].el;r.tl=n;var a=i-n.mod-t.c[0].msel;r.mod+=a,r.prelim-=a,t.c[0].el=t.c[e].el,t.c[0].msel=t.c[e].msel}function f(t,e,n,i){var r=t.c[e].er;r.tr=n;var a=i-n.mod-t.c[e].mser;r.mod+=a,r.prelim-=a,t.c[e].er=t.c[e-1].er,t.c[e].mser=t.c[e-1].mser}function g(t){t.prelim=(t.c[0].prelim+t.c[0].mod+t.c[t.cs-1].mod+t.c[t.cs-1].prelim+t.c[t.cs-1].w)/2-t.w/2}function p(t,e){e+=t.mod,t.x=t.prelim+e,x(t);for(var n=0;n<t.cs;n++)p(t.c[n],e)}function v(t,e,n,i){if(n!==e-1){var r=e-n;t.c[n+1].shift+=i/r,t.c[e].shift-=i/r,t.c[e].change-=i-i/r}}function x(t){for(var e=0,n=0,i=0;i<t.cs;i++)e+=t.c[i].shift,n+=e+t.c[i].change,t.c[i].mod+=n}function m(t,e,n){for(;null!==n&&t>=n.low;)n=n.nxt;return{low:t,index:e,nxt:n}}var y=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},b=y.isHorizontal;s(t,b);var w=u.fromNode(t,b);return e(w),p(w,0),o(w,t,b),a(t,b),t}},function(t,e,n){"use strict";var i=n(33);t.exports=function(t,e){for(var n=new i(t.data,e,!0),r=new i(t.data,e,!0),a=t.children.length,o=Math.round(a/2),s=0;s<a;s++){var u=t.children[s];s<o?r.children.push(u):n.children.push(u)}return{left:n,right:r}}},function(t,e,n){"use strict";function i(t,e,n,i){i.forceAlign?t.align=i.forceAlign:!t.isRoot()||"H"!==i.direction&&"V"!==i.direction?t.align=t.isLeaf()?a(n):n:t.align=i.isHorizontal?"CH":"CV",t.inAnchor=r[e],t.outAnchor=r[n]}var r=n(173),a=n(180);t.exports=function(t,e,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},a=arguments[4];a?i(t,e,n,r):t.eachNode(function(t){i(t,e,n,r)})}},function(t,e,n){"use strict";function i(){this.elements=[1,0,0,0,1,0,0,0,1]}var r=n(1),a=n(8);i.multiply=function(t,e){var n=t.elements,r=e.elements,a=new i;return a.set(n[0]*r[0]+n[3]*r[1]+n[6]*r[2],n[0]*r[3]+n[3]*r[4]+n[6]*r[5],n[0]*r[6]+n[3]*r[7]+n[6]*r[8],n[1]*r[0]+n[4]*r[1]+n[7]*r[2],n[1]*r[3]+n[4]*r[4]+n[7]*r[5],n[1]*r[6]+n[4]*r[7]+n[7]*r[8],n[2]*r[0]+n[5]*r[1]+n[8]*r[2],n[2]*r[3]+n[5]*r[4]+n[8]*r[5],n[2]*r[6]+n[5]*r[7]+n[8]*r[8])},i.equal=function(t,e){for(var n=t.elements,i=e.elements,r=!0,o=0,s=n.length;o<s;o++)if(!a.equal(n[o],i[o])){r=!1;break}return r},r.augment(i,{type:"matrix3",set:function(t,e,n,i,r,a,o,s,u){var c=this.elements;return c[0]=t,c[3]=e,c[6]=n,c[1]=i,c[4]=r,c[7]=a,c[2]=o,c[5]=s,c[8]=u,this},get:function(t,e){return t--,e--,this.elements[3*e+t]},identity:function(){return this.set(1,0,0,0,1,0,0,0,1)},multiplyScalar:function(t){var e=this.elements;return e[0]*=t,e[3]*=t,e[6]*=t,e[1]*=t,e[4]*=t,e[7]*=t,e[2]*=t,e[5]*=t,e[8]*=t,this},det:function(){var t=this.elements,e=t[0],n=t[1],i=t[2],r=t[3],a=t[4],o=t[5],s=t[6],u=t[7],c=t[8];return e*a*c-e*o*u-n*r*c+n*o*s+i*r*u-i*a*s},inverse:function(t){return this.copy(this.getInverse(t))},getInverse:function(t){var e=this.det();if(0===e){if(t)throw"matrix exception: get inverse matrix with 0 det";return console.warn("matrix cannot inverse"),new i}var n=this.elements,r=(n[0],n[3],n[6],n[1],n[4],n[7],n[2],n[5],n[8],new i);return r.set(n[4]*n[8]-n[7]*n[5],-(n[3]*n[8]-n[6]*n[5]),n[3]*n[7]-n[6]*n[4],-(n[1]*n[8]-n[7]*n[2]),n[0]*n[8]-n[6]*n[2],-(n[0]*n[7]-n[6]*n[1]),n[1]*n[5]-n[4]*n[2],-(n[0]*n[5]-n[3]*n[2]),n[0]*n[4]-n[3]*n[1]),r.multiplyScalar(1/e),r},transpose:function(){var t,e=this.elements;return t=e[1],e[1]=e[3],e[3]=t,t=e[2],e[2]=e[6],e[6]=t,t=e[5],e[5]=e[7],e[7]=t,this},multiply:function(t){return this.copy(i.multiply(this,t))},translate:function(t,e){var n=new i;return n.set(1,0,t,0,1,e,0,0,1),this.copy(i.multiply(n,this))},rotate:function(t){var e=new i;return e.set(Math.cos(t),-Math.sin(t),0,Math.sin(t),Math.cos(t),0,0,0,1),this.copy(i.multiply(e,this))},scale:function(t,e){var n=new i;return n.set(t,0,0,0,e,0,0,0,1),this.copy(i.multiply(n,this))},equal:function(t){return i.equal(this,t)},copy:function(t){for(var e=t.elements,n=this.elements,i=0,r=e.length;i<r;i++)n[i]=e[i];return this},clone:function(){for(var t=new i,e=t.elements,n=this.elements,r=0,a=n.length;r<a;r++)e[r]=n[r];return t},to2DObject:function(){var t=this.elements;return{a:t[0],b:t[1],c:t[3],d:t[4],e:t[6],f:t[7]}},from2DObject:function(t){var e=this.elements;return e[0]=t.a,e[1]=t.b,e[3]=t.c,e[4]=t.d,e[6]=t.e,e[7]=t.f,this}}),t.exports=i},function(t,e,n){"use strict";function i(t,e){if(1===arguments.length){var n=t;t=n[0],e=n[1]}this.x=t||0,this.y=e||0}var r=n(1),a=n(8);i.add=function(t,e){return new i(t.x+e.x,t.y+e.y)},i.sub=function(t,e){return new i(t.x-e.x,t.y-e.y)},i.lerp=function(t,e,n){return new i(t.x+(e.x-t.x)*n,t.y+(e.y-t.y)*n)},i.angle=function(t,e){var n=t.dot(e)/(t.length()*e.length());return Math.acos(a.clamp(n,-1,1))},i.direction=function(t,e){return t.x*e.y-e.x*t.y},r.augment(i,{type:"vector2",set:function(t,e){return this.x=t,this.y=e,this},setComponent:function(t,e){switch(t){case 0:return this.x=e,this;case 1:return this.y=e,this;default:throw new Error("the index out of range:"+t)}},getComponent:function(t){switch(t){case 0:return this.x;case 1:return this.y;default:throw new Error("the index out of range:"+t)}},copy:function(t){return this.x=t.x,this.y=t.y,this},add:function(t){return this.copy(i.add(this,t))},sub:function(t){return this.copy(i.sub(this,t))},subBy:function(t){return this.copy(i.sub(t,this))},multiplyScaler:function(t){return this.x*=t,this.y*=t,this},divideScaler:function(t){if(0!==t){var e=1/t;this.x*=e,this.y*=e}else this.x=0,this.y=0;return this},min:function(t){return this.x>t.x&&(this.x=t.x),this.y>t.y&&(this.y=t.y),this},max:function(t){return this.x<t.x&&(this.x=t.x),this.y<t.y&&(this.y=t.y),this},clamp:function(t,e){return this.x<t.x?this.x=t.x:this.x>e.x&&(this.x=e.x),this.y<t.y?this.y=t.y:this.y>e.y&&(this.y=e.y),this},clampScale:function(){var t,e;return function(n,r){return void 0===t&&(t=new i,e=new i),t.set(n,n),e.set(r,r),this.clamp(t,e)}}(),floor:function(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this},ceil:function(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this},round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this},roundToZero:function(){return this.x=this.x<0?Math.ceil(this.x):Math.floor(this.x),this.y=this.y<0?Math.ceil(this.y):Math.floor(this.y),this},negate:function(){return this.x=-this.x,this.y=-this.y,this},dot:function(t){return this.x*t.x+this.y*t.y},lengthSq:function(){return this.x*this.x+this.y*this.y},length:function(){return Math.sqrt(this.lengthSq())},normalize:function(){return this.divideScaler(this.length())},distanceToSquared:function(t){var e=this.x-t.x,n=this.y-t.y;return e*e+n*n},distanceTo:function(t){return Math.sqrt(this.distanceToSquared(t))},angleTo:function(t,e){var n=this.angle(t),r=i.direction(this,t)>=0;return e?r?2*Math.PI-n:n:r?n:2*Math.PI-n},vertical:function(t){return t?new i(this.y,-this.x):new i(-this.y,this.x)},angle:function(t){return i.angle(this,t)},setLength:function(t){var e=this.length();return 0!==e&&t!==e&&this.multiplyScaler(t/e),this},isZero:function(){return 0===this.x&&0===this.y},lerp:function(t,e){return this.copy(i.lerp(this,t,e))},equal:function(t){return a.equal(this.x,t.x)&&a.equal(this.y,t.y)},clone:function(){return new i(this.x,this.y)},rotate:function(t){var e=this.x*Math.cos(t)-this.y*Math.sin(t),n=this.x*Math.sin(t)+this.y*Math.cos(t);return this.x=e,this.y=n,this}}),t.exports=i},function(t,e,n){"use strict";function i(t,e,n){if(1===arguments.length)if(r.isArray(t)){var i=t;t=i[0],e=i[1],n=i[2]}else if("vector2"===t.type){var a=t;t=a.x,e=a.y,n=1}this.x=t||0,this.y=e||0,this.z=n||0}var r=n(1),a=n(8);i.add=function(t,e){return new i(t.x+e.x,t.y+e.y,t.z+e.z)},i.sub=function(t,e){return new i(t.x-e.x,t.y-e.y,t.z-e.z)},i.lerp=function(t,e,n){return new i(t.x+(e.x-t.x)*n,t.y+(e.y-t.y)*n,t.z+(e.z-t.z)*n)},i.cross=function(t,e){var n=t.x,r=t.y,a=t.z,o=e.x,s=e.y,u=e.z;return new i(r*u-a*s,a*o-n*u,n*s-r*o)},i.angle=function(t,e){var n=t.dot(e)/(t.length()*e.length());return Math.acos(a.clamp(n,-1,1))},r.augment(i,{type:"vector3",set:function(t,e,n){return this.x=t,this.y=e,this.z=n,this},setComponent:function(t,e){switch(t){case 0:return this.x=e,this;case 1:return this.y=e,this;case 2:return this.z=e,this;default:throw new Error("index is out of range:"+t)}},getComponent:function(t){switch(t){case 0:return this.x;case 1:return this.y;case 2:return this.z;default:throw new Error("index is out of range:"+t)}},add:function(t){return this.copy(i.add(this,t))},sub:function(t){return this.copy(i.sub(this,t))},subBy:function(t){return this.copy(i.sub(t,this))},multiplyScaler:function(t){return this.x*=t,this.y*=t,this.z*=t,this},divideScaler:function(t){if(0!==t){var e=1/t;this.x*=e,this.y*=e,this.z*=e}else this.x=0,this.y=0,this.z=0;return this},min:function(t){return this.x>t.x&&(this.x=t.x),this.y>t.y&&(this.y=t.y),this.z>t.z&&(this.z=t.z),this},max:function(t){return this.x<t.x&&(this.x=t.x),this.y<t.y&&(this.y=t.y),this.z<t.z&&(this.z=t.z),this},clamp:function(t,e){return this.x<t.x?this.x=t.x:this.x>e.x&&(this.x=e.x),this.y<t.y?this.y=t.y:this.y>e.y&&(this.y=e.y),this.z<t.z?this.z=t.z:this.z>e.z&&(this.z=e.z),this},clampScale:function(){var t,e;return function(n,r){return void 0===t&&(t=new i,e=new i),t.set(n,n,n),e.set(r,r,r),this.clamp(t,e)}}(),floor:function(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this.z=Math.floor(this.z),this},ceil:function(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this.z=Math.ceil(this.z),this},round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this.z=Math.round(this.z),this},roundToZero:function(){return this.x=this.x<0?Math.ceil(this.x):Math.floor(this.x),this.y=this.y<0?Math.ceil(this.y):Math.floor(this.y),this.z=this.z<0?Math.ceil(this.z):Math.floor(this.z),this},negate:function(){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this},dot:function(t){return this.x*t.x+this.y*t.y+this.z*t.z},lengthSq:function(){return this.x*this.x+this.y*this.y+this.z*this.z},length:function(){return Math.sqrt(this.lengthSq())},lengthManhattan:function(){return Math.abs(this.x)+Math.abs(this.y)+Math.abs(this.z)},normalize:function(){return this.divideScaler(this.length())},setLength:function(t){var e=this.length();return 0!==e&&t!==e&&this.multiplyScaler(t/e),this},lerp:function(t,e){return this.copy(i.lerp(this,t,e))},cross:function(t){return this.copy(i.cross(this,t))},angle:function(t){return i.angle(this,t)},distanceToSquared:function(t){var e=this.x-t.x,n=this.y-t.y,i=this.z-t.z;return e*e+n*n+i*i},distanceTo:function(t){return Math.sqrt(this.distanceToSquared(t))},applyMatrix:function(t){var e=t.elements,n=e[0]*this.x+e[3]*this.y+e[6]*this.z,i=e[1]*this.x+e[4]*this.y+e[7]*this.z,r=e[2]*this.x+e[5]*this.y+e[8]*this.z;return this.x=n,this.y=i,this.z=r,this},copy:function(t){return this.x=t.x,this.y=t.y,this.z=void 0!==t.z?t.z:1,this},equal:function(t){return a.equal(this.x,t.x)&&a.equal(this.y,t.y)&&a.equal(this.z,t.z)},clone:function(){return new i(this.x,this.y,this.z)}}),t.exports=i},function(t,e,n){var i=n(76);t.exports=i},function(t,e,n){"use strict";var i=n(1),r=function(t,e,n,i){this.type=t,this.target=null,this.currentTarget=null,this.bubbles=n,this.cancelable=i,this.timeStamp=(new Date).getTime(),this.defaultPrevented=!1,this.propagationStopped=!1,this.removed=!1,this.event=e};i.augment(r,{preventDefault:function(){this.defaultPrevented=this.cancelable&&!0},stopPropagation:function(){this.propagationStopped=!0},remove:function(){this.remove=!0},clone:function(){return i.clone(this)},toString:function(){return"[Event (type="+this.type+")]"}}),t.exports=r},function(t,e,n){var i=n(80);t.exports={interpolation:i.interpolation,unInterpolation:i.unInterpolation}},function(t,e,n){"use strict";function i(t,e){for(var n=[],r=Math.min(t.length,e.length),s=0;s<r;s++)o.isArray(t[s])&&o.isArray(e[s])?n[s]=i(t[s],e[s]):n[s]=a.singular(t[s],e[s]);return function(t){for(var e=[],i=0;i<r;i++)e[i]=n[i](t);return e}}function r(t,e){for(var n=[],i=Math.min(t.length,e.length),s=0;s<i;s++)o.isArray(t[s])&&o.isArray(e[s])?n[s]=r(t[s],e[s]):n[s]=a.unSingular(t[s],e[s]);return function(t){for(var e=Math.min(n.length,t.length),i=0,r=0,a=0;a<e;a++)i+=n[a](t[a]),r++;return 0===r?0:i/r}}var a=n(15),o=n(1);t.exports={array:i,unArray:r}},function(t,e,n){"use strict";function i(t,e){switch(e.getType()){case"rgb":return a(t,e);case"hsl":return s(t,e)}}function r(t,e){switch(e.getType()){case"rgb":return o(t,e);case"hsl":return u(t,e)}}function a(t,e){var n=t.getR(),i=t.getG(),r=t.getB(),a=t.getA(),o=e.getR()-n,s=e.getG()-i,u=e.getB()-r,h=e.getA();return void 0===a&&void 0===h||(a=a||1,h=(void 0===h?1:h)-a),function(t){var e=new c;return e.setRGB(n+o*t,i+s*t,r+u*t,void 0!==a&&void 0!==h?a+h*t:void 0),e.getRGBStyle()}}function o(t,e){var n=t.getR(),i=t.getG(),r=t.getB(),a=t.getA(),o=e.getR()-n,s=e.getG()-i,u=e.getB()-r,h=e.getA();return void 0===a&&void 0===h||(a=a||1,h=(void 0===h?1:h)-a),function(t){if(t=new c(t),!t.getType())return 0;var e=t.getR(),l=t.getG(),d=t.getB(),f=t.getA();f=f||1;var g=0,p=0;return 0!==o&&(g+=(e-n)/o,p++),0!==s&&(g+=(l-i)/s,p++),0!==u&&(g+=(d-r)/u,p++),0!==h&&h&&(g+=(f-a)/h,p++),0===p?0:g/p}}function s(t,e){var n=t.getH(),i=t.getS(),r=t.getL(),a=t.getA(),o=e.getH()-n,s=e.getS()-i,u=e.getL()-r,h=e.getA();return void 0===a&&void 0===h||(a=a||1,h=(void 0===h?1:h)-a),function(t){var e=new c;return e.setHSL(n+o*t,i+s*t,r+u*t,void 0!==a&&void 0!==h?a+h*t:void 0),e.getHSLStyle()}}function u(t,e){var n=t.getH(),i=t.getS(),r=t.getL(),a=t.getA(),o=e.getH()-n,s=e.getS()-i,u=e.getL()-r,h=e.getA();return void 0===a&&void 0===h||(a=a||1,h=(void 0===h?1:h)-a),function(t){if(t=new c(t),!t.getType())return 0;var e=t.getH(),l=t.getS(),d=t.getL(),f=t.getA();f=f||1;var g=0,p=0;return 0!==o&&(g+=(e-n)/o,p++),0!==s&&(g+=(l-i)/s,p++),0!==u&&(g+=(d-r)/u,p++),0!==h&&h&&(g+=(f-a)/h,p++),0===p?0:g/p}}var c=n(16);t.exports={color:i,unColor:r}},function(t,e,n){"use strict";function i(t,e){return a.isObject(t)&&a.isObject(e)?"matrix3"===t.type&&"matrix3"===e.type?h.matrix(t,e):"path"===t.type&&"path"===e.type?o.path(t,e):u.object(t,e):a.isArray(t)&&a.isArray(e)?s.array(t,e):c.singular(t,e)}function r(t,e){return"matrix3"===t.type&&"matrix3"===e.type?h.unMatrix(t,e):a.isArray(t)&&a.isArray(e)?s.unArray(t,e):a.isObject(t)&&a.isObject(e)?u.unObject(t,e):c.unSingular(t,e)}var a=n(1),o=n(84),s=n(78),u=n(83),c=n(15),h=n(81),l=n(3);l.Matrix3;t.exports={interpolation:i,unInterpolation:r}},function(t,e,n){"use strict";function i(t,e){for(var n=[],i=t.elements,r=e.elements,o=0;o<u;o++)n[o]=a.singular(i[o],r[o]);return function(t){for(var e=new s,i=e.elements,r=0;r<u;r++)i[r]=n[r](t);return e}}function r(t,e){for(var n=[],i=t.elements,r=e.elements,o=0;o<u;o++)n[o]=a.unSingular(i[o],r[o]);return function(t){for(var e=t.elements,i=0,r=0,a=0;a<u;a++){var o=n[a](e[a]);0!==o&&(i+=o,r++)}return i/r}}var a=n(15),o=n(3),s=o.Matrix3,u=9;t.exports={matrix:i,unMatrix:r}},function(t,e){"use strict";function n(t,e){return t=+t,e=+e,function(n){return t*(1-n)+e*n}}function i(t,e){return e-=t,function(n){return 0===e?0:(n-t)/e}}t.exports={number:n,unNumber:i}},function(t,e,n){"use strict";function i(t,e){var n={};for(var i in t)i in e&&(n[i]=a.singular(t[i],e[i]));return function(t){var e={};for(var i in n)e[i]=n[i](t);return e}}function r(t,e){var n={};for(var i in t)i in e&&(n[i]=a.unSingular(t[i],e[i]));return function(t){var e=0,i=0;for(var r in n)r in t&&(e+=n[r](t[r]),i++);return 0===i?0:e/i;
                }}var a=n(15);t.exports={object:i,unObject:r}},function(t,e,n){"use strict";function i(t,e){var n=r.toCurve(t.path,e.path),i=n[0],a=n[1];return function(n){var r=[];if(n>=1)return e.path;if(n<=0)return t.path;for(var o=0;o<i.length;o++){r[o]=[i[o][0]];for(var s=1;s<i[o].length;s++)r[o][s]=(a[o][s]-i[o][s])*n+i[o][s]}return r}}var r=n(20);t.exports={path:i}},function(t,e,n){"use strict";function i(t){this.space={},r.isString(t)?this.setStyle(t):t instanceof i&&this.copy(t)}var r=n(1),a=(n(8),n(87)),o=n(88),s=n(86),u={hex:/^#([A-Fa-f0-9]{3}|[A-Fa-f0-9]{6})$/,space:/^((?:rgb|hsl)a?)\(\s*([^\)]*)\)$/,rgbNum:/^(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*$/,rgbaNum:/^(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*([0-9]*\.?[0-9]+)\s*$/,rgbPre:/^(\d+)\%\s*,\s*(\d+)\%\s*,\s*(\d+)\%\s*$/,rgbaPre:/^(\d+)\%\s*,\s*(\d+)\%\s*,\s*(\d+)\%\s*,\s*([0-9]*\.?[0-9]+)\s*$/,hsl:/^([0-9]*\.?[0-9]+)\s*,\s*(\d+)\%\s*,\s*(\d+)\%\s*$/,hsla:/^([0-9]*\.?[0-9]+)\s*,\s*(\d+)\%\s*,\s*(\d+)\%\s*,\s*([0-9]*\.?[0-9]+)\s*$/};r.augment(i,{getType:function(){return this.space.type},toRGB:function(){var t=this.space;if("rgb"!==t.type){var e=t.toRGB();this.setRGB(e.r,e.g,e.b,e.a)}},toHSL:function(){var t=this.space;if("hsl"!==t.type){var e=t.toHSL();this.setHSL(e.h,e.s,e.l,e.a)}},getR:function(){return this.toRGB(),this.space.r},getG:function(){return this.toRGB(),this.space.g},getB:function(){return this.toRGB(),this.space.b},getH:function(){return this.toHSL(),this.space.h},getS:function(){return this.toHSL(),this.space.s},getL:function(){return this.toHSL(),this.space.l},getA:function(){return this.space.a},multiplyA:function(t){return void 0===t?this:(void 0===this.space.a&&(this.space.a=1),this.space.a*=t,this)},getRGBStyle:function(){return this.toRGB(),this.space.getStyle()},getRGBPreStyle:function(){return this.toRGB(),this.space.getPreStyle()},getHSLStyle:function(){return this.toHSL(),this.space.getStyle()},getHex:function(){return this.toRGB(),this.space.getHex()},setRGB:function(t,e,n,i){return this.space=new o,this.space.setRGB(t,e,n,i),this},setHSL:function(t,e,n,i){return this.space=new a,this.space.setHSL(t,e,n,i),this},setHex:function(t){return this.space=new o,t=Math.floor(t),this.space.r=(t>>16&255)/255,this.space.g=(t>>8&255)/255,this.space.b=(255&t)/255,this},setStyle:function(t){var e;if(e=u.hex.exec(t)){var n=e[1],i=n.length;if(3===i)return this.setRGB(parseInt(n.charAt(0)+n.charAt(0),16)/255,parseInt(n.charAt(1)+n.charAt(1),16)/255,parseInt(n.charAt(2)+n.charAt(2),16)/255),this;if(6===i)return this.setRGB(parseInt(n.charAt(0)+n.charAt(1),16)/255,parseInt(n.charAt(2)+n.charAt(3),16)/255,parseInt(n.charAt(4)+n.charAt(5),16)/255),this}else if(e=u.space.exec(t)){var r,a=e[1],o=e[2];switch(a){case"rgb":if(r=u.rgbNum.exec(o))return this.setRGB(parseInt(r[1],10)/255,parseInt(r[2],10)/255,parseInt(r[3],10)/255),this;if(r=u.rgbPre.exec(o))return this.setRGB(parseInt(r[1],10)/100,parseInt(r[2],10)/100,parseInt(r[3],10)/100),this;break;case"rgba":if(r=u.rgbaNum.exec(o))return this.setRGB(parseInt(r[1],10)/255,parseInt(r[2],10)/255,parseInt(r[3],10)/255,parseFloat(r[4])),this;if(r=u.rgbaPre.exec(o))return this.setRGB(parseInt(r[1],10)/100,parseInt(r[2],10)/100,parseInt(r[3],10)/100,parseFloat(r[4])),this;break;case"hsl":if(r=u.hsl.exec(o))return this.setHSL(parseInt(r[1],10)/360,parseInt(r[2],10)/100,parseInt(r[3],10)/100),this;break;case"hsla":if(r=u.hsla.exec(o))return this.setHSL(parseInt(r[1],10)/360,parseInt(r[2],10)/100,parseInt(r[3],10)/100,parseFloat(r[4])),this}}else t=t.toLowerCase(),void 0!==s[t]?this.setHex(s[t]):this.setHex(s.black)},copy:function(t){this.space=t.space.clone()},clone:function(){return new i(this)}}),t.exports=i},function(t,e){t.exports={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074}},function(t,e,n){"use strict";var i=n(1),r=n(8),a=function(){this.h=0,this.s=0,this.l=0};i.augment(a,{type:"hsl",setHSL:function(t,e,n,i){this.h=r.mod(t,1),this.s=r.clamp(e,0,1),this.l=r.clamp(n,0,1),void 0!==i?this.a=r.clamp(i,0,1):this.a=void 0},toRGB:function(){function t(t,e,n){return n<0&&(n+=1),n>1&&(n-=1),n<1/6?t+6*(e-t)*n:n<.5?e:n<2/3?t+6*(e-t)*(2/3-n):t}return function(){var e=this,n=e.h,i=e.s,r=e.l;if(0===i)return{r:r,g:r,b:r,a:e.a};var a=r<=.5?r*(1+i):r+i-r*i,o=2*r-a;return{r:t(o,a,n+1/3),g:t(o,a,n),b:t(o,a,n-1/3),a:e.a}}}(),clone:function(){var t=new a;return t.h=this.h,t.s=this.s,t.l=this.l,t.a=this.a,t},copy:function(t){return this.h=t.h,this.s=t.s,this.l=t.l,this.a=t.a,this},getStyle:function(){var t=this;return void 0===t.a?"hsl("+Math.round(360*t.h)+", "+Math.round(100*t.s)+"%, "+Math.round(100*t.l)+"%)":"hsla("+Math.round(360*t.h)+", "+Math.round(100*t.s)+"%, "+Math.round(100*t.l)+"%, "+t.a+")"}}),t.exports=a},function(t,e,n){"use strict";var i=n(1),r=n(8),a=function(){this.r=0,this.g=0,this.b=0,this.type="rgb"};i.augment(a,{type:"rgb",setRGB:function(t,e,n,i){this.r=r.clamp(t,0,1),this.g=r.clamp(e,0,1),this.b=r.clamp(n,0,1),void 0!==i?this.a=r.clamp(i,0,1):this.a=void 0},toHSL:function(){var t,e,n=this.r,i=this.g,r=this.b,a=Math.max(n,i,r),o=Math.min(n,i,r),s=(o+a)/2;if(o===a)t=0,e=0;else{var u=a-o;switch(e=s<=.5?u/(a+o):u/(2-a-o),a){case n:t=(i-r)/u+(i<r?6:0);break;case i:t=(r-n)/u+2;break;case r:t=(n-i)/u+4}t/=6}return{h:t,s:e,l:s,a:this.a}},getHex:function(){var t=255*this.r<<16^255*this.g<<8^255*this.b<<0;return"#"+("000000"+t.toString(16)).slice(-6)},getStyle:function(){return void 0===this.a?"rgb("+Math.round(255*this.r).toString()+", "+Math.round(255*this.g).toString()+", "+Math.round(255*this.b).toString()+")":"rgba("+Math.round(255*this.r).toString()+", "+Math.round(255*this.g).toString()+", "+Math.round(255*this.b).toString()+", "+this.a+")"},getPreStyle:function(){return void 0===this.a?"rgb("+Math.round(100*this.r).toString()+"%, "+Math.round(100*this.g).toString()+"%, "+Math.round(100*this.b).toString()+"%)":"rgba("+Math.round(100*this.r).toString()+"%, "+Math.round(100*this.g).toString()+"%, "+Math.round(100*this.b).toString()+"%, "+this.a+")"},clone:function(){var t=new a;return t.r=this.r,t.g=this.g,t.b=this.b,t.a=this.a,t},copy:function(t){return this.r=t.r,this.g=t.g,this.b=t.b,this.a=t.a,this}}),t.exports=a},function(t,e,n){"use strict";var i=n(1),r=n(11),a=n(90),o=function(t){o.superclass.constructor.call(this,t),this._init()};o.ATTRS={time:0,createTime:null,playTime:null,pauseTimeSpace:0,available:!1,canvases:[],tweens:[],endTime:0,autoPlay:!1,status:"silent",autoDraw:!0},i.extend(o,r),i.augment(o,{_init:function(){var t=this.get("autoPlay");this.set("createTime",+new Date),t&&this.play()},_trySetEndTime:function(t){var e=this;i.isObject(t)?e._setEndTime(t):i.isArray(t)&&i.each(t,function(t,n){e._setEndTime(t)})},_trySetCanvases:function(t){var e=this;i.isObject(t)?e._setCanvases(t):i.isArray(t)&&i.each(t,function(t,n){e._setCanvases(t)})},_setEndTime:function(t){var e=this.get("endTime"),n=t.endTime;n>e&&this.set("endTime",n)},_setCanvases:function(t){var e=t.canvas,n=this.get("canvases");n.indexOf(e)===-1&&n.push(e)},_resetTweens:function(){var t=this.get("tweens");t.sort(function(t,e){return e.get("startTime")-t.get("startTime")}),i.each(t,function(t){t.reset()})},_getTime:function(){var t=this.get("playTime"),e=this.get("pauseTimeSpace");return+new Date-t+e},_refresh:function(t){for(var e,n,r=this.get("tweens"),a=(this.get("canvases"),this.get("autoDraw")),o=[],s=[],u=0;u<r.length;u++)n=r[u],e=n.canvas,n.needsDestroy?n.destroy():n.destroyed||n.needsDestroy||n.tryStep(t),n.destroyed||o.push(n),i.inArray(s,e)||n.destroyed||s.push(e);a&&this.draw(),r.length>0&&0===o.length&&this.fire("animateend"),this.set("canvases",s),this.set("tweens",o)},_update:function(){if(this.get("available")){var t,e=this,n=e.get("tweens");n.length>0&&(t=e._getTime(),e._refresh(t)),e.fire("update"),i.requestAnimationFrame(function(){e._update()})}},animate:function(t,e){var n=new a({target:t,timeline:this,startTime:e?e:0});return n},add:function(t){var e,n=this.get("tweens");return i.isArray(t)?e=n.concat(t):i.isObject(t)&&"tween"===t.type?(n.push(t),e=n):console.error("Timeline not Support this type"),this.set("tweens",e),this._trySetCanvases(t),this._trySetEndTime(t),this},getNow:function(){var t=this.get("playTime");return t?+new Date-t:0},getTime:function(){var t=this.get("playTime");return t?+new Date-t:0},play:function(){var t=this.get("status");return"silent"===t&&(this.set("playTime",+new Date),this.set("available",!0),this.set("status","playing"),this._update()),this},stop:function(){this.set("status","silent"),this.set("available",!1),this.set("pauseTimeSpace",0),this._resetTweens(),this._refresh(0),this.draw()},pause:function(){var t=this.get("available");return t&&this.set("pauseTimeSpace",+new Date-this.get("playTime")),this.set("available",!1),this.set("status","silent"),this},reset:function(){this.set("status","silent"),this.set("available",!1),this.set("pauseTimeSpace",0),this.set("playTime",0),this.set("endTime",0),this.set("tweens",[]),this.set("canvases",[])},draw:function(){for(var t,e=this.get("canvases"),n=0;n<e.length;n++)t=e[n],!t.get("destroyed")&&t.draw()}}),t.exports=o},function(t,e,n){"use strict";var i=n(1),r=n(37),a=(n(11),n(38)),o=function(t){i.mix(this,t)};i.augment(o,{target:null,timeline:null,startTime:null,append:function(t,e,n,o){var s,u=i.guid("tween_"),c=this.target,h=(this.tweens,this.timeline),l=this.startTime,d=r.getKeyFrameByProps(c,e),f=d[0],g=d[1],p=r.getInterpolations(f,g);return p.matrix||0!==r.getObjectLength(p.attrs)||g.onUpdate?(t=t?t:l,e&&e.delay&&(t+=e.delay),s=new a({id:u,canvas:c.get("canvas"),startTime:t,target:c,easing:n,callBack:o,startKeyFrame:f,endKeyFrame:g,interpolations:p,duration:e.duration?e.duration:1e3,repeat:!!e.repeat&&e.repeat,destroyTarget:!!e.destroy&&e.destroy}),h&&h.add(s),this):this}}),t.exports=o},function(t,e,n){"use strict";function i(t,e){var n=e.toString(),i=n.indexOf(".");if(i===-1)return Math.round(t);var r=n.substr(i+1).length;return r>20&&(r=20),parseFloat(t.toFixed(r))}function r(t,e){for(var n in e)e.hasOwnProperty(n)&&"constructor"!==n&&void 0!==e[n]&&(t[n]=e[n])}var a=n(93);a.mix(a,{mixin:function(t,e){if(t&&e){t._mixins=e,t.ATTRS=t.ATTRS||{};var n={};a.each(e,function(e){a.augment(t,e);var i=e.ATTRS;i&&a.mix(n,i)}),t.ATTRS=a.mix(n,t.ATTRS)}},map:function(t,e){var n=[];return a.each(t,function(t,i){n.push(e(t,i))}),n},filter:function(t,e){var n=[];return a.each(t,function(t,i){e(t,i)&&n.push(t)}),n},guid:function(){var t={};return function(e){return e=e||"g",t[e]?t[e]+=1:t[e]=1,e+t[e]}}(),inArray:function(t,e){return a.indexOf(t,e)!==-1},indexOf:function(t,e){var n=Array.prototype.indexOf;if(n)return n.call(t,e);for(var i=-1,r=0;r<t.length;r++)if(t[r]===e){i=r;break}return i},remove:function(t,e){var n=a.indexOf(t,e);n!==-1&&t.splice(n,1)},empty:function(t){if(!(t instanceof Array))for(var e=t.length-1;e>=0;e--)delete t[e];t.length=0},equalsArray:function(t,e){if(t===e)return!0;if(!t||!e)return!1;if(t.length!==e.length)return!1;for(var n=!0,i=0;i<t.length;i++)if(t[i]!==e[i]){n=!1;break}return n},wrapBehavior:function(t,e){var n=function(n){t[e](n)};return t["_wrap_"+e]=n,n},getWrapBehavior:function(t,e){return t["_wrap_"+e]},fixedBase:function(t,e){return i(t,e)},length:function(t){if(a.isArray(t))return t.length;if(a.isObject(t)){var e=0;return a.each(t,function(){e++}),e}return 0},clone:function(t){if("object"!=typeof t||null===t)return t;var e;if(a.isArray(t)){e=[];for(var n=0,i=t.length;n<i;n++)"object"==typeof t[n]&&null!=t[n]?e[n]=a.clone(t[n]):e[n]=t[n]}else{e={};for(var r in t)"object"==typeof t[r]&&null!=t[r]?e[r]=a.clone(t[r]):e[r]=t[r]}return e},simpleMix:function(t,e,n,i){return e&&r(t,e),n&&r(t,n),i&&r(t,i),t}}),t.exports=a},function(t,e,n){"use strict";function i(t){if(!t._attrs&&t!==r){var e=t.superclass.constructor;e&&!e._attrs&&i(e),t._attrs={},a.mix(!0,t._attrs,e._attrs),a.mix(!0,t._attrs,t.ATTRS)}}var r,a=n(1);r=function(t){i(this.constructor),this._attrs={},this.events={};var e=this.getDefaultCfg();a.mix(this._attrs,e,t)},a.augment(r,{getDefaultCfg:function(){var t=this,e=t.constructor,n=e._attrs,i=a.mix(!0,{},n);return i},set:function(t,e){var n="_onRender"+a.ucfirst(t);return this[n]&&this[n](e,this._attrs[t]),this._attrs[t]=e,this},get:function(t){return this._attrs[t]},on:function(t,e){var n=this,i=n.events,r=i[t];return r||(r=i[t]=[]),r.push(e),n},fire:function(t,e){var n=this,i=n.events,r=i[t];r&&a.each(r,function(t){t(e)})},off:function(t,e){var n=this,i=n.events,r=i[t];return t?(r&&a.remove(r,e),n):(n.events={},n)},offEvents:function(t){var e=this,n=e.events;return t?(n[t]=null,e):(e.events={},e)},destroy:function(){var t=this,e=t.destroyed;return e?t:(t._attrs={},t.events={},void(t.destroyed=!0))}}),t.exports=r},function(t,e,n){var i=n(94);t.exports=i},function(t,e){"use strict";function n(t,e,i){i=i||0;for(var r in e)if(e.hasOwnProperty(r)){var s=e[r];null!==s&&o.isObject(s)?(o.isObject(t[r])||(t[r]={}),i<a?n(t[r],e[r],i+1):t[r]=e[r]):o.isArray(s)?(t[r]=[],t[r]=t[r].concat(s)):void 0!==s&&(t[r]=e[r])}}var i=Object.prototype,r=i.toString,a=5,o={substitute:function(t,e){return t&&e?t.replace(/\\?\{([^{}]+)\}/g,function(t,n){return"\\"===t.charAt(0)?t.slice(1):void 0===e[n]?"":e[n]}):t},ucfirst:function(t){return t+="",t.charAt(0).toUpperCase()+t.substring(1)},isString:function(t){return"string"==typeof t},isNumber:function(t){return"number"==typeof t},isNumeric:function(t){return!isNaN(parseFloat(t))&&isFinite(t)},isBoolean:function(t){return"boolean"==typeof t},isFunction:function(t){return"function"==typeof t},isArray:"isArray"in Array?Array.isArray:function(t){return"[object Array]"===r.call(t)},isDate:function(t){return"[object Date]"===r.call(t)},isNull:function(t){return void 0===t||null===t},notNull:function(t){return!o.isNull(t)},isBlank:function(t){if(o.isArray(t))return 0===t.length;if(o.isObject(t)){var e=0;return o.each(t,function(t,n){e++}),0===e}return!1},isObject:"[object Object]"===r.call(null)?function(t){return null!==t&&void 0!==t&&"[object Object]"===r.call(t)&&void 0===t.ownerDocument}:function(t){return"[object Object]"===r.call(t)},extend:function(t,e,n,i){o.isFunction(e)||(n=e,e=t,t=function(){});var r=Object.create?function(t,e){return Object.create(t,{constructor:{value:e}})}:function(t,e){function n(){}n.prototype=t;var i=new n;return i.constructor=e,i},a=r(e.prototype,t);return t.prototype=o.mix(a,t.prototype),t.superclass=r(e.prototype,e),o.mix(a,n),o.mix(t,i),t},augment:function(t){for(var e=o.toArray(arguments),n=1;n<e.length;n++){var i=e[n];o.isFunction(i)&&(i=i.prototype),o.mix(t.prototype,i)}},toArray:function(t){return t&&t.length?Array.prototype.slice.call(t):[]},mix:function(){var t=o.toArray(arguments),e=t[0];if(e===!0){e=t[1];for(var i=2;i<t.length;i++){var r=t[i];n(e,r)}}else for(var i=1;i<t.length;i++){var r=t[i];for(var a in r)r.hasOwnProperty(a)&&"constructor"!==a&&(e[a]=r[a])}return e},each:function(t,e){if(t)if(o.isObject(t)){for(var n in t)if(t.hasOwnProperty(n)){var i=e(t[n],n);if(i===!1)break}}else if(t.length)for(var r=0;r<t.length;r++){var i=e(t[r],r);if(i===!1)break}},requestAnimationFrame:function(t){var e=window.requestAnimationFrame||window.webkitRequestAnimationFrame||function(t){return setTimeout(t,16)};return e(t)},cancelAnimationFrame:function(t){var e=window.cancelAnimationFrame||window.webkitCancelAnimationFrame||function(t){return clearTimeout(t)};return e(t)}};t.exports=o},function(t,e,n){var i=n(96);i.Util=n(39),t.exports=i},function(t,e,n){"use strict";function i(t,e,n,i){var r=t[i]+(e[i]-t[i])*n;return r}var r=n(39),a=n(1),o={calColor:function(t,e,n){var a,o=t.length-1,s=Math.floor(o*e),u=o*e-s,c=t[s],h=s===o?c:t[s+1];return"hsl"===n?a=r.hsl2Rgb([i(c,h,u,0),i(c,h,u,1),i(c,h,u,2)]):(a={r:i(c,h,u,0),g:i(c,h,u,1),b:i(c,h,u,2)},a="#"+r.toHex(a.r)+r.toHex(a.g)+r.toHex(a.b)),a},lightness:function(t,e){e=e||0;var n=[[e,1,.9],[e,1,.5]];return o.calColor(n,t,"hsl")},red:function(t){return o.lightness(t,0)},blue:function(t){return o.lightness(t,.66)},green:function(t){return o.lightness(t,.33)},gradient:function(t){var e=[];return a.isString(t)&&(t=t.split("-")),a.each(t,function(t){t.indexOf("#")===-1&&(t=r.toRGB(t)),e.push(r.rgb2arr(t))}),function(t){return o.calColor(e,t)}},gradientHsl:function(t){var e=[];return a.isString(t)&&(t=t.split("-")),a.each(t,function(t){t.indexOf("#")===-1&&(t=r.toRGB(t)),e.push(r.rgb2hsl(t))}),function(t){return o.calColor(e,t,"hsl")}},saturation:function(t,e){e=e||0;var n=[[e,0,.5],[e,1,.5]];return o.calColor(n,t,"hsl")},hue:function(t){var e=[[0,1,.5],[1,1,.5]];return o.calColor(e,t,"hsl")},brightness:function(t){var e=[[255,255,255],[0,0,0]];return o.calColor(e,t)},heat:function(t){var e=[[255,255,255],[255,127.5,0],[0,0,0]];return o.calColor(e,t)},rainbow:function(t){var e=[[0,255,255],[0,0,255],[0,255,0],[255,0,0]];return o.calColor(e,t)},circular:function(t){var e=[[0,0,255],[0,255,0],[255,255,0],[255,0,0],[0,0,255]];return o.calColor(e,t)},bipolar:function(t){var e=[[0,255,0],[0,0,0],[255,0,0]];return o.calColor(e,t)}};t.exports=o},function(t,e){"use strict";function n(t,e){var n=t.length;if(0===n)return NaN;var i=t[0];if(e<t[0])return NaN;if(e>=t[n-1])return t[n-1];for(var r=1;r<t.length&&!(e<t[r]);r++)i=t[r];return i}function i(t,e){var n=t.length;if(0===n)return NaN;var i,r=t[0];if(e>t[n-1])return NaN;if(e<t[0])return t[0];for(var a=1;a<t.length;a++){if(e<=t[a]){i=t[a];break}r=t[a]}return i}var r={PRECISION:1e-5,equal:function(t,e){return Math.abs(t-e)<r.PRECISION},clamp:function(t,e,n){return t<e?e:t>n?n:t},snapTo:function(t,e){var r=n(t,e),a=i(t,e);if(isNaN(r)||isNaN(a)){if(t[0]>=e)return t[0];var o=t[t.length-1];if(o<=e)return o}return Math.abs(e-r)<Math.abs(a-e)?r:a},snapFloor:function(t,e){return n(t,e)},snapCeiling:function(t,e){return i(t,e)},degreeToRad:function(t){return Math.PI/180*t},radToDegree:function(t){return 180/Math.PI*t},mod:function(t,e){return(t%e+e)%e}};t.exports=r},function(t,e,n){"use strict";var i=n(1),r=Math.PI,a="\t\n\v\f\r \xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029",o=new RegExp("([a-z])["+a+",]*((-?\\d*\\.?\\d*(?:e[\\-+]?\\d+)?["+a+"]*,?["+a+"]*)+)","ig"),s=new RegExp("(-?\\d*\\.?\\d*(?:e[\\-+]?\\d+)?)["+a+"]*,?["+a+"]*","ig"),u=function(t){if(!t)return null;if(typeof t==typeof[])return t;var e={a:7,c:6,o:2,h:1,l:2,m:2,r:4,q:4,s:4,t:2,v:1,u:3,z:0},n=[];return String(t).replace(o,function(t,i,r){var a=[],o=i.toLowerCase();if(r.replace(s,function(t,e){e&&a.push(+e)}),"m"==o&&a.length>2&&(n.push([i].concat(a.splice(0,2))),o="l",i="m"==i?"l":"L"),"o"==o&&1==a.length&&n.push([i,a[0]]),"r"==o)n.push([i].concat(a));else for(;a.length>=e[o]&&(n.push([i].concat(a.splice(0,e[o]))),e[o]););}),n},c=function(t,e){for(var n=[],i=0,r=t.length;r-2*!e>i;i+=2){var a=[{x:+t[i-2],y:+t[i-1]},{x:+t[i],y:+t[i+1]},{x:+t[i+2],y:+t[i+3]},{x:+t[i+4],y:+t[i+5]}];e?i?r-4==i?a[3]={x:+t[0],y:+t[1]}:r-2==i&&(a[2]={x:+t[0],y:+t[1]},a[3]={x:+t[2],y:+t[3]}):a[0]={x:+t[r-2],y:+t[r-1]}:r-4==i?a[3]=a[2]:i||(a[0]={x:+t[i],y:+t[i+1]}),n.push(["C",(-a[0].x+6*a[1].x+a[2].x)/6,(-a[0].y+6*a[1].y+a[2].y)/6,(a[1].x+6*a[2].x-a[3].x)/6,(a[1].y+6*a[2].y-a[3].y)/6,a[2].x,a[2].y])}return n},h=function(t,e,n,i,r){if(null==r&&null==i&&(i=n),t=+t,e=+e,n=+n,i=+i,null!=r)var a=Math.PI/180,o=t+n*Math.cos(-i*a),s=t+n*Math.cos(-r*a),u=e+n*Math.sin(-i*a),c=e+n*Math.sin(-r*a),h=[["M",o,u],["A",n,n,0,+(r-i>180),0,s,c]];else h=[["M",t,e],["m",0,-i],["a",n,i,0,1,1,0,2*i],["a",n,i,0,1,1,0,-2*i],["z"]];return h},l=function(t){if(t=u(t),!t||!t.length)return[["M",0,0]];var e,n=[],i=0,r=0,a=0,o=0,s=0;"M"==t[0][0]&&(i=+t[0][1],r=+t[0][2],a=i,o=r,s++,n[0]=["M",i,r]);for(var l,d,f=3==t.length&&"M"==t[0][0]&&"R"==t[1][0].toUpperCase()&&"Z"==t[2][0].toUpperCase(),g=s,p=t.length;g<p;g++){if(n.push(l=[]),d=t[g],e=d[0],e!=e.toUpperCase())switch(l[0]=e.toUpperCase(),l[0]){case"A":l[1]=d[1],l[2]=d[2],l[3]=d[3],l[4]=d[4],l[5]=d[5],l[6]=+d[6]+i,l[7]=+d[7]+r;break;case"V":l[1]=+d[1]+r;break;case"H":l[1]=+d[1]+i;break;case"R":for(var v=[i,r].concat(d.slice(1)),x=2,m=v.length;x<m;x++)v[x]=+v[x]+i,v[++x]=+v[x]+r;n.pop(),n=n.concat(c(v,f));break;case"O":n.pop(),v=h(i,r,d[1],d[2]),v.push(v[0]),n=n.concat(v);break;case"U":n.pop(),n=n.concat(h(i,r,d[1],d[2],d[3])),l=["U"].concat(n[n.length-1].slice(-2));break;case"M":a=+d[1]+i,o=+d[2]+r;default:for(x=1,m=d.length;x<m;x++)l[x]=+d[x]+(x%2?i:r)}else if("R"==e)v=[i,r].concat(d.slice(1)),n.pop(),n=n.concat(c(v,f)),l=["R"].concat(d.slice(-2));else if("O"==e)n.pop(),v=h(i,r,d[1],d[2]),v.push(v[0]),n=n.concat(v);else if("U"==e)n.pop(),n=n.concat(h(i,r,d[1],d[2],d[3])),l=["U"].concat(n[n.length-1].slice(-2));else for(var y=0,b=d.length;y<b;y++)l[y]=d[y];if(e=e.toUpperCase(),"O"!=e)switch(l[0]){case"Z":i=+a,r=+o;break;case"H":i=l[1];break;case"V":r=l[1];break;case"M":a=l[l.length-2],o=l[l.length-1];default:i=l[l.length-2],r=l[l.length-1]}}return n},d=function(t,e,n,i){return[t,e,n,i,n,i]},f=function(t,e,n,i,r,a){var o=1/3,s=2/3;return[o*t+s*n,o*e+s*i,o*r+s*n,o*a+s*i,r,a]},g=function(t,e,n,i,r,a,o,s,u,c){n===i&&(n+=1);var h,l=120*Math.PI/180,d=Math.PI/180*(+r||0),f=[],p=function(t,e,n){var i=t*Math.cos(n)-e*Math.sin(n),r=t*Math.sin(n)+e*Math.cos(n);return{x:i,y:r}};if(c)S=c[0],A=c[1],_=c[2],M=c[3];else{h=p(t,e,-d),t=h.x,e=h.y,h=p(s,u,-d),s=h.x,u=h.y,t===s&&e===u&&(s+=1,u+=1);var v=(Math.cos(Math.PI/180*r),Math.sin(Math.PI/180*r),(t-s)/2),x=(e-u)/2,m=v*v/(n*n)+x*x/(i*i);m>1&&(m=Math.sqrt(m),n*=m,i*=m);var y=n*n,b=i*i,w=(a==o?-1:1)*Math.sqrt(Math.abs((y*b-y*x*x-b*v*v)/(y*x*x+b*v*v))),_=w*n*x/i+(t+s)/2,M=w*-i*v/n+(e+u)/2,S=Math.asin(((e-M)/i).toFixed(9)),A=Math.asin(((u-M)/i).toFixed(9));S=t<_?Math.PI-S:S,A=s<_?Math.PI-A:A,S<0&&(S=2*Math.PI+S),A<0&&(A=2*Math.PI+A),o&&S>A&&(S-=2*Math.PI),!o&&A>S&&(A-=2*Math.PI)}var P=A-S;if(Math.abs(P)>l){var T=A,C=s,I=u;A=S+l*(o&&A>S?1:-1),s=_+n*Math.cos(A),u=M+i*Math.sin(A),f=g(s,u,n,i,r,0,o,C,I,[A,T,_,M])}P=A-S;var k=Math.cos(S),B=Math.sin(S),E=Math.cos(A),O=Math.sin(A),F=Math.tan(P/4),z=4/3*n*F,R=4/3*i*F,N=[t,e],G=[t+z*B,e-R*k],D=[s+z*O,u-R*E],X=[s,u];if(G[0]=2*N[0]-G[0],G[1]=2*N[1]-G[1],c)return[G,D,X].concat(f);f=[G,D,X].concat(f).join().split(",");for(var Y=[],L=0,j=f.length;L<j;L++)Y[L]=L%2?p(f[L-1],f[L],d).y:p(f[L],f[L+1],d).x;return Y},p=function(t,e){for(var n=l(t),i=e&&l(e),r={x:0,y:0,bx:0,by:0,X:0,Y:0,qx:null,qy:null},a={x:0,y:0,bx:0,by:0,X:0,Y:0,qx:null,qy:null},o=(function(t,e,n){var i,r;if(!t)return["C",e.x,e.y,e.x,e.y,e.x,e.y];switch(!(t[0]in{T:1,Q:1})&&(e.qx=e.qy=null),t[0]){case"M":e.X=t[1],e.Y=t[2];break;case"A":t=["C"].concat(g.apply(0,[e.x,e.y].concat(t.slice(1))));break;case"S":"C"==n||"S"==n?(i=2*e.x-e.bx,r=2*e.y-e.by):(i=e.x,r=e.y),t=["C",i,r].concat(t.slice(1));break;case"T":"Q"==n||"T"==n?(e.qx=2*e.x-e.qx,e.qy=2*e.y-e.qy):(e.qx=e.x,e.qy=e.y),t=["C"].concat(f(e.x,e.y,e.qx,e.qy,t[1],t[2]));break;case"Q":e.qx=t[1],e.qy=t[2],t=["C"].concat(f(e.x,e.y,t[1],t[2],t[3],t[4]));break;case"L":t=["C"].concat(d(e.x,e.y,t[1],t[2]));break;case"H":t=["C"].concat(d(e.x,e.y,t[1],e.y));break;case"V":t=["C"].concat(d(e.x,e.y,e.x,t[1]));break;case"Z":t=["C"].concat(d(e.x,e.y,e.X,e.Y))}return t}),s=function(t,e){if(t[e].length>7){t[e].shift();for(var r=t[e];r.length;)c[e]="A",i&&(h[e]="A"),t.splice(e++,0,["C"].concat(r.splice(0,6)));t.splice(e,1),m=Math.max(n.length,i&&i.length||0)}},u=function(t,e,r,a,o){t&&e&&"M"==t[o][0]&&"M"!=e[o][0]&&(e.splice(o,0,["M",a.x,a.y]),r.bx=0,r.by=0,r.x=t[o][1],r.y=t[o][2],m=Math.max(n.length,i&&i.length||0))},c=[],h=[],p="",v="",x=0,m=Math.max(n.length,i&&i.length||0);x<m;x++){n[x]&&(p=n[x][0]),"C"!=p&&(c[x]=p,x&&(v=c[x-1])),n[x]=o(n[x],r,v),"A"!=c[x]&&"C"==p&&(c[x]="C"),s(n,x),i&&(i[x]&&(p=i[x][0]),"C"!=p&&(h[x]=p,x&&(v=h[x-1])),i[x]=o(i[x],a,v),"A"!=h[x]&&"C"==p&&(h[x]="C"),s(i,x)),u(n,i,r,a,x),u(i,n,a,r,x);var y=n[x],b=i&&i[x],w=y.length,_=i&&b.length;r.x=y[w-2],r.y=y[w-1],r.bx=parseFloat(y[w-4])||r.x,r.by=parseFloat(y[w-3])||r.y,a.bx=i&&(parseFloat(b[_-4])||a.x),a.by=i&&(parseFloat(b[_-3])||a.y),a.x=i&&b[_-2],a.y=i&&b[_-1]}return i?[n,i]:n},v=function(t,e,n,i){return null==t&&(t=e=n=i=0),null==e&&(e=t.y,n=t.width,i=t.height,t=t.x),{x:t,y:e,w:n,h:i,cx:t+n/2,cy:e+i/2}},x=/,?([a-z]),?/gi,m=function(t){return t.join(",").replace(x,"$1")},y=function(t,e,n,i,r){var a=-3*e+9*n-9*i+3*r,o=t*a+6*e-12*n+6*i;return t*o-3*e+3*n},b=function(t,e,n,i,r,a,o,s,u){null==u&&(u=1),u=u>1?1:u<0?0:u;for(var c=u/2,h=12,l=[-.1252,.1252,-.3678,.3678,-.5873,.5873,-.7699,.7699,-.9041,.9041,-.9816,.9816],d=[.2491,.2491,.2335,.2335,.2032,.2032,.1601,.1601,.1069,.1069,.0472,.0472],f=0,g=0;g<h;g++){var p=c*l[g]+c,v=y(p,t,n,r,o),x=y(p,e,i,a,s),m=v*v+x*x;f+=d[g]*Math.sqrt(m)}return c*f},w=function(t,e,n,i,r,a,o,s){for(var u,c,h,l,d,f,g,p,v=[],x=[[],[]],m=0;m<2;++m)if(0==m?(c=6*t-12*n+6*r,u=-3*t+9*n-9*r+3*o,h=3*n-3*t):(c=6*e-12*i+6*a,u=-3*e+9*i-9*a+3*s,h=3*i-3*e),Math.abs(u)<1e-12){if(Math.abs(c)<1e-12)continue;l=-h/c,0<l&&l<1&&v.push(l)}else g=c*c-4*h*u,p=Math.sqrt(g),g<0||(d=(-c+p)/(2*u),0<d&&d<1&&v.push(d),f=(-c-p)/(2*u),0<f&&f<1&&v.push(f));for(var y,b=v.length,w=b;b--;)l=v[b],y=1-l,x[0][b]=y*y*y*t+3*y*y*l*n+3*y*l*l*r+l*l*l*o,x[1][b]=y*y*y*e+3*y*y*l*i+3*y*l*l*a+l*l*l*s;return x[0][w]=t,x[1][w]=e,x[0][w+1]=o,x[1][w+1]=s,x[0].length=x[1].length=w+2,{min:{x:Math.min.apply(0,x[0]),y:Math.min.apply(0,x[1])},max:{x:Math.max.apply(0,x[0]),y:Math.max.apply(0,x[1])}}},_=function(t,e,n,i,r,a,o,s){if(!(Math.max(t,n)<Math.min(r,o)||Math.min(t,n)>Math.max(r,o)||Math.max(e,i)<Math.min(a,s)||Math.min(e,i)>Math.max(a,s))){var u=(t*i-e*n)*(r-o)-(t-n)*(r*s-a*o),c=(t*i-e*n)*(a-s)-(e-i)*(r*s-a*o),h=(t-n)*(a-s)-(e-i)*(r-o);if(h){var l=u/h,d=c/h,f=+l.toFixed(2),g=+d.toFixed(2);if(!(f<+Math.min(t,n).toFixed(2)||f>+Math.max(t,n).toFixed(2)||f<+Math.min(r,o).toFixed(2)||f>+Math.max(r,o).toFixed(2)||g<+Math.min(e,i).toFixed(2)||g>+Math.max(e,i).toFixed(2)||g<+Math.min(a,s).toFixed(2)||g>+Math.max(a,s).toFixed(2)))return{x:l,y:d}}}},M=function(t,e,n){return e>=t.x&&e<=t.x+t.width&&n>=t.y&&n<=t.y+t.height},S=function(t,e,n,i,r){if(r)return[["M",+t+ +r,e],["l",n-2*r,0],["a",r,r,0,0,1,r,r],["l",0,i-2*r],["a",r,r,0,0,1,-r,r],["l",2*r-n,0],["a",r,r,0,0,1,-r,-r],["l",0,2*r-i],["a",r,r,0,0,1,r,-r],["z"]];var a=[["M",t,e],["l",n,0],["l",0,i],["l",-n,0],["z"]];return a.toString=toString,a},v=function(t,e,n,i){return null==t&&(t=e=n=i=0),null==e&&(e=t.y,n=t.width,i=t.height,t=t.x),{x:t,y:e,width:n,w:n,height:i,h:i,x2:t+n,y2:e+i,cx:t+n/2,cy:e+i/2,r1:Math.min(n,i)/2,r2:Math.max(n,i)/2,r0:Math.sqrt(n*n+i*i)/2,path:S(t,e,n,i),vb:[t,e,n,i].join(" ")}},A=function(t,e){return t=v(t),e=v(e),M(e,t.x,t.y)||M(e,t.x2,t.y)||M(e,t.x,t.y2)||M(e,t.x2,t.y2)||M(t,e.x,e.y)||M(t,e.x2,e.y)||M(t,e.x,e.y2)||M(t,e.x2,e.y2)||(t.x<e.x2&&t.x>e.x||e.x<t.x2&&e.x>t.x)&&(t.y<e.y2&&t.y>e.y||e.y<t.y2&&e.y>t.y)},P=function(t,e,n,r,a,o,s,u){i.isArray(t)||(t=[t,e,n,r,a,o,s,u]);var c=w.apply(null,t);return v(c.min.x,c.min.y,c.max.x-c.min.x,c.max.y-c.min.y)},T=function(t,e,n,i,a,o,s,u,c){var h=1-c,l=Math.pow(h,3),d=Math.pow(h,2),f=c*c,g=f*c,p=l*t+3*d*c*n+3*h*c*c*a+g*s,v=l*e+3*d*c*i+3*h*c*c*o+g*u,x=t+2*c*(n-t)+f*(a-2*n+t),m=e+2*c*(i-e)+f*(o-2*i+e),y=n+2*c*(a-n)+f*(s-2*a+n),b=i+2*c*(o-i)+f*(u-2*o+i),w=h*t+c*n,_=h*e+c*i,M=h*a+c*s,S=h*o+c*u,A=90-180*Math.atan2(x-y,m-b)/r;return{x:p,y:v,m:{x:x,y:m},n:{x:y,y:b},start:{x:w,y:_},end:{x:M,y:S},alpha:A}},C=function(t,e,n){var i=P(t),r=P(e);if(!A(i,r))return n?0:[];for(var a=b.apply(0,t),o=b.apply(0,e),s=~~(a/8),u=~~(o/8),c=[],h=[],l={},d=n?0:[],f=0;f<s+1;f++){var g=T.apply(0,t.concat(f/s));c.push({x:g.x,y:g.y,t:f/s})}for(f=0;f<u+1;f++)g=T.apply(0,e.concat(f/u)),h.push({x:g.x,y:g.y,t:f/u});for(f=0;f<s;f++)for(var p=0;p<u;p++){var v=c[f],x=c[f+1],m=h[p],y=h[p+1],w=Math.abs(x.x-v.x)<.001?"y":"x",M=Math.abs(y.x-m.x)<.001?"y":"x",S=_(v.x,v.y,x.x,x.y,m.x,m.y,y.x,y.y);if(S){if(l[S.x.toFixed(4)]==S.y.toFixed(4))continue;l[S.x.toFixed(4)]=S.y.toFixed(4);var C=v.t+Math.abs((S[w]-v[w])/(x[w]-v[w]))*(x.t-v.t),I=m.t+Math.abs((S[M]-m[M])/(y[M]-m[M]))*(y.t-m.t);C>=0&&C<=1&&I>=0&&I<=1&&(n?d++:d.push({x:S.x,y:S.y,t1:C,t2:I}))}}return d},I=function(t,e,n){t=p(t),e=p(e);for(var i,r,a,o,s,u,c,h,l,d,f=n?0:[],g=0,v=t.length;g<v;g++){var x=t[g];if("M"==x[0])i=s=x[1],r=u=x[2];else{"C"==x[0]?(l=[i,r].concat(x.slice(1)),i=l[6],r=l[7]):(l=[i,r,i,r,s,u,s,u],i=s,r=u);for(var m=0,y=e.length;m<y;m++){var b=e[m];if("M"==b[0])a=c=b[1],o=h=b[2];else{"C"==b[0]?(d=[a,o].concat(b.slice(1)),a=d[6],o=d[7]):(d=[a,o,a,o,c,h,c,h],a=c,o=h);var w=C(l,d,n);if(n)f+=w;else{for(var _=0,M=w.length;_<M;_++)w[_].segment1=g,w[_].segment2=m,w[_].bez1=l,w[_].bez2=d;f=f.concat(w)}}}}}return f},k=function(t,e){return I(t,e)},B={toArray:u,toString:m,toCurve:p,toAbsolute:l,catmullRomToBezier:c,rectPath:S,intersection:k};t.exports=B},function(t,e,n){"use strict";var i=n(59),r=n(102),a=n(43),o=function(t){o.superclass.constructor.call(this,t)};o.CFG={eventEnable:!0,width:null,height:null,widthCanvas:null,heightCanvas:null,widthStyle:null,heightStyle:null,containerDOM:null,canvasDOM:null,pixelRatio:null},i.extend(o,a.Group),i.augment(o,{init:function(){o.superclass.init.call(this),this._setGlobalParam(),this._setDOM(),this._setInitSize(),this._setCanvas(),this._scale(),this.get("eventEnable")&&this._registEvents()},_registEvents:function(){var t=this,e=t.get("el"),n=new r(t);e.addEventListener("mouseout",function(t){n.mouseout(t)},!1),e.addEventListener("mouseover",function(t){n.mouseover(t)},!1),e.addEventListener("mousemove",function(t){n.mousemove(t)},!1),e.addEventListener("mousedown",function(t){n.mousedown(t)},!1),e.addEventListener("mouseup",function(t){
                n.mouseup(t)},!1),e.addEventListener("click",function(t){n.click(t)},!1),e.addEventListener("dblclick",function(t){n.dblclick(t)},!1)},_scale:function(){var t=this.get("pixelRatio");this.scale(t,t)},_setCanvas:function(){var t=this.get("canvasDOM");this.set("el",t),this.set("context",t.getContext("2d")),this.set("canvas",this)},_setGlobalParam:function(){var t=this.get("pixelRatio");t||this.set("pixelRatio",i.getRatio())},_setDOM:function(){this._setContainer(),this._setLayer()},_setContainer:function(){var t=this.get("containerId"),e=this.get("containerDOM");e||(e=document.getElementById(t),this.set("containerDOM",e)),i.modiCSS(e,{position:"relative"})},_setLayer:function(){var t=this.get("containerDOM"),e=i.guid("canvas_");if(t){var n=i.createDom('<canvas id="'+e+'"></canvas>');t.appendChild(n),this.set("canvasDOM",n)}},_setInitSize:function(){this.get("widthStyle")?this.changeSizeByCss(this.get("widthStyle"),this.get("heightStyle")):this.get("width")&&this.changeSize(this.get("width"),this.get("height"))},_getPx:function(t,e){var n=this.get("canvasDOM");n.style[t]=e;var r=i.getBoundingClientRect(n);return"width"===t?r.right-r.left:"height"===t?r.bottom-r.top:void 0},_reSize:function(){var t=this.get("canvasDOM"),e=this.get("widthCanvas"),n=this.get("heightCanvas"),i=this.get("widthStyle"),r=this.get("heightStyle");t.style.width=i,t.style.height=r,t.setAttribute("width",e),t.setAttribute("height",n)},getWidth:function(){var t=this.get("pixelRatio"),e=this.get("width");return e*t},getHeight:function(){var t=this.get("pixelRatio"),e=this.get("height");return e*t},changeSizeByCss:function(t,e){var n=this.get("pixelRatio");t=this._getPx("width",t),e=this._getPx("height",e);var i=t*n,r=e*n;this.set("widthStyle",t),this.set("heightStyle",e),this.set("widthCanvas",i),this.set("heightCanvas",r),this.set("width",t),this.set("height",e),this._reSize()},changeSize:function(t,e){var n=this.get("pixelRatio"),i=t*n,r=e*n;this.set("widthCanvas",i),this.set("heightCanvas",r),this.set("widthStyle",t+"px"),this.set("heightStyle",e+"px"),this.set("width",t),this.set("height",e),this._reSize()},getPointByClient:function(t,e){var n=this.get("el"),i=n.getBoundingClientRect(),r=i.right-i.left,a=i.bottom-i.top;return{x:(t-i.left)*(n.width/r),y:(e-i.top)*(n.height/a)}},getClientByPoint:function(t,e){var n=this.get("el"),i=n.getBoundingClientRect(),r=i.right-i.left,a=i.bottom-i.top;return{clientX:t/(n.width/r)+i.left,clientY:e/(n.height/a)+i.top}},beforeDraw:function(){var t=this.get("context"),e=this.get("el");t&&t.clearRect(0,0,e.width,e.height)},_beginDraw:function(){this.setSilent("toDraw",!0)},_endDraw:function(){this.setSilent("toDraw",!1)},draw:function(){function t(){e.set("animateHandler",i.requestAnimationFrame(function(){e.set("animateHandler",void 0),e.get("toDraw")&&t()})),e.beforeDraw();try{var n=e.get("context");o.superclass.draw.call(e,n)}catch(t){console.warn("error in draw canvas, detail as:"),console.warn(t),e._endDraw()}e._endDraw()}var e=this;e.get("destroyed")||(e.get("animateHandler")?this._beginDraw():t())},destroy:function(){var t=this.get("containerDOM"),e=this.get("canvasDOM");e&&t&&t.removeChild(e),o.superclass.destroy.call(this)}}),t.exports=o},function(t,e,n){"use strict";var i=n(1),r=function(t,e,n,i){this.type=t,this.target=null,this.currentTarget=null,this.bubbles=n,this.cancelable=i,this.timeStamp=(new Date).getTime(),this.defaultPrevented=!1,this.propagationStopped=!1,this.removed=!1,this.event=e};i.augment(r,{preventDefault:function(){this.defaultPrevented=this.cancelable&&!0},stopPropagation:function(){this.propagationStopped=!0},remove:function(){this.remove=!0},clone:function(){return i.clone(this)},toString:function(){return"[Event (type="+this.type+")]"}}),t.exports=r},function(t,e,n){var i=n(1),r=n(100);t.exports={initEventDispatcher:function(){this.__listeners={}},on:function(t,e){var n=this.__listeners;return i.isNull(n[t])&&(n[t]=[]),n[t].indexOf(e)===-1&&n[t].push(e),this},off:function(t,e){var n=this.__listeners;return 0===arguments.length?(this.__listeners={},this):1===arguments.length&&i.isString(t)?(n[t]=[],this):2===arguments.length&&i.isString(t)&&i.isFunction(e)?(i.remove(n[t],e),this):void 0},has:function(t,e){var n=this.__listeners;return 0===arguments.length&&!i.isBlank(n)||(!(1!==arguments.length||!n[t]||i.isBlank(n[t]))||!(2!==arguments.length||!n[t]||n[t].indexOf(e)===-1))},trigger:function(t){var e=this,n=e.__listeners,r=n[t.type];if(t.target=e,i.notNull(r)&&r.forEach(function(n){n.call(e,t)}),t.bubbles){var a=e.get("parent");a&&!t.propagationStopped&&a.trigger(t)}return e},fire:function(t,e){var n=new r(t);i.each(e,function(t,e){n[e]=t}),this.trigger(n)}}},function(t,e,n){"use strict";var i=n(1),r=n(75),a=function(t){this.canvas=t,this.el=t.get("el"),this.current=null,this.pre=null};i.augment(a,{tryTrigger:function(t,e){t.__listeners&&t.trigger(e)},getCurrent:function(t){var e=this.canvas,n=e.getPointByClient(t.clientX,t.clientY);this.point=n,this.pre=this.current,this.current=e.getShape(n.x,n.y)},mousemove:function(t){this.getCurrent(t);var e=this.point,n=this.canvas;if(n.has("canvas-mousemove")){var i=new r("canvas-mousemove",t,!0,!0);i.x=e.x,i.y=e.y,i.clientX=t.clientX,i.clientY=t.clientY,i.currentTarget=n,this.tryTrigger(n,i)}if(this.pre&&this.pre!==this.current){var a=new r("mouseleave",t,!0,!0);a.x=e.x,a.y=e.y,a.clientX=t.clientX,a.clientY=t.clientY,a.currentTarget=this.pre,a.target=this.pre,this.tryTrigger(this.pre,a)}if(this.current){var o=new r("mousemove",t,!0,!0);if(o.x=e.x,o.y=e.y,o.clientX=t.clientX,o.clientY=t.clientY,o.currentTarget=this.current,o.target=this.current,this.tryTrigger(this.current,o),this.pre!==this.current){var s=new r("mouseenter",t,!0,!0);s.x=e.x,s.y=e.y,s.clientX=t.clientX,s.clientY=t.clientY,s.currentTarget=this.current,s.target=this.current,this.tryTrigger(this.current,s)}}},mousedown:function(t){var e=this.point,n=this.canvas;if(n.has("canvas-mousedown")){var i=new r("canvas-mousedown",t,!0,!0);i.x=e.x,i.y=e.y,i.clientX=t.clientX,i.clientY=t.clientY,i.currentTarget=n,this.tryTrigger(n,i)}if(this.current){var a=new r("mousedown",t,!0,!0);a.x=e.x,a.y=e.y,a.clientX=t.clientX,a.clientY=t.clientY,a.currentTarget=this.current,a.target=this.current,this.tryTrigger(this.current,a)}},mouseup:function(t){var e=this.point,n=this.canvas;if(n.has("canvas-mouseup")){var i=new r("canvas-mouseup",t,!0,!0);i.x=e.x,i.y=e.y,i.clientX=t.clientX,i.clientY=t.clientY,i.currentTarget=n,this.tryTrigger(n,i)}if(this.current){var a=new r("mouseup",t,!0,!0);a.x=e.x,a.y=e.y,a.clientX=t.clientX,a.clientY=t.clientY,a.currentTarget=this.current,a.target=this.current,this.tryTrigger(this.current,a)}},click:function(t){this.getCurrent(t);var e=this.point,n=this.canvas;if(n.has("canvas-click")){var i=new r("canvas-click",t,!0,!0);i.x=e.x,i.y=e.y,i.clientX=t.clientX,i.clientY=t.clientY,i.currentTarget=n,this.tryTrigger(n,i)}if(this.current){var a=new r("click",t,!0,!0);a.x=e.x,a.y=e.y,a.clientX=t.clientX,a.clientY=t.clientY,a.currentTarget=this.current,a.target=this.current,this.tryTrigger(this.current,a)}},dblclick:function(t){var e=this.point,n=this.canvas;if(n.has("canvas-dblclick")){var i=new r("canvas-dblclick",t,!0,!0);i.x=e.x,i.y=e.y,i.clientX=t.clientX,i.clientY=t.clientY,i.currentTarget=n,this.tryTrigger(n,i)}if(this.current){var a=new r("dblclick",t,!0,!0);a.x=e.x,a.y=e.y,a.clientX=t.clientX,a.clientY=t.clientY,a.currentTarget=this.current,a.target=this.current,this.tryTrigger(this.current,a)}},mouseout:function(t){var e=this.point,n=this.canvas,i=new r("canvas-mouseleave",t,!0,!0);i.x=e.x,i.y=e.y,i.currentTarget=n,this.tryTrigger(n,i)},mouseover:function(t){var e=this.canvas,n=new r("canvas-mouseenter",t,!0,!0);n.currentTarget=e,this.tryTrigger(e,n)}}),t.exports=a},function(t,e,n){function i(t,e,n){for(var i,r=t.length-1;r>=0;r--){var a=t[r];if(a.__cfg.visible&&a.__cfg.capture&&(a.isGroup?i=a.getShape(e,n):a.isHit(e,n)&&(i=a)),i)break}return i}function r(t){if(!t.__cfg&&t!==h){var e=t.superclass.constructor;e&&!e.__cfg&&r(e),t.__cfg={},a.mix(!0,t.__cfg,e.__cfg),a.mix(!0,t.__cfg,t.CFG)}}var a=n(1),o=n(3).Vector3,s=n(41),u=n(50),c={},h=function(t){h.superclass.constructor.call(this,t),this.set("children",[]),this._beforeRenderUI(),this._renderUI(),this._bindUI()};a.extend(h,s),a.augment(h,{isGroup:!0,canFill:!0,canStroke:!0,getDefaultCfg:function(){return r(this.constructor),a.mix(!0,{},this.constructor.__cfg)},_beforeRenderUI:function(){},_renderUI:function(){},_bindUI:function(){},addShape:function(t,e){var n,i=this.get("canvas");e=e||{};var r=c[t];if(r||(r=a.ucfirst(t),c[t]=r),e.attrs){var o=e.attrs;if("text"===t){var s=i.get("fontFamily");s&&(o.fontFamily=o.fontFamily?o.fontFamily:s)}}return e.canvas=i,e.type=t,n=new u[r](e),this.add(n),n},addGroup:function(t,e){var n,i=this.get("canvas");if(e=a.mix({},e),a.isFunction(t))e?(e.canvas=i,e.parent=this,n=new t(e)):n=new t({canvas:i,parent:this}),this.add(n);else if(a.isObject(t))t.canvas=i,n=new h(t),this.add(n);else{if(void 0!==t)return!1;n=new h,this.add(n)}return n},renderBack:function(t,e){var n=this.get("backShape"),i=this.getBBox(),r=this.get("parent");return a.mix(e,{x:i.minX-t[3],y:i.minY-t[0],width:i.width+t[1]+t[3],height:i.height+t[0]+t[2]}),n?n.attr(e):n=r.addShape("rect",{zIndex:-1,attrs:e}),this.set("backShape",n),r.sort(),n},removeChild:function(t,e){if(arguments.length>=2)this.contain(t)&&t.remove(e);else{if(1===arguments.length){if(!a.isBoolean(t))return this.contain(t)&&t.remove(!0),this;e=t}0===arguments.length&&(e=!0),h.superclass.remove.call(this,e)}return this},add:function(t){var e=this,n=e.get("children");if(a.isArray(t))a.each(t,function(t){var n=t.get("parent");n&&n.removeChild(t,!1),e.__setEvn(t)}),n.push.apply(n,t);else{var i=t,r=i.get("parent");r&&r.removeChild(i,!1),e.__setEvn(i),n.push(i)}return e},contain:function(t){var e=this.get("children");return e.indexOf(t)>-1},getChildByIndex:function(t){var e=this.get("children");return e[t]},getFirst:function(){return this.getChildByIndex(0)},getLast:function(){var t=this.get("children").length-1;return this.getChildByIndex(t)},__setEvn:function(t){var e=this;t.__cfg.parent=e,t.__cfg.context=e.__cfg.context,t.__cfg.canvas=e.__cfg.canvas,t.__cfg.totalMatrix=null;var n=t.__attrs.clip;n&&(n.setSilent("parent",e),n.setSilent("context",e.get("context")));var i=t.__cfg.children;i&&a.each(i,function(e){t.__setEvn(e)})},getBBox:function(){var t=this,e=1/0,n=-(1/0),i=1/0,r=-(1/0),s=t.get("children");a.each(s,function(t){if(t.get("visible")){var a=t.getBBox();if(!a)return!0;var s=new o(a.minX,a.minY,1),u=new o(a.minX,a.maxY,1),c=new o(a.maxX,a.minY,1),h=new o(a.maxX,a.maxY,1);t.apply(s),t.apply(u),t.apply(c),t.apply(h);var l=Math.min(s.x,u.x,c.x,h.x),d=Math.max(s.x,u.x,c.x,h.x),f=Math.min(s.y,u.y,c.y,h.y),g=Math.max(s.y,u.y,c.y,h.y);l<e&&(e=l),d>n&&(n=d),f<i&&(i=f),g>r&&(r=g)}});var u={minX:e,minY:i,maxX:n,maxY:r};return u.x=u.minX,u.y=u.minY,u.width=u.maxX-u.minX,u.height=u.maxY-u.minY,u},drawInner:function(t){for(var e=this.get("children"),n=0;n<e.length;n++){var i=e[n];i.draw(t)}return this},getCount:function(){return this.get("children").length},sort:function(){var t=this.get("children");return t.sort(function(t,e){return t.get("zIndex")-e.get("zIndex")}),this},find:function(t){return this.findBy(function(e){return e.get("id")===t})},findBy:function(t){var e=this.get("children"),n=null;return a.each(e,function(e){if(t(e)?n=e:e.findBy&&(n=e.findBy(t)),n)return!1}),n},findAllBy:function(t){var e=this.get("children"),n=[],i=[];return a.each(e,function(e){t(e)&&n.push(e),e.findAllBy&&(i=e.findAllBy(t),n=n.concat(i))}),n},getShape:function(t,e){var n,r=this,a=r.__attrs.clip,o=r.__cfg.children;return a?a.inside(t,e)&&(n=i(o,t,e)):n=i(o,t,e),n},clearTotalMatrix:function(){var t=this.get("totalMatrix");if(t){this.setSilent("totalMatrix",null);for(var e=this.__cfg.children,n=0;n<e.length;n++){var i=e[n];i.clearTotalMatrix()}}},clear:function(){for(var t=this.get("children");0!==t.length;)t[t.length-1].remove();return this},destroy:function(){this.get("destroyed")||(this.clear(),h.superclass.destroy.call(this))}}),t.exports=h},function(t,e,n){var i=n(1),r=n(35),a=new r;t.exports={tween:a,animate:function(t,e,n,r){var o=a.getNow(),s=i.mix({},t,{duration:e});a.animate(this).append(o,s,n,r),"silent"===a.get("status")&&a.play()}}},function(t,e,n){var i=n(1),r=n(3).Vector3,a=["strokeStyle","fillStyle","globalAlpha"],o=["circle","ellipse","fan","polygon","rect","path"],s={r:"R",opacity:"Opacity",lineWidth:"LineWidth",clip:"Clip",stroke:"Stroke",fill:"Fill",strokeOpacity:"Stroke",fillOpacity:"Fill",x:"X",y:"Y",rx:"Rx",ry:"Ry",re:"Re",rs:"Rs",width:"Width",height:"Height",img:"Img",x1:"X1",x2:"X2",y1:"Y1",y2:"Y2",points:"Points",p1:"P1",p2:"P2",p3:"P3",p4:"P4",text:"Text",radius:"Radius",textAlign:"TextAlign",textBaseline:"TextBaseline",font:"Font",fontSize:"FontSize",fontStyle:"FontStyle",fontVariant:"FontVariant",fontWeight:"FontWeight",fontFamily:"FontFamily",clockwise:"Clockwise",startAngle:"StartAngle",endAngle:"EndAngle",path:"Path"},u={stroke:"strokeStyle",fill:"fillStyle",opacity:"globalAlpha"};t.exports={canFill:!1,canStroke:!1,initAttrs:function(t){return this.__attrs={opacity:1,fillOpacity:1,strokeOpacity:1},this.attr(i.simpleMix(this.getDefaultAttrs(),t)),this},getDefaultAttrs:function(){return{}},attr:function(t,e){var n=this;if(0===arguments.length)return n.__attrs;if(i.isObject(t)){for(var r in t)if(a.indexOf(r)===-1){var o=t[r];n._setAttr(r,o)}return n.__afterSetAttrAll&&n.__afterSetAttrAll(t),n.clearBBox(),n}if(2===arguments.length){if(n._setAttr(t,e)!==!1){var u="__afterSetAttr"+s[t];n[u]&&n[u](e)}return n.clearBBox(),n}return n._getAttr(t)},clearBBox:function(){this.setSilent("box",null)},__afterSetAttrAll:function(){},_getAttr:function(t){return this.__attrs[t]},_setAttr:function(t,e){var n=this;if("clip"===t)n.__setAttrClip(e),n.__attrs.clip=e;else{n.__attrs[t]=e;var i=u[t];i&&(n.__attrs[i]=e)}return n},hasFill:function(){return this.canFill&&this.__attrs.fillStyle},hasStroke:function(){return this.canStroke&&this.__attrs.strokeStyle},__setAttrOpacity:function(t){return this.__attrs.globalAlpha=t,t},__setAttrClip:function(t){var e=this;return t&&o.indexOf(t.type)>-1?(null===t.get("canvas")&&(t=i.clone(t)),t.set("parent",e.get("parent")),t.set("context",e.get("context")),t.inside=function(n,i){var a=new r(n,i,1);return t.invert(a,e.get("canvas")),t.__isPointInFill(a.x,a.y)},t):null}}},function(t,e,n){function i(t){var e=t.elements;return 1===e[0]&&0===e[1]&&0===e[3]&&1===e[4]&&0===e[6]&&0===e[7]}function r(t){var e=t.elements;return 0===e[1]&&0===e[3]&&0===e[6]&&0===e[7]}function a(t,e){i(e)||(r(e)?(t.elements[0]*=e.elements[0],t.elements[4]*=e.elements[4]):t.multiply(e))}var o=n(1),s=n(3).Matrix3;t.exports={initTransform:function(){this.__m=new s},translate:function(t,e){return this.__m.translate(t,e),this.clearTotalMatrix(),this},rotate:function(t){return this.__m.rotate(t),this.clearTotalMatrix(),this},scale:function(t,e){return this.__m.scale(t,e),this.clearTotalMatrix(),this},rotateAtStart:function(t){var e=this.attr("x"),n=this.attr("y");Math.abs(t)>2*Math.PI&&(t=t/180*Math.PI),this.transform([["t",-e,-n],["r",t],["t",e,n]])},move:function(t,e){var n=this.get("x")||0,i=this.get("y")||0;this.translate(t-n,e-i),this.set("x",t),this.set("y",e)},transform:function(t){var e=this;return o.each(t,function(t){switch(t[0]){case"t":e.translate(t[1],t[2]);break;case"s":e.scale(t[1],t[2]);break;case"r":e.rotate(t[1]);break;case"m":e.__m=s.multiply(t[1],e.__m),e.clearTotalMatrix()}}),e},setTransform:function(t){return this.__m.identity(),this.transform(t)},getMatrix:function(){return this.__m},setMatrix:function(t){return this.__m=t,this.clearTotalMatrix(),this},apply:function(t,e){var n;return n=e?this._getMatrixByRoot(e):this.__m,t.applyMatrix(n),this},_getMatrixByRoot:function(t){var e=this;t=t||e;for(var n=e,i=[];n!==t;)i.unshift(n),n=n.get("parent");i.unshift(n);var r=new s;return o.each(i,function(t){r.multiply(t.__m)}),r},getTotalMatrix:function(){var t=this.__cfg.totalMatrix;if(!t){t=new s;var e=this.__cfg.parent;if(e){var n=e.getTotalMatrix();a(t,n)}a(t,this.__m),this.__cfg.totalMatrix=t}return t},clearTotalMatrix:function(){},invert:function(t){var e=this.getTotalMatrix();if(r(e))t.x/=e.elements[0],t.y/=e.elements[4];else{var n=e.getInverse();t.applyMatrix(n)}return this},resetTransform:function(t){var e=this.__m.to2DObject();i(this.__m)||t.transform(e.a,e.b,e.c,e.d,e.e,e.f)}}},function(t,e){t.exports={xAt:function(t,e,n,i,r){return e*Math.cos(t)*Math.cos(r)-n*Math.sin(t)*Math.sin(r)+i},yAt:function(t,e,n,i,r){return e*Math.sin(t)*Math.cos(r)+n*Math.cos(t)*Math.sin(r)+i},xExtrema:function(t,e,n){return Math.atan(-n/e*Math.tan(t))},yExtrema:function(t,e,n){return Math.atan(n/(e*Math.tan(t)))}}},function(t,e,n){function i(t,e,n){return{x:n.x+t,y:n.y+e}}function r(t,e){return{x:e.x+(e.x-t.x),y:e.y+(e.y-t.y)}}function a(t){return Math.sqrt(t[0]*t[0]+t[1]*t[1])}function o(t,e){return(t[0]*e[0]+t[1]*e[1])/(a(t)*a(e))}function s(t,e){return(t[0]*e[1]<t[1]*e[0]?-1:1)*Math.acos(o(t,e))}function u(t,e,n,i,r,a,u){var c=h.mod(h.degreeToRad(u),2*Math.PI),l=t.x,d=t.y,f=e.x,g=e.y,p=Math.cos(c)*(l-f)/2+Math.sin(c)*(d-g)/2,v=-1*Math.sin(c)*(l-f)/2+Math.cos(c)*(d-g)/2,x=p*p/(r*r)+v*v/(a*a);x>1&&(r*=Math.sqrt(x),a*=Math.sqrt(x));var m=Math.sqrt((r*r*(a*a)-r*r*(v*v)-a*a*(p*p))/(r*r*(v*v)+a*a*(p*p)));n===i&&(m*=-1),isNaN(m)&&(m=0);var y=m*r*v/a,b=m*-a*p/r,w=(l+f)/2+Math.cos(c)*y-Math.sin(c)*b,_=(d+g)/2+Math.sin(c)*y+Math.cos(c)*b,M=s([1,0],[(p-y)/r,(v-b)/a]),S=[(p-y)/r,(v-b)/a],A=[(-1*p-y)/r,(-1*v-b)/a],P=s(S,A);return o(S,A)<=-1&&(P=Math.PI),o(S,A)>=1&&(P=0),0===i&&P>0&&(P-=2*Math.PI),1===i&&P<0&&(P+=2*Math.PI),[t,w,_,r,a,M,P,c,i]}var c=n(1),h=n(8),l=n(6),d=n(17),f=n(23),g=n(107),p=n(3),v=p.Vector2,x=p.Vector3,m=p.Matrix3,y=["m","l","c","a","q","h","v","t","s","z"],b=function(t,e,n){this.preSegment=e,this.isLast=n,this.init(t,e)};c.augment(b,{init:function(t,e){var n=t[0];e=e||{endPoint:{x:0,y:0}};var a,o,s,c,h=y.indexOf(n)>=0,l=h?n.toUpperCase():n,d=t,f=e.endPoint,g=d[1],p=d[2];switch(l){default:break;case"M":c=h?i(g,p,f):{x:g,y:p},this.command="M",this.params=[f,c],this.subStart=c,this.endPoint=c;break;case"L":c=h?i(g,p,f):{x:g,y:p},this.command="L",this.params=[f,c],this.subStart=e.subStart,this.endPoint=c,this.isLast&&(this.endTangent=function(){return new v(c.x-f.x,c.y-f.y)});break;case"H":c=h?i(g,0,f):{x:g,y:f.y},this.command="L",this.params=[f,c],this.subStart=e.subStart,this.endPoint=c,this.endTangent=function(){return new v(c.x-f.x,c.y-f.y)};break;case"V":c=h?i(0,g,f):{x:f.x,y:g},this.command="L",this.params=[f,c],this.subStart=e.subStart,this.endPoint=c,this.endTangent=function(){return new v(c.x-f.x,c.y-f.y)};break;case"Q":h?(a=i(g,p,f),o=i(d[3],d[4],f)):(a={x:g,y:p},o={x:d[3],y:d[4]}),this.command="Q",this.params=[f,a,o],this.subStart=e.subStart,this.endPoint=o,this.endTangent=function(){return new v(o.x-a.x,o.y-a.y)};break;case"T":o=h?i(g,p,f):{x:g,y:p},"Q"===e.command?(a=r(e.params[1],f),this.command="Q",this.params=[f,a,o],this.subStart=e.subStart,this.endPoint=o,this.endTangent=function(){return new v(o.x-a.x,o.y-a.y)}):(this.command="TL",this.params=[f,o],this.subStart=e.subStart,this.endPoint=o,this.endTangent=function(){return new v(o.x-f.x,o.y-f.y)});break;case"C":h?(a=i(g,p,f),o=i(d[3],d[4],f),s=i(d[5],d[6],f)):(a={x:g,y:p},o={x:d[3],y:d[4]},s={x:d[5],y:d[6]}),this.command="C",this.params=[f,a,o,s],this.subStart=e.subStart,this.endPoint=s,this.endTangent=function(){return new v(s.x-o.x,s.y-o.y)};break;case"S":h?(o=i(g,p,f),s=i(d[3],d[4],f)):(o={x:g,y:p},s={x:d[3],y:d[4]}),"C"===e.command?(a=r(e.params[2],f),this.command="C",this.params=[f,a,o,s],this.subStart=e.subStart,this.endPoint=s,this.endTangent=function(){return new v(s.x-o.x,s.y-o.y)}):(this.command="SQ",this.params=[f,o,s],this.subStart=e.subStart,this.endPoint=s,this.endTangent=function(){return new v(s.x-o.x,s.y-o.y)});break;case"A":var x=g,m=p,b=d[3],w=d[4],_=d[5];c=h?i(d[6],d[7],f):{x:d[6],y:d[7]},this.command="A",this.params=u(f,c,w,_,x,m,b),this.subStart=e.subStart,this.endPoint=c;break;case"Z":this.command="Z",this.params=[f,e.subStart],this.subStart=e.subStart,this.endPoint=e.subStart}},isInside:function(t,e,n){var i=this,r=i.command,a=i.params,o=i.box;if(o&&!l.box(o.minX,o.maxX,o.minY,o.maxY,t,e))return!1;switch(r){default:break;case"M":return!1;case"TL":case"L":case"Z":return l.line(a[0].x,a[0].y,a[1].x,a[1].y,n,t,e);case"SQ":case"Q":return l.quadraticline(a[0].x,a[0].y,a[1].x,a[1].y,a[2].x,a[2].y,n,t,e);case"C":return l.cubicline(a[0].x,a[0].y,a[1].x,a[1].y,a[2].x,a[2].y,a[3].x,a[3].y,n,t,e);case"A":var s=a,u=s[1],c=s[2],h=s[3],d=s[4],f=s[5],g=s[6],p=s[7],v=s[8],y=h>d?h:d,b=h>d?1:h/d,w=h>d?d/h:1;s=new x(t,e,1);var _=new m;return _.translate(-u,-c),_.rotate(-p),_.scale(1/b,1/w),s.applyMatrix(_),l.arcline(0,0,y,f,f+g,1-v,n,s.x,s.y)}return!1},draw:function(t){var e,n,i,r=this.command,a=this.params;switch(r){default:break;case"M":t.moveTo(a[1].x,a[1].y);break;case"TL":case"L":t.lineTo(a[1].x,a[1].y);break;case"SQ":case"Q":e=a[1],n=a[2],t.quadraticCurveTo(e.x,e.y,n.x,n.y);break;case"C":e=a[1],n=a[2],i=a[3],t.bezierCurveTo(e.x,e.y,n.x,n.y,i.x,i.y);break;case"A":var o=a,s=o[1],u=o[2],c=s,h=u,l=o[3],d=o[4],f=o[5],g=o[6],p=o[7],v=o[8],x=l>d?l:d,m=l>d?1:l/d,y=l>d?d/l:1;t.translate(c,h),t.rotate(p),t.scale(m,y),t.arc(0,0,x,f,f+g,1-v),t.scale(1/m,1/y),t.rotate(-p),t.translate(-c,-h);break;case"Z":t.closePath()}},getBBox:function(t){var e,n,i,r,a=t/2,o=this.params;switch(this.command){default:case"M":case"Z":break;case"TL":case"L":this.box={minX:Math.min(o[0].x,o[1].x)-a,maxX:Math.max(o[0].x,o[1].x)+a,minY:Math.min(o[0].y,o[1].y)-a,maxY:Math.max(o[0].y,o[1].y)+a};break;case"SQ":case"Q":for(n=f.extrema(o[0].x,o[1].x,o[2].x),i=0,r=n.length;i<r;i++)n[i]=f.at(o[0].x,o[1].x,o[2].x,n[i]);for(n.push(o[0].x,o[2].x),e=f.extrema(o[0].y,o[1].y,o[2].y),i=0,r=e.length;i<r;i++)e[i]=f.at(o[0].y,o[1].y,o[2].y,e);e.push(o[0].y,o[2].y),this.box={minX:Math.min.apply(Math,n)-a,maxX:Math.max.apply(Math,n)+a,minY:Math.min.apply(Math,e)-a,maxY:Math.max.apply(Math,e)+a};break;case"C":for(n=d.extrema(o[0].x,o[1].x,o[2].x,o[3].x),i=0,r=n.length;i<r;i++)n[i]=d.at(o[0].x,o[1].x,o[2].x,o[3].x,n[i]);for(e=d.extrema(o[0].y,o[1].y,o[2].y,o[3].y),i=0,r=e.length;i<r;i++)e[i]=d.at(o[0].y,o[1].y,o[2].y,o[3].y,e[i]);n.push(o[0].x,o[3].x),e.push(o[0].y,o[3].y),this.box={minX:Math.min.apply(Math,n)-a,maxX:Math.max.apply(Math,n)+a,minY:Math.min.apply(Math,e)-a,maxY:Math.max.apply(Math,e)+a};break;case"A":var s=o,u=s[1],c=s[2],h=s[3],l=s[4],p=s[5],v=s[6],x=s[7],m=s[8],y=p,b=p+v,w=g.xExtrema(x,h,l),_=1/0,M=-(1/0),S=[y,b];for(i=2*-Math.PI;i<=2*Math.PI;i+=Math.PI){var A=w+i;1===m?y<A&&A<b&&S.push(A):b<A&&A<y&&S.push(A)}for(i=0,r=S.length;i<r;i++){var P=g.xAt(x,h,l,u,S[i]);P<_&&(_=P),P>M&&(M=P)}var T=g.yExtrema(x,h,l),C=1/0,I=-(1/0),k=[y,b];for(i=2*-Math.PI;i<=2*Math.PI;i+=Math.PI){var B=T+i;1===m?y<B&&B<b&&k.push(B):b<B&&B<y&&k.push(B)}for(i=0,r=k.length;i<r;i++){var E=g.yAt(x,h,l,c,k[i]);E<C&&(C=E),E>I&&(I=E)}this.box={minX:_-a,maxX:M+a,minY:C-a,maxY:I+a}}}}),t.exports=b},function(t,e){var n=document.createElement("table"),i=document.createElement("tr"),r=/^\s*<(\w+|!)[^>]*>/,a={tr:document.createElement("tbody"),tbody:n,thead:n,tfoot:n,td:i,th:i,"*":document.createElement("div")};t.exports={getBoundingClientRect:function(t){var e=t.getBoundingClientRect(),n=document.documentElement.clientTop,i=document.documentElement.clientLeft;return{top:e.top-n,bottom:e.bottom-n,left:e.left-i,right:e.right-i}},getStyle:function(t,e){return window.getComputedStyle?window.getComputedStyle(t,null)[e]:t.currentStyle[e]},modiCSS:function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t.style[n]=e[n]);return t},createDom:function(t){var e=r.test(t)&&RegExp.$1;e in a||(e="*");var n=a[e];return t=t.replace(/(^\s*)|(\s*$)/g,""),n.innerHTML=""+t,n.childNodes[0]},addEventListener:function(t,e,n){return t.addEventListener?(t.addEventListener(e,n,!1),{remove:function(){t.removeEventListener(e,n,!1)}}):t.attachEvent?(t.attachEvent("on"+e,n),{remove:function(){t.detachEvent("on"+e,n)}}):void 0}}},function(t,e){t.exports={transform:function(t,e){t=t.clone();for(var n=0,i=e.length;n<i;n++){var r=e[n];switch(r[0]){case"t":t.translate(r[1],r[2]);break;case"s":t.scale(r[1],r[2]);break;case"r":t.rotate(r[1]);break;case"m":t.multiply(r[1]);break;default:continue}}return t},scale:function(t,e,n,i,r){return t=t.clone(),t.translate(-1*i,-1*r),t.scale(e,n),t.translate(i,r),t},rotate:function(t,e,n,i){return t=t.clone(),t.translate(-1*n,-1*i),t.rotate(e),t.translate(n,i),t},isMatrix3:function(t){return"matrix3"===t.type}}},function(t,e,n){"use strict";var i=n(25),r=n(4);t.exports=function(t){var e=r.getBBox(t,t),n=e.centerX,a=e.centerY;i.scaleIn(t,n,a)}},function(t,e,n){"use strict";var i=n(25),r=n(4);t.exports=function(t){var e=r.getBBox(t,t),n=e.centerX,a=e.centerY;i.scaleOut(t,n,a)}},function(t,e,n){"use strict";var i=n(7);t.exports=function(t,e){t.set("capture",!1),t.animate(e,i.updateDuration,i.updateEasing,function(){t.set("capture",!0)})}},function(t,e,n){"use strict";function i(t,e){if(!t||!e)return!1;var n=t.length,i=e.length,r=i>n?e:t,a={attrs0:{},attrs1:{}},s=!1,u=void 0,h=void 0,l=void 0,d=void 0;return o.each(r,function(n,i){u=t[i],h=e[i],o.isObject(u)||o.isObject(h)||"path"===i&&(l=o.isString(u)?u:o.pathToString(u),d=o.isString(h)?h:o.pathToString(h),l===d||l.indexOf("NaN")!==-1||d.indexOf("NaN")!==-1)||o.isArray(u)&&o.isArray(h)&&o.equalsArray(u,h)||u===h||c[i]||(a.attrs0[i]=u,a.attrs1[i]=h,s=!0)}),!!s&&a}function r(t,e,n){var i=e.get("children"),a=void 0,s=void 0;return o.each(i,function(e){n++,s=e.get("gid"),e.isGroup&&(n=r(t,e,n)),s&&(t[s]={matrix:e.getMatrix().clone(),origin:e},a=e.get("shapeCfg"),a&&(t[s].enterAnimate=e.get("enterAnimate"),t[s].leaveAnimate=e.get("leaveAnimate"),t[s].model=a.origin),e.isShape&&(t[s].attrs=e.getAllAttrs()))}),n}var a=n(3),o=n(4),s=n(24),u=a.Matrix3,c={text:"text",elements:"elements",rotate:"rotate",textAlign:"textAlign",textBaseline:"textBaseline",fontStyle:"fontStyle",font:"font",fontWeight:"fontWeight",fontFamily:"fontFamily"},h=function(t){o.mix(this,t)};o.augment(h,{canvas:null,map0:null,map1:null,run:function(){this.init(),this.count<5e3&&(this._compare(),this._addTween()),o.each(this.canvases,function(t){t.draw()})},init:function(){var t=this.canvases,e=this.elementsStash,n={},i=0;e=e?e:{},o.each(t,function(t){i+=r(n,t,0)}),this.elementsStash=n,this.map0=e,this.map1=n,this.count=i},_compare:function(){var t=this.map0,e=this.map1,n=[],i=[],r=[];o.each(e,function(e,i){t[i]?e.origin.get("type")===t[i].origin.get("type")&&r.push(i):n.push(i)}),o.each(t,function(t,n){e[n]||i.push(n)}),this.enterElements=n,this.leaveElements=i,this.updateElements=r},_addTween:function(){var t=this,e=this.enterElements,n=this.leaveElements,r=this.updateElements,a=this.map0,c=this.map1,h=void 0,l=void 0,d=void 0,f=void 0,g=void 0;o.each(e,function(t){g=c[t],g.enterAnimate&&g.enterAnimate(g.origin,a,c)}),o.each(n,function(t){f=a[t],f.leaveAnimate&&(f.origin.getParent().add(f.origin),f.leaveAnimate(f.origin,a,c))}),o.each(r,function(e){g=c[e],f=a[e],l=i(f.attrs,g.attrs),h=u.equal(f.matrix,g.matrix),d={},l&&(g.origin.attr(l.attrs0),o.mix(d,l.attrs1)),h||(g.origin.setMatrix(f.matrix),d.matrix=g.matrix),!l&&h||s.update(g.origin,d,t),f.origin!==g.origin&&f.origin.remove()})}}),t.exports=h},function(t,e,n){"use strict";function i(t,e,n){return t.addEventListener?(t.addEventListener(e,n,!1),{remove:function(){t.removeEventListener(e,n,!1)}}):t.attachEvent?(t.attachEvent("on"+e,n),{remove:function(){t.detachEvent("on"+e,n)}}):void 0}var r=n(4),a=function(t){r.mix(this,t),this.init()};r.augment(a,{graph:null,frontCanvas:null,canvas:null,currentItem:null,dragitem:null,rootGroup:null,lastEventObj:null,currentEventObj:null,el:null,init:function(){var t=this.graph;this.frontCanvas=t.get("frontCanvas"),this.canvas=t.get("canvas"),this._initEvent()},_initEvent:function(){var t=this,e=t.frontCanvas,n=e.get("el");this.el=n,this.domMouseEnter=i(n,"mouseenter",r.wrapBehavior(t,"onDomMouseEnter")),this.domMouseLeave=i(n,"mouseleave",r.wrapBehavior(t,"onDomMouseLeave")),this.domMouseDown=i(n,"mousedown",r.wrapBehavior(t,"onMouseDown")),this.domMouseUp=i(n,"mouseup",r.wrapBehavior(t,"onMouseUp")),this.domMouseMove=i(n,"mousemove",r.wrapBehavior(t,"onMouseMove")),this.domDblClick=i(n,"dblclick",r.wrapBehavior(t,"onDblClick")),this.domMouseWheel=i(n,"mousewheel",r.wrapBehavior(t,"onMouseWheel")),this.domKeyDown=i(n,"keydown",r.wrapBehavior(t,"onKeyDown")),this.domKeyUp=i(n,"keyup",r.wrapBehavior(t,"onKeyUp")),this.domContextMenu=i(n,"contextmenu",r.wrapBehavior(t,"onContextMenu")),this.domOnFocus=i(n,"focus",r.wrapBehavior(t,"onFocus")),this.domOnBlur=i(n,"blur",r.wrapBehavior(t,"onBlur"))},_parsePoint:function(t,e){var n=this.canvas.get("pixelRatio"),i=this.graph,r={x:t/n,y:e/n};return i.invertPoint(r)},_getEventObj:function(t,e){var n=this.graph,i=t.clientX,r=t.clientY,a=e.getPointByClient(i,r),o=this._parsePoint(a.x,a.y),s=e.getShape(a.x,a.y),u=n.getItem(s),c=void 0;return u&&(c=u.get("type")),{item:u,itemType:c,shape:s,x:o.x,y:o.y,domX:t.offsetX,domY:t.offsetY,domEvent:t}},getEventObj:function(t){return{item:t.item,itemType:t.itemType,x:t.x,y:t.y,domX:t.domX,domY:t.domY,shape:t.shape,toEvObj:t.toEvObj,frontEvObj:t.frontEvObj,domEvent:t.domEvent}},_processEventObj:function(t){var e=this.canvas,n=this.frontCanvas,i=this.currentEventObj;i&&r.isObject(i)&&(this.lastEventObj=r.mix({},i));var a=this._getEventObj(t,e),o=this._getEventObj(t,n);o.shape&&(a.shape=o.shape),o.item&&(a.item=o.item,a.itemType=o.item.get("type")),a.frontEvObj=o,this.currentEventObj=a,this.currentItem=a.item},onFocus:function(){this.graph.fire("domfocus")},onBlur:function(){this.graph.fire("domblur")},onDomMouseEnter:function(t){this.graph.fire("dommouseenter",t)},onDomMouseLeave:function(t){this.graph.fire("dommouseleave",t)},onContextMenu:function(t){this._processEventObj(t);var e=this.currentEventObj;this.graph.fire("contextmenu",this.getEventObj(e))},onDblClick:function(t){this._processEventObj(t);var e=this.currentEventObj;this.graph.fire("dblclick",this.getEventObj(e))},onKeyUp:function(t){this.graph.fire("keyup",t)},onKeyDown:function(t){this.graph.fire("keydown",t)},onMouseWheel:function(t){this._processEventObj(t);var e=this.currentEventObj;this.graph.fire("mousewheel",this.getEventObj(e))},onMouseDown:function(t){t.preventDefault(),this._processEventObj(t);var e=this.currentEventObj;0===t.button&&(this.pressing=!0,this.dragging=!0,this.pressingPoint={x:e.x,y:e.y},this.graph.fire("mousedown",this.getEventObj(e)),e.item&&this.graph.fire("itemmousedown",this.getEventObj(e)))},onMouseUp:function(t){t.preventDefault(),this._processEventObj(t);var e=this.currentEventObj;0===t.button&&(this.pressing&&(this.graph.fire("click",this.getEventObj(e)),e.item&&this.graph.fire("itemclick",this.getEventObj(e)),this.pressing=!1),this.dragging&&(this.dragStartPoint&&this.graph.fire("dragend",this.getEventObj(e)),this.dragging=!1),this.graph.fire("mouseup",this.getEventObj(e)),e.item&&this.graph.fire("itemmouseup",this.getEventObj(e)),this.dragStartPoint=null,this.dragItem=null)},onMouseMove:function(t){t.preventDefault(),this._processEventObj(t);var e=this.graph,n=this.currentEventObj,i=this.lastEventObj;this.pressing!==!0||n.x===i.x&&n.y===i.y||(this.pressing=!1),i&&n&&(i.toEvObj=n,n.fromEvObj=i,this.isSame(i,n,"shape")||(i.shape&&e.fire("mouseleave",this.getEventObj(i)),n.shape&&e.fire("mouseenter",this.getEventObj(n))),this.isSame(i,n,"item")||(i.item&&e.fire("itemmouseleave",this.getEventObj(i)),n.item&&e.fire("itemmouseenter",this.getEventObj(n)))),this.dragging&&(this.dragStartPoint?e.fire("dragmove",this.getEventObj(n)):(this.dragStartPoint={x:n.x,y:n.y},this.dragItem=n.item,e.fire("dragstart",this.getEventObj(n)))),n.item&&e.fire("itemhover",this.getEventObj(n)),e.fire("mousemove",this.getEventObj(n))},isSame:function(t,e,n){var i=t[n],r=e[n];return i===r},destroy:function(){
                var t=this.domMouseUp,e=this.domMouseDown,n=this.domMouseMove,i=this.domDblClick,r=this.domMouseWheel,a=this.domContextMenu,o=this.domKeyDown,s=this.domKeyUp,u=this.domOnFocus,c=this.domOnBlur,h=this.dommouseleave,l=this.domMouseEnter;a&&a.remove(),s&&s.remove(),r&&r.remove(),o&&o.remove(),i&&i.remove(),t&&t.remove(),e&&e.remove(),n&&n.remove(),h&&h.remove(),l&&l.remove(),u&&u.remove(),c&&c.remove()}}),t.exports=a},function(t,e,n){"use strict";var i=n(1),r=function(t){i.mix(this,t),this.init()};i.augment(r,{group:null,visible:!0,gridEl:null,minX:0,minY:0,cell:10,maxX:1e3,maxY:1e3,line:null,init:function(){var t=this,e=t.group,n=t._getPath(),r=i.mix({},t.line);r.path=n;var a=e.addShape("path",{attrs:r,capture:!1});a.set("visible",t.visible),this.gridEl=a},_getPath:function(){for(var t=this,e=t.minX,n=t.minY,i=t.maxX,r=t.maxY,a=t._getCell(),o=Math.ceil(e/a)*a,s=Math.ceil(n/a)*a,u=[],c=0;c<=i-e;c+=a){var h=o+c;u.push(["M",h,n]),u.push(["L",h,r])}for(var l=0;l<=r-n;l+=a){var d=s+l;u.push(["M",e,d]),u.push(["L",i,d])}return u},_getCell:function(){var t=this.cell?this.cell:10;return t},update:function(t){i.mix(this,t);var e=this._getPath(),n=this.gridEl;n.attr("path",e),n.set("visible",this.visible)},destroy:function(){var t=this,e=t.gridEl;e&&e.remove()}}),t.exports=r},function(t,e,n){"use strict";var i=n(4),r=n(26),a=function(t){i.mix(this,t),this.init()};i.augment(a,{graph:null,guides:[],frontGuideGroup:null,backGuideGroup:null,init:function(){var t=this.graph,e=t.get("frontGroup").addGroup(),n=t.get("backGroup").addGroup();this.frontGuideGroup=e,this.backGuideGroup=n},link:function(t){this.guides.push({type:"link",cfg:t})},_link:function(t){var e=this.guides,n=this.graph,a=n.find(t.source),o=n.find(t.target);if(!a||!o)return!1;var s=t.id?t.id:"guide-link-"+e.length,u=this.frontGuideGroup,c=u.addGroup(r,{data:{type:"link",cfg:t},id:s}),h=a.getCenter(),l=o.getCenter(),d=a.getIntersectionByPoint(l),f=o.getIntersectionByPoint(h),g=i.mix({},t,{source:a,target:o,points:[d,f]}),p=t.shape?t.shape:"line";return i.drawEdge(p,g,c),c},draw:function(){var t=this,e=this.guides;i.each(e,function(e){t["_"+e.type](e.cfg)})},save:function(){return this.guides},remove:function(){},clear:function(t){this.frontGuideGroup.clear(t),this.backGuideGroup.clear(t)},destroy:function(){this.frontGuideGroup.clear(),this.backGuideGroup.clear()}}),t.exports=a},function(t,e,n){"use strict";var i=n(4),r=n(7),a=function(t){i.mix(this,t),this.init()};i.augment(a,{graph:null,tooltipDOM:null,titleDOM:null,listDOM:null,tooltipCSS:{border:"none","border-radius":"4px",background:"rgba(33,33,33,0.7)",color:"white","font-size":"14px",margin:0,padding:"8px 16px"},titleCSS:{margin:0},listCSS:{margin:0,"list-style-type":"none",padding:"0px"},title:"",dx:10,dy:10,margin:10,split:": ",timer:setTimeout(function(){}),tooltipHtml:'<div class="g6-tooltip" style="position: absolute;white-space:nowrap;z-index: 5;"></div>',titleHtml:'<h4 class="g6-tooltip-title"></h4>',listHtml:'<ul class="g6-tooltip-list"></ul>',liTpl:"<li><span>{name}</span>{split}{value}</li>",custom:!1,init:function(){var t=this.custom;t||this._createDOM(),this._bindEvent()},_createDOM:function(){var t=this.graph,e=t.get("graphContainer"),n=i.createDOM(this.tooltipHtml,this.tooltipCSS),r=i.createDOM(this.titleHtml,this.titleCSS),a=i.createDOM(this.listHtml,this.listCSS);e.appendChild(n),n.appendChild(r),n.appendChild(a),n.hide(),r.innerHTML=this.title,this.titleDOM=r,this.listDOM=a,this.tooltipDOM=n},_bindEvent:function(){var t=this.graph;t.on("itemmouseenter",i.wrapBehavior(this,"onMouseenter")),t.on("itemhover",i.wrapBehavior(this,"onItemhover")),t.on("itemmouseleave",i.wrapBehavior(this,"onMouseleave")),t.on("dommouseleave",i.wrapBehavior(this,"onDomMouseleave"))},_changeContent:function(t){var e=this,n=this.listDOM,r=this.liTpl,a="";t&&(i.isArray(t[0])||(t=[t]),i.each(t,function(t){a+=i.substitute(r,{name:t[0],value:t[1],split:e.split})}),n.innerHTML=a)},_getTop:function(t,e,n){var i=this.dy;return 2*t.height>=e.height?"0px":n<t.height+i?n+i+"px":n-t.height-i+"px"},_getLeft:function(t,e,n){var i=this.dx;return 2*t.width>=e.width?"0px":e.width-n-i<t.width?n-t.width-i+"px":n+i+"px"},_changePositon:function(t){var e=this.tooltipDOM,n=this.graph.get("htmlElementContaniner"),i={x:0,y:0,width:e.width()+e.paddingRight()+e.paddingLeft(),height:e.height()+e.paddingTop()+e.paddingBottom()},r={x:0,y:0,width:n.width(),height:n.height()},a=t.domX,o=t.domY;e.css({top:this._getTop(i,r,o),left:this._getLeft(i,r,a)})},onMouseenter:function(t){var e=this.custom;if(e)this.show(t);else{var n=t.item.getShapeCfg().tooltip;n&&(this._changeContent(n),this.show(t))}},onItemhover:function(t){this._changePositon(t)},onMouseleave:function(){this.hide()},onDomMouseleave:function(){this.hide()},show:function(t){var e=this.tooltipDOM,n=this.graph,i=this.timer;clearTimeout(i),i=setTimeout(function(){e.show(),n.fire("tooltipshow",t)},r.toolTipTimeout),this.timer=i},hide:function(){var t=this.tooltipDOM;t.hide()},destroy:function(){var t=this.graph,e=this.custom,n=this.tooltipDOM;!e&&n.destroy(),t.off("itemhover",i.getWrapBehavior(this,"onItemhover")),t.off("mouseleave",i.getWrapBehavior(this,"onMouseleave"))}}),t.exports=a},function(t,e,n){"use strict";var i=n(10).G,r=n(4),a=i.Group,o=function t(e){t.superclass.constructor.call(this,e)};r.extend(o,a),r.augment(o,{drawInner:function(t){var e=this;this.traverseChildren(function(t){var n=t.get("freezePoint"),i=e.getMatrix().elements[0];t.isShape&&n&&t.get("visible")&&(t.initTransform(),t.transform([["t",-n.x,-n.y],["s",1/i,1/i],["t",n.x,n.y]]))}),o.superclass.drawInner.call(this,t)}}),t.exports=o},function(t,e,n){"use strict";function i(t,e){var n=t.get("children");a.each(n,function(n){e(n,t),n.get("children")&&i(n,e)})}var r=n(10),a=n(4),o=n(28),s=r.G,u=function(){};a.augment(u,{traverseChildren:function(t){i(this,t)},radixSort:function(){var t=this.get("children");this.set("children",a.radixSort(t,function(t){return t.get("zIndex")}))},clear:function(t){var e=this.get("children");for(t=t!==!1;0!==e.length;)e[e.length-1].remove(t);return this},findByCFG:function(t,e){var n=this.get("children"),i=[];return a.each(n,function(n){n.get(t)===e&&i.push(n)}),i}}),a.mixin(s.Group,[u,o]),t.exports=u},function(t,e,n){"use strict";function i(t,e){var n=e.elements,i=n[0]*t.x+n[3]*t.y+n[6],r=n[1]*t.x+n[4]*t.y+n[7];return t.x=i,t.y=r,t}function r(t){var e=t.fill,n=t.fillOpacity,i=new o(e);return t.stroke&&(t.border=""+t.lineWidth+"px solid "+t.stroke),e&&n?void(t["background-color"]="rgba("+255*i.getR()+", "+255*i.getG()+", "+255*i.getB()+", "+n+")"):void(e&&(t.fill=e))}var a=n(10),o=n(16),s=n(50),u=n(4),c=a.G,h=function t(e){t.superclass.constructor.call(this,e)};h.ATTRS={x:0,y:0,width:0,height:0,fillOpacity:1,lineWidth:1},u.extend(h,c.Shape),u.augment(h,{canFill:!0,type:"html",__isPointInFill:function(t,e){var n=this.getBBox(),i=n.minX,r=n.minY,a=n.maxX-n.minX,o=n.maxY-n.minY;return i<=t&&t<=i+a&&r<=e&&e<=r+o},getDefaultAttrs:function(){return h.ATTRS},init:function(){var t=this.get("canvas"),e=this.get("attrs"),n=this.get("autoSize"),i=t.get("htmlElementContaniner"),r=e.html,a=e.cx,o=e.cy,s=u.createDOM(r,{position:"absolute",padding:"0px",margin:"0px",visibility:"hidden"}),c=void 0,h=void 0;i.appendChild(s),n&&(c=s.width(),h=s.height(),this.attr("x",a-c/2),this.attr("y",o-h/2),this.attr("width",c),this.attr("height",h)),this.set("dom",s)},attr:function(t,e){var n=this.get("attrs");return u.isObject(t)?(u.mix(n,t),r(n),void 0===t.x&&void 0===t.y&&void 0===t.width&&void 0===t.height||this.calculateBox(),n):u.isNull(e)?n[t]:(n[t]=e,r(n),"x"!==t&&"y"!==t&&"width"!==t&&"height"!==t||this.calculateBox(),this)},calculateBox:function(){var t=this.attr("x"),e=this.attr("y"),n=this.attr("width"),i=this.attr("height"),r=this.attr("lineWidth");return{minX:t-r/2,minY:e-r/2,maxX:t+n+r/2,maxY:e+i+r/2}},isPointInPath:function(t,e){return this.__isPointInFill(t,e)},applyTransform:function(){var t=this.get("dom"),e=this.get("canvas"),n=e.get("pixelRatio"),r=this.getTotalMatrix(),a=this.attr("x"),o=this.attr("y"),s=this.attr("width"),u=this.attr("height"),c=i({x:a,y:o},r),h=i({x:a+s,y:o+u},r);t.css({left:c.x/n+"px",top:c.y/n+"px",width:(h.x-c.x)/n+"px",height:(h.y-c.y)/n+"px"})},tryAdd:function(){var t=this.get("canvas"),e=t.get("htmlElementContaniner"),n=this.get("dom");n.parentNode!==e&&e.appendChild(n)},createPath:function(){var t=this.get("dom"),e=this.get("attrs");this.tryAdd(),this.applyTransform(),t.css(u.mix({visibility:"visible"},e))},destroy:function(){var t=this.get("dom");t&&(u.isFunction(t.g6Destroy)&&t.g6Destroy(),t.destroy()),h.superclass.destroy.call(this)}}),s.Html=h,t.exports=h},function(t,e,n){"use strict";var i=n(1),r=n(10),a=n(28),o=r.G,s=function(){};i.augment(s,{getAllAttrs:function(){var t=this,e=t.get("attrs"),n={};return i.each(e,function(e,i){n[i]=t.attr(i)}),n}}),i.mixin(o.Shape,[s,a]),t.exports=s},function(t,e,n){"use strict";function i(t,e,n){return new a({width:t,height:e,eventEnable:!1,containerDOM:n})}var r=n(11),a=n(10),o=n(4),s=n(134),u=n(130),c=n(131),h=n(135),l=n(129),d=n(133),f=n(132),g=n(127),p=n(62),v=n(61),x=n(116),m=n(115),y=n(118),b=n(114),w=n(117),_=n(7),M=n(60),S=n(119),A=n(26),P=v.Node,T=v.Edge,C=function t(e){t.superclass.constructor.call(this,e),this._init()};C.ATTRS={id:null,container:null,graphContainer:null,width:null,height:500,addingType:"",itemCache:null,items:[],nodes:[],edges:[],guides:[],canvas:null,eventStash:{},el:null,forceFit:!1,grid:!0,guide:!0,defaultNodeShape:null,animate:!1,drawFrameObj:{},useAnchor:!0,useEdgeSortGroup:!0,useNodeSortGroup:!1,useFreezeSizeGroup:!1,wheelScaleLimit:[-(1/0),1/0],behaviourSignal:{},maxZoom:10,minZoom:.1,domFocus:!1,tooltipDOM:null,preciseAnchor:!1},o.extend(C,r),o.mixin(C,[f,d,l,g,s,u,c,h]),o.augment(C,{_init:function(){this._pluginInit(),this.fire("beforeinit"),this._initCfg(),this._initDOM(),this._initData(),this._initMapper(),this._initEvent(),this._initForceFit(),this.get("grid")&&this._initGrid(),this._initModal(),this._initEditor(),this._initMode(),this._initLayout(),this._initAnimate(),this._initGuide(),this.fire("afterinit")},_initGuide:function(){var t=o.mix({graph:this,guides:this.get("guides")},_.guide,this.get("guide")),e=new w(t);this.set("guideAssist",e)},_initGrid:function(){var t=o.mix({minX:0,minY:0,maxX:this.get("width"),maxY:this.get("height"),group:this.get("backGroup")},_.grid,this.get("grid")),e=new x(t);this.set("gridAssist",e)},_initAnimate:function(){var t=this.get("animate"),e=this.get("canvas"),n=this.get("frontCanvas");t&&this.set("animateAssist",new b({canvases:[e,n]}))},_initForceFit:function(){this.get("width")||this.set("forceFit",!0),this.get("forceFit")&&(window.addEventListener("resize",o.wrapBehavior(this,"_initForceFitEvent")),this.forceFit())},_initForceFitEvent:function(){var t=this,e=setTimeout(function(){t.forceFit()},200);clearTimeout(this.get("resizeTimer")),this.set("resizeTimer",e)},_on:function(t,e){var n=this.get("eventStash");n[t]||(n[t]=[]),n[t].push(e),this.on(t,e)},_off:function(){var t=this,e=this.get("eventStash");o.each(e,function(n,i){o.each(n,function(e){t.off(i,e)}),e[i]=[]})},_initData:function(){this.set("itemCache",{}),this.set("items",[]),this.set("nodes",[]),this.set("edges",[])},_initMapper:function(){this.set("nodeMapper",new p),this.set("edgeMapper",new p)},_initDOM:function(){var t=this.get("container");if(!t){var e=this.get("id");if(t=document.getElementById(e),!t)throw new Error("please set the id for the graph")}var n=this.get("useEdgeSortGroup"),r=this.get("useFreezeSizeGroup"),a=this.get("useNodeSortGroup"),s=this.get("width"),u=this.get("height"),c=o.createDOM('<div class="graph-container"></div>',{position:"relative"});t.appendChild(c);var h=i(s,u,c),l=c.appendChild(o.createDOM('<div class="graph-container-html-Elements"></div>')),d=i(s,u,c),f=d.addShape("rect",{attrs:o.mix({},_.modalRectStyle),visible:!1,capture:!1}),g=d.get("el");h.set("htmlElementContaniner",l),l.style.overflow="hidden",l.style.width=s+"px",l.style.height=u+"px",l.style.position="absolute",l.style.top=0,l.style.left=0,g.style.position="absolute",g.style.top=0,g.style.left=0,c.style["font-family"]=_.fontFamily;var p=r?h.addGroup(S):h.addGroup(),v=d.addGroup(S),x=p.addGroup(),m=p.addGroup(),y=n?m.addGroup(M):m.addGroup(),b=a?m.addGroup(M):m.addGroup(),w=p.addGroup(),A=v.addGroup({capture:!1}),P=v.addGroup(),T=v.addGroup(),C=v.addGroup();p.set("gid","rootGroup"),v.set("gid","frontCanvasRootGroup"),x.set("animate",!1);var I=v.addGroup(M,{visible:!1});this.set("rootGroup",p),this.set("itemGroup",m),this.set("backGroup",x),this.set("frontGroup",w),this.set("frontCanvasRootGroup",v),this.set("controlPointRootGroup",C),this.set("delegaRootGroup",P),this.set("activedRectRootGroup",A),this.set("anchorPointRootGroup",T),this.set("nodeGroup",b),this.set("edgeGroup",y),this.set("canvas",h),this.set("frontCanvas",d),this.set("graphContainer",c),this.set("htmlElementContaniner",l),this.set("container",t),this.set("el",g),this.set("modalRect",f),this.set("modalGroup",I)},_initEvent:function(){var t=new m({graph:this,frontCanvas:this.get("frontCanvas"),canvas:this.get("canvas"),rootGroup:this.get("rootGroup")});this.set("eventAssist",t)},getViewPortBox:function(){var t=this.get("width"),e=this.get("height"),n=this.invertPoint({x:0,y:0}),i=this.invertPoint({x:t,y:e});return{minX:n.x,minY:n.y,maxX:i.x,maxY:i.y}},_updateGrid:function(){var t=this.get("gridAssist");if(t){var e=this.getViewPortBox();t.update(e)}},_afterAddItem:function(t,e){var n=this.get("itemCache");this.fire("itemadd",{item:e,model:e.get("model")}),this.fire("itemchange",{item:e}),n[t]=e},_clearInner:function(){var t=this.get("guideAssist"),e=this.get("itemCache"),n=this.get("animate"),i=this.get("htmlElementContaniner");i.innerHTML="",o.each(e,function(t){t.destroy(!n)}),t.clear(!n),this.fire("afterclear")},_updateEdgeEnd:function(t,e,n){var i=this,r=i.get("itemCache"),a=e[n],o=t.get(n);if(!o||o.get("id")!==a){o&&o.removeEdge(t);var s=r[a];s.addEdge(t),t.set(n,s)}},_drawInner:function(){this._drawItems(),this._doLayout(),this._drawGuides()},getBBox:function(){var t=this.get("itemGroup");return t.getBBox()},_drawItems:function(){var t=this.get("nodes"),e=this.get("edges");this._addNodes(t),this._addEdges(e)},_drawGuides:function(){var t=this.get("guideAssist");t.draw()},_readGuides:function(t){var e=this;o.each(t,function(t){e.get("guides").push(t)})},_saveGuides:function(){var t=this.get("guideAssist");return t.save()},_getAllActived:function(){var t=this.getAllActived();return t.sort(function(t,e){var n=t.get("group"),i=e.get("group"),r=void 0,a=void 0;return n&&(r=n.get("parent"),a=r.get("children")),a.indexOf(n)-a.indexOf(i)}),t},addItem:function(t,e){t=o.ucfirst(t);var n="_add"+t+"s",i=this[n]([e])[0];return i},removeItem:function(t){var e=this,n=e.get("itemCache");o.isString(t)&&(t=n[t]);var i=t.get("id");if(this.fire("itemremove",{item:t}),delete n[i],"node"===t.get("type")){var r=t.get("edges").slice();o.each(r,function(t){t&&!t.destroyed&&(delete n[t.get("model").id],e.removeItem(t))})}this.fire("itemchange",{item:t}),t.destroy()},updateItem:function(t,e){var n=this.get("itemCache");o.isString(t)&&(t=n[t]);var i=t.get("type"),r=t.get("model");if(o.mix(r,e),"edge"===i)this._updateEdgeEnd(t,r,"source"),this._updateEdgeEnd(t,r,"target"),t.update();else if("node"===i){t.update();var a=t.get("edges");o.each(a,function(t){t.update()})}return this.fire("itemupdate",{item:t,model:e}),this.fire("itemchange",{item:t}),t},css:function(t){var e=this.get("el");o.each(t,function(t,n){e.style[n]=t})},_addNodes:function(t){var e=this,n=e.get("nodeGroup"),i=e.get("itemCache"),r=[];return o.each(t,function(t){var a=t.id;if(o.isNull(a)&&(a=o.guid(),t.id=a),i[a])throw new Error("id: "+a+" \u5df2\u5b58\u5728\uff01id: "+a+" already exist!");var s=n.addGroup(A,{id:a,type:"node"}),u=new P({id:a,graph:e,group:s,model:t,mapper:e.get("nodeMapper"),delegaRootGroup:e.get("delegaRootGroup"),useAnchor:e.get("useAnchor"),controlPointRootGroup:e.get("controlPointRootGroup"),activedRectRootGroup:e.get("activedRectRootGroup"),anchorPointRootGroup:e.get("anchorPointRootGroup")});e._afterAddItem(a,u),r.push(u),u.draw(),e.get("items").push(u)}),r},read:function(t){var e=this;o.each(t,function(t,n){e["_read"+o.ucfirst(n)](t)})},save:function(){return{source:this._saveSource(),guides:this._saveGuides()}},_addEdges:function(t){var e=this,n=e.get("itemCache"),i=e.get("edgeGroup"),r=[];return o.each(t,function(t){var a=t.id,s=n[t.source],u=n[t.target];if(!s||!u)throw new Error("can not find effective node in edge model");if(n[a])throw new Error("id: "+a+" \u5df2\u5b58\u5728\uff01id: "+a+" already exist!");o.isNull(a)&&(a=o.guid(),t.id=a);var c=i.addGroup(A,{id:a,type:"edge"}),h=new T({id:a,graph:e,source:s,target:u,model:t,group:c,mapper:e.get("edgeMapper"),useAnchor:e.get("useAnchor"),delegaRootGroup:e.get("delegaRootGroup"),controlPointRootGroup:e.get("controlPointRootGroup")});h.draw(),e._afterAddItem(a,h),r.push(h),e.get("items").push(h)}),r},invertPoint:function(t){var e=this.get("rootGroup").getMatrix();return o.invertPoint(t,e)},converPoint:function(t){var e=this.get("rootGroup").getMatrix();return o.converPoint(t,e)},forceFit:function(){var t=this.get("container"),e=o.getDOMWidth(t),n=this.get("height");e!==this.get("width")&&this.changeSize(e,n)},tooltip:function t(e){var n=this.get("tooltipAssist"),t={graph:this,tooltipDOM:this.get("tooltipDOM")};return e?(o.isObject(n)&&n.destroy(),o.isObject(e)&&o.mix(t,e),n=new y(t),this.set("tooltipAssist",n)):(n&&n.destroy(),this.set("tooltipAssist",null)),this},getItem:function(t){if(!t)return null;var e=t.get("parent"),n=this.get("itemCache"),i=e.get("id");return n[i]},updateMatrix:function(t){var e=this.get("rootGroup"),n=this.get("frontCanvasRootGroup"),i=this.get("minZoom"),r=this.get("maxZoom");t.elements[0]<i||t.elements[0]>r||(e.setMatrix(t),n.setMatrix(t.clone()),this._updateGrid(),this.fire("matrixupdate",{matrix:t}))},getScale:function(){return this.getMatrix().elements[0]},getMatrix:function(){var t=this.get("rootGroup");return t.getMatrix()},toFront:function(t){var e=t.get("group"),n=e.get("parent"),i=n.get("children");return o.remove(i,e),i.push(e),self},toBack:function(t){var e=t.get("group"),n=e.get("parent"),i=n.get("children");return o.remove(i,e),i.unshift(e),self},guide:function(){var t=this.get("guideAssist");return t},node:function(){return this.get("nodeMapper")},edge:function(){return this.get("edgeMapper")},clear:function(){this._clearInner(),this._initMapper(),this._initData()},draw:function(t){var e=this,n=e.get("animateAssist"),i=e.get("drawFrameObj");i.callback=function(){e.destroyed||(n?t!==!1?n.run():(n.init(),e.refresh(!1)):e.refresh(!1))},o.frameDraw(i)},refreshFront:function(){this.get("frontCanvas").draw()},refresh:function(){this.get("canvas").draw(),this.get("frontCanvas").draw()},updateNodesPosition:function(){var t=this.getEdges(),e=this.getNodes(),n=this.get("animate"),i=!n;o.each(e,function(t){t.updatePosition()}),o.each(t,function(t){t.update(i)}),this.draw()},render:function(){this.fire("beforerender"),this._drawInner(),this._fitView(),this.draw(),this.fire("afterrender")},changeData:function(){var t=o.toArray(arguments);this._clearInner(),this._initData(),this.source.apply(this,t),this._drawInner(),this.draw()},getWidth:function(){return this.get("width")},getHeight:function(){return this.get("height")},changeSize:function(t,e){if(Math.abs(t)>=1/0||Math.abs(e)>=1/0)return void console.warn("size parameter more than the maximum");var n=this,i=n.get("canvas"),r=n.get("frontCanvas"),a=n.get("htmlElementContaniner");i.changeSize(t,e),r.changeSize(t,e),n.set("width",t),n.set("height",e),a.css({width:t+"px",height:e+"px"}),n._updateGrid(),n.refresh(),n.fire("changesize",{width:t,height:e})},destroy:function(){var t=this,e=t.get("canvas"),n=t.get("gridAssist"),i=t.get("guideAssist"),r=t.get("tooltipAssist"),a=t.get("eventAssist"),s=t.get("container"),u=t.get("graphContainer");this._pluginDestroy(),s&&s.removeChild(u),a&&a.destroy(),n&&n.destroy(),r&&r.destroy(),i&&i.destroy(),e&&e.destroy(),C.superclass.destroy.call(this),window.removeEventListener("resize",o.getWrapBehavior(this,"_initForceFitEvent"))},find:function(t){var e=this,n=e.get("itemCache");return n[t]},snapshot:function(){var t=this.get("canvas"),e=t.get("el");return e.toDataURL("image/png")},downloadImage:function(t){var e=this.snapshot(),n=document.createElement("a"),i=t?t:"chart.png";return n.download=i,n.href=e.replace("image/png","image/octet-stream"),n.click(),this},showAnchor:function(t){return t.showAnchor(),this.refreshFront(),this},hideAnchor:function(t){return t.hideAnchor(),this.refreshFront(),this},setCapture:function(t){var e=this.get("rootGroup"),n=this.get("frontCanvasRootGroup");e.set("capture",t),n.set("capture",t)},updateAnchor:function(t,e,n){return t.updateAnchor(e,n),this.refreshFront(),this},setAnchorActived:function(t){var e=t.get("hoverStyle");return t.attr(e),this.refreshFront(),this},setAnchorUnActived:function(t){var e=t.get("attrs");return t.attr(e),this.refreshFront(),this},isInGraph:function(t){var e=this.get("itemCache"),n=!1;return o.each(e,function(e){e===t&&(n=!0)}),n},_initCfg:function(){},_initEditor:function(){},_readSource:function(){},_saveSource:function(){},update:function(){},remove:function(){},source:function(){},add:function(){}}),t.exports=C},function(t,e,n){"use strict";var i=n(4),r=n(27),a=function t(e){t.superclass.constructor.call(this,e),this._initEnds()};a.ATTRS={type:"edge",controlPoints:[null,null],source:null,target:null,sourceAnchor:null,targetAnchor:null,useAnchor:!0},i.extend(a,r),i.augment(a,{_initEnds:function(){var t=this,e=t.get("source"),n=t.get("target");e&&e.addEdge(t),n&&n.addEdge(t)},_getEdgePoints:function(){var t=this,e=t.get("model"),n=t.get("source"),r=t.get("target"),a=t.get("useAnchor"),o=t.get("graph"),s=t.getControlPoints(),u=e.sourceAnchor,c=e.targetAnchor,h=n.getCenter(),l=r?r.getCenter():n.getCenter(),d=s.length,f=t.getShapeCfg(),g=t.get("shapeManger"),p=0,v=d-1,x=o.get("preciseAnchor"),m=void 0;return a?(null===u&&delete e.sourceAnchor,null===c&&delete e.targetAnchor,i.isNumber(u)&&n&&(u=n.getAnchor(u)),i.isNumber(c)&&r&&(c=r.getAnchor(c)),d>2?(n&&!u&&(u=n.getAnchor(s[p+1])),r&&!c&&(c=r.getAnchor(s[v-1]))):(m=x&&g.getPath(f.shape,[h,l]),n&&!u&&(u=m?n.getAnchor(m):n.getAnchor(l)),r&&!c&&(c=m?r.getAnchor(m):r.getAnchor(h))),s[0]={x:u.x,y:u.y},s[v]={x:c.x,y:c.y},s):(s[0]={x:h.x,y:h.y},s[v]={x:l.x,y:l.y},s)},beforeDraw:function(){a.superclass.beforeDraw.call(this);var t=this.getShapeCfg(),e=this.get("group");t.points=this._getEdgePoints(),t.target=this.get("target"),t.source=this.get("source"),e.set("controlPoints",this.get("controlPoints"))},getControlPoints:function(){var t=this.get("model"),e=t.controlPoints?t.controlPoints:this.get("controlPoints");return e},addControlPoint:function(t){var e=this.getControlPoints(),n=1/0,r=void 0,a=void 0,o=void 0;return i.each(e,function(s,u){if(a=e[u+1]){if(o=i.segmentDistance(s,a,t),o<1)return r=u,!1;o<n&&(n=o,r=u)}}),e.splice(r+1,0,t),r},getDelegationPath:function(t){var e=this,n=e.getControlPoints(),r=t.controlPointIndex,a=n[r-1],o=n[r+1],s=[{x:t.x,y:t.y}];a&&s.unshift(a),o&&s.push(o);var u=i.pointsToPolygon(s);return u},destroyItem:function(){var t=this,e=t.get("source");e&&!e.destroyed&&e.removeEdge(t);var n=t.get("target");n&&!n.destroyed&&n.removeEdge(t)},isExtremePoint:function(t){var e=this.getControlPoints(),n=void 0;return i.isObject(t)&&(n=e.indexOf(t)),i.isNumber(t)&&(n=t),0===n||n===e.length-1},isSourcePoint:function(t){var e=this.getControlPoints(),n=void 0;return i.isObject(t)&&(n=e.indexOf(t)),i.isNumber(t)&&(n=t),0===n},isTargetPoint:function(t){var e=this.getControlPoints(),n=void 0;return i.isObject(t)&&(n=e.indexOf(t)),i.isNumber(t)&&(n=t),n===e.length-1},showAble:function(){var t=this.get("source"),e=this.get("target");return t.isVisible()&&e.isVisible()},show:function(){this.showAble()&&this._show()},hide:function(){this._hide()}}),t.exports=a},function(t,e,n){"use strict";var i=n(4),r=n(27),a=n(7),o=function t(e){t.superclass.constructor.call(this,e)};o.ATTRS={type:"node",anchorPoints:null,edges:[],anchorGroup:null,boxStash:null,useAnchor:!0},i.extend(o,r),i.augment(o,{calculateAnchorPoints:function(t){var e=this,n=e.get("useAnchor");if(n){var r=e.get("shapeManger"),a=e.getShapeCfg(),o=r.getAnchorPoints(a.shape,a,e.get("group"));if(!i.isArray(o))return o;t=t?t:e.getBBox();var s=[];return i.each(o,function(e){var n=i.mix({},{x:t.minX+e[0]*t.width,y:t.minY+e[1]*t.height},e[2]);s.push(n)}),s}},_calculateAnchorPoints:function(){var t=this.calculateAnchorPoints();return this.set("anchorPoints",t),t},hideBox:function(){var t=this.get("activedRectGroup");t&&t.remove()},showBox:function(){var t=this.getBBox(),e=this.getKeyShape(),n=e.attr("lineWidth"),r=this.get("activedRectRootGroup"),o=this.get("activedRectGroup");o&&o.remove(),o=r.addGroup({zIndex:a.zIndex.activedNodeRect,id:this.get("id")}),this.set("activedRectGroup",o),n=i.isNumber(n)?n:0,o.addShape("rect",{attrs:i.mix({x:t.x+n/2,y:t.y+n/2,width:t.width-n,height:t.height-n},a.nodeActivedBoxStyle,a.nodeAcitvedBoxStyle)})},getAnchorPoints:function(){var t=this.get("anchorPoints");return t||this._calculateAnchorPoints()},setActiveStatus:function(t){var e=this;o.superclass.setActiveStatus.call(this,t,function(){e.showBox()},function(){e.hideBox()})},getCenter:function(){var t=this.getBBox();return{x:t.centerX,y:t.centerY}},getPosition:function(){var t=this.get("model");return{x:t.x,y:t.y}},getAnchor:function(t){var e=this.getCenter(),n=this.getAnchorPoints(),r=void 0;if(i.isNumber(t)&&i.isArray(n))return this.getAnchorByIndex(t);if(i.isObject(t)&&(r=this.getIntersectionByPoint(t)),(i.isArray(t)||i.isString(t))&&(r=this.getIntersectionByPath(t)),r){if("auto"===n)return r;if(i.isArray(n))return i.getSnapAnchor(this,r)}return e},getIntersectionByPoint:function(t){var e=this.getBBox(),n=i.getRectIntersect(e,t);return n},getRootKeyShapePath:function(){var t=this.get("graph"),e=this.getKeyShape(),n=i.clone(e.attr("path")),r=this.getGroup(),a=t.get("rootGroup");return n=i.pathToAbsolute(n),i.each(n,function(t){var e=void 0;if("a"===t[0]||"A"===t[0])e={x:t[6],y:t[7]},e=i.applyPoint(e,r,a),t[6]=e.x,t[7]=e.y;else for(var n=1;n<t.length;n+=2)e={x:t[n],y:t[n+1]},e=i.applyPoint(e,r,a),t[n]=e.x,t[n+1]=e.y}),n},getIntersectionByPath:function(t){var e=this.getRootKeyShapePath(),n=i.pathIntersection(t,e)[0];if(!n){var r=this.getBBox(),a=i.getRectPath(r.x,r.y,r.width,r.height);n=i.pathIntersection(t,a)[0]}return n},getAnchorByIndex:function(t){var e=this.getAnchorPoints();return e[t]},getControlPoints:function(){var t=this,e=t.getBBox(),n=[];return n.push({x:e.x,y:e.y}),n.push({x:e.maxX,y:e.y}),n.push({x:e.maxX,y:e.maxY}),n.push({x:e.x,y:e.maxY}),n},getDelegationPath:function(t){var e=this,n=e.getBBox(),i=t.x,r=t.y,a=t.size,o=n.width,s=n.height;a&&(o=a[0],s=a[1]);var u=[];return u.push(["M",i-o/2,r-s/2]),u.push(["L",i+o/2,r-s/2]),u.push(["L",i+o/2,r+s/2]),u.push(["L",i-o/2,r+s/2]),u.push(["Z"]),u},addEdge:function(t){this.get("edges").push(t)},removeEdge:function(t){i.remove(this.get("edges"),t)},showAnchor:function(){var t=this,e=t.getAnchorPoints(),n=t.get("anchorPoints"),r=t.get("anchorPointRootGroup"),o=t.get("anchorGroup");o&&o.remove(!0),o=r.addGroup({zIndex:a.zIndex.anchorPoint,id:t.get("id")}),i.each(e,function(e,r){o.addShape("circle",{class:"anchor-point",item:t,point:e,index:r,anchorPoint:n[r],freezePoint:e,linkable:e.linkable,hoverStyle:i.mix({},a.anchorPointHoverStyle,e.hoverStyle),attrs:i.mix({x:e.x,y:e.y},a.anchorPointStyle,e.style)})}),this.set("anchorGroup",o)},hideAnchor:function(){var t=this.get("anchorGroup");t&&t.remove(!0),this.set("anchorGroup",null)},updateAnchor:function(t,e){var n=this.getAnchorPoints(),r=n[t];r&&i.mix(r,e),this.showAnchor()},beforeDraw:function(){o.superclass.beforeDraw.call(this);var t=this.get("graph"),e=this.get("group"),n=this.getShapeCfg();e.initTransform(),t&&i.isFunction(t.beforeNodeDraw)&&t.beforeNodeDraw(this),n.shape||(n.shape=t.get("defaultNodeShape")),e.translate(n.x,n.y),n.x=0,n.y=0},afterDraw:function(){var t=this.get("graph"),e=this.getShapeObj();t&&i.isFunction(t.afterNodeDraw)&&t.afterNodeDraw(this),this._calculateBBox(),e&&e.class&&this.set("class",e.class),this._calculateAnchorPoints(),o.superclass.afterDraw.call(this)},show:function(){for(var t=this.get("edges"),e=void 0,n=0;n<t.length;n++)e=t[n],!e.isVisible()&&e.showAble()&&e._show();this._show()},hide:function(){for(var t=this.get("edges"),e=void 0,n=0;n<t.length;n++)e=t[n],e.isVisible()&&e._hide();this._hide()},getLinkNodes:function(){var t=this,e=t.get("graph"),n=t.get("edges"),r=e.get("itemCache"),a=[],o=void 0,s=void 0,u=void 0;return i.each(n,function(e){o=e.get("model"),s=r[o.target],u=r[o.source],a.indexOf(s)===-1&&s!==t&&a.push(s),a.indexOf(u)===-1&&u!==t&&a.push(u)}),a},getUnLinkNodes:function(){var t=this.get("id"),e=this.getLinkNodes(),n=this.get("graph"),r=n.get("itemCache"),a=[];return i.each(r,function(n){"node"===n.get("type")&&e.indexOf(n)===-1&&n.get("id")!==t&&a.push(n)}),a},getSourceItems:function(){var t=this.get("id");return this.getRelativeItems(function(e){var n=e.getModel();return n.target===t})},getTargetItems:function(){var t=this.get("id");return this.getRelativeItems(function(e){var n=e.getModel();return n.source===t})},getRelativeItems:function(t){var e=this,n=e.get("id"),r=e.get("graph"),a=e.get("edges"),o=r.get("itemCache"),s=[],u=void 0,c=void 0,h=void 0;return t&&(a=i.filter(a,t)),s=s.concat(a),i.each(a,function(t){h=t.get("model"),u=o[h.target],c=o[h.source],s.indexOf(u)===-1&&u.get("id")!==n&&s.push(u),s.indexOf(c)===-1&&c.get("id")!==n&&s.push(c)}),s},getEdges:function(){return this.get("edges")},getUnRelativeItems:function(){var t=this.get("id"),e=this.get("graph"),n=e.get("itemCache"),r=this.getRelativeItems(),a=[];return i.each(n,function(e){r.indexOf(e)===-1&&e.get("id")!==t&&a.push(e)}),a},destroy:function(t){var e=this.get("anchorGroup"),n=this.get("activedRectGroup");e&&e.remove(),n&&n.remove(),o.superclass.destroy.call(this,t)},updatePosition:function(){var t=this.get("model"),e=this.get("group");e.initTransform(),e.translate(t.x,t.y),this._calculateBBox(),this._calculateAnchorPoints()}}),t.exports=o},function(t,e,n){"use strict";var i=n(1),r=function(t){i.mix(this,t)};i.augment(r,{type:null,mappingType:"auto",dims:null,callback:null,getValue:function(t){var e=this.dims,n=this.callback,r=this.mappingType,a=null,o=null;if(n)if("auto"===r){var s=[];i.each(e,function(e){s.push(t[e])}),a=n.apply(this,s)}else a=n.call(this,t);else a=e?e:t[this.type];return i.isArray(a)||(a=[a]),o=a.length>1?a:a[0]}}),t.exports=r},function(t,e,n){"use strict";var i=n(4),r=function(){};i.augment(r,{isItemActived:function(t){return t.isActived()},setItemActived:function(t,e){this.setItemsActived([t],e)},setItemsActived:function(t,e){if(0!==t.length){var n=this;e!==!1?i.each(t,function(t){t.setActived(),n.fire("itemactived",{item:t})}):i.each(t,function(t){t.clearActived(),n.fire("itemunactived",{item:t})})}},getItems:function(){var t=this.get("itemCache");return i.objectToValues(t)},getActived:function(){var t=this,e=t.getItems(),n=null;return i.each(e,function(e){if(t.isItemActived(e))return n=e,!1}),n},getAllActived:function(){var t=this,e=t.getItems(),n=[];return i.each(e,function(e){t.isItemActived(e)&&n.push(e)}),n},clearAllActived:function(){var t=this,e=t.getAllActived();return this.setItemsActived(e,!1),this}}),t.exports=r},function(t,e,n){"use strict";var i=n(1),r=function(){};i.augment(r,{setActiveStatus:function(){},isActived:function(){return this.get("actived")},setActived:function(){this.setActiveStatus(!0),this.set("actived",!0)},clearActived:function(){this.setActiveStatus(!1),this.set("actived",!1)}}),t.exports=r},function(t,e,n){"use strict";var i=n(4),r=function(){};r.ATTRS={nodeFilters:[],edgeFilters:[]},i.augment(r,{_addFilter:function(t,e){var n=this.get(t+"Filters");
                n.push(e)},_removeFilter:function(t,e){var n=this.get(t+"Filters");this.set(t+"Filters",i.filter(n,function(t){return e!==t}))},_filter:function(t){var e=this,n=this.get(t+"Filters"),r=this.get(t+"s"),a=void 0,o=void 0;i.each(r,function(t){a=e.find(t.id),o=!0,i.each(n,function(e){o&&!e(t)&&(o=!1)}),o?a.show():a.hide()}),this.fire("filter")},addNodeFilter:function(t){this._addFilter("node",t)},addEdgeFilter:function(t){this._addFilter("edge",t)},removeNodeFilter:function(t){this._removeFilter("node",t)},removeEdgeFilter:function(t){this._removeFilter("edge",t)},filterNode:function(){this._filter("node")},filterEdge:function(){this._filter("edge")},filter:function(t){switch(t){case"node":this.filterNode();break;case"edge":this.filterEdge();break;default:this.filterNode(),this.filterEdge()}this.draw(!1)}}),t.exports=r},function(t,e,n){"use strict";var i=n(1),r=n(3),a=n(7),o=r.Matrix3,s=function(){};s.ATTRS={fitView:null,fitViewPadding:a.fitViewPadding},i.augment(s,{_fitView:function(){var t=this.get("fitView"),e=this.get("items");i.isString(t)&&e.length>0&&this[t](!1),i.isObject(t)&&this.focusPoint(t,!1)},_zoom:function(t,e,n){var i=new o,r=this.get("width"),a=this.get("height"),s=this.get("minZoom"),u=this.getBBox(),c=(u.maxX+u.minX)/2,h=(u.maxY+u.minY)/2,l=this.get("fitViewPadding"),d=c,f=h,g=u.maxX-u.minX+2*l,p=u.maxY-u.minY+2*l;n&&(d=n.x,f=n.y),e&&(r=g,a=p,this.changeSize(g,p)),t||(t=r/g,r/g>a/p&&(t=a/p)),(!t||t<s)&&(t=s),i.translate(-d,-f),i.scale(t,t),i.translate(r/2,a/2),this.updateMatrix(i)},zoomAt:function(t,e,n){var i=new o;i.translate(-t,-e),i.scale(n,n),i.translate(t,e),this.updateMatrix(i),this.draw()},zoom:function(t,e){this._zoom(t),e!==!1&&this.draw()},autoZoom:function(t){this._zoom(),t!==!1&&this.draw()},resetZoom:function(t){var e=new o;this.updateMatrix(e),t!==!1&&this.draw()},autoSize:function(t){this._zoom(void 0,!0),t!==!1&&this.draw()},tl:function(){var t=this.getBBox(),e=new o,n=this.get("fitViewPadding");e.translate(-t.minX+n,-t.minY+n),this.updateMatrix(e)},lc:function(){var t=this.getBBox(),e=new o,n=this.get("fitViewPadding"),i=this.get("height");e.translate(-t.minX+n,-t.minY+i/2-t.height/2),this.updateMatrix(e)},bl:function(){var t=this.getBBox(),e=new o,n=this.get("fitViewPadding"),i=this.get("height");e.translate(-t.minX+n,-t.minY+i-t.height-n),this.updateMatrix(e)},cc:function(){var t=this.getBBox(),e=new o,n=this.get("height"),i=this.get("width");e.translate(-t.minX+(i-t.width)/2,-t.minY+(n-t.height)/2),this.updateMatrix(e)},tc:function(){var t=this.getBBox(),e=new o,n=this.get("width"),i=this.get("fitViewPadding");e.translate(-t.minX+(n-t.width)/2,-t.minY+i),this.updateMatrix(e)},tr:function(){var t=this.getBBox(),e=new o,n=this.get("width"),i=this.get("fitViewPadding");e.translate(-t.minX+n-t.width-i,-t.minY+i),this.updateMatrix(e)},rc:function(){var t=this.getBBox(),e=new o,n=this.get("height"),i=this.get("width"),r=this.get("fitViewPadding");e.translate(-t.minX+i-t.width-r,-t.minY+(n-t.height)/2),this.updateMatrix(e)},br:function(){var t=this.getBBox(),e=new o,n=this.get("height"),i=this.get("width"),r=this.get("fitViewPadding");e.translate(-t.minX+i-t.width-r,-t.minY+n-t.height-r),this.updateMatrix(e)},bc:function(){var t=this.getBBox(),e=new o,n=this.get("height"),i=this.get("width"),r=this.get("fitViewPadding");e.translate(-t.minX+(i-t.width)/2,-t.minY+n-t.height-r),this.updateMatrix(e)},focusPoint:function(t,e){this._zoom(1,void 0,t),e!==!1&&this.draw()}}),t.exports=s},function(t,e,n){"use strict";var i=n(4),r=function(){};i.augment(r,{isNode:i.isNode,isEdge:i.isEdge,getItemsBy:function(t){var e=this.get("itemCache"),n=[];return i.each(e,function(e){t(e)&&n.push(e)}),n},getNodes:function(){return this.getItemsBy(function(t){return"node"===t.get("type")})},getEdges:function(){return this.getItemsBy(function(t){return"edge"===t.get("type")})}}),t.exports=r},function(t,e,n){"use strict";var i=n(1),r=function(){};r.ATTRS={layoutFn:null,layoutCfg:null,layout:null},i.augment(r,{_initLayout:function(){var t=this.get("layoutFn"),e=this.get("layoutCfg"),n=this.get("layout");!n&&t&&e&&(n=new t(e),this.set("layout",n))},layout:function(){},_setNodeSize:function(){var t=this.get("nodes"),e=this.get("itemCache");i.each(t,function(t){var n=e[t.id],i=n.getBBox();t.width=i.width,t.height=i.height})},_setEdgeSize:function(){var t=this.get("edges"),e=this.get("itemCache");i.each(t,function(t){var n=e[t.id],r=n.getKeyShape();i.isNumber(t.lineWidth)||(t.lineWidth=r.attr("lineWidth"))})},_doLayout:function(){var t=this.get("layout");t&&(this._setNodeSize(),this._setEdgeSize(),this.layout())},changeLayout:function(){}}),t.exports=r},function(t,e,n){"use strict";var i=n(1),r=function(){};r.ATTRS={modalItems:[]},i.augment(r,{_initModal:function(){},_updateModalRect:function(){var t=this.get("modalRect"),e=this.get("width"),n=this.get("height");t.attr({x:0,y:0,width:e,height:n})},showModal:function(){var t=this.get("modalGroup"),e=this.get("modalRect");this._updateModalRect(),t.show(),e.show(),this.draw()},hideModal:function(){var t=this.get("modalGroup"),e=this.get("modalRect");t.hide(),e.hide(),this.draw()},modal:function(t){var e=this.get("modalGroup");i.each(t,function(t){var n=t.getGroup(),i=n.getParent();n.set("originParent",i),e.add(n)}),this.showModal(),this.set("modalItems",t)},unModal:function(){var t=this.get("modalItems");i.each(t,function(t){var e=t.getGroup(),n=e.get("originParent");n.add(e)}),this.set("modalItems",[]),this.hideModal()}}),t.exports=r},function(t,e,n){"use strict";function i(t,e){var n=void 0,i=void 0;for(n=0;n<t.length;n++)for(i=0;i<e.length;i++)t[n]===e[i]&&t.splice(n,1);for(n=0;n<e.length;n++)t.push(e[n]);return t}function r(t,e){for(var n=0;n<t.length;n++)if(t[n]===e){t.splice(n,1);break}}var a=n(1),o=n(2),s=function(){};s.ATTRS={modes:null,mode:"default",behaviourFilter:null,behaviours:null},a.augment(s,{_initMode:function(){var t=this.get("modes"),e=this.get("mode");t||(t=this.constructor.Mode,this.set("modes",t)),this.changeMode(e)},_filterBehaviour:function(t){var e=this.get("behaviourFilter"),n={};return a.each(t,function(t,i){n[i]=a.filter(t,function(t){return e.indexOf(t)===-1})}),n},_mapCursor:function(t){var e={add:"pointer",drag:"move",default:"default",edit:"default"},n=e[t];n&&this.css({cursor:e[t]})},filterBehaviour:function(t){this.set("behaviourFilter",t),this.resetMode()},addBehaviour:function(t,e){var n=this.get("modes");return a.isArray(t)?a.each(n,function(e,r){n[r]=i(e,t)}):n[t]?n[t]=i(n[t],e):n[t]=e,this.resetMode(),this},removeBehaviour:function(t,e){var n=this.get("modes");return a.isArray(t)?a.each(n,function(e){a.each(t,function(t){r(e,t)})}):n[t]&&a.each(e,function(e){r(n[t],e)}),this.resetMode(),this},resetMode:function(){var t=this.get("mode");this.changeMode(t)},changeMode:function(t){var e=this.get("modes"),n=this.get("behaviourFilter");e&&"none"!==e&&(n&&(e=this._filterBehaviour(e)),e[t]&&(o.resetMode(e[t],this),this.set("mode",t),this._mapCursor(t)))}}),t.exports=s},function(t,e,n){"use strict";var i=n(1),r=function(){};r.ATTRS={plugins:null},i.augment(r,{_pluginInit:function(){var t=this,e=this.get("plugins");i.each(e,function(e){e.set("graph",t),e.init()})},_pluginDestroy:function(){var t=this.get("plugins");i.each(t,function(t){t.destroy()})}}),t.exports=r},function(t,e,n){"use strict";var i=n(4),r=n(29);r.registGeom("edge",{defaultShapeType:"line",getPath:function(t,e){var n=this.getShape(t);return!!i.isFunction(n.getPath)&&n.getPath(e)}}),r.registEdge("polyLineFlow",{getPath:function(t){return i.getEdgePath("polyLineFlow",t,"line")},draw:function(t,e){return i.drawEdge("polyLineFlow",t,e,!0,"line")}}),r.registEdge("line",{getPath:function(t){return i.getEdgePath("line",t,"line")},draw:function(t,e){return i.drawEdge("line",t,e,!1,"line")}}),r.registEdge("arrow",{getPath:function(t){return i.getEdgePath("line",t,"line")},draw:function(t,e){return i.drawEdge("line",t,e,!0,"line")}}),r.registEdge("HV",{getPath:function(t){return i.getEdgePath("HV",t,"line")},draw:function(t,e){return i.drawEdge("HV",t,e,!1,"line",!1)}}),r.registEdge("VH",{getPath:function(t){return i.getEdgePath("VH",t,"line")},draw:function(t,e){return i.drawEdge("VH",t,e,!1,"line",!1)}}),r.registEdge("HVH",{getPath:function(t){return i.getEdgePath("HVH",t,"line")},draw:function(t,e){return i.drawEdge("HVH",t,e,!1,"line",!1)}}),r.registEdge("VHV",{getPath:function(t){return i.getEdgePath("VHV",t,"line")},draw:function(t,e){return i.drawEdge("VHV",t,e,!1,"line",!1)}}),r.registEdge("smooth",{getPath:function(t){return i.getEdgePath("bezierAuto",t,"curve")},draw:function(t,e){return i.drawEdge("bezierAuto",t,e,!1,"curve")}}),r.registEdge("smoothArrow",{getPath:function(t){return i.getEdgePath("bezierAuto",t,"curve")},draw:function(t,e){return i.drawEdge("bezierAuto",t,e,!0,"curve")}}),r.registEdge("bezierHorizontal",{getPath:function(t){return i.getEdgePath("bezierHorizontal",t,"curve")},draw:function(t,e){return i.drawEdge("bezierHorizontal",t,e,!1,"curve")}}),r.registEdge("bezierVertical",{getPath:function(t){return i.getEdgePath("bezierVertical",t,"curve")},draw:function(t,e){return i.drawEdge("bezierVertical",t,e,!1,"curve")}}),r.registEdge("bezierQuadratic",{getPath:function(t){return i.getEdgePath("bezierQuadratic",t,"curve")},draw:function(t,e){return i.drawEdge("bezierQuadratic",t,e,!1,"curve",!1)}})},function(t,e,n){"use strict";function i(){return[[.5,0],[1,.5],[.5,1],[0,.5]]}var r=n(4),a=n(29),o=.5/Math.sqrt(2);a.registGeom("node",{defaultShapeType:"rect",getAnchorPoints:function(t,e,n){var i=this.getShape(t);return!!r.isFunction(i.getAnchorPoints)&&i.getAnchorPoints(e,n)}}),a.registNode("rect",{draw:function(t,e){return r.drawNode("rect",t,e)},getAnchorPoints:i}),a.registNode("rhombus",{draw:function(t,e){return r.drawNode("rhombus",t,e)},getAnchorPoints:i}),a.registNode("text",{draw:function(t,e){return r.drawNode("text",t,e)},getAnchorPoints:i}),a.registNode("image",{draw:function(t,e){return r.drawNode("image",t,e)},getAnchorPoints:i}),a.registNode("html",{getHtml:function(t){return t.origin.html},cssSize:!1,draw:function(t,e){var n=r.createDOM('<div class="g6-html-node-container"></div>'),i=this.getHtml(t,e);return i=i?r.createDOM(i):r.createDOM("<div></div>"),n.appendChild(i),t.html=n,this.cssSize&&(t.size="auto"),r.drawNode("html",t,e)},getAnchorPoints:function(){return[[0,.25],[0,.5],[0,.75],[1,.25],[1,.5],[1,.75],[.25,0],[.5,0],[.75,0],[.25,1],[.5,1],[.75,1]]}}),a.registNode("circle",{draw:function(t,e){return r.drawNode("circle",t,e)},getAnchorPoints:function(){return[[.5-o,.5-o],[.5,0],[.5+o,.5-o],[1,.5],[.5+o,.5+o],[.5,1],[.5-o,.5+o],[0,.5]]}})},function(t,e,n){"use strict";var i=n(1),r={getDOMHeight:function(t){var e=i.getStyle(t,"height");return parseFloat(e)},getDOMWidth:function(t){var e=i.getStyle(t,"width");return parseFloat(e)},getOuterHeight:function(t){var e=i.getHeight(t),n=parseFloat(i.getStyle(t,"borderTopWidth"))||0,r=parseFloat(i.getStyle(t,"paddingTop")),a=parseFloat(i.getStyle(t,"paddingBottom")),o=parseFloat(i.getStyle(t,"borderBottomWidth"))||0;return e+n+o+r+a},getOuterWidth:function(t){var e=i.getWidth(t),n=parseFloat(i.getStyle(t,"borderLeftWidth"))||0,r=parseFloat(i.getStyle(t,"paddingLeft")),a=parseFloat(i.getStyle(t,"paddingRight")),o=parseFloat(i.getStyle(t,"borderRightWidth"))||0;return e+n+r+a+o},createDOM:function(t,e){var n=void 0;return n=i.isString(t)?i.createDom(t):t,n.bbox=n.getBoundingClientRect(),n.hide=function(){return n.style.visibility="hidden",n},n.show=function(){return n.style.visibility="visible",n},n.css=function(t){return i.modiCSS(n,t),n},n.outerWidth=function(){return r.getOuterWidth(n)},n.outerHeight=function(){return r.getOuterHeight(n)},n.width=function(){return r.getDOMWidth(n)},n.height=function(){return r.getDOMHeight(n)},n.paddingLeft=function(){return parseFloat(i.getStyle(n,"padding-left"))},n.paddingRight=function(){return parseFloat(i.getStyle(n,"padding-right"))},n.paddingTop=function(){return parseFloat(i.getStyle(n,"padding-top"))},n.paddingBottom=function(){return parseFloat(i.getStyle(n,"padding-bottom"))},n.destroy=function(){n.parentNode&&n.parentNode.removeChild(n)},n.on=function(t,e){n.addEventListener(t,e)},n.off=function(t,e){n.removeEventListener(t,e)},n.attr=function(t){return n.getAttribute(t)},n.css(e),n}};t.exports=r},function(t,e,n){"use strict";function i(t,e){return Math.abs(t.x-e.x)>Math.abs(t.y-e.y)}function r(t,e,n,r,a){var o=[];if("horizontal"===n)o.push({x:1*(t.x+e.x)/2,y:t.y}),o.push({x:1*(t.x+e.x)/2,y:e.y});else if("vertical"===n)o.push({x:t.x,y:1*(t.y+e.y)/2}),o.push({x:e.x,y:1*(t.y+e.y)/2});else{var s=Math.abs(e.x-t.x),u=Math.abs(e.y-t.y),c=t,h=e;r&&r.getCenter&&(c=r.getCenter()),a&&a.getCenter&&(h=a.getCenter()),i(t,c)||t===c&&u<s?o.push({x:1*(t.x+e.x)/2,y:t.y}):o.push({x:t.x,y:1*(t.y+e.y)/2}),i(e,h)||e===h&&u<s?o.push({x:1*(t.x+e.x)/2,y:e.y}):o.push({x:e.x,y:1*(t.y+e.y)/2})}return o}function a(t,e){var n={x:(t.x+e.x)/2,y:(t.y+e.y)/2},i=h.vector(e,t),r=i.vertical(),a=i.length();return r.setLength(.2*a),[f.add(n,r)]}function o(t,e,n,i){var a=t[0],o=t[t.length-1],s=["M",a.x,a.y],c=r(a,o,i,e,n),h=["C"],l=[s];return u.each(c,function(t){h.push(t.x,t.y)}),h.push(o.x,o.y),l.push(h),l}function s(t,e){var n=10,i=void 0,r=void 0,a=t.getBBox(),o=a.centerX,s=a.centerY,u=a.height,c=a.width,h=a.maxX,l=a.maxY;if(e=[e.x,e.y],o===e[0]&&(e[1]>=s?(i=n+u/2-Math.abs(s-e[1]),r=[o,e[1]+i]):(i=n+u/2-Math.abs(s-e[1]),r=[o,e[1]-i])),s===e[1]&&(e[0]>=o?(i=n+c/2-Math.abs(o-e[0]),r=[e[0]+i,s]):(i=n+c/2-Math.abs(o-e[0]),r=[e[0]-i,s])),r)return r;var d=Math.abs(o-e[0]),f=Math.abs(s-e[1]),g=Math.sqrt(Math.pow(d,2)+Math.pow(f,2)),p=180*Math.asin(f/g)/Math.PI;return e[0]>=o&&e[0]<=h?e[1]>=s&&e[1]<=l?p>0&&p<=45?(i=n+c/2-Math.abs(o-e[0]),r=[e[0]+i,e[1]]):(i=n+u/2-Math.abs(s-e[1]),r=[e[0],e[1]+i]):p>0&&p<=45?(i=n+c/2-Math.abs(o-e[0]),r=[e[0]+i,e[1]]):(i=n+u/2-Math.abs(s-e[1]),r=[e[0],e[1]-i]):e[1]>=s&&e[1]<=l?p>0&&p<=45?(i=n+c/2-Math.abs(o-e[0]),r=[e[0]-i,e[1]]):(i=n+u/2-Math.abs(s-e[1]),r=[e[0],e[1]+i]):p>0&&p<=45?(i=n+c/2-Math.abs(o-e[0]),r=[e[0]-i,e[1]]):(i=n+u/2-Math.abs(s-e[1]),r=[e[0],e[1]-i]),r}var u=n(1),c=n(3),h=n(31),l=n(18),d=n(140),f=c.Vector2,g={polyLineFlow:function(t,e,n){var i=s(e,t[0]),r=s(n,t[1]);n=n.get("boxStash"),e=e.get("boxStash");var a=new d({source:e,target:n,sourcePosition:[t[0].x,t[0].y],sourceHandlePosition:[i[0],i[1]],targetPosition:[t[1].x,t[1].y],targetHandlePosition:[r[0],r[1]]});return a=a.filter(function(t){return t}).map(function(t){return{x:t[0],y:t[1]}}),l.pointsToPolygon(a)},bezierHorizontal:function(t,e,n){return o(t,e,n,"horizontal")},bezierVertical:function(t,e,n){return o(t,e,n,"vertical")},bezierAuto:function(t,e,n){return o(t,e,n,"auto")},bezierQuadratic:function(t){var e=t[0],n=t[t.length-1],i=["M",e.x,e.y],r=a(e,n),o=["Q"],s=[i];return u.each(r,function(t){o.push(t.x,t.y)}),o.push(n.x,n.y),s.push(o),s},line:function(t){var e=l.pointsToPolygon(t);return e},HV:function(t){var e=t.length,n=l.pointsToPolygon([t[0],{x:t[e-1].x,y:t[0].y},t[e-1]]);return n},VH:function(t){var e=t.length,n=l.pointsToPolygon([t[0],{x:t[0].x,y:t[e-1].y},t[e-1]]);return n},HVH:function(t){var e=t.length,n=l.pointsToPolygon([t[0],{x:(t[0].x+t[e-1].x)/2,y:t[0].y},{x:(t[0].x+t[e-1].x)/2,y:t[e-1].y},t[e-1]]);return n},VHV:function(t){var e=t.length,n=l.pointsToPolygon([t[0],{x:t[0].x,y:(t[0].y+t[e-1].y)/2},{x:t[e-1].x,y:(t[0].y+t[e-1].y)/2},t[e-1]]);return n}};t.exports=g},function(t,e,n){"use strict";function i(t){var e=this,n=t.source,i=t.target,a=t.sourcePosition,o=t.targetPosition,s=t.sourceHandlePosition,u=t.targetHandlePosition,c=e.getMaxConflictArea(r.clone(s),r.clone(u),[n,i]),h=c.minCoor,l=c.maxCoor,d=e.getTurnPointGroup(r.clone(s),r.clone(u),[n,i],h,l);return d=[a,s].concat(d).concat([u,o])}var r=n(1),a=10;i.prototype={getTurnPointGroup:function(t,e,n,i,a){function o(t){return!s.isCrossNode(t[0],t[1],n)}for(var s=this,u=[],c=r.clone(t),h=r.clone(e),l=[{source:c,target:[c[0],i.y]},{source:c,target:[c[0],a.y]},{source:c,target:[i.x,c[1]]},{source:c,target:[a.x,c[1]]}],d=[{source:h,target:[h[0],i.y]},{source:h,target:[h[0],a.y]},{source:h,target:[i.x,h[1]]},{source:h,target:[a.x,h[1]]}],f=l,g=d,p=0;p<f.length;p++)for(var v=0;v<g.length;v++){var x=f[p],m=g[v],y=x.source[0],b=x.source[1],w=x.target[0],_=x.target[1],M=m.source[0],S=m.source[1],A=m.target[0],P=m.target[1],T=(y-w)*(S-P)-(b-_)*(M-A);if(T){var C=((y*_-b*w)*(M-A)-(y-w)*(M*P-S*A))/T,I=((y*_-b*w)*(S-P)-(b-_)*(M*P-S*A))/T,k=[C,I];if(!s.isCrossNode(c,k,n)&&!s.isCrossNode(k,h,n))return[[C,I]]}}if(!s.isCrossNode(c,h,n)&&(s.isEqual(c,h,0)||s.isEqual(c,h,1)))return[c,h];var B=0,E=0;if(r.each(n,function(t){B=Math.max(B,t.width),E=Math.max(E,t.height)}),c[1]===h[1])return[[c[0],c[1]+.8*E],[h[0],h[1]+.8*E]];if(c[0]===h[0])return[[c[0]+.8*B,c[1]],[h[0]+.8*B,h[1]]];for(var O=c[0]<h[0]?c[0]:h[0],F=c[0]>h[0]?c[0]:h[0],z=c[1]<h[1]?c[1]:h[1],R=c[1]>h[1]?c[1]:h[1],N=[],G=1/0,D=O;D<F;D++){var X=[D,c[1]],Y=[D,h[1]],L=[[c,X],[X,Y],[Y,h]].every(o);L&&N.push([X,Y])}if(N.length){for(var j=void 0,H=0;H<N.length;H++){var q=(O+F)/2,W=Math.min(G,Math.abs(q-N[H][0][0]));W!==G&&(j=N[H],G=W)}return j}for(var V=[],U=1/0,Z=z;Z<R;Z++){var Q=[c[0],Z],K=[h[0],Z],$=[[c,Q],[Q,K],[K,h]].every(o);$&&V.push([Q,K])}if(V.length){for(var J=void 0,tt=0;tt<V.length;tt++){var et=(z+R)/2,nt=Math.min(U,Math.abs(et-V[tt][0][1]));nt!==U&&(J=V[tt],U=nt)}return J}var it=[c[0],a.y],rt=[h[0],a.y],at=[c[0],i.y],ot=[h[0],i.y],st=[i.x,i.y],ut=[a.x,i.y],ct=[i.x,a.y],ht=[a.x,a.y];if(u=[[c,it],[it,rt],[rt,h]].every(o))return[it,rt];if(u=[[c,at],[at,ot],[ot,h]].every(o))return[at,ot];var lt=[it,rt,at,ot],dt=[st,ut,ct,ht],ft=s.loopFind(c,h,lt,dt,o);return ft?ft:(it=[i.x,c[1]],rt=[i.x,h[1]],at=[a.x,c[1]],ot=[a.x,h[1]],(u=[[c,it],[it,rt],[rt,h]].every(o))?[it,rt]:(u=[[c,at],[at,ot],[ot,h]].every(o))?[at,ot]:(lt=[it,rt,at,ot],(ft=s.loopFind(c,h,lt,dt,o))?ft:(it=[i.x,c[1]],rt=[h[0],a.y],at=[a.x,c[1]],ot=[h[0],i.y],lt=[it,rt,at,ot],(ft=s.loopFind(c,h,lt,dt,o))?ft:(it=[c[0],a.y],rt=[i.x,h[1]],at=[c[0],i.y],ot=[a.x,h[1]],lt=[it,rt,at,ot],ft=s.loopFind(c,h,lt,dt,o),ft?ft:void 0))))},loopFind:function(t,e,n,i,r){for(var a=this,o=0;o<n.length-1;o++)for(var s=1;s<n.length;s++)for(var u=0;u<i.length;u++)if((a.isEqual(t,n[o],0)||a.isEqual(t,n[o],1))&&(a.isEqual(e,n[s],0)||a.isEqual(e,n[s],1))&&(a.isEqual(n[o],i[u],0)||a.isEqual(n[o],i[u],1))&&(a.isEqual(n[s],i[u],0)||a.isEqual(n[s],i[u],1))){var c=[[t,n[o]],[n[o],i[u]],[i[u],n[s]],[n[s],e]].every(r);if(c)return[n[o],i[u],n[s]]}},getMaxConflictArea:function(t,e,n){function i(t){return t.x-a<=r&&t.x+t.width+a>=r&&(r=t.x-a),t.x-a<=o&&t.x+t.width+a>=o&&(o=t.x+t.width+a),t.y-a<=s&&t.y+t.height+a>=s&&(s=t.y-a),t.y-a<=u&&t.y+t.height+a>=u&&(u=t.y+t.height+a),t}for(var r=Math.min(t[0],e[0]),o=Math.max(e[0],t[0]),s=Math.min(t[1],e[1]),u=Math.max(e[1],t[1]),c=0;c<n.length;c++)n.map(i);return{minCoor:{x:r,y:s},maxCoor:{x:o,y:u}}},isEqual:function(t,e,n){return Math.abs(t[n]-e[n])<=1},isCrossNode:function(t,e,n){var i=this;return i.isEqual(t,e,0)?n.some(function(n){return n.x<=t[0]&&n.x+n.width>=t[0]&&(n.y>=t[1]&&n.y<=e[1]||n.y+n.height>=t[1]&&n.y+n.height<=e[1]||n.y<=t[1]&&n.y+n.height>=e[1]||n.y>=t[1]&&n.y+n.height<=e[1])}):i.isEqual(t,e,1)?n.some(function(n){return n.y<=t[1]&&n.y+n.height>=t[1]&&(n.x>=t[0]&&n.x<=e[0]||n.x+n.width>=t[0]&&n.x+n.width<=e[0]||n.x<=t[0]&&n.x+n.width>=e[0]||n.x>=t[0]&&n.x+n.width<=e[0])}):void 0}},t.exports=i},function(t,e,n){"use strict";function i(t,e){var n={};return n.arrow=e,t.color&&(n.stroke=t.color),t.size&&(n.lineWidth=t.size),a.mix({},l.edgeStyle,n,t.style)}function r(t,e,n){if(t.label){var i=void 0,r=void 0;try{i=n.getPoint(.5)}catch(t){}if(!i)return;r=a.isObject(t.label)?a.mix({},l.edgeLabelStyle,t.label,{x:i.x,y:i.y},t.labelStyle):a.mix({},l.edgeLabelStyle,{text:t.label,x:i.x,y:i.y},t.labelStyle);var o=u.drawLabel(e,r,l.zIndex.edgeLabel),s=o.getBBox(),c=s.maxX-s.minX,h=s.maxY-s.minY,d=c+2*f,g=h+2*f;e.addShape("rect",{attrs:a.mix({x:i.x-d/2,y:i.y-g/2,width:d,height:g},l.edgeLabelRectStyle),zIndex:l.zIndex.edgeLabelBackground})}}var a=n(1),o=n(3),s=n(18),u=n(30),c=n(64),h=n(139),l=n(7),d=o.Vector2,f=5,g={getEdgePath:function(t,e,n,i,r){return 2===e.length?h[t](e,i,r):"curve"===n?s.pointsToCurve(e):s.pointsToPolygon(e)},drawEdge:function(t,e,n,a,o){var s=i(e,a),u=g.getEdgePath(t,e.points,o,e.source,e.target);s.path=u;var c=n.addShape("path",{attrs:s,zIndex:l.zIndex.edge});return r(e,n,c),n.radixSort(),c},arrowTo:function(t,e,n,i,r,a,o){var s=new d(1,0),u=new d(a-i,o-r),c=u.angleTo(s,!0);return t.transform([["r",c],["t",e,n]]),t},snapPreciseAnchor:function(t,e){var n=e.getIntersectionByPath(t),i=c.getSnapAnchor(e,n);return i}};t.exports=g},function(t,e,n){"use strict";function i(t){return u.isObject(t.label)?u.mix({},c.nodeLabelStyle,t.label,{x:t.x,y:t.y}):u.mix({},c.nodeLabelStyle,{text:t.label,x:t.x,y:t.y})}function r(t,e){e.attr({y:e.attr("y")+t.attr("height")/2+f})}function a(t){var e=t.getBBox(),n=e.maxX-e.minX,i=e.maxY-e.minY,r=n+2*d[1],a=i+2*d[0];return[r,a]}function o(t,e,n){var r=void 0,o=void 0;return n=n?n:a,u.isNull(t.label)||(r=u.mix(i(t),t.labelStyle),o=l.drawLabel(e,r,c.zIndex.nodeLabel),t.size||(t.size=n(o))),t.size||(t.size=[g,g]),u.isNumber(t.size)&&(t.size=[t.size,t.size]),o}function s(t,e,n){var a={img:n},o=void 0;t.size||(t.size=g),a.width=u.isArray(t.size)?t.size[0]:t.size,a.height=u.isArray(t.size)?t.size[1]:t.size,a.x=t.x-a.width/2,a.y=t.y-a.height/2;var s=e.addShape("image",{attrs:a,zIndex:c.zIndex.node});if(t.label){var h=u.mix(i(t),t.labelStyle);h.textBaseline="top",o=l.drawLabel(e,h,c.zIndex.nodeLabel),r(s,o)}return s}var u=n(1),c=n(7),h=n(18),l=n(30),d=c.nodePadding,f=5,g=50,p={rect:function(t,e,n){o(t,e);var i=t.size[0],r=t.size[1],a=t.x-i/2,s=t.y-r/2,u=void 0;u=n.radius?h.getRectPath(a,s,i,r,n.radius):h.getRectPath(a,s,i,r);var c=e.addShape("path",{attrs:{path:u}});return c},circle:function(t,e){o(t,e,function(t){var e=t.getBBox(),n=e.maxX-e.minX+2*d[1],i=e.maxY-e.minY+2*d[0],r=void 0,a=void 0,o=void 0,s=(n+i/2)/2,u=Math.acos(n/2/s);return o=2*(Math.sin(u)*s),a=2*s,n<i&&(r=o,o=a,a=r),[a,o]});var n=t.size[0],i=t.size[1],r=e.addShape("path",{attrs:{path:h.getEllipsePath(t.x,t.y,n/2,i/2)}});return r},text:function(t,e){t.labelStyle&&!t.labelStyle.fill&&t.color&&(t.labelStyle.fill=t.color),t.color&&(t.labelStyle={fill:t.color}),t.size&&(u.isArray(t.size)&&(t.labelStyle={fontSize:Math.min(t.size[0],t.size[1])}),u.isNumber(t.size)&&(t.labelStyle={fontSize:t.size})),t.label||0===t.label||(t.label=" ");var n=o(t,e);return n},image:function(t,e){var n=t.shape,i=u.isArray(n)?n[1]:n;return s(t,e,i)},rhombus:function(t,e){o(t,e,function(t){var e=t.getBBox(),n=e.maxX-e.minX+2*d[1],i=e.maxY-e.minY+2*d[0],r=Math.sqrt(n/2*i/2),a=n+r,o=i+r;return[a,o]});var n=t.x,i=t.y,r=t.size[0],a=t.size[1],s=[{x:n,y:i-a/2},{x:n+r/2,y:i},{x:n,y:i+a/2},{x:n-r/2,y:i}],u=e.addShape("path",{attrs:{path:h.pointsToPolygon(s,!0)}});return u},html:function(t,e,n){if("auto"===t.size)return e.addShape("html",{attrs:u.mix({cx:t.x,cy:t.y,html:t.html},n),autoSize:!0});t.size||(t.size=[g,g]);var i=t.size[0],r=t.size[1],a=t.x-i/2,o=t.y-r/2;return e.addShape("html",{attrs:u.mix({x:a,y:o,width:i,height:r,html:t.html},n)})}};t.exports=p},function(t,e,n){"use strict";var i=n(2);i.clickActive=function(t){var e=void 0,n=void 0;t._on("itemclick",function(i){e=i.item,n=i.shape,n.get("clickActive")!==!1&&(t.clearAllActived(),t.setItemActived(e),t.refreshFront())})}},function(t,e,n){"use strict";var i=n(2),r=n(9);i.clickAddNode=function(t){r.addNode(t,"click")}},function(t,e,n){"use strict";var i=n(2);i.clickBlankClearActive=function(t){t._on("click",function(e){e.shape||(t.clearAllActived(),t.refreshFront())})}},function(t,e,n){"use strict";var i=n(2);i.clickFocus=function(t){var e=t.get("el");e.style.outline="none",e.setAttribute("tabindex",1),t._on("mousedown",function(){e.focus()}),t._on("domfocus",function(){t.set("domFocus",!0)}),t._on("domblur",function(){t.set("domFocus",!1)})}},function(t,e,n){"use strict";var i=n(2);i.clickNodeActive=function(t){var e=void 0,n=void 0;t._on("itemclick",function(i){e=i.item,n=i.shape,"node"===i.itemType&&n.get("clickActive")!==!1&&(t.clearAllActived(),t.setItemActived(e),t.refreshFront())})}},function(t,e,n){"use strict";var i=n(2);i.collapse=function(t){t._on("click",function(e){var n=e.shape;n&&n.hasClass("collapseButton")&&(t.fire("collapse",e),t.css({cursor:"default"}))}),t._on("collapse",function(e){var n=t.get("dataMap"),i=e.item,r=i.get("id");n[r].isCollapsed=!0,t.clearAllActived(),t.refreshFront(),t.reRender()})}},function(t,e,n){"use strict";var i=n(2),r=n(9),a=n(4);i.dragAddEdge=function(t){function e(e){var n=e.item,i=t.get("addingType"),r=t.get("addingModel");if(t.fire("beforedragaddedge",e),n&&"edge"===i&&t.isNode(n)&&e.cancel!==!0)return r.source=n.get("id"),r.target=n.get("id"),t.addItem("edge",r)}function n(t,e){if(e)return 1}function i(e,n){a.objectToValues(n).length>0?(t.updateItem(e,n),t.updateRollback(),t.clearAllActived(),t.setItemActived(e),t.draw(!1),t.endAdd(e)):(t.removeItem(e),t.refreshFront(),t.endAdd())}r.dragEdgeExtremePoint(t,e,n,i)}},function(t,e,n){"use strict";var i=n(2),r=n(19);i.dragBlankX=function(t){r(t,!0,!0,!1)}},function(t,e,n){"use strict";var i=n(2),r=n(19);i.dragBlankY=function(t){r(t,!0,!1)}},function(t,e,n){"use strict";var i=n(2),r=n(4);i.dragEdgeEndHideAnchor=function(t){t._on("dragedgeend",function(t){r.isNode(t.item)&&t.item.hideAnchor()})}},function(t,e,n){"use strict";var i=n(2),r=n(9),a=n(4);i.dragEdge=function(t){function e(e){var n=e.shape,i=void 0;if(n&&n.hasClass("control-point")&&(i=n.get("item"),t.isEdge(i)))return i}function n(t,e){var n=t.shape,i=void 0;if(e&&(i=n.get("pointIndex"),e.isExtremePoint(i)))return i}function i(e,n){a.objectToValues(n).length>0?(t.updateItem(e,n),t.updateRollback(),t.draw(!1)):t.refreshFront()}r.dragEdgeExtremePoint(t,e,n,i)}},function(t,e,n){"use strict";var i=n(2);i.dragHideEdges=function(t){var e=t.get("edgeGroup");t._on("dragstart",function(){e.hide(),t.draw(!1)}),t._on("dragend",function(){e.show(),t.draw(!1)}),t._on("dommouseleave",function(){e.show(),t.draw(!1)})}},function(t,e,n){"use strict";var i=n(2),r=n(9);i.dragHideTexts=function(t){t._on("dragstart",function(){r.hideTexts(t)}),t._on("dragend",function(){r.showTexts(t)}),t._on("dommouseleave",function(){r.showTexts(t)})}},function(t,e,n){"use strict";var i=n(2);i.dragNodeEndHideAnchor=function(t){t._on("dragnodeend",function(t){1===t.dragItems.length?t.node.showAnchor():t.node.hideAnchor()})}},function(t,e,n){"use strict";var i=n(2);i.dragNodeEndSetActive=function(t){t._on("dragnodeend",function(e){1===e.dragItems.length&&(t.clearAllActived(),t.setItemActived(e.dragItems[0]))})}},function(t,e,n){"use strict";var i=n(1),r=n(2),a=n(9);r.dragNode=function(t){var e=t.get("gridAssist"),n=e&&e.forceAlign,r=t.get("behaviourSignal"),o=[],s=null,u=!1,c=void 0,h=void 0,l=void 0,d=void 0,f=void 0,g=void 0,p=void 0;t._on("mousedown",function(e){l=e.shape,h=e.item,!t.isNode(h)||l&&l.hasClass("control-point")||l&&l.hasClass("anchor-point")||(s={x:e.x,y:e.y},h.isActived()?(c=t._getAllActived(),i.each(c,function(t){o.push(t)})):o.push(h))}),t._on("dragmove",function(e){i.isArray(o)&&0!==o.length&&(u=!0,r.draggingNode=!0,i.each(o,function(n){t.isNode(n)&&(p=n.getBBox(),g={x:(p.x+p.maxX)/2,y:(p.y+p.maxY)/2},n.showDelegation({x:g.x+e.x-s.x,y:g.y+e.y-s.y}))}),t.refreshFront())}),t._on("mouseup",function(l){i.isArray(o)&&0!==o.length&&(u&&(h=l.item,o=i.filter(o,function(e){return t.isInGraph(e)}),i.each(o,function(r){t.isNode(r)?(g=r.getPosition(),d={x:g.x+l.x-s.x,y:g.y+l.y-s.y},h!==r&&r&&!r.hasClass("preventToFront")&&t.toFront(r),n&&a.alignPoint(d,e.cell),r.hideDelegation()):(f=r.getControlPoints(),d={},f.length>2&&(i.each(f,function(t,i){0!==i&&i!==f.length-1&&(t.x=t.x+l.x-s.x,t.y=t.y+l.y-s.y,n&&a.alignPoint(t,e.cell))}),d={controlPoints:f})),t.updateItem(r,d),t.isNode(r)&&t.fire("dragnodeend",{dragItems:o,node:r})}),t.updateRollback(),t.draw(!1)),s=null,h=void 0,g=void 0,f=void 0,c=void 0,d=void 0,o=[],u=!1,r.draggingNode=void 0)})}},function(t,e,n){"use strict";var i=n(2);i.hoverAnchorSetActived=function(t){var e=void 0;t._on("mouseenter",function(n){e=n.shape,e&&e.hasClass("anchor-point")&&t.setAnchorActived(e)}),t._on("mouseleave",function(n){e=n.shape,e&&e.hasClass("anchor-point")&&t.setAnchorUnActived(e)})}},function(t,e,n){"use strict";var i=n(2);i.hoverNodeShowAnchor=function(t){var e=t.get("behaviourSignal"),n=void 0;t._on("itemmouseenter",function(i){"node"!==i.itemType||e.draggingNode||(n=setTimeout(function(){!t.destroyed&&t.showAnchor(i.item)},200))}),t._on("itemmouseleave",function(e){"node"===e.itemType&&(clearTimeout(n),!t.destroyed&&t.hideAnchor(e.item))})}},function(t,e,n){"use strict";var i=n(2),r=n(9);i.mouseupAddNode=function(t){r.addNode(t,"mouseup")}},function(t,e,n){"use strict";var i=n(2),r=n(7),a=n(4);i.multiSelect=function(t){var e=t.get("frontCanvasRootGroup"),n=t.get("behaviourSignal"),i=!1,o=[],s=void 0,u=void 0,c=void 0,h=void 0,l=void 0,d=void 0,f=void 0,g=void 0,p=void 0,v=void 0,x=void 0;t._on("mousedown",function(t){h=t.item,l=t.shape,h||d||l||(f={x:t.x,y:t.y},d=e.addShape("rect",{attrs:r.frameRectStyle}),n.frameSelecting=!0)}),t._on("dragmove",function(e){d&&(g=Math.min(f.x,e.x),p=Math.min(f.y,e.y),v=Math.max(f.x,e.x),x=Math.max(f.y,e.y),d.attr({x:g,y:p,width:v-g,height:x-p}),t.refreshFront())}),t._on("mouseup",function(){d&&(s=t.get("itemCache"),a.each(s,function(e){u=e.getBBox(),c=[{x:u.x,y:u.y},{x:u.x,y:u.maxY},{x:u.maxX,y:u.y},{x:u.maxX,y:u.maxY}],a.each(c,function(n,r){if(i=a.isInRect(n,g,p,v,x),t.isNode(e)){if(i)return o.push(e),!1}else{if(!i)return!1;r===c.length-1&&o.push(e)}})}),t.clearAllActived(),t.setItemsActived(o),d.remove(!0),t.refreshFront(),n.frameSelecting=void 0,h=void 0,d=void 0,f=void 0,g=void 0,p=void 0,v=void 0,x=void 0,o=[])})}},function(t,e,n){"use strict";var i=n(2),r=n(9),a=n(4);i.resizeEdge=function(t){var e=t.get("gridAssist"),n=e&&e.forceAlign,i=void 0,o=void 0,s=void 0,u=void 0,c=void 0,h=void 0,l=void 0,d=void 0,f=void 0,g=void 0,p=void 0,v=void 0;t._on("click",function(e){i=e.item,o=t.getActived(),v=e.shape,!t.isEdge(i)||i!==o||v&&v.hasClass("control-point")||(i.addControlPoint({x:e.x,y:e.y}),c=i.getControlPoints(),t.updateItem(i,{controlPoints:c}),t.updateRollback(),t.refreshFront())}),t._on("mousedown",function(e){if(v=e.shape,v&&v.hasClass("control-point")){if(s=v.get("item"),!t.isEdge(s))return void(s=void 0);if(g=v.get("pointIndex"),s.isExtremePoint(g))return s=void 0,void(g=void 0);u=v.get("point"),c=s.getControlPoints(),h=c[g-1],l=c[g+1]}}),t._on("dragmove",function(e){t.isEdge(s)&&(i=e.item,p={x:e.x,y:e.y,controlPointIndex:g},a.isInSegment(h,l,p)?p.stroke="red":p.stroke="blue",s.showDelegation(p),t.refreshFront())}),t._on("mouseup",function(x){t.isEdge(s)&&(i=x.item,d={x:x.x,y:x.y},f={},s.hideDelegation(),a.isInSegment(h,l,d)?c.splice(g,1):0!==g&&g!==c.length-1&&(u.x=d.x,u.y=d.y,n&&r.alignPoint(u,e.cell),f.controlPoints=c),t.updateItem(s,f),t.updateRollback(),t.draw(!1),i=void 0,o=void 0,s=void 0,u=void 0,c=void 0,h=void 0,l=void 0,d=void 0,f=void 0,g=void 0,p=void 0,v=void 0)})}},function(t,e,n){"use strict";var i=n(2),r=n(9);i.resizeNode=function(t){var e=t.get("behaviourSignal"),n=!1,i=void 0,a=void 0,o=void 0,s=void 0,u=void 0,c=void 0,h=void 0;t._on("mousedown",function(t){i=t.shape,i&&i.hasClass("control-point")&&(u=i.get("item"),c=i.get("point"),h=i.get("pointIndex"))}),t._on("dragmove",function(i){t.isNode(u)&&(n=!0,e.resizingNode=!0,a={x:i.x,y:i.y},s=r.getControlInfo(a,h,c,u,"frontCanvas"),o=s.size,o[0]>5&&o[1]>5&&(u.showDelegation(s),t.refreshFront()))}),t._on("mouseup",function(l){t.isNode(u)&&(n&&(a={x:l.x,y:l.y},s=r.getControlInfo(a,h,c,u),o=s.size,o[0]>5&&o[1]>0&&(t.updateItem(u,s),t.updateRollback()),u.hideDelegation(),t.draw(!1)),e.resizingNode=void 0,i=void 0,a=void 0,o=void 0,s=void 0,u=void 0,c=void 0,n=!1,h=void 0)})}},function(t,e,n){"use strict";var i=n(2);i.shortcut=function(t){var e=!1;t._on("keydown",function(n){if(32===n.keyCode){
                if(e)return;e=!0,"drag"===t.get("mode")?t.changeMode("edit"):t.changeMode("drag"),e=!0}return n.metaKey&&67===n.keyCode?void t.copy():n.metaKey&&86===n.keyCode?void t.paste():n.metaKey&&n.altKey&&90===n.keyCode?void t.redo():n.metaKey&&90===n.keyCode?void t.updo():n.ctrlKey&&67===n.keyCode?void t.copy():n.ctrlKey&&86===n.keyCode?void t.paste():n.ctrlKey&&n.altKey&&90===n.keyCode?void t.redo():n.ctrlKey&&90===n.keyCode?void t.updo():8===n.keyCode||46===n.keyCode?void t.del():void 0}),t._on("keyup",function(){e=!1})}},function(t,e,n){"use strict";var i=n(2);i.spreadout=function(t){t._on("click",function(e){var n=e.shape;n&&n.hasClass("spreadoutButton")&&(t.fire("spreadout",e),t.css({cursor:"default"}))}),t._on("spreadout",function(e){var n=t.get("dataMap"),i=e.item,r=i.get("id");n[r].isCollapsed=!1,t.clearAllActived(),t.refreshFront(),t.reRender()})}},function(t,e,n){"use strict";var i=n(2),r=n(9);i.wheelZoomAutoTexts=function(t){t.on("afterrender",function(){r.autoTexts(t)}),t.on("wheelzoomend",function(){r.autoTexts(t)}),t.on("itemmouseenter",function(e){"node"===e.itemType&&(r.showText(e.item),t.draw(!1))}),t.on("itemmouseleave",function(e){if("node"===e.itemType){var n=e.item.getGroup();n.traverseChildren(function(t){var e=t.get("autoTextHide");"text"===t.type&&e!==!1&&t.hide()}),t.draw(!1)}})}},function(t,e,n){"use strict";var i=n(2),r=n(9);i.onWheelZoomEdges=function(t){var e=t.get("edgeGroup");r.onWheelZoom(t,function(){e.hide(),t.draw(!1)},function(){e.show(),t.draw(!1)})}},function(t,e,n){"use strict";var i=n(2),r=n(9);i.onWheelZoomTexts=function(t){r.onWheelZoom(t,function(){r.hideTexts(t)},function(){r.showTexts(t)})}},function(t,e){"use strict";function n(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function i(t,e,n){n?(e.x=t.x,e.y=t.y):(e.x=t.y,e.y=t.x),t.children.forEach(function(t,r){i(t,e.children[r],n)})}var r=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var n=arguments[e];for(var i in n)Object.prototype.hasOwnProperty.call(n,i)&&(t[i]=n[i])}return t},a=function t(e){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[];n(this,t);var r=this;r.x=r.y=0,r.leftChild=r.rightChild=null,r.height=e||0,r.children=i},o={isHorizontal:!0,nodeSep:20,nodeSize:20,rankSep:200,subTreeSep:10};t.exports=function(t){function e(t){if(!t)return null;t.width=0,t.depth&&t.depth>c&&(c=t.depth);var n=t.children,i=n.length,r=new a(t.height,[]);return n.forEach(function(t,n){var a=e(t);r.children.push(a),0===n&&(r.leftChild=a),n===i-1&&(r.rightChild=a)}),r.originNode=t,r.isLeaf=t.isLeaf(),r}function n(t){if(t.isLeaf||0===t.children.length)t.drawingDepth=c;else{var e=t.children.map(function(t){return n(t)}),i=Math.min.apply(null,e);t.drawingDepth=i-1}return t.drawingDepth}function s(t){t.x=t.drawingDepth*u.rankSep,t.isLeaf?(t.y=0,h&&(t.y=h.y+h.height+u.nodeSep,t.originNode.parent!==h.originNode.parent&&(t.y+=u.subTreeSep)),h=t):(t.children.forEach(function(t){s(t)}),t.y=(t.leftChild.y+t.rightChild.y)/2)}var u=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};u=r({},o,u);var c=0,h=void 0,l=e(t);return n(l),s(l),i(l,t,u.isHorizontal),t}},function(t,e){"use strict";function n(t,e,n){t.x+=n*t.depth,t.y=e?e.y+e.height:0}var i=20;t.exports=function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:i,r=null;t.eachNode(function(t){n(t,r,e),r=t})}},function(t,e,n){"use strict";function i(t,e){for(var n=Object.getOwnPropertyNames(e),i=0;i<n.length;i++){var r=n[i],a=Object.getOwnPropertyDescriptor(e,r);a&&a.configurable&&void 0===t[r]&&Object.defineProperty(t,r,a)}return t}function r(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function a(t,e){if(!t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!e||"object"!=typeof e&&"function"!=typeof e?t:e}function o(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function, not "+typeof e);t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),e&&(Object.setPrototypeOf?Object.setPrototypeOf(t,e):i(t,e))}var s=n(14),u=n(69),c=n(32),h=function(t){function e(){return r(this,e),a(this,t.apply(this,arguments))}return o(e,t),e.prototype.execute=function(){t.prototype._prepareRoot.call(this);var e=this;return e.options.forceAlign="R",c(e.rootNode,e.options,u)},e}(s);t.exports=h},function(t,e){"use strict";t.exports={T:{x:.5,y:0},R:{x:1,y:.5},B:{x:.5,y:1},L:{x:0,y:.5},C:null}},function(t,e){"use strict";t.exports=["LR","RL","TB","BT","H","V"]},function(t,e){"use strict";t.exports=["LR","RL","H","L","R"]},function(t,e){"use strict";t.exports=18},function(t,e,n){"use strict";function i(t,e){for(var n=Object.getOwnPropertyNames(e),i=0;i<n.length;i++){var r=n[i],a=Object.getOwnPropertyDescriptor(e,r);a&&a.configurable&&void 0===t[r]&&Object.defineProperty(t,r,a)}return t}function r(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function a(t,e){if(!t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!e||"object"!=typeof e&&"function"!=typeof e?t:e}function o(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function, not "+typeof e);t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),e&&(Object.setPrototypeOf?Object.setPrototypeOf(t,e):i(t,e))}var s=n(14),u=n(170),c=n(32),h=function(t){function e(){return r(this,e),a(this,t.apply(this,arguments))}return o(e,t),e.prototype.execute=function(){t.prototype._prepareRoot.call(this);var e=this,n=e.rootNode,i=e.options;return n.width=0,c(n,i,u),n},e}(s);t.exports=h},function(t,e,n){"use strict";function i(t,e){for(var n=Object.getOwnPropertyNames(e),i=0;i<n.length;i++){var r=n[i],a=Object.getOwnPropertyDescriptor(e,r);a&&a.configurable&&void 0===t[r]&&Object.defineProperty(t,r,a)}return t}function r(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function a(t,e){if(!t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!e||"object"!=typeof e&&"function"!=typeof e?t:e}function o(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function, not "+typeof e);t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),e&&(Object.setPrototypeOf?Object.setPrototypeOf(t,e):i(t,e))}var s=n(14),u=n(171),c=n(71),h=n(70),l=["LR","RL","H"],d=l[0],f=function(t){function e(){return r(this,e),a(this,t.apply(this,arguments))}return o(e,t),e.prototype.execute=function(){t.prototype._prepareRoot.call(this);var e=this,n=e.rootNode,i=e.options;i.isHorizontal=!0;var r=i.indent;e.options.forceAlign="R";var a=i.direction||d;if(a&&l.indexOf(a)===-1)throw new TypeError("Invalid direction: "+a);if(a===l[0])u(n,r),c(n,"L","L",i);else if(a===l[1])u(n,r),n.right2left(),c(n,"R","R",i);else if(a===l[2]){var o=h(n,i),s=o.left,f=o.right;u(s,r),s.right2left(),c(s,"R","R",i),u(f,r),c(f,"L","L",i);var g=s.getBoundingBox();f.translate(g.width,0),n.x=f.x-n.width/2,c(n,"B","B",i,!0)}return n.eachNode(function(t){var e=t.data;e.x=t.x+t.width/2+t.hgap,e.y=t.y+t.height/2+t.vgap,e.align=t.align,e.inAnchor=t.inAnchor?[t.inAnchor.x,t.inAnchor.y]:null,e.outAnchor=t.outAnchor?[t.outAnchor.x,t.outAnchor.y]:null}),n},e}(s);t.exports=f},function(t,e,n){"use strict";function i(t,e){for(var n=Object.getOwnPropertyNames(e),i=0;i<n.length;i++){var r=n[i],a=Object.getOwnPropertyDescriptor(e,r);a&&a.configurable&&void 0===t[r]&&Object.defineProperty(t,r,a)}return t}function r(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function a(t,e){if(!t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!e||"object"!=typeof e&&"function"!=typeof e?t:e}function o(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function, not "+typeof e);t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),e&&(Object.setPrototypeOf?Object.setPrototypeOf(t,e):i(t,e))}var s=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var n=arguments[e];for(var i in n)Object.prototype.hasOwnProperty.call(n,i)&&(t[i]=n[i])}return t},u=n(33),c=n(14),h=n(69),l=n(32),d={nodeSize:20,nodeSep:20,rankSep:200},f=function(t){function e(){return r(this,e),a(this,t.apply(this,arguments))}return o(e,t),e.prototype.execute=function(){t.prototype._prepareRoot.call(this);var e=this,n=s({},d,e.options),i=n.nodeSize||d.nodeSize,r=n.nodeSep||d.nodeSep,a=n.rankSep||d.rankSep;e.rootNode=new u(e.root,s(n,{getWidth:function(){return i},getHeight:function(){return i},getHGap:function(){return a},getVGap:function(){return r}}));var o=e.rootNode;return l(o,n,h),o},e}(c);t.exports=f},function(t,e){"use strict";var n={R:"L",L:"R",T:"B",B:"T"};t.exports=function(t){return n[t]}},function(t,e,n){"use strict";var i=n(175);t.exports=function(t){return i.indexOf(t)>-1}},function(t,e,n){"use strict";n(65),n(143),n(147),n(144),n(161),n(145),n(149),n(66),n(150),n(151),n(19),n(153),n(152),n(154),n(155),n(158),n(156),n(159),n(160),n(162),n(163),n(164),n(165),n(67),n(168),n(169),n(157),n(146),n(167)},function(t,e,n){"use strict";var i=n(1),r=n(13),a=r.Util,o={max:5,current:0,cache:[]},s={nodes:[],edges:[]},u=function(){};u.ATTRS={clipboard:!1,rollback:!1},i.augment(u,{_initEditor:function(){var t=this.get("rollback"),e=this.get("clipboard");t&&(i.isObject(t)?this.set("rollback",i.mix({},o,t)):this.set("rollback",i.clone(o))),e&&this.set("clipboard",i.clone(s))},_changeData:function(t,e){this._clearInner(),this._initData(),this.source(t,e),this.render(!1)},updateRollback:function(){var t=this.get("rollback");if(i.isObject(t)){var e=t.current,n=t.cache,r=t.max,a=n.length,o=this.save().source;n.splice(0,e,o),a>r&&n.splice(r,a-r+1),t.current=0}},copy:function(){var t=this,e=t.getAllActived(),n=t.get("clipboard"),r={},o=void 0,s=void 0,u=void 0;n.nodes=[],n.edges=[],i.each(e,function(c){o=i.mix(!0,{},c.get("model"),{id:a.guid()}),r[c.get("model").id]=o.id,t.isNode(c)?(o.x+=10,o.y-=10,n.nodes.push(o)):(s=c.get("model").target,u=c.get("model").source,s=t.find(s),u=t.find(u),e.indexOf(s)!==-1&&e.indexOf(u)!==-1&&(o.controlPoints&&i.each(o.controlPoints,function(t,e){o.controlPoints[e]={x:t.x+=10,y:t.y-=10}}),o.target=r[o.target],o.source=r[o.source],n.edges.push(o)))}),this.refresh()},paste:function(){var t=this,e=t.get("clipboard"),n=t._addNodes(e.nodes);n=n.concat(t._addEdges(e.edges)),t.clearAllActived(),t.setItemsActived(n),e.nodes=[],e.edges=[],t.updateRollback(),this.refresh()},del:function(){var t=this,e=t.getAllActived();i.each(e,function(e){t.removeItem(e)}),this.updateRollback(),this.refresh()},undo:function(){var t=this.get("rollback");if(i.isObject(t)){var e=t.cache,n=t.current,r=n+1,a=e[r];0!==e.length&&a&&(a=i.clone(a),this._changeData(a.nodes,a.edges),t.current=r,this.refresh())}},updo:function(){this.undo()},redo:function(){var t=this.get("rollback");if(i.isObject(t)){var e=t.cache,n=t.current,r=n-1,a=e[r];0!==e.length&&a&&(a=i.clone(a),this._changeData(a.nodes,a.edges),t.current=r,this.refresh())}},beginAdd:function(t,e){this.changeMode("add"),this.set("addingType",t),this.set("addingModel",e)},endAdd:function(t){this.changeMode("edit"),this.set("addingType",""),this.set("addingModel",null),t&&this.fire("afteradd",{item:t})}}),t.exports=u},function(t,e,n){"use strict";var i=n(185);n(182),i.Mode={default:["dragNode","dragEdge","dragBlank","clickBlankClearActive","resizeEdge","clickActive","resizeNode","wheelZoom","dragNodeEndSetActive","clickFocus"],edit:["dragNode","dragEdge","clickBlankClearActive","clickFocus","resizeEdge","clickActive","dragNodeEndSetActive","multiSelect","resizeNode","shortcut","wheelZoom","hoverNodeShowAnchor","hoverAnchorSetActived","dragEdgeEndHideAnchor","dragNodeEndHideAnchor"],drag:["shortcut","dragCanvas","wheelZoom","clickFocus"],add:["clickAddNode","dragAddEdge","hoverAnchorSetActived","hoverNodeShowAnchor"],complicated:["dragCanvas","wheelZoom","dragHideEdges","wheelZoomHideEdges"],analysis:["dragCanvas","wheelZoom","clickFocus","dragHideEdges","wheelZoomAutoTexts","wheelZoomHideEdges","wheelZoomHideTexts"],none:[]},t.exports=i},function(t,e,n){"use strict";var i=n(1),r=n(183),a=n(13),o=function t(e){t.superclass.constructor.call(this,e)};o.ATTRS={defaultNodeShape:"rect",layoutEdgeFilter:null,layoutNodeFilter:null},i.extend(o,a),i.mixin(o,[r]),i.augment(o,{_initCfg:function(){var t=this.get("mode");"analysis"===t&&(this.set("useAnchor",!1),this.set("useFreezeSizeGroup",!0),this.set("useEdgeSortGroup",!1),this.set("grid",null)),"edit"===t&&(this.set("wheelScaleLimit",[.5,4]),this.set("rollback",!0),this.set("clipboard",!0)),o.superclass._initCfg.call(this)},_readSource:function(t){this.source(t.nodes,t.edges)},source:function(t,e){i.isObject(t)?(this.set("nodes",t.nodes),this.set("edges",t.edges)):(this.set("nodes",t),this.set("edges",e))},_saveSource:function(){function t(t,e){i.each(t.get("children"),function(t){var n=t.get("id"),i=s[n];e.push(i.get("model"))})}var e=this,n=[],r=[],a=e.get("nodeGroup"),o=e.get("edgeGroup"),s=e.get("itemCache");return t(a,n),t(o,r),i.clone({nodes:n,edges:r})},getLayoutNodes:function(){var t=this.get("nodes"),e=this.get("layoutNodeFilter");return e?i.filter(t,e):t},getLayoutEdges:function(){var t=this.get("edges"),e=this.get("layoutEdgeFilter");return e?i.filter(t,e):t},layout:function t(){var t=this.get("layout"),e=this.getLayoutNodes(),n=this.getLayoutEdges();i.isObject(t)?(t.nodes=e,t.edges=n,t.graphHeight=this.get("height"),t.graphWidth=this.get("width"),t.execute()):i.isFunction(t)&&t(e,n),this.updateNodesPosition()},changeLayout:function(t){this.set("layout",t),this.layout()},render:function(t){void 0===t&&(t=this.get("rollback")),o.superclass.render.call(this),t!==!1&&this.updateRollback()},add:function(t,e){var n=this,i=void 0;return"node"===t?i=n._addNodes([e]):"edge"===t&&(i=n._addEdges([e])),this.draw(),i[0]},update:function(t,e){this.updateItem(t,e),this.draw()},remove:function(t){this.removeItem(t),this.draw()}}),t.exports=o},function(t,e,n){"use strict";var i=n(34),r={g6:!0,version:"1.2.0",page_type:"syslog"};setTimeout(function(){if(i.tracking){var t=new i;t.log(r)}},100),t.exports=r},function(t,e,n){"use strict";n(66),n(148),n(166),n(65),n(67)},function(t,e,n){"use strict";var i=n(13),r=n(189);n(187),r.Mode={default:["dragBlank","collapse","spreadout","buttonPointer","wheelZoom"],none:[]},i.registNode("tree-node",{style:function(){return{fillOpacity:1}}},"rect"),t.exports=r},function(t,e,n){"use strict";var i=n(1),r=n(68),a=n(24),o=n(190),s=n(7),u=n(13),c=a.Util,h=u.Util,l=function t(e){t.superclass.constructor.call(this,e)};l.ATTRS={layoutFn:r.CompactBoxTree,layoutCfg:{direction:"LR",getHGap:function(){return 40},getVGap:function(){return 10}},layout:null,grid:null,data:null,dataMap:null,showButton:!0,defaultNodeShape:"tree-node",animate:!0},i.extend(l,u),i.augment(l,{_readSource:function(t){this.source(t)},_saveSource:function(){var t=this.get("data"),e=o.clone(t,{parent:!0});return e},_createMap:function(t){var e={};return o.traverseTree(t,function(n,i){n.id||(n.id=h.guid()),i?n.parent=i:t.root=!0,e[n.id]=n}),e},layout:function t(){var t=this.get("layout"),e=this.get("data");i.isObject(t)?t.execute():i.isFunction(t)&&t(e),this.updateNodesPosition()},source:function(t){var e=this._createMap(t),n=this.get("layout"),r=void 0,a=void 0;i.isObject(n)?(n.root=t,r=n.getNodes(),a=n.getEdges()):(r=[],a=[],o.traverseTree(t,function(t,e){r.push(t),e&&a.push({id:e.id+"-"+t.id,source:e.id,target:t.id})},function(t){return t.isCollapsed})),this.set("data",t),this.set("dataMap",e),this.set("nodes",r),this.set("edges",a)},reRender:function(){var t=this.get("data");this.clearAllActived(),this.refreshFront(),this._clearInner(),this._initData(),this.source(t),this._drawInner(),this.draw()},enterAnimate:function(t,e,n){var i=h.getBBox(t,t),r=i.centerX,a=i.centerY,s=t.get("shapeCfg"),u=s.origin,l=void 0;l="node"===t.get("type")?o.getButtonPoint(u,e,r,a):o.getButtonPoint(n[u.target].model,e,r,a),c.scaleIn(t,l.x,l.y,r,a)},leaveAnimate:function(t,e,n){var i=h.getBBox(t,t),r=i.centerX,a=i.centerY,s=t.get("shapeCfg"),u=s.origin,l=void 0;l="node"===t.get("type")?o.getButtonPoint(u,n,r,a):o.getButtonPoint(e[u.target].model,n,r,a),c.scaleOut(t,l.x,l.y)},beforeNodeDraw:function(t){var e=this,n=t.getShapeCfg(),r=e.get("layout");i.isObject(r)&&(n.direction=r.options.direction),t.addChild=function(n){return e.add(t.get("id"),n)}},afterNodeDraw:function(t){var e=this.get("showButton"),n=t.get("group"),i=t.getShapeCfg(),r=t.getKeyShape(),a=t.get("shapeObj"),u=i.origin,c=r.getBBox(),l=u.inAnchor,d=u.outAnchor,f=void 0;if(l){a.getAnchorPoints=function(){return[l,d]};var g=t.calculateAnchorPoints(c);if(!u.root&&g){switch(f=h.getpointInRectQuadrant(c,g[1])){case 0:i.buttonX=g[1].x,i.buttonY=g[1].y-s.treeButtonRadius;break;case 1:i.buttonX=g[1].x+s.treeButtonRadius,i.buttonY=g[1].y;break;case 2:i.buttonX=g[1].x,i.buttonY=g[1].y+s.treeButtonRadius;break;case 3:i.buttonX=g[1].x-s.treeButtonRadius,i.buttonY=g[1].y;break;default:i.buttonX=g[1].x,i.buttonY=g[1].y}if(u.isCollapsed?i.buttonType="plus":i.buttonType="minus",!e)return n.set("buttonX",(c.minX+c.maxX)/2),void n.set("buttonY",(c.minY+c.maxY)/2);u.children&&0!==u.children.length&&o.drawButton(i,n),n.set("buttonX",i.buttonX),n.set("buttonY",i.buttonY)}}},changeLayout:function(t){this.set("layout",t),this.reRender()},add:function(t,e){var n=this.get("dataMap"),r=n[t],a=e.id;return a||(a=i.guid(),e.id=a),i.isArray(r.children)?r.children.push(e):r.children=[e],this.reRender(),this.find(a)},remove:function(t){var e=this.get("dataMap"),n=void 0;i.isString(t)&&(t=e[t]);var r=t.parent;return r?(n=r.children,r.children=i.filter(n,function(e){return t!==e})):this.source({}),this.reRender(),this},update:function(t,e){return l.superclass.updateItem.call(this,t,e),this.reRender(),t},_checkData:function(t){return t&&i.isObject(t)&&h.objectToValues(t).length>0}}),t.exports=l},function(t,e,n){"use strict";var i="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},r=n(1),a=n(13),o=n(7),s=a.Util,u={traverseTree:function(t,e,n,i){var a=t.children;e(t,i),n&&n(t)||a&&r.each(a,function(i){u.traverseTree(i,e,n,t)})},getButtonPoint:function(t,e,n,i){for(var r=t.parent,a=void 0;t&&r&&!e[r.id];)r=r.parent;return r?(a=e[r.id].origin,s.applyPoint({x:a.get("buttonX"),y:a.get("buttonY")},a)):{x:n,y:i}},clone:function(t,e){var n=void 0;if(r.isArray(t)){n=[];for(var a=0,o=t.length;a<o;a++)"object"===i(t[a])&&null!==t[a]?n[a]=u.clone(t[a],e):n[a]=t[a]}else{n={};for(var s in t)e[s]||("object"===i(t[s])&&null!==t[s]?n[s]=u.clone(t[s],e):n[s]=t[s])}return n},drawButton:function(t,e){"plus"===t.buttonType?u.drawspreadoutButton(t.buttonX,t.buttonY,o.treeButtonRadius,o.treeButtonPadding,e):u.drawcollapseButton(t.buttonX,t.buttonY,o.treeButtonRadius,o.treeButtonPadding,e)},drawspreadoutButton:function(t,e,n,i,a){var s=n-i,u=a.addShape("path",{attrs:r.mix({},{path:[["M",0,0-n],["a",n,n,0,1,1,0,2*n],["a",n,n,0,1,1,0,-2*n],["z"],["M",0-s,0],["L",0+s,0],["M",0,0-s],["L",0,0+s]]},o.treeButtonStyle),clickActive:!1,class:"spreadoutButton"});return u.translate(t,e),u},drawcollapseButton:function(t,e,n,i,a){var s=n-i,u=a.addShape("path",{attrs:r.mix({},{path:[["M",0,0-n],["a",n,n,0,1,1,0,2*n],["a",n,n,0,1,1,0,-2*n],["z"],["M",0-s,0],["L",0+s,0]]},o.treeButtonStyle),clickActive:!1,class:"collapseButton"});return u.translate(t,e),u}};t.exports=u}])});
    </script>
    <script>
        /*! jQuery v3.2.1 | (c) JS Foundation and other contributors | jquery.org/license */
!function(a,b){"use strict";"object"==typeof module&&"object"==typeof module.exports?module.exports=a.document?b(a,!0):function(a){if(!a.document)throw new Error("jQuery requires a window with a document");return b(a)}:b(a)}("undefined"!=typeof window?window:this,function(a,b){"use strict";var c=[],d=a.document,e=Object.getPrototypeOf,f=c.slice,g=c.concat,h=c.push,i=c.indexOf,j={},k=j.toString,l=j.hasOwnProperty,m=l.toString,n=m.call(Object),o={};function p(a,b){b=b||d;var c=b.createElement("script");c.text=a,b.head.appendChild(c).parentNode.removeChild(c)}var q="3.2.1",r=function(a,b){return new r.fn.init(a,b)},s=/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,t=/^-ms-/,u=/-([a-z])/g,v=function(a,b){return b.toUpperCase()};r.fn=r.prototype={jquery:q,constructor:r,length:0,toArray:function(){return f.call(this)},get:function(a){return null==a?f.call(this):a<0?this[a+this.length]:this[a]},pushStack:function(a){var b=r.merge(this.constructor(),a);return b.prevObject=this,b},each:function(a){return r.each(this,a)},map:function(a){return this.pushStack(r.map(this,function(b,c){return a.call(b,c,b)}))},slice:function(){return this.pushStack(f.apply(this,arguments))},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},eq:function(a){var b=this.length,c=+a+(a<0?b:0);return this.pushStack(c>=0&&c<b?[this[c]]:[])},end:function(){return this.prevObject||this.constructor()},push:h,sort:c.sort,splice:c.splice},r.extend=r.fn.extend=function(){var a,b,c,d,e,f,g=arguments[0]||{},h=1,i=arguments.length,j=!1;for("boolean"==typeof g&&(j=g,g=arguments[h]||{},h++),"object"==typeof g||r.isFunction(g)||(g={}),h===i&&(g=this,h--);h<i;h++)if(null!=(a=arguments[h]))for(b in a)c=g[b],d=a[b],g!==d&&(j&&d&&(r.isPlainObject(d)||(e=Array.isArray(d)))?(e?(e=!1,f=c&&Array.isArray(c)?c:[]):f=c&&r.isPlainObject(c)?c:{},g[b]=r.extend(j,f,d)):void 0!==d&&(g[b]=d));return g},r.extend({expando:"jQuery"+(q+Math.random()).replace(/\D/g,""),isReady:!0,error:function(a){throw new Error(a)},noop:function(){},isFunction:function(a){return"function"===r.type(a)},isWindow:function(a){return null!=a&&a===a.window},isNumeric:function(a){var b=r.type(a);return("number"===b||"string"===b)&&!isNaN(a-parseFloat(a))},isPlainObject:function(a){var b,c;return!(!a||"[object Object]"!==k.call(a))&&(!(b=e(a))||(c=l.call(b,"constructor")&&b.constructor,"function"==typeof c&&m.call(c)===n))},isEmptyObject:function(a){var b;for(b in a)return!1;return!0},type:function(a){return null==a?a+"":"object"==typeof a||"function"==typeof a?j[k.call(a)]||"object":typeof a},globalEval:function(a){p(a)},camelCase:function(a){return a.replace(t,"ms-").replace(u,v)},each:function(a,b){var c,d=0;if(w(a)){for(c=a.length;d<c;d++)if(b.call(a[d],d,a[d])===!1)break}else for(d in a)if(b.call(a[d],d,a[d])===!1)break;return a},trim:function(a){return null==a?"":(a+"").replace(s,"")},makeArray:function(a,b){var c=b||[];return null!=a&&(w(Object(a))?r.merge(c,"string"==typeof a?[a]:a):h.call(c,a)),c},inArray:function(a,b,c){return null==b?-1:i.call(b,a,c)},merge:function(a,b){for(var c=+b.length,d=0,e=a.length;d<c;d++)a[e++]=b[d];return a.length=e,a},grep:function(a,b,c){for(var d,e=[],f=0,g=a.length,h=!c;f<g;f++)d=!b(a[f],f),d!==h&&e.push(a[f]);return e},map:function(a,b,c){var d,e,f=0,h=[];if(w(a))for(d=a.length;f<d;f++)e=b(a[f],f,c),null!=e&&h.push(e);else for(f in a)e=b(a[f],f,c),null!=e&&h.push(e);return g.apply([],h)},guid:1,proxy:function(a,b){var c,d,e;if("string"==typeof b&&(c=a[b],b=a,a=c),r.isFunction(a))return d=f.call(arguments,2),e=function(){return a.apply(b||this,d.concat(f.call(arguments)))},e.guid=a.guid=a.guid||r.guid++,e},now:Date.now,support:o}),"function"==typeof Symbol&&(r.fn[Symbol.iterator]=c[Symbol.iterator]),r.each("Boolean Number String Function Array Date RegExp Object Error Symbol".split(" "),function(a,b){j["[object "+b+"]"]=b.toLowerCase()});function w(a){var b=!!a&&"length"in a&&a.length,c=r.type(a);return"function"!==c&&!r.isWindow(a)&&("array"===c||0===b||"number"==typeof b&&b>0&&b-1 in a)}var x=function(a){var b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u="sizzle"+1*new Date,v=a.document,w=0,x=0,y=ha(),z=ha(),A=ha(),B=function(a,b){return a===b&&(l=!0),0},C={}.hasOwnProperty,D=[],E=D.pop,F=D.push,G=D.push,H=D.slice,I=function(a,b){for(var c=0,d=a.length;c<d;c++)if(a[c]===b)return c;return-1},J="checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped",K="[\\x20\\t\\r\\n\\f]",L="(?:\\\\.|[\\w-]|[^\0-\\xa0])+",M="\\["+K+"*("+L+")(?:"+K+"*([*^$|!~]?=)"+K+"*(?:'((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\"|("+L+"))|)"+K+"*\\]",N=":("+L+")(?:\\((('((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\")|((?:\\\\.|[^\\\\()[\\]]|"+M+")*)|.*)\\)|)",O=new RegExp(K+"+","g"),P=new RegExp("^"+K+"+|((?:^|[^\\\\])(?:\\\\.)*)"+K+"+$","g"),Q=new RegExp("^"+K+"*,"+K+"*"),R=new RegExp("^"+K+"*([>+~]|"+K+")"+K+"*"),S=new RegExp("="+K+"*([^\\]'\"]*?)"+K+"*\\]","g"),T=new RegExp(N),U=new RegExp("^"+L+"$"),V={ID:new RegExp("^#("+L+")"),CLASS:new RegExp("^\\.("+L+")"),TAG:new RegExp("^("+L+"|[*])"),ATTR:new RegExp("^"+M),PSEUDO:new RegExp("^"+N),CHILD:new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\("+K+"*(even|odd|(([+-]|)(\\d*)n|)"+K+"*(?:([+-]|)"+K+"*(\\d+)|))"+K+"*\\)|)","i"),bool:new RegExp("^(?:"+J+")$","i"),needsContext:new RegExp("^"+K+"*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\("+K+"*((?:-\\d)?\\d*)"+K+"*\\)|)(?=[^-]|$)","i")},W=/^(?:input|select|textarea|button)$/i,X=/^h\d$/i,Y=/^[^{]+\{\s*\[native \w/,Z=/^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/,$=/[+~]/,_=new RegExp("\\\\([\\da-f]{1,6}"+K+"?|("+K+")|.)","ig"),aa=function(a,b,c){var d="0x"+b-65536;return d!==d||c?b:d<0?String.fromCharCode(d+65536):String.fromCharCode(d>>10|55296,1023&d|56320)},ba=/([\0-\x1f\x7f]|^-?\d)|^-$|[^\0-\x1f\x7f-\uFFFF\w-]/g,ca=function(a,b){return b?"\0"===a?"\ufffd":a.slice(0,-1)+"\\"+a.charCodeAt(a.length-1).toString(16)+" ":"\\"+a},da=function(){m()},ea=ta(function(a){return a.disabled===!0&&("form"in a||"label"in a)},{dir:"parentNode",next:"legend"});try{G.apply(D=H.call(v.childNodes),v.childNodes),D[v.childNodes.length].nodeType}catch(fa){G={apply:D.length?function(a,b){F.apply(a,H.call(b))}:function(a,b){var c=a.length,d=0;while(a[c++]=b[d++]);a.length=c-1}}}function ga(a,b,d,e){var f,h,j,k,l,o,r,s=b&&b.ownerDocument,w=b?b.nodeType:9;if(d=d||[],"string"!=typeof a||!a||1!==w&&9!==w&&11!==w)return d;if(!e&&((b?b.ownerDocument||b:v)!==n&&m(b),b=b||n,p)){if(11!==w&&(l=Z.exec(a)))if(f=l[1]){if(9===w){if(!(j=b.getElementById(f)))return d;if(j.id===f)return d.push(j),d}else if(s&&(j=s.getElementById(f))&&t(b,j)&&j.id===f)return d.push(j),d}else{if(l[2])return G.apply(d,b.getElementsByTagName(a)),d;if((f=l[3])&&c.getElementsByClassName&&b.getElementsByClassName)return G.apply(d,b.getElementsByClassName(f)),d}if(c.qsa&&!A[a+" "]&&(!q||!q.test(a))){if(1!==w)s=b,r=a;else if("object"!==b.nodeName.toLowerCase()){(k=b.getAttribute("id"))?k=k.replace(ba,ca):b.setAttribute("id",k=u),o=g(a),h=o.length;while(h--)o[h]="#"+k+" "+sa(o[h]);r=o.join(","),s=$.test(a)&&qa(b.parentNode)||b}if(r)try{return G.apply(d,s.querySelectorAll(r)),d}catch(x){}finally{k===u&&b.removeAttribute("id")}}}return i(a.replace(P,"$1"),b,d,e)}function ha(){var a=[];function b(c,e){return a.push(c+" ")>d.cacheLength&&delete b[a.shift()],b[c+" "]=e}return b}function ia(a){return a[u]=!0,a}function ja(a){var b=n.createElement("fieldset");try{return!!a(b)}catch(c){return!1}finally{b.parentNode&&b.parentNode.removeChild(b),b=null}}function ka(a,b){var c=a.split("|"),e=c.length;while(e--)d.attrHandle[c[e]]=b}function la(a,b){var c=b&&a,d=c&&1===a.nodeType&&1===b.nodeType&&a.sourceIndex-b.sourceIndex;if(d)return d;if(c)while(c=c.nextSibling)if(c===b)return-1;return a?1:-1}function ma(a){return function(b){var c=b.nodeName.toLowerCase();return"input"===c&&b.type===a}}function na(a){return function(b){var c=b.nodeName.toLowerCase();return("input"===c||"button"===c)&&b.type===a}}function oa(a){return function(b){return"form"in b?b.parentNode&&b.disabled===!1?"label"in b?"label"in b.parentNode?b.parentNode.disabled===a:b.disabled===a:b.isDisabled===a||b.isDisabled!==!a&&ea(b)===a:b.disabled===a:"label"in b&&b.disabled===a}}function pa(a){return ia(function(b){return b=+b,ia(function(c,d){var e,f=a([],c.length,b),g=f.length;while(g--)c[e=f[g]]&&(c[e]=!(d[e]=c[e]))})})}function qa(a){return a&&"undefined"!=typeof a.getElementsByTagName&&a}c=ga.support={},f=ga.isXML=function(a){var b=a&&(a.ownerDocument||a).documentElement;return!!b&&"HTML"!==b.nodeName},m=ga.setDocument=function(a){var b,e,g=a?a.ownerDocument||a:v;return g!==n&&9===g.nodeType&&g.documentElement?(n=g,o=n.documentElement,p=!f(n),v!==n&&(e=n.defaultView)&&e.top!==e&&(e.addEventListener?e.addEventListener("unload",da,!1):e.attachEvent&&e.attachEvent("onunload",da)),c.attributes=ja(function(a){return a.className="i",!a.getAttribute("className")}),c.getElementsByTagName=ja(function(a){return a.appendChild(n.createComment("")),!a.getElementsByTagName("*").length}),c.getElementsByClassName=Y.test(n.getElementsByClassName),c.getById=ja(function(a){return o.appendChild(a).id=u,!n.getElementsByName||!n.getElementsByName(u).length}),c.getById?(d.filter.ID=function(a){var b=a.replace(_,aa);return function(a){return a.getAttribute("id")===b}},d.find.ID=function(a,b){if("undefined"!=typeof b.getElementById&&p){var c=b.getElementById(a);return c?[c]:[]}}):(d.filter.ID=function(a){var b=a.replace(_,aa);return function(a){var c="undefined"!=typeof a.getAttributeNode&&a.getAttributeNode("id");return c&&c.value===b}},d.find.ID=function(a,b){if("undefined"!=typeof b.getElementById&&p){var c,d,e,f=b.getElementById(a);if(f){if(c=f.getAttributeNode("id"),c&&c.value===a)return[f];e=b.getElementsByName(a),d=0;while(f=e[d++])if(c=f.getAttributeNode("id"),c&&c.value===a)return[f]}return[]}}),d.find.TAG=c.getElementsByTagName?function(a,b){return"undefined"!=typeof b.getElementsByTagName?b.getElementsByTagName(a):c.qsa?b.querySelectorAll(a):void 0}:function(a,b){var c,d=[],e=0,f=b.getElementsByTagName(a);if("*"===a){while(c=f[e++])1===c.nodeType&&d.push(c);return d}return f},d.find.CLASS=c.getElementsByClassName&&function(a,b){if("undefined"!=typeof b.getElementsByClassName&&p)return b.getElementsByClassName(a)},r=[],q=[],(c.qsa=Y.test(n.querySelectorAll))&&(ja(function(a){o.appendChild(a).innerHTML="<a id='"+u+"'></a><select id='"+u+"-\r\\' msallowcapture=''><option selected=''></option></select>",a.querySelectorAll("[msallowcapture^='']").length&&q.push("[*^$]="+K+"*(?:''|\"\")"),a.querySelectorAll("[selected]").length||q.push("\\["+K+"*(?:value|"+J+")"),a.querySelectorAll("[id~="+u+"-]").length||q.push("~="),a.querySelectorAll(":checked").length||q.push(":checked"),a.querySelectorAll("a#"+u+"+*").length||q.push(".#.+[+~]")}),ja(function(a){a.innerHTML="<a href='' disabled='disabled'></a><select disabled='disabled'><option/></select>";var b=n.createElement("input");b.setAttribute("type","hidden"),a.appendChild(b).setAttribute("name","D"),a.querySelectorAll("[name=d]").length&&q.push("name"+K+"*[*^$|!~]?="),2!==a.querySelectorAll(":enabled").length&&q.push(":enabled",":disabled"),o.appendChild(a).disabled=!0,2!==a.querySelectorAll(":disabled").length&&q.push(":enabled",":disabled"),a.querySelectorAll("*,:x"),q.push(",.*:")})),(c.matchesSelector=Y.test(s=o.matches||o.webkitMatchesSelector||o.mozMatchesSelector||o.oMatchesSelector||o.msMatchesSelector))&&ja(function(a){c.disconnectedMatch=s.call(a,"*"),s.call(a,"[s!='']:x"),r.push("!=",N)}),q=q.length&&new RegExp(q.join("|")),r=r.length&&new RegExp(r.join("|")),b=Y.test(o.compareDocumentPosition),t=b||Y.test(o.contains)?function(a,b){var c=9===a.nodeType?a.documentElement:a,d=b&&b.parentNode;return a===d||!(!d||1!==d.nodeType||!(c.contains?c.contains(d):a.compareDocumentPosition&&16&a.compareDocumentPosition(d)))}:function(a,b){if(b)while(b=b.parentNode)if(b===a)return!0;return!1},B=b?function(a,b){if(a===b)return l=!0,0;var d=!a.compareDocumentPosition-!b.compareDocumentPosition;return d?d:(d=(a.ownerDocument||a)===(b.ownerDocument||b)?a.compareDocumentPosition(b):1,1&d||!c.sortDetached&&b.compareDocumentPosition(a)===d?a===n||a.ownerDocument===v&&t(v,a)?-1:b===n||b.ownerDocument===v&&t(v,b)?1:k?I(k,a)-I(k,b):0:4&d?-1:1)}:function(a,b){if(a===b)return l=!0,0;var c,d=0,e=a.parentNode,f=b.parentNode,g=[a],h=[b];if(!e||!f)return a===n?-1:b===n?1:e?-1:f?1:k?I(k,a)-I(k,b):0;if(e===f)return la(a,b);c=a;while(c=c.parentNode)g.unshift(c);c=b;while(c=c.parentNode)h.unshift(c);while(g[d]===h[d])d++;return d?la(g[d],h[d]):g[d]===v?-1:h[d]===v?1:0},n):n},ga.matches=function(a,b){return ga(a,null,null,b)},ga.matchesSelector=function(a,b){if((a.ownerDocument||a)!==n&&m(a),b=b.replace(S,"='$1']"),c.matchesSelector&&p&&!A[b+" "]&&(!r||!r.test(b))&&(!q||!q.test(b)))try{var d=s.call(a,b);if(d||c.disconnectedMatch||a.document&&11!==a.document.nodeType)return d}catch(e){}return ga(b,n,null,[a]).length>0},ga.contains=function(a,b){return(a.ownerDocument||a)!==n&&m(a),t(a,b)},ga.attr=function(a,b){(a.ownerDocument||a)!==n&&m(a);var e=d.attrHandle[b.toLowerCase()],f=e&&C.call(d.attrHandle,b.toLowerCase())?e(a,b,!p):void 0;return void 0!==f?f:c.attributes||!p?a.getAttribute(b):(f=a.getAttributeNode(b))&&f.specified?f.value:null},ga.escape=function(a){return(a+"").replace(ba,ca)},ga.error=function(a){throw new Error("Syntax error, unrecognized expression: "+a)},ga.uniqueSort=function(a){var b,d=[],e=0,f=0;if(l=!c.detectDuplicates,k=!c.sortStable&&a.slice(0),a.sort(B),l){while(b=a[f++])b===a[f]&&(e=d.push(f));while(e--)a.splice(d[e],1)}return k=null,a},e=ga.getText=function(a){var b,c="",d=0,f=a.nodeType;if(f){if(1===f||9===f||11===f){if("string"==typeof a.textContent)return a.textContent;for(a=a.firstChild;a;a=a.nextSibling)c+=e(a)}else if(3===f||4===f)return a.nodeValue}else while(b=a[d++])c+=e(b);return c},d=ga.selectors={cacheLength:50,createPseudo:ia,match:V,attrHandle:{},find:{},relative:{">":{dir:"parentNode",first:!0}," ":{dir:"parentNode"},"+":{dir:"previousSibling",first:!0},"~":{dir:"previousSibling"}},preFilter:{ATTR:function(a){return a[1]=a[1].replace(_,aa),a[3]=(a[3]||a[4]||a[5]||"").replace(_,aa),"~="===a[2]&&(a[3]=" "+a[3]+" "),a.slice(0,4)},CHILD:function(a){return a[1]=a[1].toLowerCase(),"nth"===a[1].slice(0,3)?(a[3]||ga.error(a[0]),a[4]=+(a[4]?a[5]+(a[6]||1):2*("even"===a[3]||"odd"===a[3])),a[5]=+(a[7]+a[8]||"odd"===a[3])):a[3]&&ga.error(a[0]),a},PSEUDO:function(a){var b,c=!a[6]&&a[2];return V.CHILD.test(a[0])?null:(a[3]?a[2]=a[4]||a[5]||"":c&&T.test(c)&&(b=g(c,!0))&&(b=c.indexOf(")",c.length-b)-c.length)&&(a[0]=a[0].slice(0,b),a[2]=c.slice(0,b)),a.slice(0,3))}},filter:{TAG:function(a){var b=a.replace(_,aa).toLowerCase();return"*"===a?function(){return!0}:function(a){return a.nodeName&&a.nodeName.toLowerCase()===b}},CLASS:function(a){var b=y[a+" "];return b||(b=new RegExp("(^|"+K+")"+a+"("+K+"|$)"))&&y(a,function(a){return b.test("string"==typeof a.className&&a.className||"undefined"!=typeof a.getAttribute&&a.getAttribute("class")||"")})},ATTR:function(a,b,c){return function(d){var e=ga.attr(d,a);return null==e?"!="===b:!b||(e+="","="===b?e===c:"!="===b?e!==c:"^="===b?c&&0===e.indexOf(c):"*="===b?c&&e.indexOf(c)>-1:"$="===b?c&&e.slice(-c.length)===c:"~="===b?(" "+e.replace(O," ")+" ").indexOf(c)>-1:"|="===b&&(e===c||e.slice(0,c.length+1)===c+"-"))}},CHILD:function(a,b,c,d,e){var f="nth"!==a.slice(0,3),g="last"!==a.slice(-4),h="of-type"===b;return 1===d&&0===e?function(a){return!!a.parentNode}:function(b,c,i){var j,k,l,m,n,o,p=f!==g?"nextSibling":"previousSibling",q=b.parentNode,r=h&&b.nodeName.toLowerCase(),s=!i&&!h,t=!1;if(q){if(f){while(p){m=b;while(m=m[p])if(h?m.nodeName.toLowerCase()===r:1===m.nodeType)return!1;o=p="only"===a&&!o&&"nextSibling"}return!0}if(o=[g?q.firstChild:q.lastChild],g&&s){m=q,l=m[u]||(m[u]={}),k=l[m.uniqueID]||(l[m.uniqueID]={}),j=k[a]||[],n=j[0]===w&&j[1],t=n&&j[2],m=n&&q.childNodes[n];while(m=++n&&m&&m[p]||(t=n=0)||o.pop())if(1===m.nodeType&&++t&&m===b){k[a]=[w,n,t];break}}else if(s&&(m=b,l=m[u]||(m[u]={}),k=l[m.uniqueID]||(l[m.uniqueID]={}),j=k[a]||[],n=j[0]===w&&j[1],t=n),t===!1)while(m=++n&&m&&m[p]||(t=n=0)||o.pop())if((h?m.nodeName.toLowerCase()===r:1===m.nodeType)&&++t&&(s&&(l=m[u]||(m[u]={}),k=l[m.uniqueID]||(l[m.uniqueID]={}),k[a]=[w,t]),m===b))break;return t-=e,t===d||t%d===0&&t/d>=0}}},PSEUDO:function(a,b){var c,e=d.pseudos[a]||d.setFilters[a.toLowerCase()]||ga.error("unsupported pseudo: "+a);return e[u]?e(b):e.length>1?(c=[a,a,"",b],d.setFilters.hasOwnProperty(a.toLowerCase())?ia(function(a,c){var d,f=e(a,b),g=f.length;while(g--)d=I(a,f[g]),a[d]=!(c[d]=f[g])}):function(a){return e(a,0,c)}):e}},pseudos:{not:ia(function(a){var b=[],c=[],d=h(a.replace(P,"$1"));return d[u]?ia(function(a,b,c,e){var f,g=d(a,null,e,[]),h=a.length;while(h--)(f=g[h])&&(a[h]=!(b[h]=f))}):function(a,e,f){return b[0]=a,d(b,null,f,c),b[0]=null,!c.pop()}}),has:ia(function(a){return function(b){return ga(a,b).length>0}}),contains:ia(function(a){return a=a.replace(_,aa),function(b){return(b.textContent||b.innerText||e(b)).indexOf(a)>-1}}),lang:ia(function(a){return U.test(a||"")||ga.error("unsupported lang: "+a),a=a.replace(_,aa).toLowerCase(),function(b){var c;do if(c=p?b.lang:b.getAttribute("xml:lang")||b.getAttribute("lang"))return c=c.toLowerCase(),c===a||0===c.indexOf(a+"-");while((b=b.parentNode)&&1===b.nodeType);return!1}}),target:function(b){var c=a.location&&a.location.hash;return c&&c.slice(1)===b.id},root:function(a){return a===o},focus:function(a){return a===n.activeElement&&(!n.hasFocus||n.hasFocus())&&!!(a.type||a.href||~a.tabIndex)},enabled:oa(!1),disabled:oa(!0),checked:function(a){var b=a.nodeName.toLowerCase();return"input"===b&&!!a.checked||"option"===b&&!!a.selected},selected:function(a){return a.parentNode&&a.parentNode.selectedIndex,a.selected===!0},empty:function(a){for(a=a.firstChild;a;a=a.nextSibling)if(a.nodeType<6)return!1;return!0},parent:function(a){return!d.pseudos.empty(a)},header:function(a){return X.test(a.nodeName)},input:function(a){return W.test(a.nodeName)},button:function(a){var b=a.nodeName.toLowerCase();return"input"===b&&"button"===a.type||"button"===b},text:function(a){var b;return"input"===a.nodeName.toLowerCase()&&"text"===a.type&&(null==(b=a.getAttribute("type"))||"text"===b.toLowerCase())},first:pa(function(){return[0]}),last:pa(function(a,b){return[b-1]}),eq:pa(function(a,b,c){return[c<0?c+b:c]}),even:pa(function(a,b){for(var c=0;c<b;c+=2)a.push(c);return a}),odd:pa(function(a,b){for(var c=1;c<b;c+=2)a.push(c);return a}),lt:pa(function(a,b,c){for(var d=c<0?c+b:c;--d>=0;)a.push(d);return a}),gt:pa(function(a,b,c){for(var d=c<0?c+b:c;++d<b;)a.push(d);return a})}},d.pseudos.nth=d.pseudos.eq;for(b in{radio:!0,checkbox:!0,file:!0,password:!0,image:!0})d.pseudos[b]=ma(b);for(b in{submit:!0,reset:!0})d.pseudos[b]=na(b);function ra(){}ra.prototype=d.filters=d.pseudos,d.setFilters=new ra,g=ga.tokenize=function(a,b){var c,e,f,g,h,i,j,k=z[a+" "];if(k)return b?0:k.slice(0);h=a,i=[],j=d.preFilter;while(h){c&&!(e=Q.exec(h))||(e&&(h=h.slice(e[0].length)||h),i.push(f=[])),c=!1,(e=R.exec(h))&&(c=e.shift(),f.push({value:c,type:e[0].replace(P," ")}),h=h.slice(c.length));for(g in d.filter)!(e=V[g].exec(h))||j[g]&&!(e=j[g](e))||(c=e.shift(),f.push({value:c,type:g,matches:e}),h=h.slice(c.length));if(!c)break}return b?h.length:h?ga.error(a):z(a,i).slice(0)};function sa(a){for(var b=0,c=a.length,d="";b<c;b++)d+=a[b].value;return d}function ta(a,b,c){var d=b.dir,e=b.next,f=e||d,g=c&&"parentNode"===f,h=x++;return b.first?function(b,c,e){while(b=b[d])if(1===b.nodeType||g)return a(b,c,e);return!1}:function(b,c,i){var j,k,l,m=[w,h];if(i){while(b=b[d])if((1===b.nodeType||g)&&a(b,c,i))return!0}else while(b=b[d])if(1===b.nodeType||g)if(l=b[u]||(b[u]={}),k=l[b.uniqueID]||(l[b.uniqueID]={}),e&&e===b.nodeName.toLowerCase())b=b[d]||b;else{if((j=k[f])&&j[0]===w&&j[1]===h)return m[2]=j[2];if(k[f]=m,m[2]=a(b,c,i))return!0}return!1}}function ua(a){return a.length>1?function(b,c,d){var e=a.length;while(e--)if(!a[e](b,c,d))return!1;return!0}:a[0]}function va(a,b,c){for(var d=0,e=b.length;d<e;d++)ga(a,b[d],c);return c}function wa(a,b,c,d,e){for(var f,g=[],h=0,i=a.length,j=null!=b;h<i;h++)(f=a[h])&&(c&&!c(f,d,e)||(g.push(f),j&&b.push(h)));return g}function xa(a,b,c,d,e,f){return d&&!d[u]&&(d=xa(d)),e&&!e[u]&&(e=xa(e,f)),ia(function(f,g,h,i){var j,k,l,m=[],n=[],o=g.length,p=f||va(b||"*",h.nodeType?[h]:h,[]),q=!a||!f&&b?p:wa(p,m,a,h,i),r=c?e||(f?a:o||d)?[]:g:q;if(c&&c(q,r,h,i),d){j=wa(r,n),d(j,[],h,i),k=j.length;while(k--)(l=j[k])&&(r[n[k]]=!(q[n[k]]=l))}if(f){if(e||a){if(e){j=[],k=r.length;while(k--)(l=r[k])&&j.push(q[k]=l);e(null,r=[],j,i)}k=r.length;while(k--)(l=r[k])&&(j=e?I(f,l):m[k])>-1&&(f[j]=!(g[j]=l))}}else r=wa(r===g?r.splice(o,r.length):r),e?e(null,g,r,i):G.apply(g,r)})}function ya(a){for(var b,c,e,f=a.length,g=d.relative[a[0].type],h=g||d.relative[" "],i=g?1:0,k=ta(function(a){return a===b},h,!0),l=ta(function(a){return I(b,a)>-1},h,!0),m=[function(a,c,d){var e=!g&&(d||c!==j)||((b=c).nodeType?k(a,c,d):l(a,c,d));return b=null,e}];i<f;i++)if(c=d.relative[a[i].type])m=[ta(ua(m),c)];else{if(c=d.filter[a[i].type].apply(null,a[i].matches),c[u]){for(e=++i;e<f;e++)if(d.relative[a[e].type])break;return xa(i>1&&ua(m),i>1&&sa(a.slice(0,i-1).concat({value:" "===a[i-2].type?"*":""})).replace(P,"$1"),c,i<e&&ya(a.slice(i,e)),e<f&&ya(a=a.slice(e)),e<f&&sa(a))}m.push(c)}return ua(m)}function za(a,b){var c=b.length>0,e=a.length>0,f=function(f,g,h,i,k){var l,o,q,r=0,s="0",t=f&&[],u=[],v=j,x=f||e&&d.find.TAG("*",k),y=w+=null==v?1:Math.random()||.1,z=x.length;for(k&&(j=g===n||g||k);s!==z&&null!=(l=x[s]);s++){if(e&&l){o=0,g||l.ownerDocument===n||(m(l),h=!p);while(q=a[o++])if(q(l,g||n,h)){i.push(l);break}k&&(w=y)}c&&((l=!q&&l)&&r--,f&&t.push(l))}if(r+=s,c&&s!==r){o=0;while(q=b[o++])q(t,u,g,h);if(f){if(r>0)while(s--)t[s]||u[s]||(u[s]=E.call(i));u=wa(u)}G.apply(i,u),k&&!f&&u.length>0&&r+b.length>1&&ga.uniqueSort(i)}return k&&(w=y,j=v),t};return c?ia(f):f}return h=ga.compile=function(a,b){var c,d=[],e=[],f=A[a+" "];if(!f){b||(b=g(a)),c=b.length;while(c--)f=ya(b[c]),f[u]?d.push(f):e.push(f);f=A(a,za(e,d)),f.selector=a}return f},i=ga.select=function(a,b,c,e){var f,i,j,k,l,m="function"==typeof a&&a,n=!e&&g(a=m.selector||a);if(c=c||[],1===n.length){if(i=n[0]=n[0].slice(0),i.length>2&&"ID"===(j=i[0]).type&&9===b.nodeType&&p&&d.relative[i[1].type]){if(b=(d.find.ID(j.matches[0].replace(_,aa),b)||[])[0],!b)return c;m&&(b=b.parentNode),a=a.slice(i.shift().value.length)}f=V.needsContext.test(a)?0:i.length;while(f--){if(j=i[f],d.relative[k=j.type])break;if((l=d.find[k])&&(e=l(j.matches[0].replace(_,aa),$.test(i[0].type)&&qa(b.parentNode)||b))){if(i.splice(f,1),a=e.length&&sa(i),!a)return G.apply(c,e),c;break}}}return(m||h(a,n))(e,b,!p,c,!b||$.test(a)&&qa(b.parentNode)||b),c},c.sortStable=u.split("").sort(B).join("")===u,c.detectDuplicates=!!l,m(),c.sortDetached=ja(function(a){return 1&a.compareDocumentPosition(n.createElement("fieldset"))}),ja(function(a){return a.innerHTML="<a href='#'></a>","#"===a.firstChild.getAttribute("href")})||ka("type|href|height|width",function(a,b,c){if(!c)return a.getAttribute(b,"type"===b.toLowerCase()?1:2)}),c.attributes&&ja(function(a){return a.innerHTML="<input/>",a.firstChild.setAttribute("value",""),""===a.firstChild.getAttribute("value")})||ka("value",function(a,b,c){if(!c&&"input"===a.nodeName.toLowerCase())return a.defaultValue}),ja(function(a){return null==a.getAttribute("disabled")})||ka(J,function(a,b,c){var d;if(!c)return a[b]===!0?b.toLowerCase():(d=a.getAttributeNode(b))&&d.specified?d.value:null}),ga}(a);r.find=x,r.expr=x.selectors,r.expr[":"]=r.expr.pseudos,r.uniqueSort=r.unique=x.uniqueSort,r.text=x.getText,r.isXMLDoc=x.isXML,r.contains=x.contains,r.escapeSelector=x.escape;var y=function(a,b,c){var d=[],e=void 0!==c;while((a=a[b])&&9!==a.nodeType)if(1===a.nodeType){if(e&&r(a).is(c))break;d.push(a)}return d},z=function(a,b){for(var c=[];a;a=a.nextSibling)1===a.nodeType&&a!==b&&c.push(a);return c},A=r.expr.match.needsContext;function B(a,b){return a.nodeName&&a.nodeName.toLowerCase()===b.toLowerCase()}var C=/^<([a-z][^\/\0>:\x20\t\r\n\f]*)[\x20\t\r\n\f]*\/?>(?:<\/\1>|)$/i,D=/^.[^:#\[\.,]*$/;function E(a,b,c){return r.isFunction(b)?r.grep(a,function(a,d){return!!b.call(a,d,a)!==c}):b.nodeType?r.grep(a,function(a){return a===b!==c}):"string"!=typeof b?r.grep(a,function(a){return i.call(b,a)>-1!==c}):D.test(b)?r.filter(b,a,c):(b=r.filter(b,a),r.grep(a,function(a){return i.call(b,a)>-1!==c&&1===a.nodeType}))}r.filter=function(a,b,c){var d=b[0];return c&&(a=":not("+a+")"),1===b.length&&1===d.nodeType?r.find.matchesSelector(d,a)?[d]:[]:r.find.matches(a,r.grep(b,function(a){return 1===a.nodeType}))},r.fn.extend({find:function(a){var b,c,d=this.length,e=this;if("string"!=typeof a)return this.pushStack(r(a).filter(function(){for(b=0;b<d;b++)if(r.contains(e[b],this))return!0}));for(c=this.pushStack([]),b=0;b<d;b++)r.find(a,e[b],c);return d>1?r.uniqueSort(c):c},filter:function(a){return this.pushStack(E(this,a||[],!1))},not:function(a){return this.pushStack(E(this,a||[],!0))},is:function(a){return!!E(this,"string"==typeof a&&A.test(a)?r(a):a||[],!1).length}});var F,G=/^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]+))$/,H=r.fn.init=function(a,b,c){var e,f;if(!a)return this;if(c=c||F,"string"==typeof a){if(e="<"===a[0]&&">"===a[a.length-1]&&a.length>=3?[null,a,null]:G.exec(a),!e||!e[1]&&b)return!b||b.jquery?(b||c).find(a):this.constructor(b).find(a);if(e[1]){if(b=b instanceof r?b[0]:b,r.merge(this,r.parseHTML(e[1],b&&b.nodeType?b.ownerDocument||b:d,!0)),C.test(e[1])&&r.isPlainObject(b))for(e in b)r.isFunction(this[e])?this[e](b[e]):this.attr(e,b[e]);return this}return f=d.getElementById(e[2]),f&&(this[0]=f,this.length=1),this}return a.nodeType?(this[0]=a,this.length=1,this):r.isFunction(a)?void 0!==c.ready?c.ready(a):a(r):r.makeArray(a,this)};H.prototype=r.fn,F=r(d);var I=/^(?:parents|prev(?:Until|All))/,J={children:!0,contents:!0,next:!0,prev:!0};r.fn.extend({has:function(a){var b=r(a,this),c=b.length;return this.filter(function(){for(var a=0;a<c;a++)if(r.contains(this,b[a]))return!0})},closest:function(a,b){var c,d=0,e=this.length,f=[],g="string"!=typeof a&&r(a);if(!A.test(a))for(;d<e;d++)for(c=this[d];c&&c!==b;c=c.parentNode)if(c.nodeType<11&&(g?g.index(c)>-1:1===c.nodeType&&r.find.matchesSelector(c,a))){f.push(c);break}return this.pushStack(f.length>1?r.uniqueSort(f):f)},index:function(a){return a?"string"==typeof a?i.call(r(a),this[0]):i.call(this,a.jquery?a[0]:a):this[0]&&this[0].parentNode?this.first().prevAll().length:-1},add:function(a,b){return this.pushStack(r.uniqueSort(r.merge(this.get(),r(a,b))))},addBack:function(a){return this.add(null==a?this.prevObject:this.prevObject.filter(a))}});function K(a,b){while((a=a[b])&&1!==a.nodeType);return a}r.each({parent:function(a){var b=a.parentNode;return b&&11!==b.nodeType?b:null},parents:function(a){return y(a,"parentNode")},parentsUntil:function(a,b,c){return y(a,"parentNode",c)},next:function(a){return K(a,"nextSibling")},prev:function(a){return K(a,"previousSibling")},nextAll:function(a){return y(a,"nextSibling")},prevAll:function(a){return y(a,"previousSibling")},nextUntil:function(a,b,c){return y(a,"nextSibling",c)},prevUntil:function(a,b,c){return y(a,"previousSibling",c)},siblings:function(a){return z((a.parentNode||{}).firstChild,a)},children:function(a){return z(a.firstChild)},contents:function(a){return B(a,"iframe")?a.contentDocument:(B(a,"template")&&(a=a.content||a),r.merge([],a.childNodes))}},function(a,b){r.fn[a]=function(c,d){var e=r.map(this,b,c);return"Until"!==a.slice(-5)&&(d=c),d&&"string"==typeof d&&(e=r.filter(d,e)),this.length>1&&(J[a]||r.uniqueSort(e),I.test(a)&&e.reverse()),this.pushStack(e)}});var L=/[^\x20\t\r\n\f]+/g;function M(a){var b={};return r.each(a.match(L)||[],function(a,c){b[c]=!0}),b}r.Callbacks=function(a){a="string"==typeof a?M(a):r.extend({},a);var b,c,d,e,f=[],g=[],h=-1,i=function(){for(e=e||a.once,d=b=!0;g.length;h=-1){c=g.shift();while(++h<f.length)f[h].apply(c[0],c[1])===!1&&a.stopOnFalse&&(h=f.length,c=!1)}a.memory||(c=!1),b=!1,e&&(f=c?[]:"")},j={add:function(){return f&&(c&&!b&&(h=f.length-1,g.push(c)),function d(b){r.each(b,function(b,c){r.isFunction(c)?a.unique&&j.has(c)||f.push(c):c&&c.length&&"string"!==r.type(c)&&d(c)})}(arguments),c&&!b&&i()),this},remove:function(){return r.each(arguments,function(a,b){var c;while((c=r.inArray(b,f,c))>-1)f.splice(c,1),c<=h&&h--}),this},has:function(a){return a?r.inArray(a,f)>-1:f.length>0},empty:function(){return f&&(f=[]),this},disable:function(){return e=g=[],f=c="",this},disabled:function(){return!f},lock:function(){return e=g=[],c||b||(f=c=""),this},locked:function(){return!!e},fireWith:function(a,c){return e||(c=c||[],c=[a,c.slice?c.slice():c],g.push(c),b||i()),this},fire:function(){return j.fireWith(this,arguments),this},fired:function(){return!!d}};return j};function N(a){return a}function O(a){throw a}function P(a,b,c,d){var e;try{a&&r.isFunction(e=a.promise)?e.call(a).done(b).fail(c):a&&r.isFunction(e=a.then)?e.call(a,b,c):b.apply(void 0,[a].slice(d))}catch(a){c.apply(void 0,[a])}}r.extend({Deferred:function(b){var c=[["notify","progress",r.Callbacks("memory"),r.Callbacks("memory"),2],["resolve","done",r.Callbacks("once memory"),r.Callbacks("once memory"),0,"resolved"],["reject","fail",r.Callbacks("once memory"),r.Callbacks("once memory"),1,"rejected"]],d="pending",e={state:function(){return d},always:function(){return f.done(arguments).fail(arguments),this},"catch":function(a){return e.then(null,a)},pipe:function(){var a=arguments;return r.Deferred(function(b){r.each(c,function(c,d){var e=r.isFunction(a[d[4]])&&a[d[4]];f[d[1]](function(){var a=e&&e.apply(this,arguments);a&&r.isFunction(a.promise)?a.promise().progress(b.notify).done(b.resolve).fail(b.reject):b[d[0]+"With"](this,e?[a]:arguments)})}),a=null}).promise()},then:function(b,d,e){var f=0;function g(b,c,d,e){return function(){var h=this,i=arguments,j=function(){var a,j;if(!(b<f)){if(a=d.apply(h,i),a===c.promise())throw new TypeError("Thenable self-resolution");j=a&&("object"==typeof a||"function"==typeof a)&&a.then,r.isFunction(j)?e?j.call(a,g(f,c,N,e),g(f,c,O,e)):(f++,j.call(a,g(f,c,N,e),g(f,c,O,e),g(f,c,N,c.notifyWith))):(d!==N&&(h=void 0,i=[a]),(e||c.resolveWith)(h,i))}},k=e?j:function(){try{j()}catch(a){r.Deferred.exceptionHook&&r.Deferred.exceptionHook(a,k.stackTrace),b+1>=f&&(d!==O&&(h=void 0,i=[a]),c.rejectWith(h,i))}};b?k():(r.Deferred.getStackHook&&(k.stackTrace=r.Deferred.getStackHook()),a.setTimeout(k))}}return r.Deferred(function(a){c[0][3].add(g(0,a,r.isFunction(e)?e:N,a.notifyWith)),c[1][3].add(g(0,a,r.isFunction(b)?b:N)),c[2][3].add(g(0,a,r.isFunction(d)?d:O))}).promise()},promise:function(a){return null!=a?r.extend(a,e):e}},f={};return r.each(c,function(a,b){var g=b[2],h=b[5];e[b[1]]=g.add,h&&g.add(function(){d=h},c[3-a][2].disable,c[0][2].lock),g.add(b[3].fire),f[b[0]]=function(){return f[b[0]+"With"](this===f?void 0:this,arguments),this},f[b[0]+"With"]=g.fireWith}),e.promise(f),b&&b.call(f,f),f},when:function(a){var b=arguments.length,c=b,d=Array(c),e=f.call(arguments),g=r.Deferred(),h=function(a){return function(c){d[a]=this,e[a]=arguments.length>1?f.call(arguments):c,--b||g.resolveWith(d,e)}};if(b<=1&&(P(a,g.done(h(c)).resolve,g.reject,!b),"pending"===g.state()||r.isFunction(e[c]&&e[c].then)))return g.then();while(c--)P(e[c],h(c),g.reject);return g.promise()}});var Q=/^(Eval|Internal|Range|Reference|Syntax|Type|URI)Error$/;r.Deferred.exceptionHook=function(b,c){a.console&&a.console.warn&&b&&Q.test(b.name)&&a.console.warn("jQuery.Deferred exception: "+b.message,b.stack,c)},r.readyException=function(b){a.setTimeout(function(){throw b})};var R=r.Deferred();r.fn.ready=function(a){return R.then(a)["catch"](function(a){r.readyException(a)}),this},r.extend({isReady:!1,readyWait:1,ready:function(a){(a===!0?--r.readyWait:r.isReady)||(r.isReady=!0,a!==!0&&--r.readyWait>0||R.resolveWith(d,[r]))}}),r.ready.then=R.then;function S(){d.removeEventListener("DOMContentLoaded",S),
a.removeEventListener("load",S),r.ready()}"complete"===d.readyState||"loading"!==d.readyState&&!d.documentElement.doScroll?a.setTimeout(r.ready):(d.addEventListener("DOMContentLoaded",S),a.addEventListener("load",S));var T=function(a,b,c,d,e,f,g){var h=0,i=a.length,j=null==c;if("object"===r.type(c)){e=!0;for(h in c)T(a,b,h,c[h],!0,f,g)}else if(void 0!==d&&(e=!0,r.isFunction(d)||(g=!0),j&&(g?(b.call(a,d),b=null):(j=b,b=function(a,b,c){return j.call(r(a),c)})),b))for(;h<i;h++)b(a[h],c,g?d:d.call(a[h],h,b(a[h],c)));return e?a:j?b.call(a):i?b(a[0],c):f},U=function(a){return 1===a.nodeType||9===a.nodeType||!+a.nodeType};function V(){this.expando=r.expando+V.uid++}V.uid=1,V.prototype={cache:function(a){var b=a[this.expando];return b||(b={},U(a)&&(a.nodeType?a[this.expando]=b:Object.defineProperty(a,this.expando,{value:b,configurable:!0}))),b},set:function(a,b,c){var d,e=this.cache(a);if("string"==typeof b)e[r.camelCase(b)]=c;else for(d in b)e[r.camelCase(d)]=b[d];return e},get:function(a,b){return void 0===b?this.cache(a):a[this.expando]&&a[this.expando][r.camelCase(b)]},access:function(a,b,c){return void 0===b||b&&"string"==typeof b&&void 0===c?this.get(a,b):(this.set(a,b,c),void 0!==c?c:b)},remove:function(a,b){var c,d=a[this.expando];if(void 0!==d){if(void 0!==b){Array.isArray(b)?b=b.map(r.camelCase):(b=r.camelCase(b),b=b in d?[b]:b.match(L)||[]),c=b.length;while(c--)delete d[b[c]]}(void 0===b||r.isEmptyObject(d))&&(a.nodeType?a[this.expando]=void 0:delete a[this.expando])}},hasData:function(a){var b=a[this.expando];return void 0!==b&&!r.isEmptyObject(b)}};var W=new V,X=new V,Y=/^(?:\{[\w\W]*\}|\[[\w\W]*\])$/,Z=/[A-Z]/g;function $(a){return"true"===a||"false"!==a&&("null"===a?null:a===+a+""?+a:Y.test(a)?JSON.parse(a):a)}function _(a,b,c){var d;if(void 0===c&&1===a.nodeType)if(d="data-"+b.replace(Z,"-$&").toLowerCase(),c=a.getAttribute(d),"string"==typeof c){try{c=$(c)}catch(e){}X.set(a,b,c)}else c=void 0;return c}r.extend({hasData:function(a){return X.hasData(a)||W.hasData(a)},data:function(a,b,c){return X.access(a,b,c)},removeData:function(a,b){X.remove(a,b)},_data:function(a,b,c){return W.access(a,b,c)},_removeData:function(a,b){W.remove(a,b)}}),r.fn.extend({data:function(a,b){var c,d,e,f=this[0],g=f&&f.attributes;if(void 0===a){if(this.length&&(e=X.get(f),1===f.nodeType&&!W.get(f,"hasDataAttrs"))){c=g.length;while(c--)g[c]&&(d=g[c].name,0===d.indexOf("data-")&&(d=r.camelCase(d.slice(5)),_(f,d,e[d])));W.set(f,"hasDataAttrs",!0)}return e}return"object"==typeof a?this.each(function(){X.set(this,a)}):T(this,function(b){var c;if(f&&void 0===b){if(c=X.get(f,a),void 0!==c)return c;if(c=_(f,a),void 0!==c)return c}else this.each(function(){X.set(this,a,b)})},null,b,arguments.length>1,null,!0)},removeData:function(a){return this.each(function(){X.remove(this,a)})}}),r.extend({queue:function(a,b,c){var d;if(a)return b=(b||"fx")+"queue",d=W.get(a,b),c&&(!d||Array.isArray(c)?d=W.access(a,b,r.makeArray(c)):d.push(c)),d||[]},dequeue:function(a,b){b=b||"fx";var c=r.queue(a,b),d=c.length,e=c.shift(),f=r._queueHooks(a,b),g=function(){r.dequeue(a,b)};"inprogress"===e&&(e=c.shift(),d--),e&&("fx"===b&&c.unshift("inprogress"),delete f.stop,e.call(a,g,f)),!d&&f&&f.empty.fire()},_queueHooks:function(a,b){var c=b+"queueHooks";return W.get(a,c)||W.access(a,c,{empty:r.Callbacks("once memory").add(function(){W.remove(a,[b+"queue",c])})})}}),r.fn.extend({queue:function(a,b){var c=2;return"string"!=typeof a&&(b=a,a="fx",c--),arguments.length<c?r.queue(this[0],a):void 0===b?this:this.each(function(){var c=r.queue(this,a,b);r._queueHooks(this,a),"fx"===a&&"inprogress"!==c[0]&&r.dequeue(this,a)})},dequeue:function(a){return this.each(function(){r.dequeue(this,a)})},clearQueue:function(a){return this.queue(a||"fx",[])},promise:function(a,b){var c,d=1,e=r.Deferred(),f=this,g=this.length,h=function(){--d||e.resolveWith(f,[f])};"string"!=typeof a&&(b=a,a=void 0),a=a||"fx";while(g--)c=W.get(f[g],a+"queueHooks"),c&&c.empty&&(d++,c.empty.add(h));return h(),e.promise(b)}});var aa=/[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source,ba=new RegExp("^(?:([+-])=|)("+aa+")([a-z%]*)$","i"),ca=["Top","Right","Bottom","Left"],da=function(a,b){return a=b||a,"none"===a.style.display||""===a.style.display&&r.contains(a.ownerDocument,a)&&"none"===r.css(a,"display")},ea=function(a,b,c,d){var e,f,g={};for(f in b)g[f]=a.style[f],a.style[f]=b[f];e=c.apply(a,d||[]);for(f in b)a.style[f]=g[f];return e};function fa(a,b,c,d){var e,f=1,g=20,h=d?function(){return d.cur()}:function(){return r.css(a,b,"")},i=h(),j=c&&c[3]||(r.cssNumber[b]?"":"px"),k=(r.cssNumber[b]||"px"!==j&&+i)&&ba.exec(r.css(a,b));if(k&&k[3]!==j){j=j||k[3],c=c||[],k=+i||1;do f=f||".5",k/=f,r.style(a,b,k+j);while(f!==(f=h()/i)&&1!==f&&--g)}return c&&(k=+k||+i||0,e=c[1]?k+(c[1]+1)*c[2]:+c[2],d&&(d.unit=j,d.start=k,d.end=e)),e}var ga={};function ha(a){var b,c=a.ownerDocument,d=a.nodeName,e=ga[d];return e?e:(b=c.body.appendChild(c.createElement(d)),e=r.css(b,"display"),b.parentNode.removeChild(b),"none"===e&&(e="block"),ga[d]=e,e)}function ia(a,b){for(var c,d,e=[],f=0,g=a.length;f<g;f++)d=a[f],d.style&&(c=d.style.display,b?("none"===c&&(e[f]=W.get(d,"display")||null,e[f]||(d.style.display="")),""===d.style.display&&da(d)&&(e[f]=ha(d))):"none"!==c&&(e[f]="none",W.set(d,"display",c)));for(f=0;f<g;f++)null!=e[f]&&(a[f].style.display=e[f]);return a}r.fn.extend({show:function(){return ia(this,!0)},hide:function(){return ia(this)},toggle:function(a){return"boolean"==typeof a?a?this.show():this.hide():this.each(function(){da(this)?r(this).show():r(this).hide()})}});var ja=/^(?:checkbox|radio)$/i,ka=/<([a-z][^\/\0>\x20\t\r\n\f]+)/i,la=/^$|\/(?:java|ecma)script/i,ma={option:[1,"<select multiple='multiple'>","</select>"],thead:[1,"<table>","</table>"],col:[2,"<table><colgroup>","</colgroup></table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],_default:[0,"",""]};ma.optgroup=ma.option,ma.tbody=ma.tfoot=ma.colgroup=ma.caption=ma.thead,ma.th=ma.td;function na(a,b){var c;return c="undefined"!=typeof a.getElementsByTagName?a.getElementsByTagName(b||"*"):"undefined"!=typeof a.querySelectorAll?a.querySelectorAll(b||"*"):[],void 0===b||b&&B(a,b)?r.merge([a],c):c}function oa(a,b){for(var c=0,d=a.length;c<d;c++)W.set(a[c],"globalEval",!b||W.get(b[c],"globalEval"))}var pa=/<|&#?\w+;/;function qa(a,b,c,d,e){for(var f,g,h,i,j,k,l=b.createDocumentFragment(),m=[],n=0,o=a.length;n<o;n++)if(f=a[n],f||0===f)if("object"===r.type(f))r.merge(m,f.nodeType?[f]:f);else if(pa.test(f)){g=g||l.appendChild(b.createElement("div")),h=(ka.exec(f)||["",""])[1].toLowerCase(),i=ma[h]||ma._default,g.innerHTML=i[1]+r.htmlPrefilter(f)+i[2],k=i[0];while(k--)g=g.lastChild;r.merge(m,g.childNodes),g=l.firstChild,g.textContent=""}else m.push(b.createTextNode(f));l.textContent="",n=0;while(f=m[n++])if(d&&r.inArray(f,d)>-1)e&&e.push(f);else if(j=r.contains(f.ownerDocument,f),g=na(l.appendChild(f),"script"),j&&oa(g),c){k=0;while(f=g[k++])la.test(f.type||"")&&c.push(f)}return l}!function(){var a=d.createDocumentFragment(),b=a.appendChild(d.createElement("div")),c=d.createElement("input");c.setAttribute("type","radio"),c.setAttribute("checked","checked"),c.setAttribute("name","t"),b.appendChild(c),o.checkClone=b.cloneNode(!0).cloneNode(!0).lastChild.checked,b.innerHTML="<textarea>x</textarea>",o.noCloneChecked=!!b.cloneNode(!0).lastChild.defaultValue}();var ra=d.documentElement,sa=/^key/,ta=/^(?:mouse|pointer|contextmenu|drag|drop)|click/,ua=/^([^.]*)(?:\.(.+)|)/;function va(){return!0}function wa(){return!1}function xa(){try{return d.activeElement}catch(a){}}function ya(a,b,c,d,e,f){var g,h;if("object"==typeof b){"string"!=typeof c&&(d=d||c,c=void 0);for(h in b)ya(a,h,c,d,b[h],f);return a}if(null==d&&null==e?(e=c,d=c=void 0):null==e&&("string"==typeof c?(e=d,d=void 0):(e=d,d=c,c=void 0)),e===!1)e=wa;else if(!e)return a;return 1===f&&(g=e,e=function(a){return r().off(a),g.apply(this,arguments)},e.guid=g.guid||(g.guid=r.guid++)),a.each(function(){r.event.add(this,b,e,d,c)})}r.event={global:{},add:function(a,b,c,d,e){var f,g,h,i,j,k,l,m,n,o,p,q=W.get(a);if(q){c.handler&&(f=c,c=f.handler,e=f.selector),e&&r.find.matchesSelector(ra,e),c.guid||(c.guid=r.guid++),(i=q.events)||(i=q.events={}),(g=q.handle)||(g=q.handle=function(b){return"undefined"!=typeof r&&r.event.triggered!==b.type?r.event.dispatch.apply(a,arguments):void 0}),b=(b||"").match(L)||[""],j=b.length;while(j--)h=ua.exec(b[j])||[],n=p=h[1],o=(h[2]||"").split(".").sort(),n&&(l=r.event.special[n]||{},n=(e?l.delegateType:l.bindType)||n,l=r.event.special[n]||{},k=r.extend({type:n,origType:p,data:d,handler:c,guid:c.guid,selector:e,needsContext:e&&r.expr.match.needsContext.test(e),namespace:o.join(".")},f),(m=i[n])||(m=i[n]=[],m.delegateCount=0,l.setup&&l.setup.call(a,d,o,g)!==!1||a.addEventListener&&a.addEventListener(n,g)),l.add&&(l.add.call(a,k),k.handler.guid||(k.handler.guid=c.guid)),e?m.splice(m.delegateCount++,0,k):m.push(k),r.event.global[n]=!0)}},remove:function(a,b,c,d,e){var f,g,h,i,j,k,l,m,n,o,p,q=W.hasData(a)&&W.get(a);if(q&&(i=q.events)){b=(b||"").match(L)||[""],j=b.length;while(j--)if(h=ua.exec(b[j])||[],n=p=h[1],o=(h[2]||"").split(".").sort(),n){l=r.event.special[n]||{},n=(d?l.delegateType:l.bindType)||n,m=i[n]||[],h=h[2]&&new RegExp("(^|\\.)"+o.join("\\.(?:.*\\.|)")+"(\\.|$)"),g=f=m.length;while(f--)k=m[f],!e&&p!==k.origType||c&&c.guid!==k.guid||h&&!h.test(k.namespace)||d&&d!==k.selector&&("**"!==d||!k.selector)||(m.splice(f,1),k.selector&&m.delegateCount--,l.remove&&l.remove.call(a,k));g&&!m.length&&(l.teardown&&l.teardown.call(a,o,q.handle)!==!1||r.removeEvent(a,n,q.handle),delete i[n])}else for(n in i)r.event.remove(a,n+b[j],c,d,!0);r.isEmptyObject(i)&&W.remove(a,"handle events")}},dispatch:function(a){var b=r.event.fix(a),c,d,e,f,g,h,i=new Array(arguments.length),j=(W.get(this,"events")||{})[b.type]||[],k=r.event.special[b.type]||{};for(i[0]=b,c=1;c<arguments.length;c++)i[c]=arguments[c];if(b.delegateTarget=this,!k.preDispatch||k.preDispatch.call(this,b)!==!1){h=r.event.handlers.call(this,b,j),c=0;while((f=h[c++])&&!b.isPropagationStopped()){b.currentTarget=f.elem,d=0;while((g=f.handlers[d++])&&!b.isImmediatePropagationStopped())b.rnamespace&&!b.rnamespace.test(g.namespace)||(b.handleObj=g,b.data=g.data,e=((r.event.special[g.origType]||{}).handle||g.handler).apply(f.elem,i),void 0!==e&&(b.result=e)===!1&&(b.preventDefault(),b.stopPropagation()))}return k.postDispatch&&k.postDispatch.call(this,b),b.result}},handlers:function(a,b){var c,d,e,f,g,h=[],i=b.delegateCount,j=a.target;if(i&&j.nodeType&&!("click"===a.type&&a.button>=1))for(;j!==this;j=j.parentNode||this)if(1===j.nodeType&&("click"!==a.type||j.disabled!==!0)){for(f=[],g={},c=0;c<i;c++)d=b[c],e=d.selector+" ",void 0===g[e]&&(g[e]=d.needsContext?r(e,this).index(j)>-1:r.find(e,this,null,[j]).length),g[e]&&f.push(d);f.length&&h.push({elem:j,handlers:f})}return j=this,i<b.length&&h.push({elem:j,handlers:b.slice(i)}),h},addProp:function(a,b){Object.defineProperty(r.Event.prototype,a,{enumerable:!0,configurable:!0,get:r.isFunction(b)?function(){if(this.originalEvent)return b(this.originalEvent)}:function(){if(this.originalEvent)return this.originalEvent[a]},set:function(b){Object.defineProperty(this,a,{enumerable:!0,configurable:!0,writable:!0,value:b})}})},fix:function(a){return a[r.expando]?a:new r.Event(a)},special:{load:{noBubble:!0},focus:{trigger:function(){if(this!==xa()&&this.focus)return this.focus(),!1},delegateType:"focusin"},blur:{trigger:function(){if(this===xa()&&this.blur)return this.blur(),!1},delegateType:"focusout"},click:{trigger:function(){if("checkbox"===this.type&&this.click&&B(this,"input"))return this.click(),!1},_default:function(a){return B(a.target,"a")}},beforeunload:{postDispatch:function(a){void 0!==a.result&&a.originalEvent&&(a.originalEvent.returnValue=a.result)}}}},r.removeEvent=function(a,b,c){a.removeEventListener&&a.removeEventListener(b,c)},r.Event=function(a,b){return this instanceof r.Event?(a&&a.type?(this.originalEvent=a,this.type=a.type,this.isDefaultPrevented=a.defaultPrevented||void 0===a.defaultPrevented&&a.returnValue===!1?va:wa,this.target=a.target&&3===a.target.nodeType?a.target.parentNode:a.target,this.currentTarget=a.currentTarget,this.relatedTarget=a.relatedTarget):this.type=a,b&&r.extend(this,b),this.timeStamp=a&&a.timeStamp||r.now(),void(this[r.expando]=!0)):new r.Event(a,b)},r.Event.prototype={constructor:r.Event,isDefaultPrevented:wa,isPropagationStopped:wa,isImmediatePropagationStopped:wa,isSimulated:!1,preventDefault:function(){var a=this.originalEvent;this.isDefaultPrevented=va,a&&!this.isSimulated&&a.preventDefault()},stopPropagation:function(){var a=this.originalEvent;this.isPropagationStopped=va,a&&!this.isSimulated&&a.stopPropagation()},stopImmediatePropagation:function(){var a=this.originalEvent;this.isImmediatePropagationStopped=va,a&&!this.isSimulated&&a.stopImmediatePropagation(),this.stopPropagation()}},r.each({altKey:!0,bubbles:!0,cancelable:!0,changedTouches:!0,ctrlKey:!0,detail:!0,eventPhase:!0,metaKey:!0,pageX:!0,pageY:!0,shiftKey:!0,view:!0,"char":!0,charCode:!0,key:!0,keyCode:!0,button:!0,buttons:!0,clientX:!0,clientY:!0,offsetX:!0,offsetY:!0,pointerId:!0,pointerType:!0,screenX:!0,screenY:!0,targetTouches:!0,toElement:!0,touches:!0,which:function(a){var b=a.button;return null==a.which&&sa.test(a.type)?null!=a.charCode?a.charCode:a.keyCode:!a.which&&void 0!==b&&ta.test(a.type)?1&b?1:2&b?3:4&b?2:0:a.which}},r.event.addProp),r.each({mouseenter:"mouseover",mouseleave:"mouseout",pointerenter:"pointerover",pointerleave:"pointerout"},function(a,b){r.event.special[a]={delegateType:b,bindType:b,handle:function(a){var c,d=this,e=a.relatedTarget,f=a.handleObj;return e&&(e===d||r.contains(d,e))||(a.type=f.origType,c=f.handler.apply(this,arguments),a.type=b),c}}}),r.fn.extend({on:function(a,b,c,d){return ya(this,a,b,c,d)},one:function(a,b,c,d){return ya(this,a,b,c,d,1)},off:function(a,b,c){var d,e;if(a&&a.preventDefault&&a.handleObj)return d=a.handleObj,r(a.delegateTarget).off(d.namespace?d.origType+"."+d.namespace:d.origType,d.selector,d.handler),this;if("object"==typeof a){for(e in a)this.off(e,b,a[e]);return this}return b!==!1&&"function"!=typeof b||(c=b,b=void 0),c===!1&&(c=wa),this.each(function(){r.event.remove(this,a,c,b)})}});var za=/<(?!area|br|col|embed|hr|img|input|link|meta|param)(([a-z][^\/\0>\x20\t\r\n\f]*)[^>]*)\/>/gi,Aa=/<script|<style|<link/i,Ba=/checked\s*(?:[^=]|=\s*.checked.)/i,Ca=/^true\/(.*)/,Da=/^\s*<!(?:\[CDATA\[|--)|(?:\]\]|--)>\s*$/g;function Ea(a,b){return B(a,"table")&&B(11!==b.nodeType?b:b.firstChild,"tr")?r(">tbody",a)[0]||a:a}function Fa(a){return a.type=(null!==a.getAttribute("type"))+"/"+a.type,a}function Ga(a){var b=Ca.exec(a.type);return b?a.type=b[1]:a.removeAttribute("type"),a}function Ha(a,b){var c,d,e,f,g,h,i,j;if(1===b.nodeType){if(W.hasData(a)&&(f=W.access(a),g=W.set(b,f),j=f.events)){delete g.handle,g.events={};for(e in j)for(c=0,d=j[e].length;c<d;c++)r.event.add(b,e,j[e][c])}X.hasData(a)&&(h=X.access(a),i=r.extend({},h),X.set(b,i))}}function Ia(a,b){var c=b.nodeName.toLowerCase();"input"===c&&ja.test(a.type)?b.checked=a.checked:"input"!==c&&"textarea"!==c||(b.defaultValue=a.defaultValue)}function Ja(a,b,c,d){b=g.apply([],b);var e,f,h,i,j,k,l=0,m=a.length,n=m-1,q=b[0],s=r.isFunction(q);if(s||m>1&&"string"==typeof q&&!o.checkClone&&Ba.test(q))return a.each(function(e){var f=a.eq(e);s&&(b[0]=q.call(this,e,f.html())),Ja(f,b,c,d)});if(m&&(e=qa(b,a[0].ownerDocument,!1,a,d),f=e.firstChild,1===e.childNodes.length&&(e=f),f||d)){for(h=r.map(na(e,"script"),Fa),i=h.length;l<m;l++)j=e,l!==n&&(j=r.clone(j,!0,!0),i&&r.merge(h,na(j,"script"))),c.call(a[l],j,l);if(i)for(k=h[h.length-1].ownerDocument,r.map(h,Ga),l=0;l<i;l++)j=h[l],la.test(j.type||"")&&!W.access(j,"globalEval")&&r.contains(k,j)&&(j.src?r._evalUrl&&r._evalUrl(j.src):p(j.textContent.replace(Da,""),k))}return a}function Ka(a,b,c){for(var d,e=b?r.filter(b,a):a,f=0;null!=(d=e[f]);f++)c||1!==d.nodeType||r.cleanData(na(d)),d.parentNode&&(c&&r.contains(d.ownerDocument,d)&&oa(na(d,"script")),d.parentNode.removeChild(d));return a}r.extend({htmlPrefilter:function(a){return a.replace(za,"<$1></$2>")},clone:function(a,b,c){var d,e,f,g,h=a.cloneNode(!0),i=r.contains(a.ownerDocument,a);if(!(o.noCloneChecked||1!==a.nodeType&&11!==a.nodeType||r.isXMLDoc(a)))for(g=na(h),f=na(a),d=0,e=f.length;d<e;d++)Ia(f[d],g[d]);if(b)if(c)for(f=f||na(a),g=g||na(h),d=0,e=f.length;d<e;d++)Ha(f[d],g[d]);else Ha(a,h);return g=na(h,"script"),g.length>0&&oa(g,!i&&na(a,"script")),h},cleanData:function(a){for(var b,c,d,e=r.event.special,f=0;void 0!==(c=a[f]);f++)if(U(c)){if(b=c[W.expando]){if(b.events)for(d in b.events)e[d]?r.event.remove(c,d):r.removeEvent(c,d,b.handle);c[W.expando]=void 0}c[X.expando]&&(c[X.expando]=void 0)}}}),r.fn.extend({detach:function(a){return Ka(this,a,!0)},remove:function(a){return Ka(this,a)},text:function(a){return T(this,function(a){return void 0===a?r.text(this):this.empty().each(function(){1!==this.nodeType&&11!==this.nodeType&&9!==this.nodeType||(this.textContent=a)})},null,a,arguments.length)},append:function(){return Ja(this,arguments,function(a){if(1===this.nodeType||11===this.nodeType||9===this.nodeType){var b=Ea(this,a);b.appendChild(a)}})},prepend:function(){return Ja(this,arguments,function(a){if(1===this.nodeType||11===this.nodeType||9===this.nodeType){var b=Ea(this,a);b.insertBefore(a,b.firstChild)}})},before:function(){return Ja(this,arguments,function(a){this.parentNode&&this.parentNode.insertBefore(a,this)})},after:function(){return Ja(this,arguments,function(a){this.parentNode&&this.parentNode.insertBefore(a,this.nextSibling)})},empty:function(){for(var a,b=0;null!=(a=this[b]);b++)1===a.nodeType&&(r.cleanData(na(a,!1)),a.textContent="");return this},clone:function(a,b){return a=null!=a&&a,b=null==b?a:b,this.map(function(){return r.clone(this,a,b)})},html:function(a){return T(this,function(a){var b=this[0]||{},c=0,d=this.length;if(void 0===a&&1===b.nodeType)return b.innerHTML;if("string"==typeof a&&!Aa.test(a)&&!ma[(ka.exec(a)||["",""])[1].toLowerCase()]){a=r.htmlPrefilter(a);try{for(;c<d;c++)b=this[c]||{},1===b.nodeType&&(r.cleanData(na(b,!1)),b.innerHTML=a);b=0}catch(e){}}b&&this.empty().append(a)},null,a,arguments.length)},replaceWith:function(){var a=[];return Ja(this,arguments,function(b){var c=this.parentNode;r.inArray(this,a)<0&&(r.cleanData(na(this)),c&&c.replaceChild(b,this))},a)}}),r.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(a,b){r.fn[a]=function(a){for(var c,d=[],e=r(a),f=e.length-1,g=0;g<=f;g++)c=g===f?this:this.clone(!0),r(e[g])[b](c),h.apply(d,c.get());return this.pushStack(d)}});var La=/^margin/,Ma=new RegExp("^("+aa+")(?!px)[a-z%]+$","i"),Na=function(b){var c=b.ownerDocument.defaultView;return c&&c.opener||(c=a),c.getComputedStyle(b)};!function(){function b(){if(i){i.style.cssText="box-sizing:border-box;position:relative;display:block;margin:auto;border:1px;padding:1px;top:1%;width:50%",i.innerHTML="",ra.appendChild(h);var b=a.getComputedStyle(i);c="1%"!==b.top,g="2px"===b.marginLeft,e="4px"===b.width,i.style.marginRight="50%",f="4px"===b.marginRight,ra.removeChild(h),i=null}}var c,e,f,g,h=d.createElement("div"),i=d.createElement("div");i.style&&(i.style.backgroundClip="content-box",i.cloneNode(!0).style.backgroundClip="",o.clearCloneStyle="content-box"===i.style.backgroundClip,h.style.cssText="border:0;width:8px;height:0;top:0;left:-9999px;padding:0;margin-top:1px;position:absolute",h.appendChild(i),r.extend(o,{pixelPosition:function(){return b(),c},boxSizingReliable:function(){return b(),e},pixelMarginRight:function(){return b(),f},reliableMarginLeft:function(){return b(),g}}))}();function Oa(a,b,c){var d,e,f,g,h=a.style;return c=c||Na(a),c&&(g=c.getPropertyValue(b)||c[b],""!==g||r.contains(a.ownerDocument,a)||(g=r.style(a,b)),!o.pixelMarginRight()&&Ma.test(g)&&La.test(b)&&(d=h.width,e=h.minWidth,f=h.maxWidth,h.minWidth=h.maxWidth=h.width=g,g=c.width,h.width=d,h.minWidth=e,h.maxWidth=f)),void 0!==g?g+"":g}function Pa(a,b){return{get:function(){return a()?void delete this.get:(this.get=b).apply(this,arguments)}}}var Qa=/^(none|table(?!-c[ea]).+)/,Ra=/^--/,Sa={position:"absolute",visibility:"hidden",display:"block"},Ta={letterSpacing:"0",fontWeight:"400"},Ua=["Webkit","Moz","ms"],Va=d.createElement("div").style;function Wa(a){if(a in Va)return a;var b=a[0].toUpperCase()+a.slice(1),c=Ua.length;while(c--)if(a=Ua[c]+b,a in Va)return a}function Xa(a){var b=r.cssProps[a];return b||(b=r.cssProps[a]=Wa(a)||a),b}function Ya(a,b,c){var d=ba.exec(b);return d?Math.max(0,d[2]-(c||0))+(d[3]||"px"):b}function Za(a,b,c,d,e){var f,g=0;for(f=c===(d?"border":"content")?4:"width"===b?1:0;f<4;f+=2)"margin"===c&&(g+=r.css(a,c+ca[f],!0,e)),d?("content"===c&&(g-=r.css(a,"padding"+ca[f],!0,e)),"margin"!==c&&(g-=r.css(a,"border"+ca[f]+"Width",!0,e))):(g+=r.css(a,"padding"+ca[f],!0,e),"padding"!==c&&(g+=r.css(a,"border"+ca[f]+"Width",!0,e)));return g}function $a(a,b,c){var d,e=Na(a),f=Oa(a,b,e),g="border-box"===r.css(a,"boxSizing",!1,e);return Ma.test(f)?f:(d=g&&(o.boxSizingReliable()||f===a.style[b]),"auto"===f&&(f=a["offset"+b[0].toUpperCase()+b.slice(1)]),f=parseFloat(f)||0,f+Za(a,b,c||(g?"border":"content"),d,e)+"px")}r.extend({cssHooks:{opacity:{get:function(a,b){if(b){var c=Oa(a,"opacity");return""===c?"1":c}}}},cssNumber:{animationIterationCount:!0,columnCount:!0,fillOpacity:!0,flexGrow:!0,flexShrink:!0,fontWeight:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,widows:!0,zIndex:!0,zoom:!0},cssProps:{"float":"cssFloat"},style:function(a,b,c,d){if(a&&3!==a.nodeType&&8!==a.nodeType&&a.style){var e,f,g,h=r.camelCase(b),i=Ra.test(b),j=a.style;return i||(b=Xa(h)),g=r.cssHooks[b]||r.cssHooks[h],void 0===c?g&&"get"in g&&void 0!==(e=g.get(a,!1,d))?e:j[b]:(f=typeof c,"string"===f&&(e=ba.exec(c))&&e[1]&&(c=fa(a,b,e),f="number"),null!=c&&c===c&&("number"===f&&(c+=e&&e[3]||(r.cssNumber[h]?"":"px")),o.clearCloneStyle||""!==c||0!==b.indexOf("background")||(j[b]="inherit"),g&&"set"in g&&void 0===(c=g.set(a,c,d))||(i?j.setProperty(b,c):j[b]=c)),void 0)}},css:function(a,b,c,d){var e,f,g,h=r.camelCase(b),i=Ra.test(b);return i||(b=Xa(h)),g=r.cssHooks[b]||r.cssHooks[h],g&&"get"in g&&(e=g.get(a,!0,c)),void 0===e&&(e=Oa(a,b,d)),"normal"===e&&b in Ta&&(e=Ta[b]),""===c||c?(f=parseFloat(e),c===!0||isFinite(f)?f||0:e):e}}),r.each(["height","width"],function(a,b){r.cssHooks[b]={get:function(a,c,d){if(c)return!Qa.test(r.css(a,"display"))||a.getClientRects().length&&a.getBoundingClientRect().width?$a(a,b,d):ea(a,Sa,function(){return $a(a,b,d)})},set:function(a,c,d){var e,f=d&&Na(a),g=d&&Za(a,b,d,"border-box"===r.css(a,"boxSizing",!1,f),f);return g&&(e=ba.exec(c))&&"px"!==(e[3]||"px")&&(a.style[b]=c,c=r.css(a,b)),Ya(a,c,g)}}}),r.cssHooks.marginLeft=Pa(o.reliableMarginLeft,function(a,b){if(b)return(parseFloat(Oa(a,"marginLeft"))||a.getBoundingClientRect().left-ea(a,{marginLeft:0},function(){return a.getBoundingClientRect().left}))+"px"}),r.each({margin:"",padding:"",border:"Width"},function(a,b){r.cssHooks[a+b]={expand:function(c){for(var d=0,e={},f="string"==typeof c?c.split(" "):[c];d<4;d++)e[a+ca[d]+b]=f[d]||f[d-2]||f[0];return e}},La.test(a)||(r.cssHooks[a+b].set=Ya)}),r.fn.extend({css:function(a,b){return T(this,function(a,b,c){var d,e,f={},g=0;if(Array.isArray(b)){for(d=Na(a),e=b.length;g<e;g++)f[b[g]]=r.css(a,b[g],!1,d);return f}return void 0!==c?r.style(a,b,c):r.css(a,b)},a,b,arguments.length>1)}});function _a(a,b,c,d,e){return new _a.prototype.init(a,b,c,d,e)}r.Tween=_a,_a.prototype={constructor:_a,init:function(a,b,c,d,e,f){this.elem=a,this.prop=c,this.easing=e||r.easing._default,this.options=b,this.start=this.now=this.cur(),this.end=d,this.unit=f||(r.cssNumber[c]?"":"px")},cur:function(){var a=_a.propHooks[this.prop];return a&&a.get?a.get(this):_a.propHooks._default.get(this)},run:function(a){var b,c=_a.propHooks[this.prop];return this.options.duration?this.pos=b=r.easing[this.easing](a,this.options.duration*a,0,1,this.options.duration):this.pos=b=a,this.now=(this.end-this.start)*b+this.start,this.options.step&&this.options.step.call(this.elem,this.now,this),c&&c.set?c.set(this):_a.propHooks._default.set(this),this}},_a.prototype.init.prototype=_a.prototype,_a.propHooks={_default:{get:function(a){var b;return 1!==a.elem.nodeType||null!=a.elem[a.prop]&&null==a.elem.style[a.prop]?a.elem[a.prop]:(b=r.css(a.elem,a.prop,""),b&&"auto"!==b?b:0)},set:function(a){r.fx.step[a.prop]?r.fx.step[a.prop](a):1!==a.elem.nodeType||null==a.elem.style[r.cssProps[a.prop]]&&!r.cssHooks[a.prop]?a.elem[a.prop]=a.now:r.style(a.elem,a.prop,a.now+a.unit)}}},_a.propHooks.scrollTop=_a.propHooks.scrollLeft={set:function(a){a.elem.nodeType&&a.elem.parentNode&&(a.elem[a.prop]=a.now)}},r.easing={linear:function(a){return a},swing:function(a){return.5-Math.cos(a*Math.PI)/2},_default:"swing"},r.fx=_a.prototype.init,r.fx.step={};var ab,bb,cb=/^(?:toggle|show|hide)$/,db=/queueHooks$/;function eb(){bb&&(d.hidden===!1&&a.requestAnimationFrame?a.requestAnimationFrame(eb):a.setTimeout(eb,r.fx.interval),r.fx.tick())}function fb(){return a.setTimeout(function(){ab=void 0}),ab=r.now()}function gb(a,b){var c,d=0,e={height:a};for(b=b?1:0;d<4;d+=2-b)c=ca[d],e["margin"+c]=e["padding"+c]=a;return b&&(e.opacity=e.width=a),e}function hb(a,b,c){for(var d,e=(kb.tweeners[b]||[]).concat(kb.tweeners["*"]),f=0,g=e.length;f<g;f++)if(d=e[f].call(c,b,a))return d}function ib(a,b,c){var d,e,f,g,h,i,j,k,l="width"in b||"height"in b,m=this,n={},o=a.style,p=a.nodeType&&da(a),q=W.get(a,"fxshow");c.queue||(g=r._queueHooks(a,"fx"),null==g.unqueued&&(g.unqueued=0,h=g.empty.fire,g.empty.fire=function(){g.unqueued||h()}),g.unqueued++,m.always(function(){m.always(function(){g.unqueued--,r.queue(a,"fx").length||g.empty.fire()})}));for(d in b)if(e=b[d],cb.test(e)){if(delete b[d],f=f||"toggle"===e,e===(p?"hide":"show")){if("show"!==e||!q||void 0===q[d])continue;p=!0}n[d]=q&&q[d]||r.style(a,d)}if(i=!r.isEmptyObject(b),i||!r.isEmptyObject(n)){l&&1===a.nodeType&&(c.overflow=[o.overflow,o.overflowX,o.overflowY],j=q&&q.display,null==j&&(j=W.get(a,"display")),k=r.css(a,"display"),"none"===k&&(j?k=j:(ia([a],!0),j=a.style.display||j,k=r.css(a,"display"),ia([a]))),("inline"===k||"inline-block"===k&&null!=j)&&"none"===r.css(a,"float")&&(i||(m.done(function(){o.display=j}),null==j&&(k=o.display,j="none"===k?"":k)),o.display="inline-block")),c.overflow&&(o.overflow="hidden",m.always(function(){o.overflow=c.overflow[0],o.overflowX=c.overflow[1],o.overflowY=c.overflow[2]})),i=!1;for(d in n)i||(q?"hidden"in q&&(p=q.hidden):q=W.access(a,"fxshow",{display:j}),f&&(q.hidden=!p),p&&ia([a],!0),m.done(function(){p||ia([a]),W.remove(a,"fxshow");for(d in n)r.style(a,d,n[d])})),i=hb(p?q[d]:0,d,m),d in q||(q[d]=i.start,p&&(i.end=i.start,i.start=0))}}function jb(a,b){var c,d,e,f,g;for(c in a)if(d=r.camelCase(c),e=b[d],f=a[c],Array.isArray(f)&&(e=f[1],f=a[c]=f[0]),c!==d&&(a[d]=f,delete a[c]),g=r.cssHooks[d],g&&"expand"in g){f=g.expand(f),delete a[d];for(c in f)c in a||(a[c]=f[c],b[c]=e)}else b[d]=e}function kb(a,b,c){var d,e,f=0,g=kb.prefilters.length,h=r.Deferred().always(function(){delete i.elem}),i=function(){if(e)return!1;for(var b=ab||fb(),c=Math.max(0,j.startTime+j.duration-b),d=c/j.duration||0,f=1-d,g=0,i=j.tweens.length;g<i;g++)j.tweens[g].run(f);return h.notifyWith(a,[j,f,c]),f<1&&i?c:(i||h.notifyWith(a,[j,1,0]),h.resolveWith(a,[j]),!1)},j=h.promise({elem:a,props:r.extend({},b),opts:r.extend(!0,{specialEasing:{},easing:r.easing._default},c),originalProperties:b,originalOptions:c,startTime:ab||fb(),duration:c.duration,tweens:[],createTween:function(b,c){var d=r.Tween(a,j.opts,b,c,j.opts.specialEasing[b]||j.opts.easing);return j.tweens.push(d),d},stop:function(b){var c=0,d=b?j.tweens.length:0;if(e)return this;for(e=!0;c<d;c++)j.tweens[c].run(1);return b?(h.notifyWith(a,[j,1,0]),h.resolveWith(a,[j,b])):h.rejectWith(a,[j,b]),this}}),k=j.props;for(jb(k,j.opts.specialEasing);f<g;f++)if(d=kb.prefilters[f].call(j,a,k,j.opts))return r.isFunction(d.stop)&&(r._queueHooks(j.elem,j.opts.queue).stop=r.proxy(d.stop,d)),d;return r.map(k,hb,j),r.isFunction(j.opts.start)&&j.opts.start.call(a,j),j.progress(j.opts.progress).done(j.opts.done,j.opts.complete).fail(j.opts.fail).always(j.opts.always),r.fx.timer(r.extend(i,{elem:a,anim:j,queue:j.opts.queue})),j}r.Animation=r.extend(kb,{tweeners:{"*":[function(a,b){var c=this.createTween(a,b);return fa(c.elem,a,ba.exec(b),c),c}]},tweener:function(a,b){r.isFunction(a)?(b=a,a=["*"]):a=a.match(L);for(var c,d=0,e=a.length;d<e;d++)c=a[d],kb.tweeners[c]=kb.tweeners[c]||[],kb.tweeners[c].unshift(b)},prefilters:[ib],prefilter:function(a,b){b?kb.prefilters.unshift(a):kb.prefilters.push(a)}}),r.speed=function(a,b,c){var d=a&&"object"==typeof a?r.extend({},a):{complete:c||!c&&b||r.isFunction(a)&&a,duration:a,easing:c&&b||b&&!r.isFunction(b)&&b};return r.fx.off?d.duration=0:"number"!=typeof d.duration&&(d.duration in r.fx.speeds?d.duration=r.fx.speeds[d.duration]:d.duration=r.fx.speeds._default),null!=d.queue&&d.queue!==!0||(d.queue="fx"),d.old=d.complete,d.complete=function(){r.isFunction(d.old)&&d.old.call(this),d.queue&&r.dequeue(this,d.queue)},d},r.fn.extend({fadeTo:function(a,b,c,d){return this.filter(da).css("opacity",0).show().end().animate({opacity:b},a,c,d)},animate:function(a,b,c,d){var e=r.isEmptyObject(a),f=r.speed(b,c,d),g=function(){var b=kb(this,r.extend({},a),f);(e||W.get(this,"finish"))&&b.stop(!0)};return g.finish=g,e||f.queue===!1?this.each(g):this.queue(f.queue,g)},stop:function(a,b,c){var d=function(a){var b=a.stop;delete a.stop,b(c)};return"string"!=typeof a&&(c=b,b=a,a=void 0),b&&a!==!1&&this.queue(a||"fx",[]),this.each(function(){var b=!0,e=null!=a&&a+"queueHooks",f=r.timers,g=W.get(this);if(e)g[e]&&g[e].stop&&d(g[e]);else for(e in g)g[e]&&g[e].stop&&db.test(e)&&d(g[e]);for(e=f.length;e--;)f[e].elem!==this||null!=a&&f[e].queue!==a||(f[e].anim.stop(c),b=!1,f.splice(e,1));!b&&c||r.dequeue(this,a)})},finish:function(a){return a!==!1&&(a=a||"fx"),this.each(function(){var b,c=W.get(this),d=c[a+"queue"],e=c[a+"queueHooks"],f=r.timers,g=d?d.length:0;for(c.finish=!0,r.queue(this,a,[]),e&&e.stop&&e.stop.call(this,!0),b=f.length;b--;)f[b].elem===this&&f[b].queue===a&&(f[b].anim.stop(!0),f.splice(b,1));for(b=0;b<g;b++)d[b]&&d[b].finish&&d[b].finish.call(this);delete c.finish})}}),r.each(["toggle","show","hide"],function(a,b){var c=r.fn[b];r.fn[b]=function(a,d,e){return null==a||"boolean"==typeof a?c.apply(this,arguments):this.animate(gb(b,!0),a,d,e)}}),r.each({slideDown:gb("show"),slideUp:gb("hide"),slideToggle:gb("toggle"),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"},fadeToggle:{opacity:"toggle"}},function(a,b){r.fn[a]=function(a,c,d){return this.animate(b,a,c,d)}}),r.timers=[],r.fx.tick=function(){var a,b=0,c=r.timers;for(ab=r.now();b<c.length;b++)a=c[b],a()||c[b]!==a||c.splice(b--,1);c.length||r.fx.stop(),ab=void 0},r.fx.timer=function(a){r.timers.push(a),r.fx.start()},r.fx.interval=13,r.fx.start=function(){bb||(bb=!0,eb())},r.fx.stop=function(){bb=null},r.fx.speeds={slow:600,fast:200,_default:400},r.fn.delay=function(b,c){return b=r.fx?r.fx.speeds[b]||b:b,c=c||"fx",this.queue(c,function(c,d){var e=a.setTimeout(c,b);d.stop=function(){a.clearTimeout(e)}})},function(){var a=d.createElement("input"),b=d.createElement("select"),c=b.appendChild(d.createElement("option"));a.type="checkbox",o.checkOn=""!==a.value,o.optSelected=c.selected,a=d.createElement("input"),a.value="t",a.type="radio",o.radioValue="t"===a.value}();var lb,mb=r.expr.attrHandle;r.fn.extend({attr:function(a,b){return T(this,r.attr,a,b,arguments.length>1)},removeAttr:function(a){return this.each(function(){r.removeAttr(this,a)})}}),r.extend({attr:function(a,b,c){var d,e,f=a.nodeType;if(3!==f&&8!==f&&2!==f)return"undefined"==typeof a.getAttribute?r.prop(a,b,c):(1===f&&r.isXMLDoc(a)||(e=r.attrHooks[b.toLowerCase()]||(r.expr.match.bool.test(b)?lb:void 0)),void 0!==c?null===c?void r.removeAttr(a,b):e&&"set"in e&&void 0!==(d=e.set(a,c,b))?d:(a.setAttribute(b,c+""),c):e&&"get"in e&&null!==(d=e.get(a,b))?d:(d=r.find.attr(a,b),
null==d?void 0:d))},attrHooks:{type:{set:function(a,b){if(!o.radioValue&&"radio"===b&&B(a,"input")){var c=a.value;return a.setAttribute("type",b),c&&(a.value=c),b}}}},removeAttr:function(a,b){var c,d=0,e=b&&b.match(L);if(e&&1===a.nodeType)while(c=e[d++])a.removeAttribute(c)}}),lb={set:function(a,b,c){return b===!1?r.removeAttr(a,c):a.setAttribute(c,c),c}},r.each(r.expr.match.bool.source.match(/\w+/g),function(a,b){var c=mb[b]||r.find.attr;mb[b]=function(a,b,d){var e,f,g=b.toLowerCase();return d||(f=mb[g],mb[g]=e,e=null!=c(a,b,d)?g:null,mb[g]=f),e}});var nb=/^(?:input|select|textarea|button)$/i,ob=/^(?:a|area)$/i;r.fn.extend({prop:function(a,b){return T(this,r.prop,a,b,arguments.length>1)},removeProp:function(a){return this.each(function(){delete this[r.propFix[a]||a]})}}),r.extend({prop:function(a,b,c){var d,e,f=a.nodeType;if(3!==f&&8!==f&&2!==f)return 1===f&&r.isXMLDoc(a)||(b=r.propFix[b]||b,e=r.propHooks[b]),void 0!==c?e&&"set"in e&&void 0!==(d=e.set(a,c,b))?d:a[b]=c:e&&"get"in e&&null!==(d=e.get(a,b))?d:a[b]},propHooks:{tabIndex:{get:function(a){var b=r.find.attr(a,"tabindex");return b?parseInt(b,10):nb.test(a.nodeName)||ob.test(a.nodeName)&&a.href?0:-1}}},propFix:{"for":"htmlFor","class":"className"}}),o.optSelected||(r.propHooks.selected={get:function(a){var b=a.parentNode;return b&&b.parentNode&&b.parentNode.selectedIndex,null},set:function(a){var b=a.parentNode;b&&(b.selectedIndex,b.parentNode&&b.parentNode.selectedIndex)}}),r.each(["tabIndex","readOnly","maxLength","cellSpacing","cellPadding","rowSpan","colSpan","useMap","frameBorder","contentEditable"],function(){r.propFix[this.toLowerCase()]=this});function pb(a){var b=a.match(L)||[];return b.join(" ")}function qb(a){return a.getAttribute&&a.getAttribute("class")||""}r.fn.extend({addClass:function(a){var b,c,d,e,f,g,h,i=0;if(r.isFunction(a))return this.each(function(b){r(this).addClass(a.call(this,b,qb(this)))});if("string"==typeof a&&a){b=a.match(L)||[];while(c=this[i++])if(e=qb(c),d=1===c.nodeType&&" "+pb(e)+" "){g=0;while(f=b[g++])d.indexOf(" "+f+" ")<0&&(d+=f+" ");h=pb(d),e!==h&&c.setAttribute("class",h)}}return this},removeClass:function(a){var b,c,d,e,f,g,h,i=0;if(r.isFunction(a))return this.each(function(b){r(this).removeClass(a.call(this,b,qb(this)))});if(!arguments.length)return this.attr("class","");if("string"==typeof a&&a){b=a.match(L)||[];while(c=this[i++])if(e=qb(c),d=1===c.nodeType&&" "+pb(e)+" "){g=0;while(f=b[g++])while(d.indexOf(" "+f+" ")>-1)d=d.replace(" "+f+" "," ");h=pb(d),e!==h&&c.setAttribute("class",h)}}return this},toggleClass:function(a,b){var c=typeof a;return"boolean"==typeof b&&"string"===c?b?this.addClass(a):this.removeClass(a):r.isFunction(a)?this.each(function(c){r(this).toggleClass(a.call(this,c,qb(this),b),b)}):this.each(function(){var b,d,e,f;if("string"===c){d=0,e=r(this),f=a.match(L)||[];while(b=f[d++])e.hasClass(b)?e.removeClass(b):e.addClass(b)}else void 0!==a&&"boolean"!==c||(b=qb(this),b&&W.set(this,"__className__",b),this.setAttribute&&this.setAttribute("class",b||a===!1?"":W.get(this,"__className__")||""))})},hasClass:function(a){var b,c,d=0;b=" "+a+" ";while(c=this[d++])if(1===c.nodeType&&(" "+pb(qb(c))+" ").indexOf(b)>-1)return!0;return!1}});var rb=/\r/g;r.fn.extend({val:function(a){var b,c,d,e=this[0];{if(arguments.length)return d=r.isFunction(a),this.each(function(c){var e;1===this.nodeType&&(e=d?a.call(this,c,r(this).val()):a,null==e?e="":"number"==typeof e?e+="":Array.isArray(e)&&(e=r.map(e,function(a){return null==a?"":a+""})),b=r.valHooks[this.type]||r.valHooks[this.nodeName.toLowerCase()],b&&"set"in b&&void 0!==b.set(this,e,"value")||(this.value=e))});if(e)return b=r.valHooks[e.type]||r.valHooks[e.nodeName.toLowerCase()],b&&"get"in b&&void 0!==(c=b.get(e,"value"))?c:(c=e.value,"string"==typeof c?c.replace(rb,""):null==c?"":c)}}}),r.extend({valHooks:{option:{get:function(a){var b=r.find.attr(a,"value");return null!=b?b:pb(r.text(a))}},select:{get:function(a){var b,c,d,e=a.options,f=a.selectedIndex,g="select-one"===a.type,h=g?null:[],i=g?f+1:e.length;for(d=f<0?i:g?f:0;d<i;d++)if(c=e[d],(c.selected||d===f)&&!c.disabled&&(!c.parentNode.disabled||!B(c.parentNode,"optgroup"))){if(b=r(c).val(),g)return b;h.push(b)}return h},set:function(a,b){var c,d,e=a.options,f=r.makeArray(b),g=e.length;while(g--)d=e[g],(d.selected=r.inArray(r.valHooks.option.get(d),f)>-1)&&(c=!0);return c||(a.selectedIndex=-1),f}}}}),r.each(["radio","checkbox"],function(){r.valHooks[this]={set:function(a,b){if(Array.isArray(b))return a.checked=r.inArray(r(a).val(),b)>-1}},o.checkOn||(r.valHooks[this].get=function(a){return null===a.getAttribute("value")?"on":a.value})});var sb=/^(?:focusinfocus|focusoutblur)$/;r.extend(r.event,{trigger:function(b,c,e,f){var g,h,i,j,k,m,n,o=[e||d],p=l.call(b,"type")?b.type:b,q=l.call(b,"namespace")?b.namespace.split("."):[];if(h=i=e=e||d,3!==e.nodeType&&8!==e.nodeType&&!sb.test(p+r.event.triggered)&&(p.indexOf(".")>-1&&(q=p.split("."),p=q.shift(),q.sort()),k=p.indexOf(":")<0&&"on"+p,b=b[r.expando]?b:new r.Event(p,"object"==typeof b&&b),b.isTrigger=f?2:3,b.namespace=q.join("."),b.rnamespace=b.namespace?new RegExp("(^|\\.)"+q.join("\\.(?:.*\\.|)")+"(\\.|$)"):null,b.result=void 0,b.target||(b.target=e),c=null==c?[b]:r.makeArray(c,[b]),n=r.event.special[p]||{},f||!n.trigger||n.trigger.apply(e,c)!==!1)){if(!f&&!n.noBubble&&!r.isWindow(e)){for(j=n.delegateType||p,sb.test(j+p)||(h=h.parentNode);h;h=h.parentNode)o.push(h),i=h;i===(e.ownerDocument||d)&&o.push(i.defaultView||i.parentWindow||a)}g=0;while((h=o[g++])&&!b.isPropagationStopped())b.type=g>1?j:n.bindType||p,m=(W.get(h,"events")||{})[b.type]&&W.get(h,"handle"),m&&m.apply(h,c),m=k&&h[k],m&&m.apply&&U(h)&&(b.result=m.apply(h,c),b.result===!1&&b.preventDefault());return b.type=p,f||b.isDefaultPrevented()||n._default&&n._default.apply(o.pop(),c)!==!1||!U(e)||k&&r.isFunction(e[p])&&!r.isWindow(e)&&(i=e[k],i&&(e[k]=null),r.event.triggered=p,e[p](),r.event.triggered=void 0,i&&(e[k]=i)),b.result}},simulate:function(a,b,c){var d=r.extend(new r.Event,c,{type:a,isSimulated:!0});r.event.trigger(d,null,b)}}),r.fn.extend({trigger:function(a,b){return this.each(function(){r.event.trigger(a,b,this)})},triggerHandler:function(a,b){var c=this[0];if(c)return r.event.trigger(a,b,c,!0)}}),r.each("blur focus focusin focusout resize scroll click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup contextmenu".split(" "),function(a,b){r.fn[b]=function(a,c){return arguments.length>0?this.on(b,null,a,c):this.trigger(b)}}),r.fn.extend({hover:function(a,b){return this.mouseenter(a).mouseleave(b||a)}}),o.focusin="onfocusin"in a,o.focusin||r.each({focus:"focusin",blur:"focusout"},function(a,b){var c=function(a){r.event.simulate(b,a.target,r.event.fix(a))};r.event.special[b]={setup:function(){var d=this.ownerDocument||this,e=W.access(d,b);e||d.addEventListener(a,c,!0),W.access(d,b,(e||0)+1)},teardown:function(){var d=this.ownerDocument||this,e=W.access(d,b)-1;e?W.access(d,b,e):(d.removeEventListener(a,c,!0),W.remove(d,b))}}});var tb=a.location,ub=r.now(),vb=/\?/;r.parseXML=function(b){var c;if(!b||"string"!=typeof b)return null;try{c=(new a.DOMParser).parseFromString(b,"text/xml")}catch(d){c=void 0}return c&&!c.getElementsByTagName("parsererror").length||r.error("Invalid XML: "+b),c};var wb=/\[\]$/,xb=/\r?\n/g,yb=/^(?:submit|button|image|reset|file)$/i,zb=/^(?:input|select|textarea|keygen)/i;function Ab(a,b,c,d){var e;if(Array.isArray(b))r.each(b,function(b,e){c||wb.test(a)?d(a,e):Ab(a+"["+("object"==typeof e&&null!=e?b:"")+"]",e,c,d)});else if(c||"object"!==r.type(b))d(a,b);else for(e in b)Ab(a+"["+e+"]",b[e],c,d)}r.param=function(a,b){var c,d=[],e=function(a,b){var c=r.isFunction(b)?b():b;d[d.length]=encodeURIComponent(a)+"="+encodeURIComponent(null==c?"":c)};if(Array.isArray(a)||a.jquery&&!r.isPlainObject(a))r.each(a,function(){e(this.name,this.value)});else for(c in a)Ab(c,a[c],b,e);return d.join("&")},r.fn.extend({serialize:function(){return r.param(this.serializeArray())},serializeArray:function(){return this.map(function(){var a=r.prop(this,"elements");return a?r.makeArray(a):this}).filter(function(){var a=this.type;return this.name&&!r(this).is(":disabled")&&zb.test(this.nodeName)&&!yb.test(a)&&(this.checked||!ja.test(a))}).map(function(a,b){var c=r(this).val();return null==c?null:Array.isArray(c)?r.map(c,function(a){return{name:b.name,value:a.replace(xb,"\r\n")}}):{name:b.name,value:c.replace(xb,"\r\n")}}).get()}});var Bb=/%20/g,Cb=/#.*$/,Db=/([?&])_=[^&]*/,Eb=/^(.*?):[ \t]*([^\r\n]*)$/gm,Fb=/^(?:about|app|app-storage|.+-extension|file|res|widget):$/,Gb=/^(?:GET|HEAD)$/,Hb=/^\/\//,Ib={},Jb={},Kb="*/".concat("*"),Lb=d.createElement("a");Lb.href=tb.href;function Mb(a){return function(b,c){"string"!=typeof b&&(c=b,b="*");var d,e=0,f=b.toLowerCase().match(L)||[];if(r.isFunction(c))while(d=f[e++])"+"===d[0]?(d=d.slice(1)||"*",(a[d]=a[d]||[]).unshift(c)):(a[d]=a[d]||[]).push(c)}}function Nb(a,b,c,d){var e={},f=a===Jb;function g(h){var i;return e[h]=!0,r.each(a[h]||[],function(a,h){var j=h(b,c,d);return"string"!=typeof j||f||e[j]?f?!(i=j):void 0:(b.dataTypes.unshift(j),g(j),!1)}),i}return g(b.dataTypes[0])||!e["*"]&&g("*")}function Ob(a,b){var c,d,e=r.ajaxSettings.flatOptions||{};for(c in b)void 0!==b[c]&&((e[c]?a:d||(d={}))[c]=b[c]);return d&&r.extend(!0,a,d),a}function Pb(a,b,c){var d,e,f,g,h=a.contents,i=a.dataTypes;while("*"===i[0])i.shift(),void 0===d&&(d=a.mimeType||b.getResponseHeader("Content-Type"));if(d)for(e in h)if(h[e]&&h[e].test(d)){i.unshift(e);break}if(i[0]in c)f=i[0];else{for(e in c){if(!i[0]||a.converters[e+" "+i[0]]){f=e;break}g||(g=e)}f=f||g}if(f)return f!==i[0]&&i.unshift(f),c[f]}function Qb(a,b,c,d){var e,f,g,h,i,j={},k=a.dataTypes.slice();if(k[1])for(g in a.converters)j[g.toLowerCase()]=a.converters[g];f=k.shift();while(f)if(a.responseFields[f]&&(c[a.responseFields[f]]=b),!i&&d&&a.dataFilter&&(b=a.dataFilter(b,a.dataType)),i=f,f=k.shift())if("*"===f)f=i;else if("*"!==i&&i!==f){if(g=j[i+" "+f]||j["* "+f],!g)for(e in j)if(h=e.split(" "),h[1]===f&&(g=j[i+" "+h[0]]||j["* "+h[0]])){g===!0?g=j[e]:j[e]!==!0&&(f=h[0],k.unshift(h[1]));break}if(g!==!0)if(g&&a["throws"])b=g(b);else try{b=g(b)}catch(l){return{state:"parsererror",error:g?l:"No conversion from "+i+" to "+f}}}return{state:"success",data:b}}r.extend({active:0,lastModified:{},etag:{},ajaxSettings:{url:tb.href,type:"GET",isLocal:Fb.test(tb.protocol),global:!0,processData:!0,async:!0,contentType:"application/x-www-form-urlencoded; charset=UTF-8",accepts:{"*":Kb,text:"text/plain",html:"text/html",xml:"application/xml, text/xml",json:"application/json, text/javascript"},contents:{xml:/\bxml\b/,html:/\bhtml/,json:/\bjson\b/},responseFields:{xml:"responseXML",text:"responseText",json:"responseJSON"},converters:{"* text":String,"text html":!0,"text json":JSON.parse,"text xml":r.parseXML},flatOptions:{url:!0,context:!0}},ajaxSetup:function(a,b){return b?Ob(Ob(a,r.ajaxSettings),b):Ob(r.ajaxSettings,a)},ajaxPrefilter:Mb(Ib),ajaxTransport:Mb(Jb),ajax:function(b,c){"object"==typeof b&&(c=b,b=void 0),c=c||{};var e,f,g,h,i,j,k,l,m,n,o=r.ajaxSetup({},c),p=o.context||o,q=o.context&&(p.nodeType||p.jquery)?r(p):r.event,s=r.Deferred(),t=r.Callbacks("once memory"),u=o.statusCode||{},v={},w={},x="canceled",y={readyState:0,getResponseHeader:function(a){var b;if(k){if(!h){h={};while(b=Eb.exec(g))h[b[1].toLowerCase()]=b[2]}b=h[a.toLowerCase()]}return null==b?null:b},getAllResponseHeaders:function(){return k?g:null},setRequestHeader:function(a,b){return null==k&&(a=w[a.toLowerCase()]=w[a.toLowerCase()]||a,v[a]=b),this},overrideMimeType:function(a){return null==k&&(o.mimeType=a),this},statusCode:function(a){var b;if(a)if(k)y.always(a[y.status]);else for(b in a)u[b]=[u[b],a[b]];return this},abort:function(a){var b=a||x;return e&&e.abort(b),A(0,b),this}};if(s.promise(y),o.url=((b||o.url||tb.href)+"").replace(Hb,tb.protocol+"//"),o.type=c.method||c.type||o.method||o.type,o.dataTypes=(o.dataType||"*").toLowerCase().match(L)||[""],null==o.crossDomain){j=d.createElement("a");try{j.href=o.url,j.href=j.href,o.crossDomain=Lb.protocol+"//"+Lb.host!=j.protocol+"//"+j.host}catch(z){o.crossDomain=!0}}if(o.data&&o.processData&&"string"!=typeof o.data&&(o.data=r.param(o.data,o.traditional)),Nb(Ib,o,c,y),k)return y;l=r.event&&o.global,l&&0===r.active++&&r.event.trigger("ajaxStart"),o.type=o.type.toUpperCase(),o.hasContent=!Gb.test(o.type),f=o.url.replace(Cb,""),o.hasContent?o.data&&o.processData&&0===(o.contentType||"").indexOf("application/x-www-form-urlencoded")&&(o.data=o.data.replace(Bb,"+")):(n=o.url.slice(f.length),o.data&&(f+=(vb.test(f)?"&":"?")+o.data,delete o.data),o.cache===!1&&(f=f.replace(Db,"$1"),n=(vb.test(f)?"&":"?")+"_="+ub++ +n),o.url=f+n),o.ifModified&&(r.lastModified[f]&&y.setRequestHeader("If-Modified-Since",r.lastModified[f]),r.etag[f]&&y.setRequestHeader("If-None-Match",r.etag[f])),(o.data&&o.hasContent&&o.contentType!==!1||c.contentType)&&y.setRequestHeader("Content-Type",o.contentType),y.setRequestHeader("Accept",o.dataTypes[0]&&o.accepts[o.dataTypes[0]]?o.accepts[o.dataTypes[0]]+("*"!==o.dataTypes[0]?", "+Kb+"; q=0.01":""):o.accepts["*"]);for(m in o.headers)y.setRequestHeader(m,o.headers[m]);if(o.beforeSend&&(o.beforeSend.call(p,y,o)===!1||k))return y.abort();if(x="abort",t.add(o.complete),y.done(o.success),y.fail(o.error),e=Nb(Jb,o,c,y)){if(y.readyState=1,l&&q.trigger("ajaxSend",[y,o]),k)return y;o.async&&o.timeout>0&&(i=a.setTimeout(function(){y.abort("timeout")},o.timeout));try{k=!1,e.send(v,A)}catch(z){if(k)throw z;A(-1,z)}}else A(-1,"No Transport");function A(b,c,d,h){var j,m,n,v,w,x=c;k||(k=!0,i&&a.clearTimeout(i),e=void 0,g=h||"",y.readyState=b>0?4:0,j=b>=200&&b<300||304===b,d&&(v=Pb(o,y,d)),v=Qb(o,v,y,j),j?(o.ifModified&&(w=y.getResponseHeader("Last-Modified"),w&&(r.lastModified[f]=w),w=y.getResponseHeader("etag"),w&&(r.etag[f]=w)),204===b||"HEAD"===o.type?x="nocontent":304===b?x="notmodified":(x=v.state,m=v.data,n=v.error,j=!n)):(n=x,!b&&x||(x="error",b<0&&(b=0))),y.status=b,y.statusText=(c||x)+"",j?s.resolveWith(p,[m,x,y]):s.rejectWith(p,[y,x,n]),y.statusCode(u),u=void 0,l&&q.trigger(j?"ajaxSuccess":"ajaxError",[y,o,j?m:n]),t.fireWith(p,[y,x]),l&&(q.trigger("ajaxComplete",[y,o]),--r.active||r.event.trigger("ajaxStop")))}return y},getJSON:function(a,b,c){return r.get(a,b,c,"json")},getScript:function(a,b){return r.get(a,void 0,b,"script")}}),r.each(["get","post"],function(a,b){r[b]=function(a,c,d,e){return r.isFunction(c)&&(e=e||d,d=c,c=void 0),r.ajax(r.extend({url:a,type:b,dataType:e,data:c,success:d},r.isPlainObject(a)&&a))}}),r._evalUrl=function(a){return r.ajax({url:a,type:"GET",dataType:"script",cache:!0,async:!1,global:!1,"throws":!0})},r.fn.extend({wrapAll:function(a){var b;return this[0]&&(r.isFunction(a)&&(a=a.call(this[0])),b=r(a,this[0].ownerDocument).eq(0).clone(!0),this[0].parentNode&&b.insertBefore(this[0]),b.map(function(){var a=this;while(a.firstElementChild)a=a.firstElementChild;return a}).append(this)),this},wrapInner:function(a){return r.isFunction(a)?this.each(function(b){r(this).wrapInner(a.call(this,b))}):this.each(function(){var b=r(this),c=b.contents();c.length?c.wrapAll(a):b.append(a)})},wrap:function(a){var b=r.isFunction(a);return this.each(function(c){r(this).wrapAll(b?a.call(this,c):a)})},unwrap:function(a){return this.parent(a).not("body").each(function(){r(this).replaceWith(this.childNodes)}),this}}),r.expr.pseudos.hidden=function(a){return!r.expr.pseudos.visible(a)},r.expr.pseudos.visible=function(a){return!!(a.offsetWidth||a.offsetHeight||a.getClientRects().length)},r.ajaxSettings.xhr=function(){try{return new a.XMLHttpRequest}catch(b){}};var Rb={0:200,1223:204},Sb=r.ajaxSettings.xhr();o.cors=!!Sb&&"withCredentials"in Sb,o.ajax=Sb=!!Sb,r.ajaxTransport(function(b){var c,d;if(o.cors||Sb&&!b.crossDomain)return{send:function(e,f){var g,h=b.xhr();if(h.open(b.type,b.url,b.async,b.username,b.password),b.xhrFields)for(g in b.xhrFields)h[g]=b.xhrFields[g];b.mimeType&&h.overrideMimeType&&h.overrideMimeType(b.mimeType),b.crossDomain||e["X-Requested-With"]||(e["X-Requested-With"]="XMLHttpRequest");for(g in e)h.setRequestHeader(g,e[g]);c=function(a){return function(){c&&(c=d=h.onload=h.onerror=h.onabort=h.onreadystatechange=null,"abort"===a?h.abort():"error"===a?"number"!=typeof h.status?f(0,"error"):f(h.status,h.statusText):f(Rb[h.status]||h.status,h.statusText,"text"!==(h.responseType||"text")||"string"!=typeof h.responseText?{binary:h.response}:{text:h.responseText},h.getAllResponseHeaders()))}},h.onload=c(),d=h.onerror=c("error"),void 0!==h.onabort?h.onabort=d:h.onreadystatechange=function(){4===h.readyState&&a.setTimeout(function(){c&&d()})},c=c("abort");try{h.send(b.hasContent&&b.data||null)}catch(i){if(c)throw i}},abort:function(){c&&c()}}}),r.ajaxPrefilter(function(a){a.crossDomain&&(a.contents.script=!1)}),r.ajaxSetup({accepts:{script:"text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"},contents:{script:/\b(?:java|ecma)script\b/},converters:{"text script":function(a){return r.globalEval(a),a}}}),r.ajaxPrefilter("script",function(a){void 0===a.cache&&(a.cache=!1),a.crossDomain&&(a.type="GET")}),r.ajaxTransport("script",function(a){if(a.crossDomain){var b,c;return{send:function(e,f){b=r("<script>").prop({charset:a.scriptCharset,src:a.url}).on("load error",c=function(a){b.remove(),c=null,a&&f("error"===a.type?404:200,a.type)}),d.head.appendChild(b[0])},abort:function(){c&&c()}}}});var Tb=[],Ub=/(=)\?(?=&|$)|\?\?/;r.ajaxSetup({jsonp:"callback",jsonpCallback:function(){var a=Tb.pop()||r.expando+"_"+ub++;return this[a]=!0,a}}),r.ajaxPrefilter("json jsonp",function(b,c,d){var e,f,g,h=b.jsonp!==!1&&(Ub.test(b.url)?"url":"string"==typeof b.data&&0===(b.contentType||"").indexOf("application/x-www-form-urlencoded")&&Ub.test(b.data)&&"data");if(h||"jsonp"===b.dataTypes[0])return e=b.jsonpCallback=r.isFunction(b.jsonpCallback)?b.jsonpCallback():b.jsonpCallback,h?b[h]=b[h].replace(Ub,"$1"+e):b.jsonp!==!1&&(b.url+=(vb.test(b.url)?"&":"?")+b.jsonp+"="+e),b.converters["script json"]=function(){return g||r.error(e+" was not called"),g[0]},b.dataTypes[0]="json",f=a[e],a[e]=function(){g=arguments},d.always(function(){void 0===f?r(a).removeProp(e):a[e]=f,b[e]&&(b.jsonpCallback=c.jsonpCallback,Tb.push(e)),g&&r.isFunction(f)&&f(g[0]),g=f=void 0}),"script"}),o.createHTMLDocument=function(){var a=d.implementation.createHTMLDocument("").body;return a.innerHTML="<form></form><form></form>",2===a.childNodes.length}(),r.parseHTML=function(a,b,c){if("string"!=typeof a)return[];"boolean"==typeof b&&(c=b,b=!1);var e,f,g;return b||(o.createHTMLDocument?(b=d.implementation.createHTMLDocument(""),e=b.createElement("base"),e.href=d.location.href,b.head.appendChild(e)):b=d),f=C.exec(a),g=!c&&[],f?[b.createElement(f[1])]:(f=qa([a],b,g),g&&g.length&&r(g).remove(),r.merge([],f.childNodes))},r.fn.load=function(a,b,c){var d,e,f,g=this,h=a.indexOf(" ");return h>-1&&(d=pb(a.slice(h)),a=a.slice(0,h)),r.isFunction(b)?(c=b,b=void 0):b&&"object"==typeof b&&(e="POST"),g.length>0&&r.ajax({url:a,type:e||"GET",dataType:"html",data:b}).done(function(a){f=arguments,g.html(d?r("<div>").append(r.parseHTML(a)).find(d):a)}).always(c&&function(a,b){g.each(function(){c.apply(this,f||[a.responseText,b,a])})}),this},r.each(["ajaxStart","ajaxStop","ajaxComplete","ajaxError","ajaxSuccess","ajaxSend"],function(a,b){r.fn[b]=function(a){return this.on(b,a)}}),r.expr.pseudos.animated=function(a){return r.grep(r.timers,function(b){return a===b.elem}).length},r.offset={setOffset:function(a,b,c){var d,e,f,g,h,i,j,k=r.css(a,"position"),l=r(a),m={};"static"===k&&(a.style.position="relative"),h=l.offset(),f=r.css(a,"top"),i=r.css(a,"left"),j=("absolute"===k||"fixed"===k)&&(f+i).indexOf("auto")>-1,j?(d=l.position(),g=d.top,e=d.left):(g=parseFloat(f)||0,e=parseFloat(i)||0),r.isFunction(b)&&(b=b.call(a,c,r.extend({},h))),null!=b.top&&(m.top=b.top-h.top+g),null!=b.left&&(m.left=b.left-h.left+e),"using"in b?b.using.call(a,m):l.css(m)}},r.fn.extend({offset:function(a){if(arguments.length)return void 0===a?this:this.each(function(b){r.offset.setOffset(this,a,b)});var b,c,d,e,f=this[0];if(f)return f.getClientRects().length?(d=f.getBoundingClientRect(),b=f.ownerDocument,c=b.documentElement,e=b.defaultView,{top:d.top+e.pageYOffset-c.clientTop,left:d.left+e.pageXOffset-c.clientLeft}):{top:0,left:0}},position:function(){if(this[0]){var a,b,c=this[0],d={top:0,left:0};return"fixed"===r.css(c,"position")?b=c.getBoundingClientRect():(a=this.offsetParent(),b=this.offset(),B(a[0],"html")||(d=a.offset()),d={top:d.top+r.css(a[0],"borderTopWidth",!0),left:d.left+r.css(a[0],"borderLeftWidth",!0)}),{top:b.top-d.top-r.css(c,"marginTop",!0),left:b.left-d.left-r.css(c,"marginLeft",!0)}}},offsetParent:function(){return this.map(function(){var a=this.offsetParent;while(a&&"static"===r.css(a,"position"))a=a.offsetParent;return a||ra})}}),r.each({scrollLeft:"pageXOffset",scrollTop:"pageYOffset"},function(a,b){var c="pageYOffset"===b;r.fn[a]=function(d){return T(this,function(a,d,e){var f;return r.isWindow(a)?f=a:9===a.nodeType&&(f=a.defaultView),void 0===e?f?f[b]:a[d]:void(f?f.scrollTo(c?f.pageXOffset:e,c?e:f.pageYOffset):a[d]=e)},a,d,arguments.length)}}),r.each(["top","left"],function(a,b){r.cssHooks[b]=Pa(o.pixelPosition,function(a,c){if(c)return c=Oa(a,b),Ma.test(c)?r(a).position()[b]+"px":c})}),r.each({Height:"height",Width:"width"},function(a,b){r.each({padding:"inner"+a,content:b,"":"outer"+a},function(c,d){r.fn[d]=function(e,f){var g=arguments.length&&(c||"boolean"!=typeof e),h=c||(e===!0||f===!0?"margin":"border");return T(this,function(b,c,e){var f;return r.isWindow(b)?0===d.indexOf("outer")?b["inner"+a]:b.document.documentElement["client"+a]:9===b.nodeType?(f=b.documentElement,Math.max(b.body["scroll"+a],f["scroll"+a],b.body["offset"+a],f["offset"+a],f["client"+a])):void 0===e?r.css(b,c,h):r.style(b,c,e,h)},b,g?e:void 0,g)}})}),r.fn.extend({bind:function(a,b,c){return this.on(a,null,b,c)},unbind:function(a,b){return this.off(a,null,b)},delegate:function(a,b,c,d){return this.on(b,a,c,d)},undelegate:function(a,b,c){return 1===arguments.length?this.off(a,"**"):this.off(b,a||"**",c)}}),r.holdReady=function(a){a?r.readyWait++:r.ready(!0)},r.isArray=Array.isArray,r.parseJSON=JSON.parse,r.nodeName=B,"function"==typeof define&&define.amd&&define("jquery",[],function(){return r});var Vb=a.jQuery,Wb=a.$;return r.noConflict=function(b){return a.$===r&&(a.$=Wb),b&&a.jQuery===r&&(a.jQuery=Vb),r},b||(a.jQuery=a.$=r),r});

    </script>
    <script type="text/javascript">
        const tree = new G6.Tree({
            id: 'myTreeMap', // 容器ID
            height: window.innerHeight || document.body.clientHeight,
            fitView: "autoZoom",
            layoutFn: G6.Layouts.{{ layout }},
            layoutCfg: {
                direction: "{{ direction }}", // 方向（LR/RL/H/TB/BT/V）
                indent: {{ indent }},
                getHGap: function( /* d */ ) { // 横向间距
                    return {{ hgap }};
                },
                getVGap: function( /* d */ ) { // 横向间距
                    return {{ vgap }};
                },
            },
        });
        tree.source(
            {{ json_data }}
        );
        tree.node()
            .label(function(obj) {
                return obj.name;
            })
            .style({
                fillOpacity: 1
            });
        tree.edge().shape('{{ shape }}');
        tree.render();
    </script>
</body>

</html>

"""